<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class aclmgrModelrules extends Model {

	public function getObjects($admin=0) {
		$query = "SELECT * FROM #__acl_objects"
						." WHERE ao_is_admin=".intval($admin)
						." AND (ao_module_name='system' OR ao_module_name='common_rules' OR ao_module_name IN ('".implode("','",Module::getInstalledModules(0))."'))"
						." ORDER BY ao_module_name, ao_name";
		$this->_db->setQuery($query);
		$allObjects = $this->_db->loadObjectList("ao_id");
		$enObjects = array();
		foreach ($allObjects as $object) {
			if (!in_array($object->ao_module_name,Portal::getInstance()->getDisabledModules())) {
				$enObjects[$object->ao_id] = $object; 
			}
		}
		
		return $enObjects;
	}

	public function setRule($aclObjectId,$aclRoleId,$aclAccess) {
		/*
		$aclAccess = intval($aclAccess);
		$query = "SELECT acl_access FROM #__acl_rules WHERE (acl_object_id=".$aclObjectId.") AND (acl_role_id=".$aclRoleId.")";
		$this->_db->setQuery($query);
		if ($this->_db->loadObject($r)) {
			$query = "UPDATE #__acl_rules SET acl_access=".$aclAccess." WHERE (acl_object_id=".$aclObjectId.") AND (acl_role_id=".$aclRoleId.")";
			$this->_db->setQuery($query);
			$this->_db->query();	
		}
		else {
			$query = "INSERT INTO `#__acl_rules` VALUES(".$aclObjectId.",".$aclRoleId.",".$aclAccess.")";
			$this->_db->setQuery($query);
			$this->_db->query();	
		}
		*/		
		$aclAccess = intval($aclAccess);
		$query = "INSERT INTO `#__acl_rules` VALUES(".$aclObjectId.",".$aclRoleId.",".$aclAccess.")";
		$query .= " ON DUPLICATE KEY UPDATE acl_access=".$aclAccess;
		$this->_db->setQuery($query);
		$this->_db->query();	
	}
	
	public function getRules($roleId,$objects) {
		$qin = "(";
		foreach ($objects as $objectId=>$object) {
			if ($qin != "(") $qin .= ",";
			$qin .= $objectId;
		}
		$qin .= ")";
		
//		$query = "SELECT * FROM `#__acl_rules` WHERE (`acl_role_id`=".intval($roleId).") AND (`acl_object_id` IN ".$qin.")";
		$query = "SELECT * FROM #__acl_rules AS ar LEFT JOIN #__acl_objects AS ao ON ar.acl_object_id=ao.ao_id"
						." WHERE (ar.acl_role_id=".intval($roleId).") AND (ar.acl_object_id IN ".$qin.")"
						." ORDER BY ao.ao_module_name";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

}

?>