<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogControllerdefault extends SpravController {

	public function ajaxgetSKU() {
		$psid=request::getSafe('psid');
		$model=$this->getModel();
		echo $model->getSKUPath($psid);
	}
	public function ajaxgetGoodsInfo() {
		$psid=request::getInt('psid');
		$model = $this->getModel('goods');
		$result=$model->getElement($psid);
		echo json_encode($result);
	}
	public function showExport()  {
		ini_set('memory_limit','196M');
		ini_set('max_execution_time','60');
		$hidden_fields=array("g_id", "g_deleted", "g_thumb", "g_medium_image", "g_thumb");
		$mdl = Module::getInstance();
		$model = $this->getModel();
		$view = $this->getView();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($view->getName()));
		$step=Request::getInt('step',0);
		if ($step){
			$res=$model->proceedExport($hidden_fields);
			$view->assign("res", $res );
		} else {
			$fields=$model->getFields();
			$helper=$this->getHelper("groupsTree");
			$tree=$helper->getTreeHTML(0, "ul", "export_ggr");
			$view->assign("tree", $tree );
			$view->assign("hidden_fields", $hidden_fields );
			$view->assign("fields", $fields );
			$view->setLayout('settings');
		}
	}
	public function showImport()  {
		ini_set('memory_limit','196M');
		ini_set('max_execution_time','60');
		$mdl = Module::getInstance();
		$model = $this->getModel();
		$view = $this->getView();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($view->getName()));
		$hidden_fields=array("g_id", "g_deleted", "g_enabled", "g_thumb", "g_image");
		$def_fields = array(
				"g_type"=>1,
				"g_measure"=>catalogConfig::$default_measure,
				"g_pack_measure"=>catalogConfig::$default_measure,
				"g_pack_koeff"=>1,
				"g_vmeasure"=>catalogConfig::$default_vol_measure,
				"g_wmeasure"=>catalogConfig::$default_wmeasure,
				"g_currency"=>catalogConfig::$default_currency,
				"g_selltype"=>0,
				"g_tax"=>catalogConfig::$default_order_taxes,
				"g_vendor"=>catalogConfig::$default_vendor,
				"g_manufacturer"=>catalogConfig::$default_manufacturer
				);
		$step=Request::getInt('step',0);
		$codepage=Request::getSafe('codepage',"");
		if ($codepage=="windows-1251") $convert=true; else $convert=false;
		switch ($step){
			case 1:
				$count_records=0;
				/* НЕ УБИВАТЬ !!! ОТРЕМИТЬ ПЕРЕД РАБОТОЙ !!! */
				$model->resetSessionVars();
				$model->cleanTempTable();
				$result=Files::uploadDataFile("CSV","filecsv", "import", PATH_TMP,true,$convert);
				if ($result) $count_records = $model->importTempTable($result["file"]);
				$fields=$model->getFields($hidden_fields);
				$fields_data=$model->getFieldsData($def_fields);
				$add_fields_w_lists=$model->getAddFieldsWLists($hidden_fields);
				$groupsTree=$mdl->getHelper("groupsTree");
				$view->assign("groupsTree", $groupsTree );
				$view->assign("fields", $fields );
				$view->assign("fields_data", $fields_data );
				$view->assign("af_wlists", $add_fields_w_lists );
				$view->assign("count_records", $count_records );
				$view->setLayout('settings');
			break;
			case 2:
				// сложим всё в сессию
				$model->setImportVars(array_keys($def_fields));
				$view->setLayout('confirm');
			break;
			case 3:
				$view->setLayout('results');
			break;
			case 4:
				Portal::getInstance()->disableTemplate();
				$start=Request::getInt("start",0);
				$res=$model->proceedImport($start,$hidden_fields,array_keys($def_fields));
				echo json_encode($res);
				Util::halt();
			break;
			default:
				$view->setLayout('fileselector');
			break;
		}
		//$this->getHelper("Import")->proceed();
	}
	/**
	 * проверка уникальности поля
	 */
	public function ajaxcheckfield()  {
		$fld=Request::getSafe('fld');
		$val=Request::getSafe('val');
		$psid=Request::getInt('psid');
		switch($fld){
			case "g_sku":
				$model = $this->getModel("goods");
				if(!$model->isGoods($val,$psid))  echo "OK";  else  echo Text::_("Occupied");
				break;
		}
	}
	public function printOrders() {
		Portal::getInstance()->changeTemplateFile('print');
		$mdl = Module::getInstance();
		$moduleName	= $mdl->getName();
		$reestr = $mdl->get('reestr');
		$model = $this->getModel();
		$view = $this->getView();
		$viewname = $view->getName();
		$arr_psid     = request::get('cps_id', false);				// массив отмеченных галочкой элементов
		$multy_code   = request::getInt('multy_code', false); 		// ид верхней группы
		$reestr->set('view',$viewname);
		$reestr->set('model',$model);
		$reestr->set("multy_code",$multy_code);
		$reestr->set('arr_psid',$arr_psid);

		$orders=$model->getOrders();
		if ($orders) {
			$orders=$model->decodeOrdersData($orders);
			$orders_items=$model->getOrdersItems();
		}
		else {$orders=false;$orders_items=false;}

		$view->setLayout('print');
		$view->assign("orders", $orders );
		$view->assign("orders_items", $orders_items );
		$view->render();
	}
	function showGoodsgroup() {
		$this->showData();
	}
	public function showGoods() {
		$this->showData('ggr_name','goodsgroup');
	}
	function showCurrency() {
		$this->showData();
	}
	function showCurrency_rate(){
		$this->showData('c_name','currency');
	}
	public function showImages() {
		$this->showData('g_name','goods');
	}
	public function showVideos() {
		$this->showData('g_name','goods');
	}
	public function showUsers() {
		$this->showData();
	}

	public function showVendors() {
		$this->showData('vc_name','vendor_categories');
	}
	public function showVendor_cats() {
		$this->showData();
	}
	public function showManufacturers() {
		$this->showData('mfc_name','manufacturer_categories');
	}
	public function showManufacturer_cats() {
		$this->showData();
	}
	public function showOrders() {
		switch ($this->get('layout','')) 	{
			case "order":
				Portal::getInstance()->disableTemplate();
				$reestr = Module::getInstance()->get('reestr');
				$reestr->set('needpan',false);
				$this->showData("o_id","orders");
				break;
			default:
				$this->showOrdersData();
				break;
		}
	}
	public function showOrdersData() {
		$viewname 	= $this->getView()->getName();
		$mdl = Module::getInstance();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		$reestr = $mdl->get('reestr');
		$model = $this->getModel('orders');
		$model->loadMeta();

		$multy_code   = request::getSafe('multy_code', false); 		// ид верхней группы
		$psid         = request::getSafe('psid', false); 					// ид строки
		$arr_psid     = request::getSafe('cps_id', false);				// массив отмеченных галочкой элементов
		if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
		if(!$multy_code)	$multy_code=$psid;
		elseif(!$psid) $psid=$multy_code;
		$reestr->set('psid',$psid);

//		$reestr->set('parent_element_name',$parent_element_name);
//		$reestr->set('parent_element_table',$parent_element_table);
		$reestr->set('canModify',true);
		$reestr->set('start',Request::getInt("start",0));
		$reestr->set('sort',Request::getSafe("sort"));
		$reestr->set('orderby',Request::getSafe("orderby"));
		$reestr->set("multy_code",$multy_code);

		$trash=Request::getInt('trash',0);
		$reestr->set("trash",$trash);
		$view = $this->getView();
		Request::getSafe('option')=="ajax" ? $is_ajax=1 : $is_ajax=0;
		$reestr->set("is_ajax",$is_ajax);
		$result = $model->getData();
		$result=$model->decodeOrdersData($result);

		$view->renderSprav($model->meta,$result);
	}
	public function showDeliverytypes() {
		$reestr = Module::getInstance()->get('reestr');
		$reestr->set('consider_parents',false);
		$this->showData();
	}
	public function showPaymenttypes() {
		$this->showData();
	}
	public function showMeasures() {
		$this->showData();
	}
	public function showTaxes() {
		$this->showData();
	}

	public function modifyElement($ajaxModify=false, $clone_mode=false){
		$mdl		= Module::getInstance();
		$reestr 	= $mdl->get('reestr');
		$view 		= $this->getView();
		$model 		= $this->getModel();
		$viewname 	= $view->getName();
		switch($viewname){
			case "goods":
				$arr_psid     = request::get('cps_id', false);				// массив отмеченных галочкой элементов
				$multy_code   = request::getInt('multy_code', false); 		// ид верхней группы
				$psid         = request::getInt('psid', false); 					// ид строки
				if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
				$links=$model->getLinkArray($psid);
				$groups=$this->getModule()->getHelper('groupsTree');
				$parents=$groups->getWholeTreeUp($links);
				$fbgList=$model->getGroupsFields(array_keys($parents));
				foreach($model->meta->is_add as $key=>$is_add){
					if ($is_add){
						if ($model->meta->is_add_custom[$key]==1){
							if (!array_key_exists($is_add, $fbgList)) {
								$model->meta->input_view[$key]=0;
							}
						}
					}
				}
				$analogList=$model->getAnalogs($psid);
				$view->assign('analogList',$analogList);
				$complectList=$model->getComplectSet($psid);
				$view->assign('complectList',$complectList);
				$activeTab=Request::getInt("activeTab",1);
				$view->assign('activeTab',$activeTab);
				parent::modifyElement($ajaxModify, $clone_mode);
			break;
			case "goodsgroup":
				$arr_psid     = request::get('cps_id', false);				// массив отмеченных галочкой элементов
				$multy_code   = request::getInt('multy_code', false); 		// ид верхней группы
				$psid         = request::getInt('psid', false); 					// ид строки
				if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
				$activeTab=Request::getInt("activeTab",1);
				$view->assign('activeTab',$activeTab);
				$group_fields=$model->getGroupFields($psid);
				$view->assign('group_fields',$group_fields);
				parent::modifyElement($ajaxModify, $clone_mode);
			break;
			default:
				parent::modifyElement($ajaxModify, $clone_mode);
			break;
		}
	}
	public function save() {
		$mdl				= Module::getInstance();
		$moduleName	= $mdl->getName();
		$reestr 		= $mdl->get('reestr');
		$model 			= $this->getModel();
		$viewname 	= $this->getView()->getName();
		if (defined("_ADMIN_MODE")) $this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		else $this->checkACL("modify".ucfirst($mdl->getName()).ucfirst($viewname));
		$psid       = request::getSafe('psid', false); 					// ид строки
		$multy_code	= request::getSafe('multy_code', 0);
		$layout			= request::getSafe('layout');
		$start			= request::getInt('start');
		$sort				= request::getSafe('sort');
		$orderby		= request::getSafe('orderby');
		$is_apply		= request::getSafe('apply',0);
		$is_add_clone		= request::getSafe('add_clone',0);
		$is_add_new		= request::getSafe('add_new',0);
		$reestr->set('multy_code',$multy_code);
		$reestr->set('view',$viewname);
		$reestr->set('psid',$psid);
		$new_psid=$model->save();
		if($new_psid) {
			$model->garbageCollector($new_psid);
			$msg=Text::_("Save successfull");
		}	else { $msg=Text::_("Save unsuccessfull"); $new_psid=$psid; }
		switch($viewname){
			case "goods":
				if($new_psid) {
					$group = $this->getModel('goodsgroup');
					$links=$model->getLinkArray($new_psid);
					$groups=$this->getModule()->getHelper('groupsTree');
					$parents=$groups->getWholeTreeUp($links);
					$model->cleanNonGroupsFields($new_psid, array_keys($parents));
					$analogs=Request::get("analogEditor",array());
					if (!$model->saveAnalogs($new_psid,$analogs)) $msg=Text::_("Save unsuccessfull");
					$g_type	= Request::getInt('g_type',0);
					$complectsets=array();
					if ($g_type==5) { // это комплект
						$complect_ids=Request::get("complectEditor",array());
						$complect_quantities=Request::get("complectEditor_quantity",array());
						if (count($complect_ids)){
							foreach($complect_ids as $complect_gid){
								if (array_key_exists($complect_gid, $complect_quantities)){
									$cquantity=$complect_quantities[$complect_gid];
									if ($cquantity) $complectsets[$complect_gid]=$cquantity;
								}
							}
						}
					}
					if (!$model->saveComplectSet($new_psid,$complectsets)) {
						$msg=Text::_("Save unsuccessfull");
					} else {
						$name	= request::get('g_name',"");
						$alias	= request::get('g_alias',"");
						$model->updateAlias($new_psid,$alias,$name);
					}
				}
				break;
			case "goodsgroup":
					$name	= request::get('ggr_name',"");
					$alias	= request::get('ggr_alias',"");
					if($new_psid) {
						$fields = Request::get('group_field', array());
						$model->saveGroupFields($new_psid,$fields);
						$model->updateAlias($new_psid,$alias,$name);
					}
				break;
			default:
				break;
		}
		$activeTab=Request::getInt("activeTab",1);
		if ($is_apply) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modify&psid='.$new_psid.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code.'&activeTab='.$activeTab;
		elseif($is_add_clone) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=make_clone&psid='.$new_psid.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		elseif($is_add_new) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modify&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		else $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		$this->setRedirect($url,$msg);
	}
	public function showXmlformat(){
		$view=$this->getView();
		$layout			= request::getSafe('layout');
		switch($layout){
			case "confirm":
				// получили файл выводим по нему инфу из заголовка
				$err_url="index.php?module=catalog&view=xmlformat&layout=fileselector";
				$filename="import".time();
				$link=Files::uploadXML('filexml', $filename, PATH_TMP, true);
				if($link) { // файл у нас загрузился, читаем его
					$xml = simplexml_load_file($link['file']);
					if($xml) {
						if(($xml->header->getName()=='header')) {
							//забрали заголовок - верстаем карту загрузки
							$info = array();
							foreach ($xml->header[0]->children() as $name=>$val) { 	$info[$name]=$val; }
							$view->assign("info",$info);
							$view->assign("link",$link);
							// если все нормально , просим согласие на сохранение данных в базу
						}	else { $this->setRedirect($err_url,Text::_("Wrong inner structure of file xml"));	}
					}	else { $this->setRedirect($err_url,Text::_("File can`t reed. uncorrect type of file or wrong codepage"));	}
				}
				else { // загрузки файла не произошло. например не совпал тип
					$this->setRedirect($err_url,Text::_("File can`t upload. Possible uncorrect type of file"));
				}
				break;
			case "fileselector":
				break;
			default:
				break;
		}
	}
	// Основная процедура подъема обновления в базу
	public function importXMLData()	{
		die("FIX ME !!!");
		$filename			= Request::getSafe('xmlfile');
		$is_cancel		= Request::get('cancel',0);
		if ($is_cancel) {
			Files::delete($filename, true);
			$this->setRedirect("index.php?module=catalog&view=xmlformat&layout=fileselector");
		} else {
			$this->set('view','xmlformat',true);
			$model=$this->getModel();
			$result=$model->importXMLData($filename);
		}
	}
	public function newDTS() {
		$this->checkACL("viewCatalogDeliverytypes");
		$model = Module::getInstance()->getModel();
		$view = $this->getView();
		$templates=$model->getTemplates();
		$view->assign('selector',HTMLControls::renderSelect('tmpl_name','tmpl_name', 'filename', 'filename', $templates,0,0));
		$view->set('layout','new');
		$view->render();
	}
	public function saveNewDTS() {
		$this->checkACL("viewCatalogDeliverytypes");
		$tmpl_name = Request::getSafe("tmpl_name","");
		if (!$tmpl_name) $this->newDTS();
		else {
			$model = Module::getInstance()->getModel();
			$psid=$model->saveNewDTS($tmpl_name);
			if($psid) {
				$this->setRedirect("index.php?module=catalog&view=deliverytypes&task=modifyDTS&psid=".$psid);
			}	else {
				$this->setRedirect("index.php?module=catalog&view=deliverytypes","Save unsuccessfull");
			}
		}
	}
	public function newPTS() {
		$this->checkACL("viewCatalogPaymenttypes");
		$model = Module::getInstance()->getModel();
		$view = $this->getView();
		$templates=$model->getTemplates();
		$view->assign('selector',HTMLControls::renderSelect('tmpl_name','tmpl_name', 'filename', 'filename', $templates,0,0));
		$view->set('layout','new');
		$view->render();
	}
	public function saveNewPTS() {
		$this->checkACL("viewCatalogPaymenttypes");
		$tmpl_name = Request::getSafe("tmpl_name","");
		if (!$tmpl_name) $this->newPTS();
		else {
			$model = Module::getInstance()->getModel();
			$psid=$model->saveNewPTS($tmpl_name);
			if($psid) {
				$this->setRedirect("index.php?module=catalog&view=paymenttypes&task=modifyPTS&psid=".$psid);
			}	else {
				$this->setRedirect("index.php?module=catalog&view=paymenttypes","Save unsuccessfull");
			}
		}
	}
	public function modifyDTS() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$model = $this->getModel();
		$arr_psid     = request::get('cps_id', false);									// массив отмеченных галочкой элементов
		$psid         = request::get('psid', false); 					// ид строки
		if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
		$reestr->set('psid',$psid);
		$reestr->set('task','saveDTS');
		$reestr->set('view','deliverytypes');
		$reestr->set('start',Request::getInt('start'));
		$reestr->set('sort',Request::getSafe('sort'));
		$reestr->set('orderby',Request::getSafe('orderby'));
		$reestr->set('model',$model);
		$elem = $model->getElement();
		$view = $this->getView();
		$reestr->set("onCancelURL","index.php?module=catalog&view=deliverytypes");
		$params = Params::parse($elem->dt_params);
		$def_params = $model->getParamsMask($elem);
		$view->assign("params",$params);
		$view->assign("def_params",$def_params);
		$view->modify($elem);
	}
	public function saveDTS() {
		$mdl = Module::getInstance();
		$moduleName	= $mdl->getName();
		$reestr = $mdl->get('reestr');

		$psid      = Request::get('psid', false);
		$multy_code = Request::get('multy_code',0);
		$layout		= Request::get('layout');
		$start		= Request::get('start');
		$sort		= Request::get('sort');
		$orderby	= Request::get('orderby');
		$is_apply	= Request::get('apply',0);

		$model = $this->getModel();
		$view = $this->getView();
		$viewname = $view->getName();

		$reestr->set('multy_code',$multy_code);
		$reestr->set('view',$viewname);
		$reestr->set('psid',$psid);

		$new_psid = $model->save();
		if($new_psid) {
			$params = Request::get("dt_params",array());
			$elem = $model->getElement($new_psid);
			$def_params = $model->getParamsMask($elem);
			if($model->saveParams($new_psid,$def_params,$params)) {
				$msg = Text::_("Save successfull");
			} else {
				$msg = Text::_("Save unsuccessfull");
			}
			$new_psid = urlencode($new_psid);
		}
		else {
			$new_psid = urlencode($psid); $msg = Text::_("Save unsuccessfull");
		}

		if ($is_apply) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modifyDTS&psid='.$new_psid.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		else $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		$this->setRedirect($url,$msg);
	}
	public function modifyPTS() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$model = $this->getModel();
		$arr_psid     = request::get('cps_id', false);									// массив отмеченных галочкой элементов
		$psid         = request::get('psid', false); 					// ид строки
		if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
		$reestr->set('psid',$psid);
		$reestr->set('task','savePTS');
		$reestr->set('view','paymenttypes');
		$reestr->set('start',Request::getInt('start'));
		$reestr->set('sort',Request::getSafe('sort'));
		$reestr->set('orderby',Request::getSafe('orderby'));
		$reestr->set('model',$model);
		$elem = $model->getElement();
		$view = $this->getView();
		$reestr->set("onCancelURL","index.php?module=catalog&view=paymenttypes");
		$params = Params::parse($elem->pt_params);
		$def_params = $model->getParamsMask($elem);
		$view->assign("params",$params);
		$view->assign("def_params",$def_params);
		$view->modify($elem);
	}
	public function saveGoodsgroup() {
		$model = $this->getModel();
		$new_psid = $model->save();
		if($new_psid) {

		}	else {
			$new_psid = urlencode($psid); $msg = Text::_("Save unsuccessfull");
		}

		if ($is_apply) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modifyPTS&psid='.$new_psid.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		else $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		$this->setRedirect($url,$msg);
	}
	public function savePTS() {
		$mdl = Module::getInstance();
		$moduleName	= $mdl->getName();
		$reestr = $mdl->get('reestr');

		$psid      = Request::get('psid', false);
		$multy_code = Request::get('multy_code',0);
		$layout		= Request::get('layout');
		$start		= Request::get('start');
		$sort		= Request::get('sort');
		$orderby	= Request::get('orderby');
		$is_apply	= Request::get('apply',0);

		$model = $this->getModel();
		$view = $this->getView();
		$viewname = $view->getName();

		$reestr->set('multy_code',$multy_code);
		$reestr->set('view',$viewname);
		$reestr->set('psid',$psid);

		$new_psid = $model->save();
		if($new_psid) {
			$params = Request::get("pt_params",array());
			$elem = $model->getElement($new_psid);
			$def_params = $model->getParamsMask($elem);
			if($model->saveParams($new_psid,$def_params,$params)) {
				$msg = Text::_("Save successfull");
			} else {
				$msg = Text::_("Save unsuccessfull");
			}
			$new_psid = urlencode($new_psid);
		}
		else {
			$new_psid = urlencode($psid); $msg = Text::_("Save unsuccessfull");
		}

		if ($is_apply) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modifyPTS&psid='.$new_psid.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		else $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		$this->setRedirect($url,$msg);
	}
	public function showPrice() {
		$view=$this->getView();
		$model=$this->getModel();
		switch ($this->get('layout','')) 	{
			case "list":
				$reestr = Module::getInstance()->get('reestr');
				$reestr->set('needpan',false);
				$params["parent_group"]=Request::getInt("parent_group",0);
				$params["break_by_groups"]=Request::getInt("break_by_groups",0);
				$params["show_pack_price"]=Request::getInt("show_pack_price",0);
				$params["show_weight_price"]=Request::getInt("show_weight_price",0);
				$params["show_volume_price"]=Request::getInt("show_volume_price",0);
				$params["enabled_only"]=Request::getInt("enabled_only",0);
				$params["show_company_info"]=Request::getInt("show_company_info",0);
				$params["price_type"]=Request::getInt("price_type",1);
				$params["show_thumbs"]=Request::getInt("show_thumbs",0);
				$params["show_dimensions"]=Request::getInt("show_dimensions",0);
				$params["show_weight"]=Request::getInt("show_weight",0);
				$params["add_header"]=Request::getSafe("add_header","");
				$params["add_footer"]=Request::getSafe("add_footer","");

				$mainGrp=$model->getGroupTitle($params);
				$view->assign("mainGrp",$mainGrp);
				if($params["break_by_groups"]){
					$grpArr=$model->getTreeArr($params);
					$view->assign("grpArr",$grpArr);
				}
				$view->assign("params",$params);
				break;
			default:
				$grpTree=$this->getModule()->getHelper('groupsTree');
				$view->assign("grpTree",$grpTree);
				break;
		}
	}
	public function showImportRussianPostTables()  {
		// @FIXME как то нужно таблицы почты россии например притащить
	}
}
?>