<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogModelgoods extends SpravModel {

	private $arr_table_clean=array();

	public function cleanLinkFromGoods(){
		// удаление ссылок
		$query = "DELETE FROM #__goods_links WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_data WHERE obj_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_analogs WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_analogs WHERE a_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$this->_db->setQuery($query); if(!$this->_db->query_batch(true,true)) return false;
		return true;
	}
	public function cleanRecords()	{
		// помечаем дочерние таблицвы
		$this->arr_table_clean['m_table']="goods";
		$this->arr_table_clean['m_key']="g_id";
		$this->arr_table_clean['m_deleted']="g_deleted";
		$this->arr_table_clean['ch_table']="goods_img";
		$this->arr_table_clean['ch_deleted']="i_deleted";
		$this->arr_table_clean['ch_key']="i_gid";
		parent::markDeleteTrashChildsTable($this->arr_table_clean);
		if(parent::cleanRecords()) return $this->cleanLinkFromGoods();	else return false;
	}


	public function getGoods($shortdata=0,$ids=array()) {
		if($shortdata) $query = "SELECT g_id as id, g_name as title FROM `#__goods` WHERE `g_deleted`=0";
		else $query = "SELECT * FROM `#__goods` WHERE `g_deleted`=0";
		if(count($ids)>0) $query.=" AND g_id IN ('".implode("','",$ids)."')";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	public function updateThumb($psid,$thumb){
		$sql="UPDATE #__goods SET g_thumb='".$thumb."' WHERE g_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}

	public function updateMediumImage($psid,$medium_image){
		$sql="UPDATE #__goods SET g_medium_image='".$medium_image."' WHERE g_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
	public function save()	{
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$psid = $reestr->get('psid');
		$sku=Request::getSafe("g_sku","");
		if(!$sku) return false;
		if (!$this->isGoods($sku,$psid)) {
			$new_psid=parent::save();
			if ($new_psid) {
				if ((catalogConfig::$thumbAutoCreate)&&($_FILES["g_image"]["name"])&&(!$_FILES["g_thumb"]["name"])) {
					$res=$this->getElement($new_psid);
					if (!$res) return false;
					$_dest=ALTADOC_UF_PATH."catalog".DS."i".DS."thumbs".DS.$res->g_thumb;
					if ((!$res->g_thumb)||(!file_exists($_dest))) {
						$filename=Files::splitAppendix($res->g_image, true);
						if ($filename) {
							Files::checkFolder(ALTADOC_UF_PATH."catalog".DS."i".DS."thumbs".DS.Files::getAppendix($filename), true);
							$_src=ALTADOC_UF_PATH."catalog".DS."i".DS."fullsize".DS.$filename;
							$_dest=ALTADOC_UF_PATH."catalog".DS."i".DS."thumbs".DS.$filename;
							if(Files::isImage($_src))	{
								$result=Files::resizeImage($_src, $_dest,catalogConfig::$thumb_width,catalogConfig::$thumb_height);
								if (!$result) return false;
								if (!$res->g_thumb) $result=$this->updateThumb($new_psid,$res->g_image);
								if (!$result) return false;
							}
						} else return false;
					}
				}
				if ((catalogConfig::$mediumImgAutoCreate)&&($_FILES["g_image"]["name"])&&(!$_FILES["g_medium_image"]["name"])) {
					$res=$this->getElement($new_psid);
					if (!$res) return false;
					$_dest=ALTADOC_UF_PATH."catalog".DS."i".DS."medium".DS.$res->g_medium_image;
					if ((!$res->g_medium_image)||(!file_exists($_dest))) {
						$filename=Files::splitAppendix($res->g_image, true);
						if ($filename) {
							Files::checkFolder(ALTADOC_UF_PATH."catalog".DS."i".DS."medium".DS.Files::getAppendix($filename), true);
							$_src=ALTADOC_UF_PATH."catalog".DS."i".DS."fullsize".DS.$filename;
							$_dest=ALTADOC_UF_PATH."catalog".DS."i".DS."medium".DS.$filename;
							if(Files::isImage($_src)) {
								$result=Files::resizeImage($_src, $_dest,catalogConfig::$mediumImgWidth,catalogConfig::$mediumImgHeight);
								if (!$result) return false;
								if (!$res->g_medium_image) $result=$this->updateMediumImage($new_psid,$res->g_image);
								if (!$result) return false;
							}
						} else return false;
					}
				}
				$sql="UPDATE #__goods SET g_change_date=NOW(), g_change_uid=".User::getInstance()->getID()." WHERE g_id=".$new_psid;
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
		} else return false;
		return $new_psid;
	}

	public function getGroupsFields($linkArray){
		if (!is_array($linkArray) || !count($linkArray)) return array();
		$sql = "SELECT f.*, ggf.parent_id  FROM #__fields_list AS f";
		$sql.=" LEFT JOIN #__goods_group_fields AS ggf ON ggf.f_id=f.f_id";
		$sql.=" WHERE f.f_custom=1 AND f.f_table='goods'";
		$sql.=" AND ggf.parent_id IN ('".implode("','",$linkArray)."') ";
		$sql.=" ORDER BY f.f_descr";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList("f_id");
	}

	public function getCommonFields(){
		$sql = "SELECT f.*  FROM #__fields_list AS f";
		$sql.=" WHERE f.f_custom=0 AND f.f_table='goods'";
		$sql.=" ORDER BY f.f_descr";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList("f_id");
	}
	
	public function cleanNonGroupsFields($psid,$linkArray){
		$fcList=$this->getCommonFields();
		$fbgList=$this->getGroupsFields($linkArray);
		if (is_array($fbgList) && count($fbgList)){
			$fbgList_IDS=array_keys($fbgList);
			if (is_array($fcList) && count($fcList)){
				$fcList_IDS = array_keys($fcList);
				$fList_IDS = array_merge($fbgList_IDS, $fcList_IDS);
			} else $fList_IDS=$fbgList_IDS;
			$sql = "DELETE FROM #__goods_data WHERE obj_id=".$psid." AND field_id NOT IN(".implode(",",$fList_IDS).")";
			$this->_db->setQuery($sql);
			$this->_db->query();
		}
	}
	public function getElementClone($psid=0,$fillempty=false) {
		$row = $this->getElement($psid, $fillempty);
		if (is_object($row)){
			$meta = $this->meta;
			foreach($meta->field as $ind=>$field)	{
				if ($field == $meta->keystring) $row->$field=0;
				if($meta->input_type[$ind]=="image" || $meta->input_type[$ind]=="file" || $field =="g_sku") $row->$field="";
			}
		}
		return $row;
	}
/*	
	public function getDataDopField($psid) {
		if(!$psid) return false;
		$sql="select * from #__goods_pdata where obj_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList('field_id');
	}
*/	
/*
	public function saveAddFields($psid,$parents) {
		$delimeter=$this->_db->getDelimiter();
		$res_field=$this->getListField(array_keys($parents));
		$sql_ad=''; $res=true;
		foreach($res_field as $key=>$val) {
			$field_value=Request::reductionOfTypeCustomField($key,$val->t_val_type);
			if($field_value||intval($field_value)===0||trim($field_value)==="") {
				$sql_ad.="insert into #__goods_pdata";
				$sql_ad.=" VALUES('".$psid."','".$val->f_id."','".$key."','".$field_value."')";
				$sql_ad.=" ON DUPLICATE KEY UPDATE `field_value`='".$field_value."'".$delimeter."\n";
			}
		}
		if($sql_ad)	{
			$this->_db->setQuery($sql_ad);
			$res=$this->_db->query_batch(true,true,$delimeter);
		}
		return $res;
	}
*/
	public function isGoods($val,$psid){
		$query = "SELECT COUNT(*) FROM #__goods WHERE g_sku='".strval($val)."'";
		if ($psid) $query.=" AND g_id<>'".$psid."'";
		$this->_db->setQuery($query);
		$cnt = $this->_db->loadResult();
		return (intval($cnt) != 0);
	}
	public function getAnalogs($psid){
		$sql="SELECT DISTINCT a.a_id AS id, g.g_name AS title FROM #__goods_analogs AS a,#__goods AS g WHERE g.g_id=a.a_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function saveAnalogs($psid,$analogs){
		$sql="DELETE FROM #__goods_analogs WHERE g_id=".$psid." OR a_id=".$psid.$this->_db->getDelimiter();
		$res=true;
		if(count($analogs)){
			foreach($analogs as $aid){
				if ($aid!=$psid) {
					$sql.="INSERT INTO #__goods_analogs VALUES(".$psid.",".$aid.")".$this->_db->getDelimiter();
					$sql.="INSERT INTO #__goods_analogs VALUES(".$aid.",".$psid.")".$this->_db->getDelimiter();
				}
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);
	}
	public function getSKUPath($psid){
		$sql="SELECT CONCAT(g_sku,' : ',g_name) FROM #__goods WHERE g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	public function getComplectSet($psid){
		$sql="SELECT DISTINCT a.s_id AS id, g.g_name AS title, a.s_quantity AS quantity FROM #__goods_sets AS a,#__goods AS g WHERE g.g_id=a.s_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function saveComplectSet($psid,$complects){
		$sql="DELETE FROM #__goods_sets WHERE g_id=".$psid.$this->_db->getDelimiter();
		$res=true;
		if(count($complects)){
			foreach($complects as $aid=>$quantity){
				if ($aid!=$psid && $quantity) {
					$sql.="INSERT INTO #__goods_sets VALUES(".$psid.",".$aid.",".$quantity.")".$this->_db->getDelimiter();
				}
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);
	}
	public function updateAlias($psid,$alias,$name){
		$alias=mb_substr(Translit::_($alias), 0,255);
		if (!$alias) $alias=mb_substr(Translit::_($name), 0,255);
		if ($alias=="goods") $alias=mb_substr(Translit::_($psid."_".$name), 0,255);
		$sql="SELECT COUNT(*) FROM #__goods WHERE g_alias='".$alias."' AND g_id<>".$psid;
		$this->_db->setQuery($sql);
		if ($this->_db->loadResult()>0){
			$alias=mb_substr($psid."_".$alias,0,255);
		}
		$sql="UPDATE #__goods SET g_alias='".$alias."' WHERE g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
}

?>