<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogModule extends Module {

	public function getParamsMask(){
		$params=parent::getParamsMask();
		$params['video_width']["vtype"]="integer";				$params['video_width']["vdefault"]=320;
		$params['video_height']["vtype"]="integer";				$params['video_height']["vdefault"]=190;
		$params['breadcrumb_lenght']["vtype"]="integer";		$params['breadcrumb_lenght']["vdefault"]=0;
		$params['breadcrumb_start']["vtype"]="string";			$params['breadcrumb_start']["vdefault"]="catalog";
		$params['breadcrumb_start_link']["vtype"]="string";		$params['breadcrumb_start_link']["vdefault"]="index.php?module=catalog";
		$params['show_filter_button']["vtype"]="boolean";		$params['show_filter_button']["vdefault"]=1;
		$params['show_sort_links']["vtype"]="boolean";			$params['show_sort_links']["vdefault"]=1;
		return $params;
	}


	public function prepare() {
		$this->setDefaultView('goodsgroup');
		$reestr = new FieldSet();
		$this->set('reestr',$reestr);
	}
	public function getLinksArray(&$i,&$_arr) {
		$db=Database::getInstance();		
		$module=$this->getName();
		$arr_grp=array();
		$arr_goods=array();
		$sql='SELECT ggr_id, ggr_name, ggr_alias,ggr_id_parent FROM #__goods_group WHERE ggr_deleted=0 AND ggr_enabled=1';
		$db->setQuery($sql);
		$res=$db->loadObjectList('ggr_id');
		if (count($res)) {
			foreach($res as $val)  {
				if(array_key_exists($val->ggr_id_parent,$res))
				{	
				$i++;
				$arr_grp[$val->ggr_id]=$val->ggr_id;
				$_arr[$module][$i]['link']=Router::_("index.php?module=catalog&view=goods&psid=".$val->ggr_id."&alias=".$val->ggr_alias, true);
				$_arr[$module][$i]['name']=$val->ggr_name;
				$_arr[$module][$i]['fullname']=$val->ggr_name;
				}
			}
		}
		$sql2='SELECT g.g_id, g.g_name, g.g_fullname, g.g_alias, l.parent_id FROM #__goods as g
				LEFT JOIN #__goods_links as l ON l.g_id=g.g_id
				WHERE g_deleted=0 AND g_enabled=1 AND g_type<100 ';
		$db->setQuery($sql2);
		$res2=$db->loadObjectList();
		if (count($res2)) {
			foreach($res2 as $val2)  {
				if(array_key_exists($val2->parent_id,$arr_grp)&&!array_key_exists($val2->g_id,$arr_goods))
				{	
				$i++;
				$arr_goods[$val2->g_id]=$val2->g_id;
				$_arr[$module][$i]['link']=Router::_("index.php?module=catalog&view=goods&layout=info&psid=".$val2->g_id."&alias=".$val2->g_alias, true);
				$_arr[$module][$i]['name']=$val2->g_name;
				$_arr[$module][$i]['fullname']=$val2->g_fullname;
				}
			}
		}
		return true;
	}
	public function getACLTemplate($is_admin=true){		
		$acl=array();$i=0;
		if($is_admin){
			$i++;$acl[$i]['ao_name']='catalogModule'; $acl[$i]['ao_description']='Module access';
			$i++;$acl[$i]['ao_name']='viewCatalogFeedbacks'; $acl[$i]['ao_description']='Feedbacks';
			$i++;$acl[$i]['ao_name']='viewCatalogShowFields'; $acl[$i]['ao_description']='Fields';
			$i++;$acl[$i]['ao_name']='viewCatalogMeasures'; $acl[$i]['ao_description']='Measures';
			$i++;$acl[$i]['ao_name']='viewCatalogPaymenttypes'; $acl[$i]['ao_description']='Payment types';
			$i++;$acl[$i]['ao_name']='viewCatalogDeliverytypes'; $acl[$i]['ao_description']='Delivery types';
			$i++;$acl[$i]['ao_name']='viewCatalogOrders'; $acl[$i]['ao_description']='Orders';
			$i++;$acl[$i]['ao_name']='viewCatalogOrderItems'; $acl[$i]['ao_description']='Order items';
			$i++;$acl[$i]['ao_name']='viewCatalogManufacturercategories'; $acl[$i]['ao_description']='Manufacturer categories';
			$i++;$acl[$i]['ao_name']='viewCatalogManufacturers'; $acl[$i]['ao_description']='Manufacturers';
			$i++;$acl[$i]['ao_name']='viewCatalogVendorCategories'; $acl[$i]['ao_description']='Vendor categories';
			$i++;$acl[$i]['ao_name']='viewCatalogVendors'; $acl[$i]['ao_description']='Vendors';
			$i++;$acl[$i]['ao_name']='viewCatalogCurrency'; $acl[$i]['ao_description']='Currency';
			$i++;$acl[$i]['ao_name']='viewCatalogGoods'; $acl[$i]['ao_description']='Goods';
			$i++;$acl[$i]['ao_name']='viewCatalogGoodsgroup'; $acl[$i]['ao_description']='Goods groups';
			$i++;$acl[$i]['ao_name']='viewCatalogFields'; $acl[$i]['ao_description']='List fields';
			$i++;$acl[$i]['ao_name']='viewCatalogTaxes'; $acl[$i]['ao_description']='List of taxes';
			$i++;$acl[$i]['ao_name']='viewCatalogVendor_cats'; $acl[$i]['ao_description']='Vendor categories';
			$i++;$acl[$i]['ao_name']='viewCatalogManufacturer_cats'; $acl[$i]['ao_description']='Manufacturer categories';
			$i++;$acl[$i]['ao_name']='viewCatalogCurrency_rate'; $acl[$i]['ao_description']='Currency rates';
			$i++;$acl[$i]['ao_name']='viewCatalogPool'; $acl[$i]['ao_description']='View pool';
			$i++;$acl[$i]['ao_name']='viewCatalogImages'; $acl[$i]['ao_description']='Goods images';
			$i++;$acl[$i]['ao_name']='viewCatalogUsers'; $acl[$i]['ao_description']='Vendors link';
			$i++;$acl[$i]['ao_name']='deleteCatalogGoodsgroup'; $acl[$i]['ao_description']='Delete goods groups';
			$i++;$acl[$i]['ao_name']='deleteCatalogGoods'; $acl[$i]['ao_description']='Delete goods';
			$i++;$acl[$i]['ao_name']='viewCatalogImport'; $acl[$i]['ao_description']='Import data';
			$i++;$acl[$i]['ao_name']='viewCatalogExport'; $acl[$i]['ao_description']='Export data';
			$i++;$acl[$i]['ao_name']='viewCatalogVideos'; $acl[$i]['ao_description']='Goods videos';
			$i++;$acl[$i]['ao_name']='deleteCatalogVideos'; $acl[$i]['ao_description']='Finally delete videos';
			$i++;$acl[$i]['ao_name']='deleteCatalogImages'; $acl[$i]['ao_description']='Finally delete images';
			$i++;$acl[$i]['ao_name']='deleteCatalogFields'; $acl[$i]['ao_description']='Finally delete group fields';
		} else {
			$i++;$acl[$i]['ao_name']='catalogModule'; $acl[$i]['ao_description']='Module access';
			$i++;$acl[$i]['ao_name']='viewCatalogGoods'; $acl[$i]['ao_description']='View goods';
			$i++;$acl[$i]['ao_name']='viewCatalogDownloadDemo'; $acl[$i]['ao_description']='Download demo files';
			$i++;$acl[$i]['ao_name']='viewCatalogVendors'; $acl[$i]['ao_description']='Vendors';
			$i++;$acl[$i]['ao_name']='viewCatalogManufacturers'; $acl[$i]['ao_description']='Manufacturers';
//			$i++;$acl[$i]['ao_name']='useCatalogToolbar'; $acl[$i]['ao_description']='Use catalog toolbar';
		}
		return 	$acl;
	}
}
?>