<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class confModelsitemap extends Model {
	public $map_messages="";
	private $crlf="";
	
	public function createMaps($_html_file, $_xml_file) {
		$this->crlf=chr(10).chr(13);
		$_br="<br />";
		$this->map_messages=""; $msg="";
		if (($_html_file)||($_xml_file)) {
			$linkarray=$this->getLinksArr();
			if ($_html_file) {
				$filemap=PATH_FRONT.DS.'sitemap.html';
				$maptext=$this->getSiteMapText($linkarray);
				$msg.="The file ".$filemap." successfully created.".$_br;
				$url="index.php?module=conf&task=showmap";
				clearstatcache();
				if (!($handle = fopen($filemap, "w"))) 		{ $msg.="Cannot open file (".$filemap.")".$_br; }
				elseif (fwrite($handle, $maptext) === FALSE)	{ $msg.="Cannot write to file (".$filemap.")".$_br; }
				else fclose($handle);
				if ($_xml_file) {
					$filemapxml=PATH_FRONT.DS.'sitemap.xml';
					$mapxml=$this->getSiteMapXML($linkarray);
					clearstatcache();
					if (!($handlexml = fopen($filemapxml, "w"))) 		{ $msg.="Cannot open file (".$filemapxml.")".$_br; }
					else {
						if (fwrite($handlexml, $mapxml) === FALSE)	{ $msg.="Cannot write to file (".$filemapxml.")".$_br; }
						else $msg.="The file ".$filemapxml." successfully created.".$_br;
						fclose($handlexml);
					}
				}
			}
		}
		$this->map_messages=$msg;
		return $this->map_messages;
	}
	function getLinksArr() {
		$_arr=array();
		$i=0;
		$arr_name=Module::getInstalledModules(true);
		foreach($arr_name as $module) {
			// на всякий случай проверяем существует ли модуль на фронте
			if (file_exists(PATH_FRONT_MODULES.$module.DS.'module.php')) Module::getInstance($module)->getLinksArray($i,$_arr);
		}
		return $_arr;
	}

	function getSiteMapText($module_arr)	{
		$html=HTMLControls::renderStaticHeader();
		if (count($module_arr)>0) {
//			$html.='<table class="sitemap">'.$this->crlf;
			foreach($module_arr as $module=>$linkarray) {
				if (count($linkarray)>0) {
					foreach($linkarray as $rec) {
//						$html.='<tr><th><a class="link_'.$module.'" href="'.$rec['link'].'" title="'.htmlspecialchars($rec['fullname']).'">'.htmlspecialchars($rec['name']).'</a></th></tr>'.$this->crlf;
						$html.='<p class="link_'.$module.'"><a href="'.$rec['link'].'" title="'.htmlspecialchars($rec['fullname'],ENT_COMPAT,"UTF-8",false).'">'.htmlspecialchars($rec['name'],ENT_COMPAT,"UTF-8",false).'</a></p>'.$this->crlf;
					}
				}
			}
//			$html.='</table>'.$this->crlf;
		}	
		$html.=HTMLControls::renderStaticFooter();
		return $html;
	}
	public function getSiteMapXML($module_arr){
		$_xml ='<?xml version="1.0" encoding="UTF-8"?>'.$this->crlf;
		$_xml.='<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:image="http://www.sitemaps.org/schemas/sitemap-image/1.1" xmlns:video="http://www.sitemaps.org/schemas/sitemap-video/1.1">'.$this->crlf;
		$date=Date::todaySQL();
		if (count($module_arr)>0) {
			foreach($module_arr as $module=>$linkarray) {
				if (count($linkarray)>0) {
					foreach($linkarray as $rec) {
						$_xml.="<url>".$this->crlf;
						$_xml.="<loc>".$rec['link']."</loc>".$this->crlf;
						$_xml.="<lastmod>".$date."</lastmod>".$this->crlf;
						$_xml.="<changefreq>weekly</changefreq>".$this->crlf;
						$_xml.="<priority>0.5</priority>".$this->crlf;
						$_xml.="</url>".$this->crlf;
					}
				}
			}
		}
		$_xml.='</urlset>';
	  return $_xml;
	}
}
?>