<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

$_activeTab=Request::getSafe("config","site"); ?>
<h4 class="title">
	<?php echo Text::_("System settings") ?>
</h4>
<div class="cpanel_conf clearfix">
	<div id="tab_switcher">
		<ul class="switcher" id="tabs">
			<?php foreach(ConfigTMPL::$_tabs as $_key=>$_val) {
				if ($_val[0]==$_activeTab) $_style=' current'; else $_style="";
				?>
			<li class="switcher<?php echo $_style; ?>"
				onclick="switchTab(this,<?php echo $_key; ?>);">
				<div class="switcher">
					<span class="pseudo-href"><?php echo Text::_($_val[1]); ?> </span>
				</div>
			</li>
			<?php }?>
		</ul>
	</div>
	<?php foreach(ConfigTMPL::$_tabs as $_key=>$_val) {
		if ($_val[0]==$_activeTab) $_style='style="display: block;"'; else $_style="";
		?>
	<div class="tab_body" id="tab_<?php echo $_key; ?>"
	<?php echo $_style?>>
		<form name="<?php echo $_val[0]?>Form" action="index.php"
			method="post">
			<input type="hidden" name="config" value="<?php echo $_val[0]?>" /> <input
				type="hidden" name="module" value="conf" /> <input type="hidden"
				name="task" value="saveConfig" />
			<?php
			$confTMPL_name=$_val[0]."ConfigTMPL";
			$confTMPL= new $confTMPL_name;
			$conf_name=$_val[0]."Config";
			echo '<table class="config clearfix">';
			foreach ($confTMPL->props as $_key=>$_val ) {
				$_cur_val = $confTMPL->getConfigVar($conf_name,$_key);
				$_source=false;
				$fld_id=$conf_name.$_key;
				echo '<tr>';
				echo '<td class="left">';
				echo HTMLControls::renderLabelField($fld_id, Text::_($_key));
				if(isset($_val[3]) && $_val[3]) echo HTMLControls::renderBalloonButton($_key." description");
				echo '</td>';
				echo '<td class="right">';
				switch($_val[0]) {
					case 'boolean':
						if ($_cur_val) $checked="checked=\"checked\""; else $checked="";
						echo '<input type="checkbox" id="'.$fld_id.'" value="1" name="'.$_key.'" '.$checked.' />';
						break;
					case 'integer':
					case 'float':
						echo '<input type="text" id="'.$fld_id.'" class="numeric" size="19" value="'.$_cur_val.'" name="'.$_key.'" />';
						break;
					case 'text':
						echo '<textarea id="'.$fld_id.'" name="'.$_key.'" cols="45" rows="6" >'.$_cur_val.'</textarea>';
						break;
					case 'string':
						echo '<input type="text" id="'.$fld_id.'" size="60" value="'.$_cur_val.'" name="'.$_key.'" />';
						break;
					case 'select':
						if (isset($_val[2])) {
							foreach($_val[2] as $key=>$val) $_val[2][$key]=Text::_($val);
							echo HTMLControls::renderSelect($_key,$fld_id, "", "", $_val[2], $_cur_val, 0,"",0);
						}
						break;
					case 'select_method':
						if (isset($_val[2])) {
							$method_array=explode("!!",$_val[2]);
							if (is_array($method_array) && count($method_array)){
								$class_func=explode("::",$method_array[0]);
								if (is_array($class_func) && count($class_func)>1){
									if (count($method_array)>1){
										$arr=call_user_func($class_func, $method_array[1]);
									} else {
										$arr=call_user_func($class_func);
									}
									echo HTMLControls::renderSelect($_key,$fld_id, false, false,  $arr, $_cur_val, 0,"",0);
								}
							}
						}
						break;
					case 'multiselect':
						if (isset($_val[2])) {
							echo HTMLControls::renderSelect($_key,$fld_id, "", "", $_val[2], $_cur_val, 0,"",5);
						}
						break;
					case 'multiselect_method':
						if (isset($_val[2])) {
							$method_array=explode("!!",$_val[2]);
							if (is_array($method_array) && count($method_array)){
								$class_func=explode("::",$method_array[0]);
								if (is_array($class_func) && count($class_func)>1){
									if (count($method_array)>1){
										$arr=call_user_func($class_func, $method_array[1]);
									} else {
										$arr=call_user_func($class_func);
									}
									echo HTMLControls::renderSelect($_key,$fld_id, false, false,  $arr, $_cur_val, 0,"",5);
								}
							}
						}
						break;
					case 'table_multiselect':
						if (isset($_val[2])) {
							$db=Database::getInstance();
							$db->setQuery($_val[2]);
							$_source=$db->loadObjectList();
							echo HTMLControls::renderSelect($_key,$fld_id, "fld_id", "fld_name", $_source, $_cur_val, 0,"",5);
						}
						break;
					case 'table_select':
						if (isset($_val[2])) {
							$db=Database::getInstance();
							$db->setQuery($_val[2]);
							$_source=$db->loadObjectList();
							echo HTMLControls::renderSelect($_key,$fld_id, "fld_id", "fld_name", $_source, $_cur_val, 0);
						}
						break;
					case 'folder':
						if (isset($_val[2])) {
							$_source=Files::getFolders(PATH_FRONT.DS.$_val[2],array(".svn",".",".."));
							echo HTMLControls::renderSelect($_key,$fld_id, 0, 'filename', $_source, $_cur_val, 0);
						}
						break;
					default:
						echo '&nbsp;';
				}
				echo '</td>';
				echo '</tr>';
			}
			echo '</table>';
			?>
			<div class="buttons">
				<input type="submit" class="commonButton"
					value="<?php echo Text::_('Apply'); ?>" /> <input type="submit"
					name="cancel_but" class="commonButton"
					value="<?php echo Text::_('Cancel'); ?>" />
			</div>
		</form>
	</div>
	<?php } ?>
</div>
