<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

?>
<div class="tablHeader"><?php echo Text::_("Package instalation and deleting"); ?></div>
<div class="installer tablBody">
	<div class="wide">
<?php 
		if (count($this->packages)) {
			echo "<table class=\"rounded-tbl\">";
			echo "<tr>";
			echo "<th>".Text::_("Package type")."</th>";
			echo "<th>".Text::_("Package name")."</th>";
			echo "<th>".Text::_("Version")."</th>";
			echo "<th>".Text::_("Description")."</th>";
			echo "<th>".Text::_("Author")."</th>";
			echo "<th>".Text::_("E-mail")."</th>";
			echo "<th>".Text::_("Site")."</th>";
			echo "<th>".Text::_("License")."</th>";
			echo "<th>".Text::_("Uninstall")."</th>";
			echo "</tr>";
			$crow = 0;
			foreach($this->packages as $package){
				$crow=abs($crow-1);
				$class="crow_".$crow;
				echo "<tr class=\"".$class."\">";
				echo "<td>".Text::_($package->c_type)."</td>";
				echo "<td class=\"package_name\">".$package->c_name."</td>";
				echo "<td class=\"package\">".$package->c_version."</td>";
 				echo "<td class=\"package\">".$package->c_description."</td>";
				echo "<td class=\"package\">".$package->c_author."</td>";
				if ($package->c_email) $link="<a href=\"mailto:".$package->c_email."\">".$package->c_email."</a>"; else $link="";
				echo "<td class=\"package\">".$link."</td>";
				if ($package->c_site) $link="<a target=\"_blank\" href=\"".$package->c_site."\">".$package->c_site."</a>"; else $link="";
				echo "<td class=\"package\">".$link."</td>";
				if ($package->c_license) $link="<a class=\"relpopupwt\" href=\"index.php?module=installer&option=ajax&task=readLicense&psid=".$package->c_id."\">".Text::_("Read")."</a>";	else $link=Text::_("Absent");
				echo "<td class=\"but\">".$link."</td>";
				$button="<a onclick=\"if (confirm('".Text::_("Do you want to delete")." ".Text::_($package->c_type)." ".$package->c_name." ?')) return true; else return false;\" href=\"index.php?module=installer&task=uninstall&psid=".$package->c_id."\">".Text::_("Uninstall")."</a>";
				echo "<td class=\"but\" width=\"10%\">".$button."</td>";
				echo "</tr>";
			}
			echo "</table>";
		}
?>
	</div>
</div>
<div class="installer">
	<div>
		<form action="index.php" method="post" enctype="multipart/form-data">
			<input type="hidden" name="option" value="module" />
			<input type="hidden" name="module" value="installer" />
			<input type="hidden" name="task" value="installFromFile" />
			<table class="rounded-tbl">
				<tr>
					<td><label for="packageFile"><?php echo Text::_("File"); ?>:</label>
					<input type="file" id="packageFile" name="packageFile" value="" size="135" /></td>
					<td width="5%"><input class="commonButton" type="submit" value="<?php echo Text::_("Upload and install"); ?>" /></td>
				</tr>
			</table>
		</form>
		<form action="index.php" method="post">
			<input type="hidden" name="option" value="module" />
			<input type="hidden" name="module" value="installer" />
			<input type="hidden" name="task" value="installFromFolder" />
			<table class="rounded-tbl">
				<tr>
					<td><label for="packagePath"><?php echo Text::_("Package path"); ?>:</label></td>
					<td><input type="text" id="packagePath" name="packagePath" value="" /></td>
					<td width="5%"><input class="commonButton" type="submit" value="<?php echo Text::_("Install"); ?>" /></td>
				</tr>
			</table>
		</form>
		<form action="index.php" method="post">
			<input type="hidden" name="option" value="module" />
			<input type="hidden" name="module" value="installer" />
			<input type="hidden" name="task" value="installFromURL" />
			<table class="rounded-tbl">
				<tr>
					<td><label for="packagePath"><?php echo Text::_("File"); ?>:</label></td>
					<td><input type="text" id="packageURL" name="packageURL" value="" /></td>
					<td width="5%"><input class="commonButton" type="submit" value="<?php echo Text::_("Download and install"); ?>" /></td>
				</tr>
			</table>
		</form>
	</div>
</div>
