<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class serviceControllerdefault extends SpravController {

	private $start_path=ALTADOC_UF_PATH;
	private $start_link=ALTADOC_UF;
	private static $_hiddenfiles=array('.', '..',	'.svn', 'index.php', 'index.html',	'.htaccess','.htpasswd','web.config');
	
	// @TODO Придумать что-то другое когда будут не только виджеты
	public function showCachemanager(){
		$this->checkACL("viewCacheManager");
		$folders=Files::getFolders(PATH_CACHE,self::$_hiddenfiles);
		$view=$this->getView();
		$view->assign("folders", $folders);
		if ($folders)	{
			foreach($folders as $folder) {
				$files=Files::getFiles(PATH_CACHE.$folder["filename"].DS,self::$_hiddenfiles);
				$view->assign($folder."_files", $files);
			}
		}
	}
	public function showUserFilter() {
		$view=$this->getView();
		$model=$this->getModel('cachemanager');
		$filtercount=$model->getFilterCount();
		$view->assign("filtercount", $filtercount);
	}
	public function clearUserFilter(){
		$view=$this->getView();
		$model=$this->getModel('cachemanager');
		$model->clearUserFilter(0);
		$this->setRedirect("index.php",Text::_('Cleared all filter records'));
	}
	
	public function deleteCacheFolder(){
		$this->checkACL("viewCacheManager");
		$folder=Request::getSafe("folder","");
		$files=Files::getFiles(PATH_CACHE.$folder.DS, self::$_hiddenfiles);
		if ($files){
			foreach ($files as $file){
				Files::delete(PATH_CACHE.$folder.DS.$file["filename"], true);
			}
		}
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=cachemanager", $msg);
	}
	public function deleteCacheFile(){
		$this->checkACL("viewCacheManager");
		$folder=Request::getSafe("folder","");
		$file=Request::getSafe("file","");
		if (Files::delete(PATH_CACHE.$folder.DS.$file, true)) $msg=Text::_("Operation complete");	
		else $msg=Text::_("File delete error");
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=cachemanager", $msg);
	}
	/* Резервное копирование таблиц БД */
	public function showDb(){
		$this->checkACL("viewDatabase");
		$backup_path=PATH_FRONT.".backup".DS;
		$view=$this->getView();
		switch($this->get('layout')) {
			case "export":
				$tables = Exporter::getInstance()->getTablesList();
				$view->assign("tables",$tables);
				$view->assign("backup_path", $backup_path);
				$file="dbexport_".date("Ymd")."_".date("Gi").".sql";
				$view->assign("file", $file);
			break;
			default:
				$files=Files::getFiles($backup_path);
				$view->assign("files", $files);
				$view->assign("backup_path", $backup_path);
			break;
 		}
		
	}
	public function exportTables() {
		$this->checkACL("viewDatabase");
		$backup_path=PATH_FRONT.".backup".DS;
		$file=Request::getSafe("file","");
		$model=Module::getInstance()->getModel('db');
		$model->backupDB($backup_path,$file);
		$msg=Text::_("Operation complete");
		$this->setRedirect("index.php?module=service&view=db", $msg);
	}
	public function deleteBackup() {
		$this->checkACL("viewDatabase");
		$backup_path=PATH_FRONT.".backup".DS;
		$file=Request::getSafe("file","");
		if (Files::delete($backup_path.$file, true)) $msg=Text::_("Operation complete");	
		else $msg=Text::_("File delete error");
		$this->setRedirect("index.php?module=service&view=db", $msg);
	}
	/* Медиа менеджер */
	public function startMediamanager($ajax=true) {
		if ($ajax) Portal::getInstance()->disableTemplate();
		$this->checkACL("viewMediamanager");
		$this->set('view','mediamanager',true);
		$model=Module::getInstance()->getModel();
		$return_element=Request::getSafe("ret_elem",""); // ид элемента в который вернуть значение
		$nfl=Request::getInt("nfl",1); // 0 - относительный путь файла 
		$folder=$model->parsePath("","",0);
		$files=$model->getFiles($folder);
		$view=$this->getView();
		$view->assign("folder",$folder);
		$view->assign("files",$files);
		$filepath = ALTADOC_UF_PATH.str_replace("/",DS,$folder);
		$view->assign("info_message","");
		$view->assign("error_class","");
		$view->assign("filepath",$filepath);
		$view->assign("is_ajax",$ajax);
		$view->assign("return_element",$return_element);
		$view->assign("nfl",$nfl);
		$view->renderFull ();
		$this->haltView();
	}
	public function showMediamanager() {
		$this->startMediamanager(false);
	}
	/* Медиа менеджер */
	public function startEditorFileBrowser($ajax=true) {
		if ($ajax) Portal::getInstance()->disableTemplate();
		if($this->checkACL("viewMediamanager",false)){
			$data=array();
			Event::raise("editor.mediamanager_params", array("file_browser_mode"=>"browser"), $data);
			if(array_key_exists("file_browser_path", $data) && is_file($data["file_browser_path"])){
				require_once($data["file_browser_path"]);
			}
		}
	}
	public function getLink() {
		$this->checkACL("viewMediamanager");
		Portal::getInstance()->disableTemplate();
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$ret_elem=Request::getSafe("ret_elem","");
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		$nfl=Request::getInt("nfl",1); // 0 - относительный путь файла 
		if (Files::validFileName($file)) {
			$filelink=$model->getFileLink($folder,$file,$nfl);
			if(!$filelink) echo Text::_("Link error"); 
			else {
				if (!$ret_elem) {
					if ($nfl) echo "<b>".Text::_("Full file link").": </b>";
					else  echo "<b>".Text::_("Relative file link").": </b>";
				}
				echo $filelink;
			}
		} else echo Text::_("Wrong file name");
		Util::halt();
	}
	public function downloadFile() {
		$this->checkACL("viewMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		$href="index.php?module=service&view=mediamanager&folder=".$folder;
		if (Files::validFileName($file)) {
			$model->downloadFile($folder,$file,$href);
		} else {
			$this->setRedirect($href, Text::_("Wrong file name"));
		}
	}
	public function showMailerlog(){
		$this->showData();
	}
	public function cleanMailerlog(){
		$this->checkACL("viewServiceMailerlog");
		$model=Module::getInstance()->getModel("mailerlog");
		$model->cleanMailerlog();
		$this->showMailerlog();
	}
/**************************************************/
/*************** Ajax media manager ***************/	
/**************************************************/
	public function ajaxgetMediaContent($info_message="",	$is_error=false) {
		Portal::getInstance()->disableTemplate();
		$this->checkACL("viewMediamanager");
		$this->set('view','mediamanager',true);
		$model=Module::getInstance()->getModel();
		$folder=Request::getSafe("folder","");
		$goto=Request::getSafe("go_to","");
		$up=Request::getInt("is_up",0);
		$folder=$model->parsePath($folder,$goto,$up);
		$files=$model->getFiles($folder); 
		$view=$this->getView();
		$view->assign("folder",$folder);
		$view->assign("files",$files);
		$filepath = $this->start_path.str_replace("/",DS,$folder);
		$view->assign("filepath",$filepath);
		$view->assign("info_message",$info_message);
		if ($is_error) $view->assign("error_class","error_message");
		else $view->assign("error_class","");
		$view->render();
	}
	public function ajaxdeleteMediaFolder() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$dir=Request::getSafe("oldfolder","");
		$href="index.php?module=service&view=mediamanager&folder=".$folder;
		$error_message="";
		if (Files::validFolderName($dir)) {
			$folder=str_replace("/",DS,$folder);
			if (!$dir) $error_message = Text::_("Folder delete error")." : ".$dir;
			else {
				if ($folder) $_dir = $this->start_path.DS.$folder.DS.$dir;
				else $_dir = $this->start_path.DS.$dir;
				if(is_dir($_dir)){
					if (Files::folderIsEmpty($_dir)) {
						if(rmdir($_dir)) {
							$error_message = Text::_("Folder deleted")." : ".$dir;
							$is_error=false;
						}	else $error_message = Text::_("Folder not deleted")." : ".$dir;
					} else $error_message = Text::_("Folder not empty")." : ".$dir;
				} else 	$error_message = Text::_("Folder not exists")." : ".$dir;
			}	
		} else {
			$error_message=Text::_("Wrong folder name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	public function ajaxcreateMediaFolder() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$dir=Request::getSafe("newfolder","");
		if (Files::validFolderName($dir)) {
			$folder=str_replace("/",DS,$folder);
			if ($folder) $_dir = $this->start_path.DS.$folder.DS.$dir;
			else $_dir = $this->start_path.DS.$dir;
			if(!is_dir($_dir)){
				if(!mkdir($_dir, 0755, true)) $error_message=Text::_("Folder not created")." : ".$dir;
			} else 	$error_message=Text::_("Folder already exists")." : ".$dir;
			$error_message=Text::_("Folder created")." : ".$dir;
			$is_error=false;
		} else {
			$error_message=Text::_("Wrong folder name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	public function ajaxdeleteMediaFile() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		$file=Request::getSafe("file","");
		if (Files::validFileName($file)) {
			if (in_array($file, self::$_hiddenfiles)) Util::redirect($href, Text::_("File not exists")." : ".$file);
			$folder=str_replace("/",DS,$folder);
			if (!$file) $error_message = Text::_("File delete error")." : ".$file;
			if ($folder) $fullname = $this->start_path.DS.$folder.DS.$file;
			else $fullname = $this->start_path.DS.$file;
			if(is_file($fullname)){
				if(unlink($fullname)) {
					$error_message = Text::_("File deleted")." : ".$file;
					$is_error=false;
				}
				else $error_message = Text::_("File not deleted")." : ".$file;
			} else $error_message = Text::_("File not exists")." : ".$file;
		} else {
			$error_message = Text::_("Wrong file name");
		}
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	
	public function ajaxcreateMedia() {
		$is_error=true;
		$this->checkACL("useMediamanager");
		$model=Module::getInstance()->getModel('mediamanager');
		$folder=Request::getSafe("folder",""); $goto=""; $up=0;
		$folder=$model->parsePath($folder,$goto,$up);
		
		$fieldname="up_file";
		if(isset($_FILES[$fieldname]['tmp_name'])) {
			Debugger::getInstance()->message('File uploaded. Type:'.$_FILES[$fieldname]['type'].'.  Name: '.$_FILES[$fieldname]['name']);
			if(is_uploaded_file($_FILES[$fieldname]['tmp_name'])) {
				if ($folder) $upload_dir = $this->start_path.DS.$folder;
				else $upload_dir = $this->start_path;
				if (is_dir($upload_dir)) {
					$file=$_FILES[$fieldname]['name'];
					if (Files::validFileName($file)) {
						if (in_array($file, self::$_hiddenfiles)) $error_message = Text::_("File allready exists")." : ".$file;
						$fullpath=$upload_dir.DS.$file;
						if (file_exists($fullpath)) {
							$error_message = Text::_("File allready exists")." : ".$file;
						} else {
							$tmp_name=$_FILES[$fieldname]['tmp_name'];
							$flag = copy($tmp_name,$fullpath);
							if($flag) { $error_message = Text::_("File uploaded")." : ".$file; $is_error=false; }
							else  $error_message = Text::_("Error copying file")." : ".$file;
						}
					} else $error_message = Text::_("Wrong file name");
				} else $error_message = Text::_("Folder not exists");
			} else $error_message = Text::_("File upload failed");
		} else $error_message = Text::_("File upload failed");
		$this->ajaxgetMediaContent($error_message,$is_error);
	}
	
/* updater */
	public function showUpdater() {
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$current_version=$model->checkNewVersion();
		$version=$model->getVersion();
		$view=$this->getView();
		$view->assign("current_version",$current_version);
		$view->assign("version",$version);
	}
	public function downloadUpdates() {
		ini_set('max_execution_time',"300");
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$current_version=$model->checkNewVersion();
		$version=$model->getVersion();
		if ($current_version>$version) {
			$view=$this->getView();
			if ($model->processPackage()) $view->setLayout('confirm');
			else $view->setLayout('updated');
			$view->assign('packagelog',$model->getLog());
			$view->render();
		} else {
			$this->setRedirect("index.php", Text::_("Your version is up-to-date"));
		}
	}
	public function applyUpdates() {
		ini_set('max_execution_time',"300");
		$this->checkACL("viewUpdater");
		$model=Module::getInstance()->getModel();
		$current_version=$model->checkNewVersion();
		$version=$model->getVersion();
		if ($current_version>$version) {
			$result=$model->processUpdates($current_version,$version);
			$view=$this->getView();
			$view->setLayout('updated');
			$view->assign('packagelog',$result);
			$view->render();
		} else {
			$this->setRedirect("index.php", Text::_("Your version is up-to-date"));
		}
	}
	
	public function showAclRules(){
		$model=$this->getModel();
		$view=$this->getView();
		$message=array();
		// проверка доступов к модулям системы для админа
		if($model->checkModulesAccess($message)){
			$model->checkModulesAcl($message);
		}
		$view->assign('message',$message);		
	}
}

?>