<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class serviceModelaclrules extends Model {

	public function checkModulesAccess(&$message) {
		$modules=Module::getInstalledModules();
		foreach($modules as $module) {
			$sql = "SELECT COUNT(ao_id) FROM #__acl_objects WHERE ao_name='".$module."Module' AND ao_module_name='".$module."' AND ao_is_admin=1";
			$this->_db->setQuery($sql);
			if(!$this->_db->LoadResult()) {
				$message[]=Text::_('Admin module access rule for module')." ".$module." ".Text::_("is absent");
				$sql = "INSERT INTO `#__acl_objects`
						(`ao_name`,`ao_module_name`,`ao_description`,`ao_is_admin`)
						VALUES ('".$module."Module','".$module."','Module access',1)";
				$this->_db->setQuery($sql);
				if(!$this->_db->query()) {
					$message[]=Text::_('Adding admin module access rule for module')." ".$module." ".Text::_("failed");
					return false;
				} else {
					$message[]=Text::_('Admin module access rule for module')." ".$module." ".Text::_("added");
				}
			}
		}
		if(count($message)){
			$message[]=Text::_('Check module access rules first');
			return false;
		} else return true;

	}

	public function checkModulesAcl(&$message) {
		$modules=Module::getInstalledModules();
		foreach($modules as $module) {
			// проверка админских прав для модуля
			$sql = "SELECT ao_name FROM #__acl_objects WHERE ao_module_name='".$module."' AND ao_is_admin=1";
			$this->_db->setQuery($sql);
			$res_db=$this->_db->LoadResultArray();
			$res_core=Module::getInstance($module)->getACLTemplate();
			if(count($res_core)) {
				foreach($res_core as $acl) 	{
					if(!in_array($acl['ao_name'], $res_db)) {
						$message[]=sprintf(Text::_('Admin rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("is absent");
						$sql = "INSERT INTO `#__acl_objects`
								(`ao_name`,`ao_module_name`,`ao_description`,`ao_is_admin`)
								VALUES ('".$acl['ao_name']."','".$module."','".$acl['ao_description']."',1)";
						$this->_db->setQuery($sql);
						if(!$this->_db->query()) {
							$message[]=sprintf(Text::_('Adding admin rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("failed");
						} else {
							$message[]=sprintf(Text::_('Admin rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("added");
						}
					}
				}
			}
			// проверка фронтовых прав для модуля
			$sql = "SELECT ao_name FROM #__acl_objects WHERE ao_module_name='".$module."' AND ao_is_admin=0";
			$this->_db->setQuery($sql);
			$res_db=$this->_db->LoadResultArray();
			$res_core=Module::getInstance($module)->getACLTemplate(false);
			if(count($res_core)) {
				foreach($res_core as $acl) {
					if(!in_array($acl['ao_name'], $res_db)) {
						$message[]=sprintf(Text::_('Front rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("is absent");
						$sql = "INSERT INTO `#__acl_objects`
								(`ao_name`,`ao_module_name`,`ao_description`,`ao_is_admin`)
								VALUES ('".$acl['ao_name']."','".$module."','".$acl['ao_description']."',0)";
						$this->_db->setQuery($sql);
						if(!$this->_db->query()) {
							$message[]=sprintf(Text::_('Adding front rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("failed");
						} else {
							$message[]=sprintf(Text::_('Front rule %s for module'),$acl['ao_name'])." ".$module." ".Text::_("added");
						}
					}
				}
			}
		}
	}
}
?>