<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class userControllerdefault extends SpravController {

	public function ajaxgetRegionSelector() {
		$psid=Request::getInt("psid");
		$ctrl_prefix=Request::getSafe("ctrl_pref","");
		echo Address::renderRegionSelector($psid,$ctrl_prefix);
	}

	public function ajaxgetTownSelector() {
		$psid=Request::getInt("psid");
		$ctrl_prefix=Request::getSafe("ctrl_pref","");
		echo Address::renderTownSelector($psid,$ctrl_prefix);
	}

	public function ajaxcheckField()  {
		$fld=Request::getSafe('fld');
		$val=Request::getSafe('val');
		$psid=Request::getInt('psid');
		switch($fld){
			case "u_login":
				if(!User::isUser($val,$psid))  echo "OK";  else  echo Text::_("Occupied");
				break;
			case "u_nickname":
				if(!User::isNickName($val,$psid))  echo "OK";  else  echo Text::_("Occupied");
				break;
			case "u_email":
				if(!User::isEmail($val,$psid))  echo "OK";  else  echo Text::_("Occupied");
				break;
		}
	}

	public function showUsers() {
		$this->showData();
	}

	public function showBlacklist() {
		$this->showData();
	}
	public function modifyBlacklist() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$reestr->set('task','saveBlacklist');
		parent::modify();
	}
	public function saveBlacklist() {
		parent::save();
	}

	public function showPanel(){
		$this->set('view','users',true);
		$this->showData();
	}

	public function save() {
		$mdl				= Module::getInstance();
		$moduleName	= $mdl->getName();
		$viewname 	= $this->getView()->getName();
		if (defined("_ADMIN_MODE")) $this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		else $this->checkACL("modify".ucfirst($mdl->getName()).ucfirst($viewname));

		$userId 				= Request::getInt('psid',0);
		$userLogin 			= Request::get('u_login','');
		$referral  			= Request::get('u_referral',0);
		$discount  			= Request::get('u_discount',0);
		$priceType  			= Request::get('u_pricetype',1);
		$userNickname 	= Request::get('u_nickname','');
		$userEmail	 		= Request::get('u_email','');
		$userPassword 	= Request::get('u_secret','');
		$userActivated 	= Request::getInt('u_activated');
		$userRole	 			= Request::getInt('u_role',User::getDefaultRole());

		$is_apply		= request::getSafe('apply',0);
		$multy_code	= request::getSafe('multy_code', 0);
		$layout			= request::getSafe('layout');
		$start			= request::getInt('start');
		$sort				= request::getSafe('sort');
		$orderby		= request::getSafe('orderby');
		if ($userLogin == '' || $userNickname == '' || $userEmail == '' || $userRole == 0) {
			$msg=Text::_('Not enough data');
		}	else {
			if ($userId) {
				// Edit user
				$res=User::saveUser($userId,$userLogin,$userNickname,$userEmail,$userRole,$userActivated,$discount,$priceType);
				if ($res) {
					if ($userPassword) User::setPassword($userId,$userPassword,$userLogin);
					$msg=Text::_('User saved');
				} else {
					$msg=Text::_('Save failed');
				}
			}	else {
				// New user
				if ($userPassword == '') {
					$msg=Text::_('Not enough data');
				} elseif (User::isUser($userLogin)) {
					$msg=Text::_('Login is reserved');
				}	else {
					$userId=User::addUser($userLogin,$userNickname,$userPassword,$userEmail,$userRole,"",$userActivated,$discount,$priceType);
					$msg=Text::_('User added');
				}
			}
		}
		if ($is_apply) $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&task=modify&psid='.$userId.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		else $url='index.php?module='.$moduleName.'&view='.$viewname.'&layout='.$layout.'&sort='.$sort.'&start='.$start.'&orderby='.$orderby.'&multy_code='.$multy_code;
		$this->setRedirect($url,$msg);
	}

	public function modify($ajaxModify=false){
		$mdl				= Module::getInstance();
		$moduleName	= $mdl->getName();
		$viewname 	= $this->getView()->getName();
		$this->checkACL("modify".ucfirst($mdl->getName()).ucfirst($viewname));
		parent::modify($ajaxModify);
	}
	public function modifyProfile() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$reestr->set('task','saveProfile');
		parent::modify();
	}

	public function saveProfile() {
		parent::save();
	}

	public function activityUser()
	{
		$userId=$this->getPsid();
		$model=$this->getModel();
		$view=$this->getView();
		// активность в статьях


		// активность в голосованиях


		// активность в форумах
		$view->assign('$act_forums',$model->getForumInfo($userId));

		// активность в комментариях

		// активность в блогах

		// активность в ЖКХ



		echo $userId;
	}
}
?>