<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class adminmenuWidget extends Widget {
	private $max_levels = 5;
	private $all_res = "";
	private $tree_level = 0;
	private $html = "";

	public function render() {
		Portal::getInstance()->addStyleSheet("dropdown.css",true); // вызывать из виджета надо
		$this->buildTreeArrays();
		if (siteConfig::$treeDepth) $this->max_levels=(int)siteConfig::$treeDepth;

		$this->html=""; $this->tree_level=0;
		$parents_arr=preg_split('/(\,)/', 0);
		$this->drawTreeLevelUL ($parents_arr,"adm");
/*
		$menuHTML ="<ul class=\"mnu\" id=\"adminhome\">
									<li><a href=\"".Router::_("index.php?module=conf")."\">".Text::_('CPanel')."</a></li>
								</ul>";
*/
		$menuHTML = $this->renderMenu();
		$menuHTML = "<div id=\"".$this->get('menu_divId','stdmenu')."\">".$menuHTML."</div>";
		return $menuHTML;
	}

	private function drawTreeLevelUL($parent_id, $ul_id) {
		$item_drawed=0; $this->tree_level++;
		if (count($this->all_res)){
			foreach($this->all_res as $res_row) {
				if (in_array($res_row->mnu_parent_id,$parent_id)) {
					if (!$item_drawed) {
						if ($ul_id) $this->html.= '<ul class="mnu">';
						else $this->html.= '<ul>';
						$item_drawed=1;
					}
					//if (!$res_row->mnu_enabled) $class=" class=\"disabled\""; else
					$class="";
					$this->html.= '<li>';
					if ($res_row->mnu_link) $href=Router::_($res_row->mnu_link);
					else {
						$href="index.php?";
					}
					//if ($res_row->mnu_target) $target="target=\"".$res_row->mnu_target."\""; else
					$target="";
					$this->html.= '<a href="'.$href.'" '.$target.'>'.Text::_($res_row->mnu_name).'</a>';
					$parents_arr=preg_split('/(\,)/', $res_row->mnu_id);
					if ($this->tree_level<$this->max_levels) $this->drawTreeLevelUL ( $parents_arr, 'tree-'.$res_row->mnu_id);
					$this->html.= '</li>';
				}
			}
		}
		$this->tree_level--;
		if ($item_drawed) $this->html.=  '</ul>';
	}

	private function buildTreeArrays( $max_levels=0) {
		if ($max_levels) $this->max_levels=(int)$max_levels;
		$sql = "SELECT * FROM #__admin_menus WHERE mnu_id>0 ORDER BY mnu_order,mnu_id";
		Database::getInstance()->setQuery($sql);
		$this->all_res=Database::getInstance()->loadObjectList();
	}
	private function renderMenu(){
	$result="<ul class=\"mnu\">";
	$result.= "<li><a href=\"#\">".Text::_("Service menu")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=service&amp;view=cachemanager")."\">".Text::_("Cache manager")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=service&amp;view=UserFilter")."\">".Text::_("Clear users filters")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=service&amp;view=aclrules")."\">".Text::_("Check ACL objects")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=service&amp;view=db&amp;")."\">".Text::_("DB Service")."</a></li>
								<li><a href=\"".Router::_("index.php?module=service&amp;")."\">".Text::_("Check for updates")."</a></li>
								<li><a href=\"".Router::_("index.php?module=installer")."\">".Text::_("Installer")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;task=pi&amp;")."\">".Text::_("PHP Info")."</a></li>
								<li><a href=\"".Router::_("index.php?module=service&amp;view=mailerlog&amp;")."\">".Text::_("Mailer log")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;task=createmap&amp;")."\">".Text::_("Site map create")."</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=sitemap&amp;")."\">".Text::_("Site map show")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>

<!--
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=metadata")."\">".Text::_("Metadata editor")."</a></li>
-->
								<li><a href=\"".Router::_("index.php?module=service&amp;view=mediamanager&amp;")."\">".Text::_("Media manager")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Configuration")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=config&amp;")."\">".Text::_("Settings")."</a></li>
								<li><a href=\"".Router::_("index.php?module=menus")."\">".Text::_("Menu editor")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=modules&amp;")."\">".Text::_("Modules")."</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=plugins&amp;")."\">".Text::_("Plugins")."</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=widgets&amp;")."\">".Text::_("Widgets")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=cladr&amp;")."\">".Text::_("Address classifier")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=currency&amp;")."\">".Text::_("Currencies")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=measures&amp;")."\">".Text::_("Measures")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;task=selectVisio&amp;")."\">".Text::_("Prepare visio")."</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=dopfields&amp;")."\">".Text::_("Additional fields")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=conf&amp;view=redirectlinks&amp;")."\">".Text::_("Redirect links")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("ACL")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=user&amp;")."\">".Text::_("Users")."</a></li>
								<li><a href=\"".Router::_("index.php?module=aclmgr&amp;view=roles&amp;")."\">".Text::_("Roles")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=user&amp;view=blacklist&amp;")."\">".Text::_("Blacklist")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Common content")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=article&amp;")."\">".Text::_("Articles")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=blog")."\">".Text::_("Blogs categories")."</a></li>
								<li><a href=\"".Router::_("index.php?module=blog&amp;view=list&amp;layout=all")."\">".Text::_("All blogs")."</a></li>
								<li><a href=\"".Router::_("index.php?module=blog&amp;view=rights&layout=rolesmap")."\">".Text::_("Rights map by roles")."</a></li>
								<li><a href=\"".Router::_("index.php?module=blog&amp;view=rights&layout=usersmap")."\">".Text::_("Rights map by users")."</a></li>
										</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Multimedia")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=gallery&amp;")."\">".Text::_("Image gallery")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=videoset&amp;")."\">".Text::_("Video gallery")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=acrm&amp;view=cats&amp;")."\">".Text::_("Banners categories")."</a></li>
								<li><a href=\"".Router::_("index.php?module=acrm&amp;view=clients&amp;")."\">".Text::_("Banners clients")."</a></li>
								<li><a href=\"".Router::_("index.php?module=acrm&amp;view=items&amp;layout=all&amp;")."\">".Text::_("ACRM")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Forum")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=forum")."\">".Text::_("Forum sections")."</a></li>
								<li><a href=\"".Router::_("index.php?module=forum&amp;view=rights&layout=rolesmap")."\">".Text::_("Rights map by roles")."</a></li>
								<li><a href=\"".Router::_("index.php?module=forum&amp;view=rights&layout=usersmap")."\">".Text::_("Rights map by users")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Comments")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=comments")."\">".Text::_("Comments groups")."</a></li>
								<li><a href=\"".Router::_("index.php?module=comments&amp;view=rights")."\">".Text::_("Rights map by roles")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Feedback")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=feedback&amp;view=messages")."\">".Text::_("Messages from site")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=polls&amp;")."\">".Text::_("Polls")."</a></li>
							</ul>
						</li>";
	$result.= "<li><a href=\"#\">".Text::_("Catalog")."</a>
							<ul class=\"mnu\">
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=goodsgroup&amp;")."\">".Text::_("Goods groups")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=goods")."\">".Text::_("Goods without groups")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=price")."\">".Text::_("Price list")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=orders&amp;")."\">".Text::_("Orders")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=vendor_cats&amp;")."\">".Text::_("Vendors categories")."</a></li>";
	if(catalogConfig::$multy_vendor)
		$result.= "<li><a href=\"".Router::_("index.php?module=catalog&amp;view=users&amp;")."\">".Text::_("Vendors links")."</a></li>";
	$result.= "<li><a href=\"".Router::_("index.php?module=catalog&amp;view=manufacturer_cats&amp;")."\">".Text::_("Manufacturers categories")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=deliverytypes&amp;")."\">".Text::_("Delivery types")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=paymenttypes&amp;")."\">".Text::_("Payment types")."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=taxes")."\">".Text::_("List of taxes")."</a></li>
								<li class=\"separator\"><a>&nbsp;</a></li>
<!--
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=xmlformat&amp;layout=fileselector")."\">".Text::_("Import catalog data")."</a></li>
-->
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=export")."\">".Text::_("Export catalog data")." (CSV)"."</a></li>
								<li><a href=\"".Router::_("index.php?module=catalog&amp;view=import")."\">".Text::_("Import catalog data")." (CSV)"."</a></li>
							</ul>
						</li>";
	$result.= "</ul>";

	if ($this->html) { $result.= $this->html; }

	return $result;
	}
}

?>