<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Installer extends Object {

	//---------- Singleton implementation ------------
	private static $_instance = null;
	private $_delimiter=null;

	public static function createInstance() {
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}

	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}
	//------------------------------------------------

	private $_existedCfg = "";

	private function __construct() {
		$this->initObj();
		$this->initializeRegistry();
		$this->prepare();
		
	}

	private function initializeRegistry() {
		$returnUrl	= Request::get('return_url','');
		if ($returnUrl != '') $returnUrl = base64_decode($returnUrl);
		else $returnUrl = 'index.php';
		$step = Request::getInt('step',0);
		$this->set('returnUrl',$returnUrl,true);
		$this->set('step',$step,true);
	}

	private function prepare() {
		//
	}

	private function initDB() {
		DatabaseConfig::$dbHost = Request::get('dbHost','');
		DatabaseConfig::$dbPort = Request::get('dbPort','');
		DatabaseConfig::$dbUser = Request::get('dbUser','');
		DatabaseConfig::$dbPassword = Request::get('dbPassword','');
		DatabaseConfig::$dbName = Request::get('dbName','');
		DatabaseConfig::$dbPrefix = Request::get('dbPrefix','');
		

		$db = Database::getInstance(false);
		
		if ($db->isConnected() == false) {
			Util::redirect("install.php?step=2&fail=1");
		}
		$this->_delimiter=$db->getDelimiter();
		return $db;
	}

	private function populateDatabase($db,$sqlfile,&$err_array) {
		if(!($buffer = file_get_contents($sqlfile))) return false; 
//		$queries = preg_split ("/[".self::$query_delimiter."]+/", $buffer);
		$queries = preg_split ("/".$this->_delimiter."/", $buffer);
		foreach ($queries as $query) {
			$query = trim($query);
			if ($query != '' && $query {0} != '#') {
				$db->setQuery($query);
				if (!$db->query()) {
					$err_array[]="<p class=\"sql_error\">"."SQL Error :".$db->getLastError()."</p>".$db->getQuery();
					return false;
				}
			}
		}
		return true;
	}

	private function getLicense() {
		$licPath = PATH_FRONT.'administrator'.DS."modules".DS.'help'.DS.'views'.DS.'template'.DS.'default'.DS.'license.php';
		require_once ($licPath);
	}

	private function writeConfig() {
		// database.php
		$siteCfgPath				= PATH_CONFIG.'site.php';
		$databaseCfgPath		= PATH_CONFIG.'database.php';
		$buffer = '<?php defined("_ALTADOC_VALID") or die("Access denied");
class DatabaseConfig {
	// Database configuration
	public static	'.'$'.'dbHost		= "'.DatabaseConfig::$dbHost.'";
	public static	'.'$'.'dbPort		= "'.DatabaseConfig::$dbPort.'";
	public static	'.'$'.'dbName		= "'.DatabaseConfig::$dbName.'";
	public static	'.'$'.'dbUser		= "'.DatabaseConfig::$dbUser.'";
	public static	'.'$'.'dbPassword	= "'.DatabaseConfig::$dbPassword.'";
	public static	'.'$'.'dbPrefix		= "'.DatabaseConfig::$dbPrefix.'";
	public static	'.'$'.'dbSecret		= "'.DatabaseConfig::$dbSecret.'";
	}
?>';
		$f = fopen($databaseCfgPath,"wt");
		if ($f) { fwrite($f,$buffer); fclose($f);	} else return false;

		// site.php
		$buffer = file_get_contents($siteCfgPath);
		$buffer = str_replace('###SITE_URL###',Request::get('siteUrl',''),$buffer);
		$buffer = str_replace('###SITE_PORT###',Request::get('sitePort',''),$buffer);
		$buffer = str_replace('###SITE_SSL_PORT###',Request::get('siteSSLPort',''),$buffer);
		$buffer = str_replace('###SITE_TITLE###',stripcslashes(Request::getSafe('siteTitle','')),$buffer);
		$buffer = str_replace('###SITE_TEMPLATE###',Request::get('siteTemplate','example'),$buffer);
		$f = fopen($siteCfgPath,"wt");
		if ($f) { fwrite($f,$buffer); fclose($f);	} else return false;
		return true;
	}

	public function render() {
		$step = $this->get('step');
		ob_start();
		include_once PATH_INSTALL.'wizard'.DS.'step'.$step.'.php';
		$stepHTML = ob_get_contents();
		ob_end_clean();

		include_once PATH_INSTALL.'template.php';
	}
}

?>