<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

// Check server settings
include_once PATH_PACKAGES.DS.'cms_core'.DS.'Util.php';
Util::checkServerSettings(true);

// Include loader
include_once PATH_PACKAGES.DS.'loader.php';

// CMS packages configuration
Loader::usePackage("cms_core");
Loader::usePackage("database");
Loader::usePackage("mvc_base");
Loader::usePackage("sprav");
Loader::usePackage("tools");

final class DatabaseConfig {
	public static $dbHost			= '';
	public static $dbPort			= '';
	public static $dbName			= '';
	public static $dbUser			= '';
	public static $dbPassword	= '';
	public static $dbPrefix		= '';
	public static	$dbSecret		= '';
}

class siteConfig {
	public static $debugMode		= false;
	public static $defaultLanguage	= 'ru';
	public static $siteDisabled		= false;
	public static $siteTemplate		= '';
	public static $def_account_bonus	= 0;
}
class seoConfig {
	public static $sefMode			= false;
//	public static $strictSefMode	= false;
}

// Set PHP interpreter parameters
ini_set('display_errors',0);		// Show errors
error_reporting(0);				// Report all errors

if (version_compare(phpversion(), '5.3.0', '<') == true)	error_reporting(E_ALL|E_STRICT);
else error_reporting(E_ALL|E_STRICT|E_DEPRECATED);

ini_set('memory_limit','64M');		// Limit memory to 64 megabytes
ini_set('max_execution_time','300');		// Limit memory to 64 megabytes

// Initialize system debugger
Debugger::createInstance();

// Setup locale (core config contains default language parameter)
siteConfig::$defaultLanguage = Request::get('lang','ru');
Util::setupLocale();

// Setup system localization
Text::setLanguage(siteConfig::$defaultLanguage);
Text::parse('debug');
Text::parse('install');

// Installer itself
require_once PATH_INSTALL.DS.'Installer.php';

Installer::getInstance()->render();

?>