SET NAMES 'UTF8'###qb_delimiter###
DROP TABLE IF EXISTS `#__acl_objects`###qb_delimiter###
CREATE TABLE `#__acl_objects` (
  `ao_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `ao_name` varchar(50) NOT NULL,
  `ao_module_name` varchar(25) NOT NULL DEFAULT 'common_rules',
  `ao_description` varchar(255) NOT NULL,
  `ao_is_admin` int(1) DEFAULT '0',
  PRIMARY KEY (`ao_id`),
  UNIQUE KEY `module_name` (`ao_name`,`ao_module_name`,`ao_is_admin`)
) ENGINE=MyISAM AUTO_INCREMENT=283 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__acl_roles`###qb_delimiter###
CREATE TABLE `#__acl_roles` (
  `ar_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `ar_name` varchar(50) NOT NULL,
  `ar_title` varchar(50) NOT NULL,
  `ar_admin` int(1) DEFAULT '0',
  `ar_active` int(1) NOT NULL DEFAULT '1',
  `ar_system` int(1) NOT NULL DEFAULT '1',
  `ar_deleted` int(1) DEFAULT '0',
  PRIMARY KEY (`ar_id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__acl_rules`###qb_delimiter###
CREATE TABLE `#__acl_rules` (
  `acl_object_id` int(11) NOT NULL,
  `acl_role_id` int(11) NOT NULL,
  `acl_access` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`acl_object_id`,`acl_role_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__addr_countries`###qb_delimiter###
CREATE TABLE `#__addr_countries` (
  `c_id` int(11) NOT NULL AUTO_INCREMENT,
  `c_name` varchar(64) NOT NULL,
  `c_alpha_2` varchar(2) NOT NULL,
  `c_alpha_3` varchar(3) NOT NULL,
  `c_descr` varchar(255) NOT NULL,
  `c_ordering` int(11) NOT NULL DEFAULT '100',
  `c_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `c_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`c_id`),
  UNIQUE KEY `alpha_2` (`c_alpha_2`),
  UNIQUE KEY `alpha_3` (`c_alpha_3`),
  KEY `idx_country_name` (`c_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__addr_regions`###qb_delimiter###
CREATE TABLE `#__addr_regions` (
  `r_id` int(11) NOT NULL AUTO_INCREMENT,
  `r_parent_id` int(11) NOT NULL DEFAULT '0',
  `r_name` varchar(64) NOT NULL,
  `r_ordering` int(11) NOT NULL DEFAULT '0',
  `r_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `r_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`r_id`),
  KEY `idx_country_id` (`r_parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__addr_towns`###qb_delimiter###
CREATE TABLE `#__addr_towns` (
  `t_id` int(11) NOT NULL AUTO_INCREMENT,
  `t_parent_id` int(11) NOT NULL DEFAULT '0',
  `t_name` varchar(64) NOT NULL,
  `t_long` float(14,7) NOT NULL DEFAULT '0.0000000',
  `t_lat` float(14,7) NOT NULL DEFAULT '0.0000000',
  `t_show_on_map` int(1) NOT NULL DEFAULT '0',
  `t_ordering` int(11) NOT NULL DEFAULT '0',
  `t_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `t_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__admin_menus`###qb_delimiter###
CREATE TABLE `#__admin_menus` (
  `mnu_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `mnu_parent_id` int(11) NOT NULL DEFAULT '0',
  `mnu_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `mnu_link` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `mnu_module` varchar(50) NOT NULL,
  `mnu_order` int(5) NOT NULL DEFAULT '0',
  PRIMARY KEY (`mnu_id`)
) ENGINE=MyISAM AUTO_INCREMENT=123 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__articles`###qb_delimiter###
CREATE TABLE `#__articles` (
  `a_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `a_parent_id` int(11) DEFAULT '0',
  `a_author_id` int(11) DEFAULT NULL,
  `a_date` datetime DEFAULT NULL,
  `a_title` varchar(200) DEFAULT NULL,
  `a_alias` varchar(255) DEFAULT NULL,
  `a_thumb` varchar(255) DEFAULT NULL,
  `a_text` longtext,
  `a_show_info` tinyint(1) NOT NULL DEFAULT '1',
  `a_show_in_contents` tinyint(1) NOT NULL DEFAULT '1',
  `a_show_childs` tinyint(1) NOT NULL DEFAULT '1',
  `a_show_title` tinyint(1) NOT NULL DEFAULT '1',
  `a_show_breadcrumb` tinyint(1) NOT NULL DEFAULT '1',
  `a_meta_title` varchar(250) NOT NULL DEFAULT '',
  `a_meta_description` varchar(250) NOT NULL DEFAULT '',
  `a_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  `a_rating` int(11) NOT NULL DEFAULT '0',
  `a_ordering` int(11) NOT NULL DEFAULT '0',
  `a_published` tinyint(1) NOT NULL DEFAULT '1',
  `a_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `a_title_thm` varchar(255) NOT NULL DEFAULT '',
  `a_alt_thm` varchar(255) NOT NULL DEFAULT '',
  `a_childs_order_by` varchar(25) NOT NULL DEFAULT 'a_ordering',
  `a_childs_order_dir` varchar(4) NOT NULL DEFAULT 'ASC',
  PRIMARY KEY (`a_id`)
) ENGINE=MyISAM AUTO_INCREMENT=98 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_hkvit`###qb_delimiter###
CREATE TABLE `#__atsj_hkvit` (
  `kh_id` int(11) NOT NULL AUTO_INCREMENT,
  `kh_lic_id` int(11) DEFAULT NULL,
  `kh_month` tinyint(2) DEFAULT NULL,
  `kh_year` int(4) DEFAULT NULL,
  `kh_number` varchar(20) DEFAULT NULL,
  `kh_poluchat` text,
  `kh_bank` text,
  `kh_plat` text,
  `kh_inn` varchar(12) DEFAULT NULL,
  `kh_kpp` varchar(9) DEFAULT NULL,
  `kh_addr` text,
  `kh_flat` varchar(20) DEFAULT NULL,
  `kh_square_1` float(15,2) DEFAULT '0.00',
  `kh_square_2` float(15,2) DEFAULT '0.00',
  `kh_people_1` tinyint(2) DEFAULT '0',
  `kh_people_2` tinyint(2) DEFAULT '0',
  `kh_message_1` text,
  `kh_message_2` text,
  `kh_debet` float(15,2) DEFAULT '0.00',
  `kh_debet_date` date DEFAULT NULL,
  `kh_cursum` float(15,2) DEFAULT '0.00',
  `kh_pay` float(15,2) DEFAULT '0.00',
  `kh_lgot` float(15,2) DEFAULT '0.00',
  `kh_peny` float(15,2) DEFAULT '0.00',
  `kh_itog` float(15,2) DEFAULT '0.00',
  PRIMARY KEY (`kh_id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_hkvit_tmp`###qb_delimiter###
CREATE TABLE `#__atsj_hkvit_tmp` (
  `kh_id` int(11) NOT NULL AUTO_INCREMENT,
  `l_link` int(11) DEFAULT NULL,
  `kh_lic_id` int(11) DEFAULT NULL,
  `kh_month` tinyint(2) DEFAULT NULL,
  `kh_year` int(4) DEFAULT NULL,
  `kh_number` varchar(20) DEFAULT NULL,
  `kh_poluchat` text,
  `kh_bank` text,
  `kh_plat` text,
  `kh_inn` varchar(12) DEFAULT NULL,
  `kh_kpp` varchar(9) DEFAULT NULL,
  `kh_addr` text,
  `kh_flat` varchar(20) DEFAULT NULL,
  `kh_square_1` float(15,2) DEFAULT '0.00',
  `kh_square_2` float(15,2) DEFAULT '0.00',
  `kh_people_1` tinyint(2) DEFAULT '0',
  `kh_people_2` tinyint(2) DEFAULT '0',
  `kh_message_1` text,
  `kh_message_2` text,
  `kh_debet` float(15,2) DEFAULT '0.00',
  `kh_debet_date` date DEFAULT NULL,
  `kh_cursum` float(15,2) DEFAULT '0.00',
  `kh_pay` float(15,2) DEFAULT '0.00',
  `kh_lgot` float(15,2) DEFAULT '0.00',
  `kh_peny` float(15,2) DEFAULT '0.00',
  `kh_itog` float(15,2) DEFAULT '0.00',
  PRIMARY KEY (`kh_id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_lic`###qb_delimiter###
CREATE TABLE `#__atsj_lic` (
  `l_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `l_uid` int(11) DEFAULT NULL,
  `l_lic` varchar(50) DEFAULT NULL,
  `l_fio` varchar(100) DEFAULT NULL,
  `l_addr` varchar(250) DEFAULT NULL,
  `l_flat` varchar(20) DEFAULT NULL,
  `l_debet` float(17,2) DEFAULT NULL,
  `l_enabled` tinyint(1) DEFAULT '1',
  `l_deleted` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`l_id`),
  UNIQUE KEY `lic` (`l_lic`),
  KEY `user` (`l_uid`),
  KEY `deleted` (`l_deleted`),
  KEY `enabled` (`l_enabled`)
) ENGINE=MyISAM AUTO_INCREMENT=86 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_lic_tmp`###qb_delimiter###
CREATE TABLE `#__atsj_lic_tmp` (
  `l_id` int(11) DEFAULT '0',
  `l_link` int(11) DEFAULT NULL,
  `l_uid` int(11) DEFAULT NULL,
  `l_mail` varchar(100) DEFAULT NULL,
  `l_lic` varchar(50) DEFAULT NULL,
  `l_fio` varchar(100) DEFAULT NULL,
  `l_addr` varchar(250) DEFAULT NULL,
  `l_flat` varchar(20) DEFAULT NULL,
  `l_debet` float(17,2) DEFAULT NULL,
  `l_enabled` tinyint(1) DEFAULT '1',
  KEY `user` (`l_uid`),
  KEY `enabled` (`l_enabled`),
  KEY `lic` (`l_lic`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_meter`###qb_delimiter###
CREATE TABLE `#__atsj_meter` (
  `cl_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `cl_type` tinyint(1) DEFAULT NULL,
  `cl_lic` int(11) DEFAULT NULL,
  `cl_name` varchar(50) DEFAULT NULL,
  `cl_nextcheck` date DEFAULT NULL,
  `cl_enabled` tinyint(1) DEFAULT '1',
  `cl_deleted` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`cl_id`),
  KEY `lic` (`cl_lic`),
  KEY `enabled` (`cl_enabled`),
  KEY `deleted` (`cl_deleted`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_meter_tmp`###qb_delimiter###
CREATE TABLE `#__atsj_meter_tmp` (
  `cl_id` int(11) DEFAULT '0',
  `l_link` int(11) DEFAULT '0',
  `cl_type` tinyint(1) DEFAULT NULL,
  `cl_lic` int(11) DEFAULT NULL,
  `cl_name` varchar(50) DEFAULT NULL,
  `cl_nextcheck` date DEFAULT NULL,
  `cl_enabled` tinyint(1) DEFAULT '1',
  `cl_deleted` tinyint(1) DEFAULT '0',
  KEY `lic` (`cl_lic`),
  KEY `enabled` (`cl_enabled`),
  KEY `deleted` (`cl_deleted`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_meter_val`###qb_delimiter###
CREATE TABLE `#__atsj_meter_val` (
  `cp_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `cp_meterid` int(11) DEFAULT NULL,
  `cp_month` tinyint(2) DEFAULT NULL,
  `cp_year` int(4) DEFAULT NULL,
  `cp_date` datetime NOT NULL,
  `cp_checked` tinyint(1) DEFAULT '0',
  `cp_val` float(17,4) NOT NULL DEFAULT '0.0000',
  `cp_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cp_id`),
  UNIQUE KEY `mmy` (`cp_meterid`,`cp_month`,`cp_year`),
  KEY `check` (`cp_checked`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_plat_tmp`###qb_delimiter###
CREATE TABLE `#__atsj_plat_tmp` (
  `p_id` int(11) DEFAULT NULL,
  `l_link` int(11) DEFAULT NULL,
  `p_licid` int(11) DEFAULT NULL,
  `p_month` tinyint(2) DEFAULT NULL,
  `p_year` int(4) DEFAULT NULL,
  `p_sum` float(15,2) DEFAULT NULL,
  `p_data` date DEFAULT NULL,
  `p_comment` text
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_tkvit`###qb_delimiter###
CREATE TABLE `#__atsj_tkvit` (
  `kt_id` int(11) NOT NULL AUTO_INCREMENT,
  `kt_kh_id` int(11) NOT NULL,
  `kt_name` varchar(200) NOT NULL,
  `kt_tarif` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_meter_1` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_meter_2` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_quantity` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_sum` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_lgota` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_lgota_k` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_recalc` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_itogo` float(15,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`kt_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__atsj_tkvit_tmp`###qb_delimiter###
CREATE TABLE `#__atsj_tkvit_tmp` (
  `kt_id` int(11) DEFAULT '0',
  `kt_kh_id` int(11) NOT NULL,
  `kt_name` varchar(200) NOT NULL,
  `kt_tarif` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_meter_1` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_meter_2` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_quantity` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_sum` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_lgota` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_lgota_k` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_recalc` float(15,2) NOT NULL DEFAULT '0.00',
  `kt_itogo` float(15,2) NOT NULL DEFAULT '0.00'
) ENGINE=MyISAM AUTO_INCREMENT=56 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__banners`###qb_delimiter###
CREATE TABLE `#__banners` (
  `b_id` int(11) NOT NULL AUTO_INCREMENT,
  `b_client_id` int(11) NOT NULL DEFAULT '0',
  `b_cat_id` int(10) unsigned NOT NULL DEFAULT '0',
  `b_name` varchar(255) NOT NULL DEFAULT '',
  `b_alias` varchar(255) NOT NULL DEFAULT '',
  `b_show_total` int(11) NOT NULL DEFAULT '0',
  `b_show_made` int(11) NOT NULL DEFAULT '0',
  `b_clicks` int(11) NOT NULL DEFAULT '0',
  `b_image` varchar(100) NOT NULL DEFAULT '',
  `b_target` varchar(200) NOT NULL DEFAULT '',
  `b_custom_code` text NOT NULL,
  `b_descr` text NOT NULL,
  `b_sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `b_ordering` int(11) NOT NULL DEFAULT '0',
  `b_width` int(4) NOT NULL DEFAULT '0',
  `b_height` int(4) NOT NULL DEFAULT '0',
  `b_publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `b_publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `b_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `b_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`b_id`),
  KEY `viewbanner` (`b_deleted`),
  KEY `idx_banner_catid` (`b_cat_id`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__banners_categories`###qb_delimiter###
CREATE TABLE `#__banners_categories` (
  `bc_id` int(11) NOT NULL AUTO_INCREMENT,
  `bc_name` varchar(255) NOT NULL DEFAULT '',
  `bc_descr` text NOT NULL,
  `bc_published` tinyint(1) NOT NULL DEFAULT '0',
  `bc_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`bc_id`),
  KEY `cat_idx` (`bc_published`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__banners_clients`###qb_delimiter###
CREATE TABLE `#__banners_clients` (
  `bcl_id` int(11) NOT NULL AUTO_INCREMENT,
  `bcl_name` varchar(255) NOT NULL DEFAULT '',
  `bcl_contact` varchar(255) NOT NULL DEFAULT '',
  `bcl_email` varchar(255) NOT NULL DEFAULT '',
  `bcl_info` text NOT NULL,
  `bcl_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `bcl_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`bcl_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blacklist`###qb_delimiter###
CREATE TABLE `#__blacklist` (
  `bl_id` int(11) NOT NULL AUTO_INCREMENT,
  `bl_val` varchar(255) NOT NULL,
  `bl_type` varchar(20) NOT NULL,
  `bl_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `bl_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`bl_id`),
  UNIQUE KEY `uni` (`bl_val`,`bl_type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs`###qb_delimiter###
CREATE TABLE `#__blogs` (
  `b_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `b_name` varchar(255) NOT NULL,
  `b_alias` varchar(255) NOT NULL DEFAULT '',
  `b_description` text,
  `b_meta_title` varchar(250) NOT NULL,
  `b_meta_description` varchar(250) NOT NULL,
  `b_meta_keywords` varchar(250) NOT NULL,
  `b_thumb` varchar(250) DEFAULT NULL,
  `b_title_thm` varchar(255) DEFAULT NULL,
  `b_alt_thm` varchar(255) DEFAULT NULL,
  `b_porder_by` varchar(25) NOT NULL DEFAULT 'p_date',
  `b_porder_dir` varchar(4) NOT NULL DEFAULT 'DESC',
  `b_corder_dir` varchar(4) NOT NULL DEFAULT 'ASC',
  `b_layout` varchar(20) NOT NULL DEFAULT 'default',
  `b_show_in_list` tinyint(1) NOT NULL DEFAULT '0',
  `b_post_rating` tinyint(1) NOT NULL DEFAULT '1',
  `b_comments_rating` tinyint(1) NOT NULL DEFAULT '1',
  `b_premoderated` tinyint(1) NOT NULL DEFAULT '0',
  `b_guieditor` tinyint(1) NOT NULL DEFAULT '1',
  `b_hide_properties` tinyint(1) NOT NULL DEFAULT '0',
  `b_hide_comments` tinyint(1) NOT NULL DEFAULT '0',
  `b_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `b_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`b_id`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_cats`###qb_delimiter###
CREATE TABLE `#__blogs_cats` (
  `bc_id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'ид группы',
  `bc_id_parent` int(10) NOT NULL DEFAULT '0' COMMENT 'ид родителя',
  `bc_name` varchar(50) NOT NULL DEFAULT '0' COMMENT 'наименование группы',
  `bc_alias` varchar(255) NOT NULL DEFAULT '',
  `bc_comment` text COMMENT 'описание группы',
  `bc_meta_title` varchar(250) NOT NULL,
  `bc_meta_description` varchar(250) NOT NULL,
  `bc_meta_keywords` varchar(250) NOT NULL,
  `bc_ordering` tinyint(5) NOT NULL DEFAULT '0',
  `bc_enabled` smallint(1) NOT NULL DEFAULT '1',
  `bc_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`bc_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_comments`###qb_delimiter###
CREATE TABLE `#__blogs_comments` (
  `cm_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `cm_post_id` int(11) DEFAULT NULL,
  `cm_parent_id` int(11) DEFAULT '0',
  `cm_author_id` int(11) DEFAULT NULL,
  `cm_date` datetime DEFAULT NULL,
  `cm_text` text,
  `cm_rating` int(5) DEFAULT '0',
  `cm_deleted` int(1) DEFAULT '0',
  PRIMARY KEY (`cm_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_links`###qb_delimiter###
CREATE TABLE `#__blogs_links` (
  `b_id` varchar(50) NOT NULL COMMENT 'код элемента',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `parent_id` int(10) NOT NULL DEFAULT '0' COMMENT 'ид группы',
  PRIMARY KEY (`b_id`,`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_posts`###qb_delimiter###
CREATE TABLE `#__blogs_posts` (
  `p_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_author_id` int(11) DEFAULT NULL,
  `p_blog_id` int(11) DEFAULT '0',
  `p_theme` varchar(250) DEFAULT NULL,
  `p_text` text,
  `p_date` datetime DEFAULT NULL,
  `p_touch_date` datetime DEFAULT NULL,
  `p_comments` int(8) DEFAULT '0',
  `p_rating` int(5) DEFAULT '0',
  `p_tags` tinytext,
  `p_enabled` tinyint(1) DEFAULT '0',
  `p_deleted` tinyint(1) DEFAULT '0',
  `p_closed` tinyint(1) DEFAULT '0',
  `p_thumb` varchar(250) DEFAULT NULL,
  `p_title_thm` varchar(250) DEFAULT NULL,
  `p_alt_thm` varchar(250) DEFAULT NULL,
  `p_meta_title` varchar(250) DEFAULT NULL,
  `p_meta_description` varchar(250) DEFAULT NULL,
  `p_meta_keywords` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`p_id`)
) ENGINE=MyISAM AUTO_INCREMENT=73 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_rights`###qb_delimiter###
CREATE TABLE `#__blogs_rights` (
  `b_id` int(11) DEFAULT NULL,
  `u_id` int(11) DEFAULT '0',
  `r_id` int(11) DEFAULT '0',
  `action` varchar(55) DEFAULT NULL,
  `flag` int(1) DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__blogs_tag_counts`###qb_delimiter###
CREATE TABLE `#__blogs_tag_counts` (
  `t_name` varchar(255) NOT NULL,
  `b_id` int(11) NOT NULL,
  `t_count` int(11) DEFAULT NULL,
  PRIMARY KEY (`t_name`,`b_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__bonus_list`###qb_delimiter###
CREATE TABLE `#__bonus_list` (
  `b_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `b_uid` int(11) DEFAULT NULL,
  `b_oper` int(11) DEFAULT NULL,
  `b_date` datetime DEFAULT NULL,
  `b_sum` int(11) DEFAULT NULL,
  PRIMARY KEY (`b_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__bonus_type`###qb_delimiter###
CREATE TABLE `#__bonus_type` (
  `b_id` int(10) DEFAULT NULL,
  `b_name` varchar(100) DEFAULT NULL,
  `b_price` int(4) DEFAULT NULL,
  `b_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `b_deleted` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__comms`###qb_delimiter###
CREATE TABLE `#__comms` (
  `cm_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `cm_grp_id` varchar(32) NOT NULL,
  `cm_obj_id` int(11) NOT NULL DEFAULT '0',
  `cm_parent_id` int(11) NOT NULL DEFAULT '0',
  `cm_uid` int(11) NOT NULL DEFAULT '0',
  `cm_nickname` varchar(32) NOT NULL,
  `cm_email` varchar(50) NOT NULL,
  `cm_date` datetime NOT NULL,
  `cm_ip` varchar(15) NOT NULL,
  `cm_title` varchar(250) NOT NULL,
  `cm_text` text NOT NULL,
  `cm_rating` int(5) NOT NULL DEFAULT '0',
  `cm_cat` int(5) DEFAULT NULL,
  `cm_type` int(11) NOT NULL DEFAULT '0',
  `cm_published` tinyint(1) NOT NULL DEFAULT '0',
  `cm_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cm_id`),
  KEY `mod_view_obj` (`cm_grp_id`,`cm_obj_id`),
  KEY `uid` (`cm_uid`)
) ENGINE=MyISAM AUTO_INCREMENT=142 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__comms_acl`###qb_delimiter###
CREATE TABLE `#__comms_acl` (
  `ca_grp_id` int(11) NOT NULL,
  `ca_r_id` int(11) NOT NULL DEFAULT '0',
  `ca_action` varchar(32) NOT NULL,
  `ca_flag` int(1) DEFAULT '0',
  PRIMARY KEY (`ca_grp_id`,`ca_r_id`,`ca_action`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__comms_cat`###qb_delimiter###
CREATE TABLE `#__comms_cat` (
  `cc_id` int(11) NOT NULL AUTO_INCREMENT,
  `cc_cgrp_id` int(11) DEFAULT NULL,
  `cc_title` varchar(150) NOT NULL,
  `cc_marker` int(5) DEFAULT NULL,
  `cc_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `cc_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cc_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__comms_grp`###qb_delimiter###
CREATE TABLE `#__comms_grp` (
  `cg_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `cg_title` varchar(150) NOT NULL,
  `cg_module` varchar(32) NOT NULL,
  `cg_view` varchar(32) NOT NULL,
  `cg_tablename` varchar(32) NOT NULL,
  `cg_list_limit` tinyint(3) NOT NULL DEFAULT '20',
  `cg_text_limit` int(3) NOT NULL DEFAULT '1000',
  `cg_bbcode` tinyint(1) NOT NULL DEFAULT '1',
  `cg_premoderate` tinyint(1) NOT NULL DEFAULT '0',
  `cg_mailmoder` tinyint(1) NOT NULL DEFAULT '0',
  `cg_vote_obj` tinyint(1) NOT NULL DEFAULT '0',
  `cg_vote_comms` tinyint(1) NOT NULL DEFAULT '0',
  `cg_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `cg_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cg_id`),
  UNIQUE KEY `module_view` (`cg_module`,`cg_view`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__comms_types`###qb_delimiter###
CREATE TABLE `#__comms_types` (
  `ct_id` int(11) NOT NULL AUTO_INCREMENT,
  `ct_cgrp_id` int(11) DEFAULT NULL,
  `ct_title` varchar(150) NOT NULL,
  `ct_class` tinyint(2) NOT NULL DEFAULT '1',
  `ct_marker` varchar(50) DEFAULT NULL,
  `ct_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `ct_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ct_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__config`###qb_delimiter###
CREATE TABLE `#__config` (
  `cfg_section` varchar(25) NOT NULL DEFAULT '',
  `cfg_key` varchar(255) NOT NULL,
  `cfg_value` text,
  PRIMARY KEY (`cfg_section`,`cfg_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__contr_acc`###qb_delimiter###
CREATE TABLE `#__contr_acc` (
  `u_id` int(11) NOT NULL AUTO_INCREMENT,
  `u_contraid` int(11) DEFAULT NULL,
  `u_bank` varchar(250) NOT NULL DEFAULT '-',
  `u_bik` varchar(20) NOT NULL DEFAULT '-',
  `u_rs` varchar(20) NOT NULL DEFAULT '-',
  `u_cs` varchar(20) NOT NULL DEFAULT '-',
  `u_default` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`u_id`),
  UNIQUE KEY `d_id` (`u_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__contra_categories`###qb_delimiter###
CREATE TABLE `#__contra_categories` (
  `c_id` int(11) NOT NULL AUTO_INCREMENT,
  `c_name` varchar(150) NOT NULL,
  `c_desc` text,
  `c_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`c_id`),
  KEY `idx_vendor_category_category_name` (`c_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__contra_link`###qb_delimiter###
CREATE TABLE `#__contra_link` (
  `u_id` int(11) NOT NULL COMMENT 'ид пользователя',
  `v_id` int(11) NOT NULL COMMENT 'ид контрагента',
  `role_id` tinyint(1) NOT NULL COMMENT 'ид роли продавца',
  `isvendor` tinyint(1) DEFAULT '0' COMMENT 'признак продавца',
  PRIMARY KEY (`u_id`,`v_id`,`role_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__contragents`###qb_delimiter###
CREATE TABLE `#__contragents` (
  `u_id` int(11) NOT NULL AUTO_INCREMENT,
  `u_name` varchar(250) DEFAULT '-',
  `u_postadress` text,
  `u_juradress` text,
  `u_phone` varchar(100) DEFAULT NULL,
  `u_fax` varchar(100) DEFAULT NULL,
  `u_email` varchar(100) DEFAULT NULL,
  `u_jrdoctype` varchar(200) DEFAULT NULL,
  `u_jrdepartment` varchar(200) DEFAULT NULL,
  `u_jrdocdate` date DEFAULT NULL,
  `u_inn` varchar(12) NOT NULL DEFAULT '-',
  `u_kpp` varchar(10) DEFAULT NULL,
  `u_ogrn` varchar(20) DEFAULT NULL,
  `u_default` tinyint(1) NOT NULL DEFAULT '0',
  `u_boss` varchar(50) DEFAULT NULL,
  `u_buh` varchar(50) DEFAULT NULL,
  `u_vendor` tinyint(1) DEFAULT '0' COMMENT 'признак продавца',
  `u_groupid` int(11) DEFAULT NULL,
  PRIMARY KEY (`u_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__contragents_links`###qb_delimiter###
CREATE TABLE `#__contragents_links` (
  `u_id` varchar(50) NOT NULL COMMENT 'код товара',
  `ordering` tinyint(3) NOT NULL DEFAULT '0',
  `parent_id` int(10) NOT NULL DEFAULT '0' COMMENT 'ид группы',
  PRIMARY KEY (`u_id`,`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__currency`###qb_delimiter###
CREATE TABLE `#__currency` (
  `c_id` int(11) NOT NULL AUTO_INCREMENT,
  `c_code` char(3) NOT NULL,
  `c_name` varchar(64) NOT NULL,
  `c_short_name` varchar(10) NOT NULL,
  `c_enabled` smallint(1) NOT NULL DEFAULT '0',
  `c_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`c_id`),
  UNIQUE KEY `c_code` (`c_code`),
  KEY `idx_currency_name` (`c_name`)
) ENGINE=MyISAM AUTO_INCREMENT=303 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__currency_rate`###qb_delimiter###
CREATE TABLE `#__currency_rate` (
  `cr_id` int(11) NOT NULL AUTO_INCREMENT,
  `c_id` int(11) NOT NULL,
  `c_datetime` datetime NOT NULL,
  `c_value` decimal(17,4) NOT NULL DEFAULT '1.0000',
  `c_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`cr_id`),
  KEY `idx_currency_name` (`c_datetime`)
) ENGINE=MyISAM AUTO_INCREMENT=147 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__dg_countries`###qb_delimiter###
CREATE TABLE `#__dg_countries` (
  `country_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_name` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`country_id`),
  KEY `idx_country_name` (`country_name`)
) ENGINE=MyISAM AUTO_INCREMENT=240 DEFAULT CHARSET=utf8 COMMENT='Country records'###qb_delimiter###


DROP TABLE IF EXISTS `#__dg_regions`###qb_delimiter###
CREATE TABLE `#__dg_regions` (
  `region_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_id` int(11) NOT NULL DEFAULT '1',
  `region_name` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`region_id`),
  KEY `idx_country_id` (`country_id`)
) ENGINE=MyISAM AUTO_INCREMENT=255 DEFAULT CHARSET=utf8 COMMENT='States that are assigned to a country'###qb_delimiter###


DROP TABLE IF EXISTS `#__dg_towns`###qb_delimiter###
CREATE TABLE `#__dg_towns` (
  `town_id` int(11) NOT NULL AUTO_INCREMENT,
  `country_id` int(11) NOT NULL DEFAULT '0',
  `region_id` int(11) NOT NULL DEFAULT '0',
  `town_name` varchar(64) NOT NULL DEFAULT '',
  `town_x` int(11) NOT NULL DEFAULT '0',
  `town_y` int(11) NOT NULL DEFAULT '0',
  `show_on_map` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`town_id`)
) ENGINE=MyISAM AUTO_INCREMENT=178 DEFAULT CHARSET=cp1251###qb_delimiter###


DROP TABLE IF EXISTS `#__feedback`###qb_delimiter###
CREATE TABLE `#__feedback` (
  `f_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `f_sender` varchar(255) NOT NULL,
  `f_uid` int(11) NOT NULL DEFAULT '0',
  `f_mail` varchar(50) NOT NULL,
  `f_ip` varchar(15) NOT NULL,
  `f_theme` varchar(255) NOT NULL,
  `f_text` text NOT NULL,
  `f_date` datetime NOT NULL,
  `f_sent` tinyint(1) NOT NULL DEFAULT '0',
  `f_read` tinyint(1) NOT NULL DEFAULT '0',
  `f_readdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `f_comments` text,
  `f_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`f_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__feedback_data`###qb_delimiter###
CREATE TABLE `#__feedback_data` (
  `obj_id` int(11) NOT NULL COMMENT 'ид объекта',
  `field_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ид поля свойства',
  `field_name` varchar(50) NOT NULL DEFAULT '' COMMENT 'название поля из метадаты',
  `field_value` text NOT NULL COMMENT 'поля свойства',
  PRIMARY KEY (`obj_id`,`field_name`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__fields_list`###qb_delimiter###
CREATE TABLE `#__fields_list` (
  `f_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'ид',
  `f_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'название параметра',
  `f_descr` varchar(255) DEFAULT NULL COMMENT 'Название поля',
  `f_default` text NOT NULL COMMENT 'значение по умолчанию',
  `f_type` mediumint(10) NOT NULL COMMENT 'тип параметра(связь)',
  `f_choices` text NOT NULL COMMENT 'если выбор, то список',
  `f_writeable` smallint(5) NOT NULL DEFAULT '90' COMMENT 'возможность изменять для роли',
  `f_required` smallint(1) NOT NULL DEFAULT '0',
  `f_deleted` smallint(1) NOT NULL DEFAULT '0' COMMENT 'признак выключения',
  `f_table` varchar(50) DEFAULT 'goods' COMMENT 'имя модуля в котором используем',
  `f_custom` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`f_id`),
  UNIQUE KEY `f_fieldname` (`f_name`,`f_table`),
  KEY `name` (`f_name`),
  KEY `disabled` (`f_deleted`),
  KEY `f_table` (`f_table`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8 PACK_KEYS=0###qb_delimiter###


DROP TABLE IF EXISTS `#__fields_type`###qb_delimiter###
CREATE TABLE `#__fields_type` (
  `t_id` int(10) NOT NULL,
  `t_val_type` varchar(50) NOT NULL COMMENT 'тип поля для кода',
  `t_input_type` varchar(50) NOT NULL,
  `t_name` varchar(50) NOT NULL COMMENT 'название типа'
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__filters`###qb_delimiter###
CREATE TABLE `#__filters` (
  `f_time` int(11) NOT NULL,
  `f_uid` varchar(50) NOT NULL DEFAULT '0' COMMENT 'ид пользователя',
  `f_module` varchar(30) NOT NULL DEFAULT '' COMMENT 'модуль',
  `f_view` varchar(30) NOT NULL DEFAULT '' COMMENT 'view(таблица)',
  `f_layout` varchar(30) NOT NULL DEFAULT '',
  `f_side` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0-front,1-admin',
  `f_key` varchar(20) NOT NULL DEFAULT '' COMMENT 'поле фильтра',
  `f_val` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`f_uid`,`f_module`,`f_view`,`f_layout`,`f_side`,`f_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 CHECKSUM=1 DELAY_KEY_WRITE=1 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__forum_posts`###qb_delimiter###
CREATE TABLE `#__forum_posts` (
  `p_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_author_id` int(11) NOT NULL,
  `p_theme_id` int(11) NOT NULL DEFAULT '0',
  `p_theme` varchar(250) NOT NULL,
  `p_text` text NOT NULL,
  `p_date` datetime NOT NULL,
  `p_touch_date` datetime NOT NULL,
  `p_ip` varchar(15) NOT NULL,
  `p_rating` int(11) NOT NULL DEFAULT '0',
  `p_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `p_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`p_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__forum_rights`###qb_delimiter###
CREATE TABLE `#__forum_rights` (
  `f_id` int(11) DEFAULT NULL,
  `u_id` int(11) DEFAULT '0',
  `r_id` int(11) DEFAULT '0',
  `action` varchar(55) DEFAULT NULL,
  `flag` int(1) DEFAULT '0'
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__forum_sections`###qb_delimiter###
CREATE TABLE `#__forum_sections` (
  `f_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `f_parent_id` int(11) NOT NULL,
  `f_name` varchar(255) NOT NULL,
  `f_description` text,
  `f_meta_title` varchar(250) NOT NULL,
  `f_meta_description` varchar(250) NOT NULL,
  `f_meta_keywords` varchar(250) NOT NULL,
  `f_layout` varchar(20) NOT NULL DEFAULT 'default',
  `f_show_in_list` tinyint(1) NOT NULL DEFAULT '0',
  `f_post_rating` tinyint(1) NOT NULL DEFAULT '1',
  `f_premoderated` tinyint(1) NOT NULL DEFAULT '0',
  `f_ordering` int(3) NOT NULL DEFAULT '0',
  `f_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `f_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`f_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__forum_tag_counts`###qb_delimiter###
CREATE TABLE `#__forum_tag_counts` (
  `t_name` varchar(255) NOT NULL,
  `theme_id` int(11) NOT NULL,
  `t_count` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_name`,`theme_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__forum_themes`###qb_delimiter###
CREATE TABLE `#__forum_themes` (
  `t_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `t_author_id` int(11) NOT NULL,
  `t_forum_id` int(11) NOT NULL DEFAULT '0',
  `t_theme` varchar(250) NOT NULL,
  `t_text` text NOT NULL,
  `t_date` datetime NOT NULL,
  `t_touch_date` datetime NOT NULL,
  `t_rating` int(11) NOT NULL DEFAULT '0',
  `t_tags` tinytext NOT NULL,
  `t_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `t_ip` varchar(15) NOT NULL,
  `t_views` int(11) NOT NULL DEFAULT '0',
  `t_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `t_fixed` tinyint(1) NOT NULL DEFAULT '0',
  `t_closed` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__galleries`###qb_delimiter###
CREATE TABLE `#__galleries` (
  `g_id` int(11) NOT NULL AUTO_INCREMENT,
  `g_alias` varchar(255) NOT NULL DEFAULT '',
  `g_group_id` int(11) NOT NULL DEFAULT '0',
  `g_title` varchar(250) NOT NULL DEFAULT '',
  `g_thumb` varchar(64) NOT NULL DEFAULT '',
  `g_comment` text,
  `g_ordering` int(11) NOT NULL DEFAULT '0',
  `g_show_in_list` tinyint(1) NOT NULL DEFAULT '1',
  `g_hide_image_titles` tinyint(1) NOT NULL DEFAULT '0',
  `g_published` tinyint(1) NOT NULL DEFAULT '1',
  `g_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `g_alt_thm` varchar(255) DEFAULT NULL,
  `g_title_thm` varchar(255) DEFAULT NULL,
  `g_meta_title` varchar(250) NOT NULL DEFAULT '',
  `g_meta_description` varchar(250) NOT NULL DEFAULT '',
  `g_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`g_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__gallery_groups`###qb_delimiter###
CREATE TABLE `#__gallery_groups` (
  `gr_id` int(11) NOT NULL AUTO_INCREMENT,
  `gr_alias` varchar(255) NOT NULL DEFAULT '',
  `gr_title` varchar(250) NOT NULL DEFAULT '',
  `gr_thumb` varchar(64) NOT NULL DEFAULT '',
  `gr_comment` text,
  `gr_ordering` int(11) NOT NULL DEFAULT '0',
  `gr_show_in_list` tinyint(1) NOT NULL DEFAULT '1',
  `gr_published` tinyint(1) NOT NULL DEFAULT '1',
  `gr_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `gr_title_thm` varchar(255) DEFAULT NULL,
  `gr_alt_thm` varchar(255) DEFAULT NULL,
  `gr_meta_title` varchar(250) NOT NULL DEFAULT '',
  `gr_meta_description` varchar(250) NOT NULL DEFAULT '',
  `gr_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`gr_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__gallery_images`###qb_delimiter###
CREATE TABLE `#__gallery_images` (
  `gi_id` int(11) NOT NULL AUTO_INCREMENT,
  `gi_gallery_id` int(4) DEFAULT NULL,
  `gi_title` varchar(200) DEFAULT NULL,
  `gi_image` varchar(64) DEFAULT NULL,
  `gi_thumb` varchar(64) DEFAULT NULL,
  `gi_comment` text,
  `gi_published` tinyint(1) DEFAULT '0',
  `gi_ordering` int(11) NOT NULL DEFAULT '0',
  `gi_deleted` tinyint(1) DEFAULT '0',
  `gi_title_img` varchar(255) DEFAULT NULL,
  `gi_alt_img` varchar(255) DEFAULT NULL,
  `gi_title_thm` varchar(255) DEFAULT NULL,
  `gi_meta_title` varchar(250) NOT NULL DEFAULT '',
  `gi_meta_description` varchar(250) NOT NULL DEFAULT '',
  `gi_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  `gi_alt_thm` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`gi_id`)
) ENGINE=MyISAM AUTO_INCREMENT=260 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods`###qb_delimiter###
CREATE TABLE `#__goods` (
  `g_id` int(11) NOT NULL AUTO_INCREMENT,
  `g_type` int(3) NOT NULL DEFAULT '1',
  `g_sku` varchar(50) NOT NULL COMMENT 'артикул товара',
  `g_name` varchar(150) NOT NULL DEFAULT '' COMMENT 'наименование',
  `g_alias` varchar(255) NOT NULL DEFAULT '',
  `g_fullname` varchar(255) NOT NULL DEFAULT '' COMMENT 'полное наименование',
  `g_stock` decimal(17,4) NOT NULL DEFAULT '0.0000' COMMENT 'остаток',
  `g_measure` int(11) NOT NULL DEFAULT '0' COMMENT 'ед.измерения',
  `g_pack_measure` int(11) NOT NULL DEFAULT '0' COMMENT 'ед измерения упаковки',
  `g_pack_koeff` decimal(11,4) NOT NULL DEFAULT '1.0000' COMMENT 'коэффициент ед.измерения в ед.упаковки',
  `g_height` decimal(11,3) NOT NULL DEFAULT '0.000' COMMENT 'высота',
  `g_width` decimal(11,3) NOT NULL DEFAULT '0.000' COMMENT 'ширина',
  `g_length` decimal(11,3) NOT NULL DEFAULT '0.000' COMMENT 'длина',
  `g_vmeasure` int(11) NOT NULL DEFAULT '0' COMMENT 'ед измерения объема',
  `g_weight` decimal(17,3) NOT NULL DEFAULT '0.000' COMMENT 'вес',
  `g_wmeasure` int(11) NOT NULL DEFAULT '0' COMMENT 'ед измерения веса',
  `g_points` int(10) NOT NULL DEFAULT '0' COMMENT 'баллы',
  `g_currency` int(11) NOT NULL,
  `g_selltype` int(1) NOT NULL DEFAULT '0' COMMENT 'отпуск в единицах измерения',
  `g_price_1` decimal(19,2) NOT NULL DEFAULT '0.00' COMMENT 'Цена',
  `g_price_2` decimal(19,2) NOT NULL DEFAULT '0.00' COMMENT 'цена',
  `g_price_3` decimal(19,2) NOT NULL DEFAULT '0.00' COMMENT 'цена',
  `g_price_4` decimal(19,2) NOT NULL DEFAULT '0.00' COMMENT 'цена',
  `g_price_5` decimal(19,2) NOT NULL DEFAULT '0.00' COMMENT 'цена',
  `g_tax` int(11) NOT NULL DEFAULT '0' COMMENT 'ставка налога',
  `g_image` varchar(64) NOT NULL DEFAULT '' COMMENT 'изображение',
  `g_medium_image` varchar(64) NOT NULL DEFAULT '' COMMENT 'уменьшенное изображение',
  `g_thumb` varchar(64) NOT NULL DEFAULT '' COMMENT 'мини изображение',
  `g_comments` text COMMENT 'комментарий',
  `g_meta_title` varchar(250) NOT NULL DEFAULT '',
  `g_meta_description` varchar(250) NOT NULL DEFAULT '',
  `g_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  `g_enabled` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'включен',
  `g_deleted` smallint(1) NOT NULL DEFAULT '0' COMMENT 'помечен для удаления',
  `g_flypage` varchar(20) NOT NULL DEFAULT 'info' COMMENT 'шаблон страницы товара',
  `g_order_tmpl` varchar(30) NOT NULL DEFAULT '' COMMENT 'шаблон заказа товара',
  `g_is_single` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'один в заказе',
  `g_vendor` int(11) NOT NULL DEFAULT '0' COMMENT 'продавец товара',
  `g_manufacturer` int(11) NOT NULL DEFAULT '0' COMMENT 'товара',
  `g_file_demo` varchar(200) NOT NULL DEFAULT '' COMMENT 'демо файл для скачивания',
  `g_file` varchar(200) NOT NULL DEFAULT '' COMMENT 'файл для скачивания',
  `g_new` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'новинка',
  `g_hit` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'хит продаж',
  `g_change_date` datetime NOT NULL,
  `g_change_uid` int(11) NOT NULL DEFAULT '0',
  `g_title_img` varchar(255) DEFAULT NULL COMMENT 'тайтл основной картинки',
  `g_title_med` varchar(255) DEFAULT NULL COMMENT 'тайтл уменьшенного изображения',
  `g_title_thm` varchar(255) DEFAULT NULL COMMENT 'тайтл мини изображения',
  `g_alt_img` varchar(255) DEFAULT NULL COMMENT 'алт основной картинки',
  `g_alt_med` varchar(255) DEFAULT NULL COMMENT 'алт уменьшенного изображения картинки',
  `g_alt_thm` varchar(255) DEFAULT NULL COMMENT 'алт мини изображения картинки',
  PRIMARY KEY (`g_id`),
  UNIQUE KEY `goods_sku` (`g_sku`),
  KEY `goods_deleted` (`g_deleted`),
  KEY `goods_enabled` (`g_enabled`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_analogs`###qb_delimiter###
CREATE TABLE `#__goods_analogs` (
  `g_id` int(11) NOT NULL DEFAULT '0',
  `a_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`g_id`,`a_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_data`###qb_delimiter###
CREATE TABLE `#__goods_data` (
  `obj_id` int(11) NOT NULL COMMENT 'ид объекта',
  `field_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ид поля свойства',
  `field_name` varchar(50) NOT NULL DEFAULT '' COMMENT 'название поля из метадаты',
  `field_value` text NOT NULL COMMENT 'поля свойства',
  PRIMARY KEY (`obj_id`,`field_name`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_dts`###qb_delimiter###
CREATE TABLE `#__goods_dts` (
  `dt_id` int(11) NOT NULL AUTO_INCREMENT,
  `dt_name` varchar(150) NOT NULL,
  `dt_price` decimal(19,2) NOT NULL DEFAULT '0.00',
  `dt_weight_limit` decimal(19,2) NOT NULL DEFAULT '0.00',
  `dt_currency` int(11) NOT NULL,
  `dt_file` varchar(50) NOT NULL DEFAULT 'default',
  `dt_params` text NOT NULL,
  `dt_comments` text,
  `dt_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `dt_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`dt_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_dts_links`###qb_delimiter###
CREATE TABLE `#__goods_dts_links` (
  `dt_id` varchar(50) NOT NULL COMMENT 'код товара',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `parent_id` int(10) NOT NULL DEFAULT '0' COMMENT 'ид группы',
  PRIMARY KEY (`dt_id`,`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_feedbacks`###qb_delimiter###
CREATE TABLE `#__goods_feedbacks` (
  `gf_id` int(11) NOT NULL AUTO_INCREMENT,
  `gf_date` datetime NOT NULL,
  `gf_goods_id` int(11) NOT NULL COMMENT 'код товара',
  `gf_userid` int(11) NOT NULL DEFAULT '0',
  `gf_username` varchar(50) NOT NULL,
  `gf_usermail` varchar(50) NOT NULL,
  `gf_userip` varchar(15) NOT NULL,
  `gf_rating` int(11) NOT NULL DEFAULT '3',
  `gf_merits` text NOT NULL,
  `gf_demerits` text NOT NULL,
  `gf_published` int(1) NOT NULL DEFAULT '0',
  `gf_deleted` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`gf_id`),
  UNIQUE KEY `mail_goods` (`gf_goods_id`,`gf_usermail`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_group`###qb_delimiter###
CREATE TABLE `#__goods_group` (
  `ggr_id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'ид группы',
  `ggr_id_parent` int(10) NOT NULL DEFAULT '0' COMMENT 'ид родителя',
  `ggr_name` varchar(150) NOT NULL DEFAULT '' COMMENT 'наименование группы',
  `ggr_alias` varchar(255) NOT NULL,
  `ggr_thumb` varchar(64) NOT NULL COMMENT 'мини изображение',
  `ggr_comment` text COMMENT 'описание группы',
  `ggr_meta_title` varchar(250) NOT NULL DEFAULT '',
  `ggr_meta_description` varchar(250) NOT NULL DEFAULT '',
  `ggr_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  `ggr_ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'порядок сортировки',
  `ggr_list_tmpl` varchar(50) NOT NULL COMMENT 'темплейт категории',
  `ggr_enabled` smallint(1) NOT NULL DEFAULT '1' COMMENT 'включен',
  `ggr_deleted` smallint(1) NOT NULL DEFAULT '0' COMMENT 'помечен для удаления',
  `ggr_title_thm` varchar(255) DEFAULT NULL,
  `ggr_alt_thm` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ggr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_group_data`###qb_delimiter###
CREATE TABLE `#__goods_group_data` (
  `obj_id` int(11) NOT NULL COMMENT 'ид объекта',
  `field_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ид поля свойства',
  `field_name` varchar(50) NOT NULL COMMENT 'название поля из метадаты',
  `field_value` text NOT NULL COMMENT 'поля свойства',
  PRIMARY KEY (`obj_id`,`field_name`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_group_fields`###qb_delimiter###
CREATE TABLE `#__goods_group_fields` (
  `f_id` int(11) NOT NULL DEFAULT '0',
  `parent_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) DEFAULT '0',
  PRIMARY KEY (`f_id`,`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_img`###qb_delimiter###
CREATE TABLE `#__goods_img` (
  `i_id` int(11) NOT NULL AUTO_INCREMENT,
  `i_gid` int(11) NOT NULL,
  `i_type` tinyint(3) NOT NULL,
  `i_link` varchar(250) NOT NULL,
  `i_title` varchar(250) NOT NULL,
  `i_image` varchar(64) NOT NULL,
  `i_thumb` varchar(64) NOT NULL,
  `i_ordering` int(11) NOT NULL,
  `i_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `i_deleted` smallint(1) NOT NULL DEFAULT '0',
  `i_alt_img` varchar(255) DEFAULT NULL COMMENT 'алт картинки',
  `i_alt_thm` varchar(255) DEFAULT NULL COMMENT 'алт мини картинки',
  `i_title_thm` varchar(225) DEFAULT NULL COMMENT 'тайтл мини картинки',
  `i_title_img` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`i_id`),
  KEY `goods_deleted` (`i_deleted`),
  KEY `goods_enabled` (`i_enabled`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_import_tmp`###qb_delimiter###
CREATE TABLE `#__goods_import_tmp` (
  `id` int(11) NOT NULL DEFAULT '0',
  `f1` varchar(255) NOT NULL DEFAULT '',
  `f2` varchar(255) NOT NULL DEFAULT '',
  `f3` varchar(255) NOT NULL DEFAULT '',
  `f4` varchar(255) NOT NULL DEFAULT '',
  `f5` varchar(255) NOT NULL DEFAULT '',
  `f6` varchar(255) NOT NULL DEFAULT '',
  `f7` varchar(255) NOT NULL DEFAULT '',
  `f8` varchar(255) NOT NULL DEFAULT '',
  `f9` varchar(255) NOT NULL DEFAULT '',
  `f10` varchar(255) NOT NULL DEFAULT '',
  `f11` varchar(255) NOT NULL DEFAULT '',
  `f12` varchar(255) NOT NULL DEFAULT '',
  `f13` varchar(255) NOT NULL DEFAULT '',
  `f14` varchar(255) NOT NULL DEFAULT '',
  `f15` varchar(255) NOT NULL DEFAULT '',
  `f16` varchar(255) NOT NULL DEFAULT '',
  `f17` varchar(255) NOT NULL DEFAULT '',
  `f18` varchar(255) NOT NULL DEFAULT '',
  `f19` varchar(255) NOT NULL DEFAULT '',
  `f20` varchar(255) NOT NULL DEFAULT '',
  `f21` varchar(255) NOT NULL DEFAULT '',
  `f22` varchar(255) NOT NULL DEFAULT '',
  `f23` varchar(255) NOT NULL DEFAULT '',
  `f24` varchar(255) NOT NULL DEFAULT '',
  `f25` varchar(255) NOT NULL DEFAULT '',
  `f26` varchar(255) NOT NULL DEFAULT '',
  `f27` varchar(255) NOT NULL DEFAULT '',
  `f28` varchar(255) NOT NULL DEFAULT '',
  `f29` varchar(255) NOT NULL DEFAULT '',
  `f30` varchar(255) NOT NULL DEFAULT '',
  `f31` varchar(255) NOT NULL DEFAULT '',
  `f32` varchar(255) NOT NULL DEFAULT '',
  `f33` varchar(255) NOT NULL DEFAULT '',
  `f34` varchar(255) NOT NULL DEFAULT '',
  `f35` varchar(255) NOT NULL DEFAULT '',
  `f36` varchar(255) NOT NULL DEFAULT '',
  `f37` varchar(255) NOT NULL DEFAULT '',
  `f38` varchar(255) NOT NULL DEFAULT '',
  `f39` varchar(255) NOT NULL DEFAULT '',
  `f40` varchar(255) NOT NULL DEFAULT '',
  `f41` varchar(255) NOT NULL DEFAULT '',
  `f42` varchar(255) NOT NULL DEFAULT ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_links`###qb_delimiter###
CREATE TABLE `#__goods_links` (
  `g_id` int(11) NOT NULL COMMENT 'код товара',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `parent_id` int(10) NOT NULL DEFAULT '0' COMMENT 'ид группы',
  PRIMARY KEY (`g_id`,`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_opts`###qb_delimiter###
CREATE TABLE `#__goods_opts` (
  `go_id` int(11) NOT NULL AUTO_INCREMENT,
  `go_gid` int(11) NOT NULL,
  `go_fid` tinyint(3) NOT NULL,
  `go_title` varchar(250) NOT NULL,
  `go_ordering` int(11) NOT NULL,
  `go_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `go_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`go_id`),
  KEY `goods_deleted` (`go_deleted`),
  KEY `goods_enabled` (`go_enabled`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_opts_vals`###qb_delimiter###
CREATE TABLE `#__goods_opts_vals` (
  `v_id` int(11) NOT NULL AUTO_INCREMENT,
  `v_oid` tinyint(3) NOT NULL,
  `v_title` varchar(250) NOT NULL,
  `v_thumb` varchar(64) NOT NULL,
  `v_image` varchar(64) NOT NULL,
  `v_ordering` int(11) NOT NULL,
  `v_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `v_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`v_id`),
  KEY `goods_deleted` (`v_deleted`),
  KEY `goods_enabled` (`v_enabled`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_pts`###qb_delimiter###
CREATE TABLE `#__goods_pts` (
  `pt_id` int(11) NOT NULL AUTO_INCREMENT,
  `pt_name` varchar(150) NOT NULL,
  `pt_file` varchar(25) NOT NULL DEFAULT 'default',
  `pt_price` decimal(19,2) NOT NULL DEFAULT '0.00',
  `pt_currency` int(11) NOT NULL,
  `pt_params` text NOT NULL,
  `pt_comments` text,
  `pt_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `pt_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`pt_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_sets`###qb_delimiter###
CREATE TABLE `#__goods_sets` (
  `g_id` int(11) NOT NULL,
  `s_id` int(11) NOT NULL,
  `s_quantity` float(17,4) NOT NULL DEFAULT '0.0000',
  PRIMARY KEY (`g_id`,`s_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__goods_videos`###qb_delimiter###
CREATE TABLE `#__goods_videos` (
  `v_id` int(11) NOT NULL AUTO_INCREMENT,
  `v_gid` int(4) DEFAULT NULL,
  `v_title` varchar(200) DEFAULT NULL,
  `v_image` varchar(64) DEFAULT NULL,
  `v_title_img` varchar(255) DEFAULT NULL,
  `v_alt_img` varchar(255) DEFAULT NULL,
  `v_video_ogg` varchar(250) DEFAULT NULL,
  `v_video_mp4` varchar(250) DEFAULT NULL,
  `v_video_webm` varchar(250) DEFAULT NULL,
  `v_comment` text,
  `v_published` tinyint(1) DEFAULT '0',
  `v_ordering` int(11) NOT NULL DEFAULT '0',
  `v_deleted` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`v_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__install`###qb_delimiter###
CREATE TABLE `#__install` (
  `c_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `c_type` enum('module','widget','plugin','template','langpack') DEFAULT NULL,
  `c_name` varchar(255) DEFAULT NULL,
  `c_version` varchar(25) DEFAULT NULL,
  `c_description` varchar(255) DEFAULT NULL,
  `c_author` varchar(100) DEFAULT NULL,
  `c_email` varchar(100) DEFAULT NULL,
  `c_site` varchar(100) DEFAULT NULL,
  `c_license` text,
  `c_data` text,
  PRIMARY KEY (`c_id`),
  UNIQUE KEY `tn` (`c_type`,`c_name`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__kladr`###qb_delimiter###
CREATE TABLE `#__kladr` (
  `NAME` varchar(40) DEFAULT NULL,
  `SOCR` varchar(10) DEFAULT NULL,
  `CODE` varchar(17) NOT NULL DEFAULT '',
  `INDEX` varchar(6) DEFAULT NULL,
  `GNINMB` varchar(4) DEFAULT NULL,
  `UNO` varchar(4) DEFAULT NULL,
  `OCATD` varchar(11) DEFAULT NULL,
  `STATUS` varchar(1) DEFAULT NULL,
  PRIMARY KEY (`CODE`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__kladr_doma`###qb_delimiter###
CREATE TABLE `#__kladr_doma` (
  `NAME` varchar(40) DEFAULT NULL,
  `KORR` varchar(10) DEFAULT NULL,
  `SOCR` varchar(10) DEFAULT NULL,
  `CODE` varchar(19) DEFAULT NULL,
  `INDEX` varchar(6) DEFAULT NULL,
  `GNINMB` varchar(4) DEFAULT NULL,
  `UNO` varchar(4) DEFAULT NULL,
  `OCATD` varchar(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__kladr_socrbase`###qb_delimiter###
CREATE TABLE `#__kladr_socrbase` (
  `LEVEL` varchar(5) DEFAULT NULL,
  `SCNAME` varchar(10) DEFAULT NULL,
  `SOCRNAME` varchar(29) DEFAULT NULL,
  `KOD_T_ST` varchar(3) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__kladr_street`###qb_delimiter###
CREATE TABLE `#__kladr_street` (
  `NAME` varchar(40) DEFAULT NULL,
  `SOCR` varchar(10) DEFAULT NULL,
  `CODE` varchar(17) NOT NULL,
  `INDEX` varchar(6) DEFAULT NULL,
  `GNINMB` varchar(4) DEFAULT NULL,
  `UNO` varchar(4) DEFAULT NULL,
  `OCATD` varchar(11) DEFAULT NULL,
  `FULL_NAME` varchar(51) DEFAULT NULL,
  PRIMARY KEY (`CODE`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__link_gr_user`###qb_delimiter###
CREATE TABLE `#__link_gr_user` (
  `id_group` int(6) DEFAULT NULL,
  `id_user` int(11) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__mail`###qb_delimiter###
CREATE TABLE `#__mail` (
  `l_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `l_sender_id` int(11) DEFAULT NULL,
  `l_reciever_id` int(11) DEFAULT NULL,
  `l_theme` varchar(155) DEFAULT NULL,
  `l_text` text,
  `l_date` datetime DEFAULT NULL,
  `l_read` int(1) DEFAULT '0',
  `l_deleted_s` int(1) DEFAULT '0',
  `l_deleted_r` int(1) DEFAULT '0',
  PRIMARY KEY (`l_id`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__mailer_log`###qb_delimiter###
CREATE TABLE `#__mailer_log` (
  `email` varchar(50) DEFAULT NULL,
  `err_code` varchar(5) DEFAULT NULL,
  `err_time` datetime DEFAULT NULL,
  `m_theme` varchar(250) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__manufacturer_categories`###qb_delimiter###
CREATE TABLE `#__manufacturer_categories` (
  `mfc_id` int(11) NOT NULL AUTO_INCREMENT,
  `mfc_name` varchar(64) NOT NULL,
  `mfc_desc` text,
  `mfc_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`mfc_id`),
  KEY `idx_manufacturer_category_category_name` (`mfc_name`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Manufacturers are assigned to these categories'###qb_delimiter###


DROP TABLE IF EXISTS `#__manufacturers`###qb_delimiter###
CREATE TABLE `#__manufacturers` (
  `mf_id` int(11) NOT NULL AUTO_INCREMENT,
  `mf_cat_id` int(11) NOT NULL,
  `mf_name` varchar(150) NOT NULL,
  `mf_email` varchar(255) NOT NULL DEFAULT '',
  `mf_url` varchar(255) NOT NULL DEFAULT '',
  `mf_desc` text NOT NULL,
  `mf_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `mf_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`mf_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__md_btns`###qb_delimiter###
CREATE TABLE `#__md_btns` (
  `b_id` int(11) NOT NULL AUTO_INCREMENT,
  `b_hid` int(11) NOT NULL,
  `b_unique` tinyint(1) NOT NULL DEFAULT '0',
  `b_name` varchar(50) NOT NULL,
  `b_title` varchar(100) NOT NULL,
  `b_show` tinyint(1) NOT NULL DEFAULT '0',
  `b_module` varchar(50) NOT NULL,
  `b_view` varchar(50) NOT NULL,
  `b_layout` varchar(50) NOT NULL,
  `b_task` varchar(50) NOT NULL,
  `b_link` varchar(50) NOT NULL,
  `b_img` varchar(50) NOT NULL,
  PRIMARY KEY (`b_id`),
  UNIQUE KEY `btn_name` (`b_hid`,`b_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__md_flds`###qb_delimiter###
CREATE TABLE `#__md_flds` (
  `f_id` int(11) NOT NULL AUTO_INCREMENT,
  `f_hid` int(11) NOT NULL DEFAULT '0',
  `f_name` varchar(25) NOT NULL COMMENT 'field',
  `f_title` varchar(50) NOT NULL COMMENT 'field_title',
  `f_orderby` varchar(4) NOT NULL DEFAULT 'NONE' COMMENT 'field_orderby',
  `f_val_type` varchar(20) NOT NULL COMMENT 'val_type',
  `f_input_type` varchar(20) NOT NULL COMMENT 'input_type',
  `f_default_value` varchar(50) NOT NULL COMMENT 'default_value',
  `f_validate` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'check_value',
  `f_onchange_js` varchar(50) NOT NULL COMMENT 'field_on_change',
  `f_translate` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'translate_value',
  `f_no_update` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'field_no_update',
  `f_is_method` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'field_is_method',
  `f_ck_array` varchar(50) NOT NULL COMMENT 'ck_reestr',
  `f_ch_tablename` varchar(50) NOT NULL COMMENT 'ch_table',
  `f_ch_keystring` varchar(25) NOT NULL COMMENT 'ch_id',
  `f_ch_namestring` varchar(25) NOT NULL COMMENT 'ch_field',
  `f_ch_deleted` varchar(25) NOT NULL COMMENT 'ch_deleted',
  `f_ch_keysort` varchar(25) NOT NULL COMMENT 'ch_sort',
  `f_link` varchar(150) NOT NULL COMMENT 'link',
  `f_link_vars` varchar(100) NOT NULL COMMENT 'link_vars',
  `f_link_type` varchar(50) NOT NULL COMMENT 'link_types',
  `f_link_img` varchar(50) NOT NULL COMMENT 'link_picture',
  `f_upload_path` varchar(150) NOT NULL COMMENT 'upload_path',
  `f_ordering` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`f_id`),
  UNIQUE KEY `fld_name` (`f_hid`,`f_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__md_hdrs`###qb_delimiter###
CREATE TABLE `#__md_hdrs` (
  `h_id` int(11) NOT NULL AUTO_INCREMENT,
  `h_side` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0-admin,1-front',
  `h_module` varchar(50) NOT NULL,
  `h_view` varchar(50) NOT NULL,
  `h_layout` varchar(50) NOT NULL,
  `h_title` varbinary(255) NOT NULL COMMENT 'title',
  `h_table` varchar(50) NOT NULL COMMENT 'tablename',
  `h_is_tree` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'is_tree',
  `h_keystring` varchar(50) NOT NULL COMMENT 'keystring',
  `h_namestring` varchar(50) NOT NULL COMMENT 'namestring',
  `h_keycurrency` varchar(50) NOT NULL COMMENT 'keycurrency',
  `h_enabled` varchar(50) NOT NULL COMMENT 'enabled',
  `h_deleted` varchar(50) NOT NULL COMMENT 'deleted',
  `h_keysort` varchar(50) NOT NULL COMMENT 'keysort',
  `h_ordering_fld` varchar(50) NOT NULL COMMENT 'ordering_field',
  `h_ordering_parent` varchar(50) NOT NULL COMMENT 'ordering_parent',
  `h_show_cb` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'checkbox',
  `h_selector` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'selector',
  `h_multy_field` varchar(50) NOT NULL COMMENT 'multy_field',
  `h_l_tablename` varchar(50) NOT NULL COMMENT 'linktable',
  `h_p_tablename` varchar(50) NOT NULL COMMENT 'parent_table',
  `h_p_keystring` varchar(50) NOT NULL COMMENT 'parent_code',
  `h_p_namestring` varchar(50) NOT NULL COMMENT 'parent_name',
  `h_p_view` varbinary(50) DEFAULT NULL COMMENT 'parent_view',
  `h_tmpl_new` varchar(50) NOT NULL COMMENT 'templates[new]',
  `h_tmpl_modify` varchar(50) NOT NULL COMMENT 'templates[modify]',
  `h_custom_sql` text NOT NULL COMMENT 'custom_sql',
  PRIMARY KEY (`h_id`),
  UNIQUE KEY `smvl` (`h_side`,`h_module`,`h_view`,`h_layout`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__measure`###qb_delimiter###
CREATE TABLE `#__measure` (
  `meas_id` int(10) NOT NULL AUTO_INCREMENT,
  `meas_short_name` varchar(50) NOT NULL DEFAULT '0',
  `meas_full_name` varchar(100) NOT NULL DEFAULT '0',
  `meas_kf` float(19,4) NOT NULL DEFAULT '1.0000',
  `meas_type` tinyint(2) NOT NULL DEFAULT '0',
  `meas_comment` varchar(200) NOT NULL DEFAULT '0',
  `meas_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`meas_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__menus`###qb_delimiter###
CREATE TABLE `#__menus` (
  `mi_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `mi_parent_id` int(11) NOT NULL,
  `mi_name` varchar(100) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `mi_target` varchar(20) NOT NULL DEFAULT 'window',
  `mi_nofollow` tinyint(1) NOT NULL DEFAULT '0',
  `mi_link` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `mi_module` varchar(100) NOT NULL,
  `mi_view` varchar(100) NOT NULL,
  `mi_layout` varchar(100) NOT NULL,
  `mi_alias` varchar(250) NOT NULL,
  `mi_psid` int(11) NOT NULL DEFAULT '0',
  `mi_ordering` smallint(3) NOT NULL DEFAULT '10',
  `mi_custom_template` varchar(255) NOT NULL DEFAULT '',
  `mi_enabled` smallint(1) NOT NULL DEFAULT '1',
  `mi_deleted` smallint(1) NOT NULL DEFAULT '0',
  `mi_access` text NOT NULL COMMENT 'уровень доступа',
  PRIMARY KEY (`mi_id`),
  KEY `mi_deleted` (`mi_deleted`),
  KEY `mi_enabled` (`mi_enabled`)
) ENGINE=MyISAM AUTO_INCREMENT=149 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__metadata`###qb_delimiter###
CREATE TABLE `#__metadata` (
  `m_id` int(11) NOT NULL AUTO_INCREMENT,
  `m_module` varchar(30) NOT NULL,
  `m_view` varchar(30) NOT NULL,
  `m_field` varchar(30) NOT NULL,
  `m_layout` varchar(50) NOT NULL,
  `m_show` tinyint(1) DEFAULT '1',
  `m_width` varchar(10) DEFAULT NULL,
  `m_input_view` tinyint(1) DEFAULT '1',
  `m_input_size` varchar(10) DEFAULT NULL,
  `m_show_in_filter` tinyint(1) DEFAULT '1',
  `m_admin_side` tinyint(1) NOT NULL DEFAULT '0' COMMENT '0 - фронтенд, 1 - админка',
  `m_field_loaded` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'флаг для перечитки метадаты',
  `m_field_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`m_module`,`m_view`,`m_field`,`m_layout`,`m_admin_side`),
  UNIQUE KEY `m_id` (`m_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1390 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__modules`###qb_delimiter###
CREATE TABLE `#__modules` (
  `m_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `m_name` varchar(255) DEFAULT NULL,
  `m_show_breadcrumb` int(1) DEFAULT '1',
  `m_config` text,
  `m_incl_map` tinyint(1) NOT NULL DEFAULT '1',
  `m_deleted` int(1) DEFAULT '0',
  PRIMARY KEY (`m_id`)
) ENGINE=MyISAM AUTO_INCREMENT=34 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__notifications`###qb_delimiter###
CREATE TABLE `#__notifications` (
  `n_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `n_from` varchar(50) NOT NULL,
  `n_fromname` varchar(50) NOT NULL,
  `n_to` varchar(50) NOT NULL,
  `n_time` int(11) NOT NULL,
  `n_title` varchar(150) NOT NULL,
  `n_text` text NOT NULL,
  `n_format` varchar(5) NOT NULL,
  PRIMARY KEY (`n_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__orders`###qb_delimiter###
CREATE TABLE `#__orders` (
  `o_id` int(11) NOT NULL AUTO_INCREMENT,
  `o_date` date NOT NULL DEFAULT '2000-01-01',
  `o_uid` int(11) NOT NULL,
  `o_vendor` int(11) NOT NULL,
  `o_pt_id` int(11) NOT NULL,
  `o_pt_name` varchar(200) NOT NULL,
  `o_pt_data` text NOT NULL,
  `o_pt_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  `o_dt_id` int(11) NOT NULL,
  `o_dt_name` varchar(200) NOT NULL,
  `o_dt_data` text NOT NULL,
  `o_dt_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  `o_discount_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  `o_taxes_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  `o_total_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  `o_points` decimal(19,4) NOT NULL DEFAULT '0.0000',
  `o_currency` int(11) NOT NULL,
  `o_quantity` decimal(19,4) NOT NULL DEFAULT '0.0000',
  `o_measure` int(11) NOT NULL,
  `o_weight` decimal(19,4) NOT NULL DEFAULT '0.0000',
  `o_wmeasure` int(11) NOT NULL,
  `o_status` int(11) NOT NULL,
  `o_paid` smallint(1) NOT NULL DEFAULT '0',
  `o_ip_address` varchar(15) NOT NULL DEFAULT '',
  `o_comments` text NOT NULL,
  `o_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`o_id`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__orders_items`###qb_delimiter###
CREATE TABLE `#__orders_items` (
  `i_order_id` int(11) NOT NULL,
  `i_g_id` int(11) DEFAULT NULL,
  `i_g_sku` varchar(50) NOT NULL,
  `i_g_name` varchar(250) NOT NULL,
  `i_g_quantity` decimal(19,4) NOT NULL DEFAULT '0.0000',
  `i_g_measure` int(11) NOT NULL,
  `i_g_price` decimal(19,2) NOT NULL DEFAULT '0.00',
  `i_g_weight` decimal(19,2) NOT NULL DEFAULT '0.00',
  `i_g_wmeasure` int(11) NOT NULL,
  `i_g_tax` decimal(19,2) NOT NULL DEFAULT '0.00',
  `i_g_tax_name` varchar(150) NOT NULL,
  `i_g_sum` decimal(19,2) NOT NULL DEFAULT '0.00',
  KEY `i_goods_sku` (`i_g_sku`),
  KEY `i_order_id` (`i_order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__orders_links`###qb_delimiter###
CREATE TABLE `#__orders_links` (
  `o_id` int(11) DEFAULT NULL,
  `parent_id` int(11) DEFAULT NULL,
  `ordering` tinyint(2) DEFAULT NULL,
  UNIQUE KEY `o_id` (`o_id`,`parent_id`),
  UNIQUE KEY `o_pool` (`o_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__orders_payments`###qb_delimiter###
CREATE TABLE `#__orders_payments` (
  `payment_id` int(11) NOT NULL AUTO_INCREMENT,
  `payment_order_id` int(11) NOT NULL DEFAULT '0',
  `payment_method_id` int(11) DEFAULT NULL,
  `payment_code` varchar(30) NOT NULL DEFAULT '',
  `payment_number` blob,
  `payment_expire` int(11) DEFAULT NULL,
  `payment_name` varchar(255) DEFAULT NULL,
  `payment_log` text,
  `payment_trans_id` text NOT NULL,
  PRIMARY KEY (`payment_id`),
  KEY `idx_order_payment_order_id` (`payment_order_id`),
  KEY `idx_order_payment_method_id` (`payment_method_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='The payment method that was chosen for a specific order'###qb_delimiter###


DROP TABLE IF EXISTS `#__orders_status`###qb_delimiter###
CREATE TABLE `#__orders_status` (
  `os_id` int(11) NOT NULL AUTO_INCREMENT,
  `os_name` varchar(50) NOT NULL,
  `os_enabled` smallint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`os_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__plugins`###qb_delimiter###
CREATE TABLE `#__plugins` (
  `p_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_path` varchar(255) NOT NULL,
  `p_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL,
  `p_params` text NOT NULL,
  `p_ordering` int(3) NOT NULL DEFAULT '0',
  `p_enabled` int(1) NOT NULL DEFAULT '1',
  `p_deleted` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`p_id`)
) ENGINE=MyISAM AUTO_INCREMENT=51 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__poll_items`###qb_delimiter###
CREATE TABLE `#__poll_items` (
  `pi_id` int(11) NOT NULL AUTO_INCREMENT,
  `pi_poll_id` int(11) NOT NULL DEFAULT '0',
  `pi_text` varchar(255) NOT NULL,
  `pi_hits` int(11) NOT NULL DEFAULT '0',
  `pi_ordering` tinyint(3) NOT NULL DEFAULT '0',
  `pi_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`pi_id`),
  KEY `pollid` (`pi_poll_id`,`pi_text`(1))
) ENGINE=MyISAM AUTO_INCREMENT=48 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__poll_stats`###qb_delimiter###
CREATE TABLE `#__poll_stats` (
  `ps_voter` varchar(20) NOT NULL COMMENT 'Unique id of user(not u_id)',
  `ps_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ps_item_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ps_voter`,`ps_item_id`)
) ENGINE=MyISAM AUTO_INCREMENT=52 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__polls`###qb_delimiter###
CREATE TABLE `#__polls` (
  `p_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `p_title` varchar(255) NOT NULL,
  `p_alias` varchar(255) NOT NULL,
  `p_lag` int(11) NOT NULL DEFAULT '86400',
  `p_startdate` datetime NOT NULL,
  `p_enddate` datetime NOT NULL,
  `p_comments` text NOT NULL,
  `p_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `p_enabled` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`p_id`)
) ENGINE=MyISAM AUTO_INCREMENT=23 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__profiles`###qb_delimiter###
CREATE TABLE `#__profiles` (
  `pf_id` int(11) unsigned NOT NULL,
  `pf_deleted` int(1) DEFAULT '0',
  `pf_pollkey` varchar(20) DEFAULT NULL,
  `pf_age` varchar(3) DEFAULT NULL,
  `pf_sex` tinyint(1) DEFAULT NULL,
  `pf_site` varchar(50) DEFAULT NULL,
  `pf_icq` varchar(12) DEFAULT NULL,
  `pf_skype` varchar(50) DEFAULT NULL,
  `pf_jabber` varchar(50) DEFAULT NULL,
  `pf_img` varchar(250) DEFAULT NULL,
  `pf_text` text,
  PRIMARY KEY (`pf_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__profiles_data`###qb_delimiter###
CREATE TABLE `#__profiles_data` (
  `obj_id` varchar(50) NOT NULL COMMENT 'код товара',
  `field_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'ид поля свойства',
  `field_name` varchar(50) NOT NULL COMMENT 'название поля из метадаты',
  `field_value` text NOT NULL COMMENT 'поля свойства',
  PRIMARY KEY (`obj_id`,`field_name`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__redirect_links`###qb_delimiter###
CREATE TABLE `#__redirect_links` (
  `rl_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `rl_old_url` varchar(255) NOT NULL,
  `rl_new_url` varchar(255) NOT NULL,
  `rl_referer` varchar(150) NOT NULL,
  `rl_comment` varchar(255) NOT NULL,
  `rl_redirects` int(11) unsigned NOT NULL DEFAULT '0',
  `rl_published` tinyint(3) NOT NULL DEFAULT '1',
  `rl_deleted` tinyint(3) NOT NULL DEFAULT '0',
  `rl_create_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`rl_id`),
  UNIQUE KEY `idx_link_old` (`rl_old_url`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__rp_cross_post_regions`###qb_delimiter###
CREATE TABLE `#__rp_cross_post_regions` (
  `post_capital_from` varchar(100) NOT NULL,
  `post_capital_to` varchar(100) NOT NULL,
  `railway_km` int(11) NOT NULL,
  `total_km` int(11) NOT NULL,
  `km_verified` int(11) NOT NULL,
  `post_trunkzone` int(11) NOT NULL,
  `post_trunkzone_verified` int(11) NOT NULL,
  PRIMARY KEY (`post_capital_from`,`post_capital_to`),
  KEY `city_to` (`post_capital_to`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__rp_post_indexes`###qb_delimiter###
CREATE TABLE `#__rp_post_indexes` (
  `post_index` char(6) NOT NULL,
  `ems_location_code` varchar(255) NOT NULL,
  `post_capital_code` varchar(255) NOT NULL,
  PRIMARY KEY (`post_index`),
  KEY `ems_location_code` (`ems_location_code`),
  KEY `post_capital_code` (`post_capital_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__rp_post_regions`###qb_delimiter###
CREATE TABLE `#__rp_post_regions` (
  `post_capital_code` varchar(255) NOT NULL,
  `post_region_code` varchar(255) NOT NULL,
  `post_region_id` char(5) NOT NULL,
  `parcel_zone` varchar(6) NOT NULL,
  `railway_code` varchar(255) NOT NULL,
  PRIMARY KEY (`post_capital_code`),
  KEY `post_region_id` (`post_region_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__rp_shipping_restrictions`###qb_delimiter###
CREATE TABLE `#__rp_shipping_restrictions` (
  `post_index` varchar(6) NOT NULL,
  `ops_name` varchar(255) NOT NULL,
  `post_capital_code` varchar(255) NOT NULL,
  `ems_location_code` varchar(255) NOT NULL,
  PRIMARY KEY (`post_index`),
  KEY `post_capital_code` (`post_capital_code`,`post_index`),
  KEY `ems_location_code` (`ems_location_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__sessions`###qb_delimiter###
CREATE TABLE `#__sessions` (
  `s_id` varchar(128) NOT NULL,
  `s_uid` int(11) NOT NULL,
  `s_agent` varchar(32) NOT NULL,
  `s_ip` varchar(15) NOT NULL,
  `s_time` int(11) NOT NULL,
  `s_last` int(11) NOT NULL,
  PRIMARY KEY (`s_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__taxes`###qb_delimiter###
CREATE TABLE `#__taxes` (
  `t_id` int(11) NOT NULL AUTO_INCREMENT,
  `t_name` varchar(50) NOT NULL,
  `t_value` decimal(5,2) NOT NULL DEFAULT '0.00',
  `t_fixed` tinyint(1) NOT NULL DEFAULT '0',
  `t_comment` varchar(255) NOT NULL DEFAULT '',
  `t_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `t_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__users`###qb_delimiter###
CREATE TABLE `#__users` (
  `u_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `u_affiliate_code` varchar(12) NOT NULL DEFAULT '0',
  `u_referral` varchar(12) NOT NULL DEFAULT '0',
  `u_login` varchar(50) NOT NULL,
  `u_secret` varchar(255) DEFAULT NULL,
  `u_email` varchar(100) DEFAULT NULL,
  `u_reg_date` datetime DEFAULT NULL,
  `u_nickname` varchar(50) DEFAULT NULL,
  `u_account` float(19,4) DEFAULT '0.0000',
  `u_points` float(19,4) DEFAULT '0.0000',
  `u_discount` float(19,4) DEFAULT '0.0000',
  `u_pricetype` int(11) DEFAULT '1',
  `u_role` int(11) DEFAULT NULL,
  `u_rating` int(5) DEFAULT '0',
  `u_activated` int(1) DEFAULT '0',
  `u_deleted` int(1) DEFAULT '0',
  `u_validation` varchar(50) DEFAULT NULL,
  `u_source` varchar(10) NOT NULL DEFAULT 'system',
  `u_last_visit` datetime DEFAULT '0000-00-00 00:00:00',
  `u_login_date` datetime DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`u_id`),
  UNIQUE KEY `Affiliate` (`u_affiliate_code`),
  UNIQUE KEY `u_login` (`u_login`),
  UNIQUE KEY `u_nickname` (`u_nickname`),
  UNIQUE KEY `u_email` (`u_email`)
) ENGINE=MyISAM AUTO_INCREMENT=72 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__users_addr`###qb_delimiter###
CREATE TABLE `#__users_addr` (
  `a_id` int(11) NOT NULL AUTO_INCREMENT,
  `a_uid` int(11) NOT NULL DEFAULT '0',
  `a_type` tinyint(1) NOT NULL DEFAULT '0',
  `a_default` tinyint(1) NOT NULL DEFAULT '0',
  `a_data` blob,
  PRIMARY KEY (`a_id`,`a_uid`),
  UNIQUE KEY `d_id` (`a_id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 CHECKSUM=1 DELAY_KEY_WRITE=1 ROW_FORMAT=DYNAMIC###qb_delimiter###


DROP TABLE IF EXISTS `#__users_bank`###qb_delimiter###
CREATE TABLE `#__users_bank` (
  `b_id` int(11) NOT NULL AUTO_INCREMENT,
  `b_uid` int(11) NOT NULL DEFAULT '0',
  `b_default` tinyint(1) NOT NULL DEFAULT '0',
  `b_data` blob,
  PRIMARY KEY (`b_id`,`b_uid`),
  UNIQUE KEY `d_id` (`b_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__users_company`###qb_delimiter###
CREATE TABLE `#__users_company` (
  `c_id` int(11) NOT NULL,
  `c_data` blob,
  PRIMARY KEY (`c_id`),
  UNIQUE KEY `d_id` (`c_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__users_vendors`###qb_delimiter###
CREATE TABLE `#__users_vendors` (
  `uv_id` int(11) NOT NULL AUTO_INCREMENT,
  `uv_uid` int(11) NOT NULL,
  `uv_vid` int(11) NOT NULL,
  `uv_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `uv_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`uv_id`),
  UNIQUE KEY `vendor` (`uv_vid`),
  UNIQUE KEY `user` (`uv_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__vendor_categories`###qb_delimiter###
CREATE TABLE `#__vendor_categories` (
  `vc_id` int(11) NOT NULL AUTO_INCREMENT,
  `vc_name` varchar(150) NOT NULL DEFAULT '',
  `vc_desc` text,
  `vc_deleted` smallint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`vc_id`),
  KEY `idx_vendor_category_category_name` (`vc_name`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8 COMMENT='The categories that vendors are assigned to'###qb_delimiter###


DROP TABLE IF EXISTS `#__vendors`###qb_delimiter###
CREATE TABLE `#__vendors` (
  `v_id` int(11) NOT NULL AUTO_INCREMENT,
  `v_cat_id` int(11) NOT NULL,
  `v_name` varchar(150) NOT NULL,
  `v_store_name` varchar(150) NOT NULL DEFAULT '',
  `v_store_desc` text,
  `v_contact_name` varchar(255) NOT NULL DEFAULT '',
  `v_contact_phone` varchar(32) NOT NULL DEFAULT '',
  `v_contact_email` varchar(255) NOT NULL DEFAULT '',
  `v_ogrn` varchar(15) NOT NULL DEFAULT '',
  `v_inn` varchar(12) NOT NULL DEFAULT '',
  `v_kpp` varchar(9) NOT NULL DEFAULT '',
  `v_boss` varchar(75) NOT NULL DEFAULT '',
  `v_ca_name` varchar(75) NOT NULL DEFAULT '',
  `v_bank` varchar(255) NOT NULL DEFAULT '',
  `v_sett_acc` varchar(20) NOT NULL DEFAULT '',
  `v_bik` varchar(9) NOT NULL DEFAULT '',
  `v_bank_acc` varchar(20) NOT NULL DEFAULT '',
  `v_address_p` text NOT NULL,
  `v_address_u` text NOT NULL,
  `v_phone` varchar(32) NOT NULL DEFAULT '',
  `v_fax` varchar(32) NOT NULL DEFAULT '',
  `v_url` varchar(255) NOT NULL DEFAULT '',
  `v_logo` varchar(64) NOT NULL DEFAULT '',
  `v_terms_of_service` text NOT NULL,
  `v_pechat` varchar(64) NOT NULL DEFAULT '',
  `v_enabled` tinyint(1) NOT NULL DEFAULT '1',
  `v_deleted` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`v_id`),
  KEY `idx_vendor_name` (`v_name`),
  KEY `idx_vendor_category_id` (`v_cat_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__videoset_galleries`###qb_delimiter###
CREATE TABLE `#__videoset_galleries` (
  `vg_id` int(11) NOT NULL AUTO_INCREMENT,
  `vg_alias` varchar(50) NOT NULL DEFAULT '',
  `vg_group_id` int(11) NOT NULL DEFAULT '0',
  `vg_title` varchar(250) NOT NULL DEFAULT '',
  `vg_thumb` varchar(64) NOT NULL DEFAULT '',
  `vg_comment` text,
  `vg_ordering` int(11) NOT NULL DEFAULT '0',
  `vg_show_in_list` tinyint(1) NOT NULL DEFAULT '1',
  `vg_published` tinyint(1) NOT NULL DEFAULT '1',
  `vg_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `vg_alt_thm` varchar(255) DEFAULT NULL,
  `vg_title_thm` varchar(255) DEFAULT NULL,
  `vg_meta_title` varchar(250) NOT NULL DEFAULT '',
  `vg_meta_description` varchar(250) NOT NULL DEFAULT '',
  `vg_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`vg_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__videoset_groups`###qb_delimiter###
CREATE TABLE `#__videoset_groups` (
  `vgr_id` int(11) NOT NULL AUTO_INCREMENT,
  `vgr_alias` varchar(50) NOT NULL DEFAULT '',
  `vgr_title` varchar(250) NOT NULL DEFAULT '',
  `vgr_thumb` varchar(64) NOT NULL DEFAULT '',
  `vgr_comment` text,
  `vgr_ordering` int(11) NOT NULL DEFAULT '0',
  `vgr_show_in_list` tinyint(1) NOT NULL DEFAULT '1',
  `vgr_published` tinyint(1) NOT NULL DEFAULT '1',
  `vgr_deleted` tinyint(1) NOT NULL DEFAULT '0',
  `vgr_title_thm` varchar(255) DEFAULT NULL,
  `vgr_alt_thm` varchar(255) DEFAULT NULL,
  `vgr_meta_title` varchar(250) NOT NULL DEFAULT '',
  `vgr_meta_description` varchar(250) NOT NULL DEFAULT '',
  `vgr_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  PRIMARY KEY (`vgr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__videoset_videos`###qb_delimiter###
CREATE TABLE `#__videoset_videos` (
  `v_id` int(11) NOT NULL AUTO_INCREMENT,
  `v_gallery_id` int(4) DEFAULT NULL,
  `v_title` varchar(200) DEFAULT NULL,
  `v_image` varchar(64) DEFAULT NULL,
  `v_title_img` varchar(255) DEFAULT NULL,
  `v_meta_title` varchar(250) NOT NULL DEFAULT '',
  `v_meta_description` varchar(250) NOT NULL DEFAULT '',
  `v_meta_keywords` varchar(250) NOT NULL DEFAULT '',
  `v_alt_img` varchar(255) DEFAULT NULL,
  `v_video_ogg` varchar(250) DEFAULT NULL,
  `v_video_mp4` varchar(250) DEFAULT NULL,
  `v_video_webm` varchar(250) DEFAULT NULL,
  `v_comment` text,
  `v_published` tinyint(1) DEFAULT '0',
  `v_ordering` int(11) NOT NULL DEFAULT '0',
  `v_deleted` tinyint(1) DEFAULT '0',
  `v_alias` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`v_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__votes`###qb_delimiter###
CREATE TABLE `#__votes` (
  `v_uid` int(11) NOT NULL COMMENT 'id юзера',
  `v_type` tinyint(2) NOT NULL COMMENT '1-users,2-articles,3-blog posts,4-blog comments,',
  `v_eid` int(11) NOT NULL COMMENT 'id элемента',
  PRIMARY KEY (`v_uid`,`v_type`,`v_eid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__widgets`###qb_delimiter###
CREATE TABLE `#__widgets` (
  `w_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `w_name` varchar(55) NOT NULL,
  `w_side` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`w_id`),
  UNIQUE KEY `w_name` (`w_name`)
) ENGINE=MyISAM AUTO_INCREMENT=56 DEFAULT CHARSET=utf8###qb_delimiter###


DROP TABLE IF EXISTS `#__widgets_active`###qb_delimiter###
CREATE TABLE `#__widgets_active` (
  `aw_id` int(11) NOT NULL AUTO_INCREMENT,
  `aw_name` varchar(255) NOT NULL,
  `aw_title` varchar(100) NOT NULL,
  `aw_show_title` tinyint(1) NOT NULL DEFAULT '0',
  `aw_title_link` varchar(150) NOT NULL,
  `aw_zone` varchar(255) NOT NULL,
  `aw_class` varchar(50) NOT NULL,
  `aw_config` text NOT NULL,
  `aw_access` text NOT NULL,
  `aw_content` text NOT NULL,
  `aw_ordering` int(5) NOT NULL DEFAULT '0',
  `aw_visible_in` text COMMENT 'Menu IDs',
  `aw_cache` int(7) NOT NULL DEFAULT '0',
  `aw_enabled` tinyint(1) NOT NULL DEFAULT '0',
  `aw_deleted` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`aw_id`)
) ENGINE=MyISAM AUTO_INCREMENT=58 DEFAULT CHARSET=utf8###qb_delimiter###


