<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

$db = $this->initDB();
$pass1 = Request::get('adminPass','');
$pass2 = Request::get('adminPass2','');
$siteUrl = Request::get('siteUrl','');
$sitePort = Request::getInt('sitePort',80);
$siteSSLPort = Request::getInt('siteSSLPort',443);
$adminEmail = Request::get('adminEmail','');
if ($pass1 != $pass2) {
	$err_txt=Text::_('Administrator passwords are not equal');
} else if (mb_strlen($pass1,DEF_CP) < 6) {
	$err_txt=Text::_('Administrator password must be at least 6-chars length');
} else if ($siteUrl == '') {
	$err_txt=Text::_('Enter site URL');
} else if ($adminEmail == '') {
	$err_txt=Text::_('Enter administrator e-mail');
} else $err_txt="";
if ($err_txt) { ?>
<h4 class="invalid">
	<?php echo $err_txt; ?>
</h4>
<form name="frm_install" id="inst_frm" action="install.php"
	method="post">
	<input type="hidden" name="step" value="3" /> 
	<input type="hidden" name="dbHost" value="<?php echo DatabaseConfig::$dbHost; ?>" /> 
	<input type="hidden" name="dbPort" value="<?php echo DatabaseConfig::$dbPort; ?>" /> 
	<input type="hidden" name="dbUser" value="<?php echo DatabaseConfig::$dbUser; ?>" /> 
	<input type="hidden" name="dbPassword" value="<?php echo DatabaseConfig::$dbPassword; ?>" />
	<input type="hidden" name="dbName" value="<?php echo DatabaseConfig::$dbName; ?>" /> 
	<input type="hidden" name="dbPrefix" value="<?php echo DatabaseConfig::$dbPrefix; ?>" />
	<div class="buttons">
		<input type="submit" value="<?php echo Text::_('Go back and fix'); ?>" />
	</div>
</form>
<?php } else {
	DatabaseConfig::$dbSecret=User::genAffiliateCode(rand(1000,2000),10);
	$error_detected=false; $err_array=array();
	$dots=str_repeat("&nbsp;&nbsp;.", 30)."&nbsp;";
	$dots="&nbsp;";
	echo "<h3 class=\"title\">".Text::_('Finishing setup')." : </h3>";
	// Write config
	echo "<p class=\"processing\">";
	echo Text::_("Updating config files").$dots;
	if (!$this->writeConfig()) echo "<span class=\"invalid\">".Text::_("Failed")." !!!</span></p>";	else echo "<span class=\"ok\">OK</span></p>";
	// SQL files
	echo "<p class=\"processing\">";
	echo Text::_("Creating tables structure").$dots;
	$sqlPath = PATH_INSTALL.'sql'.DS;
	// System structure
	$sqlFile = $sqlPath.'system.sql';
	if (!$this->populateDatabase($db,$sqlFile,$err_array)) {
		$error_detected=true;
	}
	if ($error_detected) echo "<span class=\"invalid\">".Text::_("Failed")." !!!</span>";	else echo "<span class=\"ok\">OK</span>";
	echo "</p>";
	// System data
	$sqlFilesData = Files::getFiles($sqlPath."data".DS,array(),false);
	if (!$error_detected && $sqlFilesData) {
		echo "<p class=\"processing\">";
		echo Text::_("Inserting system data").$dots;
		foreach ($sqlFilesData as $sqlFile) {
			if (!$this->populateDatabase($db,$sqlPath."data".DS.$sqlFile["filename"],$err_array)) {
				$error_detected=true; break;
			}
		}
		if ($error_detected) echo "<span class=\"invalid\">".Text::_("Failed")." !!!</span>";	else echo "<span class=\"ok\">OK</span>";
		echo "</p>";
	}
	// Demo data
	$installDemo = Request::getInt('installDemo',0);
	if (!$error_detected && $installDemo) {
		$sqlFilesDemo = Files::getFiles($sqlPath."demo".DS,array(),false);
		if ($sqlFilesDemo && count($sqlFilesDemo)) {
			foreach ($sqlFilesDemo as $sqlFile) {
				if (!$this->populateDatabase($db,$sqlPath."demo".DS.$sqlFile["filename"],$err_array)) {
					$error_detected=true; break;
				}
			}
		}
		if (!$error_detected){
			if(!Files::copyFolder(PATH_INSTALL.'userfiles'.DS, PATH_SITE.'userfiles'.DS,true)) $error_detected=true;
		}
		echo "<p class=\"processing\">".Text::_("Inserting DEMO data").$dots;
		if ($error_detected) echo "<span class=\"invalid\">".Text::_("Failed")." !!!</span>";	else echo "<span class=\"ok\">OK</span>";
		echo "</p>";
	}
	if (count($err_array)){
		echo "<h4 class=\"invalid\">".Text::_("Detected errors")." : </h4>";
		foreach($err_array as $curent_error){
			echo "<div class=\"found_errors\">".$curent_error."</div>";
		}
	}
	if (!$error_detected) {
		ACLObject::initialize();
		echo "<p class=\"processing\">".Text::_("Creating administrator").$dots;
		if (!User::addUser('admin', 'admin', $pass1, $adminEmail, 1,"",1,0,1)) {
			$error_detected=true;
			echo "<span class=\"invalid\">".Text::_("Failed")." !!!</span>";
		}	else {
			$sql="UPDATE #__users SET u_id=14 WHERE u_login='admin'";
			$db->setQuery($sql);
			$db->query();
			echo "<span class=\"ok\">OK</span>";
		}
		echo "</p>";
		$siteUrl = Request::get('siteUrl','#');
		$sitePort = Request::getInt('sitePort',80);
		$siteSSLPort = Request::getInt('siteSSLPort',443);
		if (!$error_detected) {
?>
<h4 class="setup_ok">
	<?php echo Text::_('AltaDOC CMS installed successfully'); ?>
</h4>
<p class="final_message">
	<?php echo Text::_('Remove INSTALL directory before going to site'); ?>
	! ! !
</p>
<p class="final_message">
	<?php echo Text::_('Administrator login is'); ?>
	: admin
</p>
<div class="buttons">
	<a class="linkButton" href="<?php echo $siteUrl.":".$sitePort."/administrator/index.php"; ?>"><?php echo Text::_('Admin panel'); ?></a>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	<a class="linkButton" href="<?php echo $siteUrl.":".$sitePort; ?>"><?php echo Text::_('Site'); ?> </a>
	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	<a class="linkButton" target="_blank" href="http://altadoc.ru/"><?php echo Text::_('Visit AltadocCMS site'); ?></a>
</div>
<?php 
		} else {
?>
<h4 class="setup_failed">
	<?php echo Text::_('AltaDOC CMS installation failed'); ?>
</h4>
<?php
		}
	} else {
?>
<h4 class="setup_failed">
	<?php echo Text::_('AltaDOC CMS installation failed'); ?>
</h4>
<?php
		
	}
}
?>