//ALTADOC_COPYRIGHT_TEMPLATE

function mm_setContent(content){
	$('#mediamanager').html(content);
	mm_prepareUploader();
}
function mm_getContent(folder, go_to, is_up){
	$.fancybox.showActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type:'module',
			option:'ajax',
			module:'service',
			task:'getMediaContent',
			folder:folder,
			go_to:go_to,
			is_up:is_up
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			mm_setContent(html_data);
			$.fancybox.resize();
			$.fancybox.hideActivity();
		},
		error: function () { $.fancybox.hideActivity(); return false; }
	});
}
function mm_deleteFolder(folder, oldfolder){
	if (confirm('Do you want to delete')) {
		$.fancybox.showActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'deleteMediaFolder',
				folder:folder,
				oldfolder:oldfolder
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				$.fancybox.hideActivity();
			},
			error: function () { $.fancybox.hideActivity(); return false; }
		});
	}
}
function mm_createFolder(folder){
	var newfolder=$('#newfolder').val();
	if (newfolder !='') {
		$.fancybox.showActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'createMediaFolder',
				folder:folder,
				newfolder:newfolder
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				$.fancybox.hideActivity();
			},
			error: function () { $.fancybox.hideActivity(); return false; }
		});
	}
}
function mm_deleteFile(folder, file){
	if (confirm('Do you want to delete')) {
		$.fancybox.showActivity();
		$.ajax({
			url : siteConfig['siteUrl']+"index.php",
			data:({
				type:'module',
				option:'ajax',
				module:'service',
				task:'deleteMediaFile',
				folder:folder,
				file:file
			}),
			dataType:'html',
			success: function (html_data, textStatus) {
				mm_setContent(html_data);
				$.fancybox.resize();
				$.fancybox.hideActivity();
			},
			error: function () { $.fancybox.hideActivity(); return false; }
		});
	}
}
function mm_setLink(folder, file){
	var ret_elem=$('#mm_return_element').val();
	var nfl=$('#mm_nfl').val();
	$.fancybox.showActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type:'module',
			module:'service',
			task:'getLink',
			folder:folder,
			file:file,
			ret_elem:ret_elem,
			nfl:nfl
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			if (ret_elem !='') {
				$('#'+ret_elem).val(html_data);
				$('#'+ret_elem).trigger('change');
				$.fancybox.close();
			} else {
				$('#medialink').html(html_data);
			}
			$.fancybox.hideActivity();
		},
		error: function () { $.fancybox.hideActivity(); return false; }
	});
}
function mm_prepareUploader() {
	var bar = $('#mm_single_upload .bar');
	var percent = $('#mm_single_upload .percent');
	var status = $('#status');
	$('#mm_single_upload').ajaxForm({
		beforeSend: function() {
			status.empty();
			var percentVal = '0%';
			bar.width(percentVal)
			percent.html(percentVal);
			},
		uploadProgress: function(event, position, total, percentComplete) {
			var percentVal = percentComplete + '%';
			bar.width(percentVal)
			percent.html(percentVal);
		},
		success: function() {
			var percentVal = '100%';
			bar.width(percentVal)
			percent.html(percentVal);
		},
		complete: function(xhr) {
			mm_setContent(xhr.responseText);
			//status.html(xhr.responseText);
		}
	}); 
}
function mm_startMediaManager(ret_elem, nfl){
	$.fancybox.showActivity();
	$.ajax({
		url : siteConfig['siteUrl']+"index.php",
		data:({
			type: 'module',
			module: 'service',
			task: 'startMediamanager',
			ret_elem: ret_elem,
			nfl:nfl
		}),
		dataType:'html',
		success: function (html_data, textStatus) {
			$.fancybox({'content'	: html_data});		
			mm_prepareUploader();
			$.fancybox.resize();
			$('#fancybox-overlay').css('z-index','20000');
			$('#fancybox-wrap').css('z-index','20001');
			$.fancybox.hideActivity();
		},
		error: function () { $.fancybox.hideActivity(); return false; }
	});
}