<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class articleControllerdefault extends Controller {
	public function showRead($childs_order='title') {
		$page404	= Request::getBool('page404',false);
		if ($page404) $this->setRedirect('index.php',Text::_('Article not found'),404);
		$psid	= Request::getInt('psid',siteConfig::$defaultItemID);
		$layout = $this->get('layout','read');
		$notmpl = Request::getInt('notmpl',0);
		$noctrl = Request::getInt('noctrl',$notmpl);
		$addbreadcrumb = Request::getBool('bc',true);
		//Util::ddump($addbreadcrumb,'addbreadcrumb');
		$view = $this->getView();
		$model = $this->getModel('article');
		$view->assign("use_rating",$this->getConfigValue("use_rating",false));
		if (!$psid) {
			if ( siteConfig::$defaultModule == 'article') {
				echo Text::_('Article not found');
				$view->assign('art',false);
			}	else { $this->setRedirect('index.php',Text::_('Article not found'),404); }
		} else {
			// Article
			if ($this->checkACL("articleEditing",false)) $art = $model->getArticle($psid, 0, 0);
			else $art = $model->getArticle($psid);
			if (!$art) {
				if ($noctrl) { Util::halt(Text::_('Article not found')); }
				else {
					if (( siteConfig::$defaultModule == 'article')&&(siteConfig::$defaultItemID==$psid)) {
						echo Text::_('Article not found');
						$view->assign('art',false);
						if ($this->checkACL("articleEditing",false)) {
							$view->addShortcut(Text::_('Tree'),"javascript: document.location.href='".Router::_("index.php?module=article&amp;view=tree")."';","treeArticle");
							$view->addShortcut(Text::_('New article'),"javascript: document.location.href='".Router::_("index.php?module=article&amp;view=edit")."';","newArticle");
						}
					} else $this->setRedirect('index.php',Text::_('Article not found'),404);
				}
			} else {
				Module::getInstance()->setBreadCrumbVisibility($art->a_show_breadcrumb);
				if ($art->a_show_childs == '1') {	$arrChilds=$model->getChildsArray($art->a_id, $art->a_childs_order_by, $art->a_childs_order_dir);	}
				else $arrChilds=null;
				$user = User::getInstance();
				$artUrl = 'index.php?module=article&amp;view=read&amp;psid='.$art->a_id;
				if ($art->a_alias) $artUrl.="&alias=".$art->a_alias;
				if (!$noctrl){
					if ($art->a_id!=siteConfig::$defaultItemID) {
						if($addbreadcrumb) $this->createUpBreadcrumb($view,$art->a_id);
					}
/*
					if($addbreadcrumb) $view->setBreadcrumb(Text::_('Main page'),'index.php');
					if ($art->a_parent_id != 0) {
						if($addbreadcrumb) $view->addBreadcrumb($art->parentTitle,'index.php?module=article&amp;view=read&amp;psid='.$art->a_parent_id);
					} elseif ($art->a_show_in_contents == '1') {
						if($addbreadcrumb) $view->addBreadcrumb(Text::_('Articles'),'index.php?module=article');
					}
					if ($art->a_id==siteConfig::$defaultItemID) {
						if($addbreadcrumb) $view->setBreadcrumb(Text::_('Main page'),$artUrl);
					}	else	if($addbreadcrumb) $view->addBreadcrumb($art->a_title,$artUrl);
*/
					// Shortcuts
					if ($this->checkACL("articleEditing",false)/* || $user->getId() == $art->a_author_id*/) {
						$view->addShortcut(Text::_('Tree'),"javascript: document.location.href='".Router::_("index.php?module=article&amp;view=tree")."';","treeArticle");
						$view->addShortcut(Text::_('New article'),"javascript: document.location.href='".Router::_("index.php?module=article&amp;task=modify")."';","newArticle");
						$view->addShortcut(Text::_('Edit'),"javascript: document.location.href='".Router::_("index.php?module=article&amp;task=modify&amp;psid=".$art->a_id)."';","editArticle");
						if ($art->a_deleted) $view->addShortcut(Text::_('Undelete'),"javascript: document.location.href='index.php?module=article&amp;task=undelete&amp;psid=".$art->a_id."';","undeleteArticle");
						else $view->addShortcut(Text::_('Delete'),"javascript: document.location.href='index.php?module=article&amp;task=delete&amp;psid=".$art->a_id."';","deleteArticle");
					}
				}

				if ($art->a_meta_keywords) $view->setMeta("keywords",$art->a_meta_keywords);
				if ($art->a_meta_title) $view->setMeta("title",$art->a_meta_title);
				else $view->setMeta("title",$art->a_title);
				if ($art->a_meta_description) $view->setMeta("description",$art->a_meta_description);
				$authorProfileUrl = Router::_("index.php?module=user&amp;view=info&amp;psid=".$art->a_author_id);
				$view->assign("comm",$this->initComments($art->a_id));
				$view->assign('articleAuthor',$art->author);
				$view->assign('articleRating',$art->a_rating);
				$view->assign('canVote',$this->checkACL("articleVoting",false));
				$view->assign('articleAuthorProfileUrl',$authorProfileUrl);
				$view->assign('articleDate',$art->a_date);
				$articleTitle = $art->a_title;
				$view->assign('articleTitle',$articleTitle);
				$view->assign('articleHTML',$art->a_text);
				$view->assign('art',$art);
				$view->assign("notmpl",$notmpl);
				$view->assign('articleShowInfo',$art->a_show_info);
				$view->assign('showTitle',$art->a_show_title);
				$view->assign('arrChilds',$arrChilds);
			}
		}
		$this->set("layout","default", true);
		if ($layout) {$view->setLayout($layout);}
	}

	//
	public function showTree() {
		$view = $this->getView();
		$model = $this->getModel('tree');
		$rootArticle=Request::getSafe("psid",0);
		$view->addBreadcrumb(Text::_('Articles'),'index.php?module=article');
		$model->buildTreeArrays();
		$tree=$model->getTreeHTML($rootArticle,'ul','article_tree');
		$brokenParents=$model->getBrokenParents();
		$view->assign('tree',$tree);
		$view->assign('brokenParents',$brokenParents);
	}

	public function modify() {
		$this->checkACL("articleEditing");

		$user	= User::getInstance();
		$psid	= Request::getSafe('psid',"");
		$layout = $this->get('layout');
		$aParentId	= Request::get('parentid',Registry::getInstance()->get('articleParentId',0));
		//$this->set("view","read",true);
		$this->setViewName("read");
		$view = $this->getView();
		$view->setLayout("modify");
		$tree_model = $this->getModel('tree');

		$model = $this->getModel('article');
		$view->addBreadcrumb(Text::_('Articles'),'index.php?module=article');
		$view->addBreadcrumb(Text::_('Editing'),'#');

		if (!$psid) { // New article
			$tree_model->buildTreeArrays("",0,0);
			$select=$tree_model->getTreeHTML($aParentId, 'select','ArticleParent', 'parentId', $aParentId);
			$view->assign('articleSelect',$select);

			$view->assign('articleId',0);
			$view->assign('articleText','');
			$view->assign('articleAlias','');
			$today = date('d-m-Y H:i');
			$view->assign('articleDate',$today);
			$view->assign('articleTitle','');
			$view->assign('showInfoCheck','checked="checked"');
			$view->assign('showInContentsCheck','checked="checked"');
			$view->assign('showChildsCheck','checked="checked"');
			$view->assign('showTitleCheck','checked="checked"');
			$view->assign('showBCCheck','checked="checked"');
			$view->assign('published','checked="checked"');
			$view->assign('metadescr','');
			$view->assign('metakeywords','');
			$view->assign('metatitle','');
			$view->render();
		}	else { // Edit article
			if ($this->checkACL("articleEditing",false)) $art = $model->getArticle($psid, 0, 0);
			else $art = $model->getArticle($psid);
			$artUrl = 'index.php?module=article&amp;view=read&amp;psid='.$psid;
			if (!$art) {
				$this->setRedirect('index.php',Text::_('Article not found'));
			}	else {
				if ($user->isAdmin() != true && $user->getId() != $art->a_author_id) {
					$this->setRedirect('index.php?module=article',Text::_('Permission is absent for editing this article'));
				}
				else {
					$showInfoCheck = '';
					$showInContentsCheck = '';
					$showChildsCheck = '';
					$showTitleCheck = '';
					$showBreadCrumbCheck = '';
					$published="";
					if ($art->a_show_info == '1') { $showInfoCheck = "checked=\"checked\""; }
					if ($art->a_show_in_contents == '1') { $showInContentsCheck = "checked=\"checked\""; }
					if ($art->a_show_childs == '1') { $showChildsCheck = "checked=\"checked\""; }
					if ($art->a_show_title == '1') { $showTitleCheck = "checked=\"checked\""; }
					if ($art->a_show_breadcrumb == '1') { $showBreadCrumbCheck = "checked=\"checked\""; }
					if ($art->a_published == '1') { $published = "checked=\"checked\""; }

					$tree_model->buildTreeArrays($art->a_id,0,0);
					$select=$tree_model->getTreeHTML(0,'select','ArticleParent', 'parentId', $art->a_parent_id);
					$view->assign('articleSelect',$select);
					$view->assign('articleId',$art->a_id);
					$view->assign('articleText',$art->a_text);
					$view->assign('articleAlias',$art->a_alias);
					$view->assign('articleDate',Date::fromSQL($art->a_date, false, true));
					$view->assign('articleTitle',$art->a_title);
					$view->assign('showInfoCheck',$showInfoCheck);
					$view->assign('showInContentsCheck',$showInContentsCheck);
					$view->assign('showChildsCheck',$showChildsCheck);
					$view->assign('showTitleCheck',$showTitleCheck);
					$view->assign('showBCCheck',$showBreadCrumbCheck);
					$view->assign('published',$published);
					$view->assign('metadescr',$art->a_meta_description);
					$view->assign('metakeywords',$art->a_meta_keywords);
					$view->assign('metatitle',$art->a_meta_title);
					$view->render();
				}
			}
		}
		if ($layout=="alias") {$view->setLayout('default');}
	}

	public function saveComment() {
		$layout	= Request::getSafe('layout');
		if ($layout=="alias") $this->set("layout","",true);
		parent::saveComment();
	}
	public function save() {
		$this->checkACL("articleEditing");
		$user = User::getInstance();
		$today = date('Y-m-d H:i:s');
		$psid							= Request::getInt('psid',0);
		$aParentId				= Request::getInt('parentId',0);
		$aTitle						= Request::getSafe('articleTitle','');
		$aAlias						= Request::getSafe('articleAlias','');
		$aText						= Request::get('articleText','');
		$aShowInfo				= Request::getInt('articleShowInfo','');
		$aShowInContents	= Request::getInt('articleShowInContents',0);
		$aShowChilds			= Request::getInt('articleShowChilds',0);
		$aShowTitle				= Request::getInt('articleShowTitle',0);
		$aShowBreadCrumb	= Request::getInt('articleShowBreadCrumb',0);
		$published	= Request::getInt('articlePublished',0);
		$aDate						= Request::get('articleDate',$today);
		$metakeywords 		= Request::getSafe('metakeywords','');
		$metatitle 				= Request::getSafe('metatitle','');
		$metadescr 				= Request::getSafe('metadescr','');
		if ($aShowInfo) $aShowInfo = 1; else $aShowInfo = 0;
		if ($aShowInContents) $aShowInContents = 1; else $aShowInContents = 0;
		if ($aShowChilds) $aShowChilds = 1;	else $aShowChilds = 0;
		if ($aShowTitle) $aShowTitle = 1;	else $aShowTitle = 0;
		if ($aShowBreadCrumb) $aShowBreadCrumb = 1;	else $aShowBreadCrumb = 0;

		$model = $this->getModel('article');
		$new_alias="";
		if (!$psid) {
			$psid = $model->saveArticle(0,$aDate,$aParentId,$aAlias,$aTitle,$user->getId(),$aText,$aShowInfo,$aShowInContents,$aShowChilds,$aShowTitle,$aShowBreadCrumb,$metakeywords, $metatitle, $metadescr,$published);
			if($psid && $this->getConfigValue("use_rating",false)) Event::raise("rating.new",array("module"=>"article","element"=>"object","psid"=>$psid));   // content.rating
			if($psid) {
				$msg=Text::_('Article saved');
				$new_alias = $model->updateAlias($psid,$aAlias,$aTitle);
			}	else $msg=Text::_('Article not saved');
		}	else {
			$art = $model->getArticle($psid);
			if ($user->isAdmin() == false && $user->getId() != $art->a_author_id) {
				$this->setRedirect('index.php?module=article',Text::_('Permission is absent for editing this article'));
				return;
			}	else {
				if($model->saveArticle($psid,$aDate,$aParentId,$aAlias,$aTitle,0,$aText,$aShowInfo,$aShowInContents,$aShowChilds,$aShowTitle,$aShowBreadCrumb,$metakeywords, $metatitle, $metadescr,$published)) $msg=Text::_('Article saved');
				else $msg=Text::_('Article not saved');
				$new_alias = $model->updateAlias($psid,$aAlias,$aTitle);
			}
		}
		if($psid){
			$href='index.php?module=article&view=read&psid='.$psid;
			if ($new_alias) $href.="&amp;alias=".$new_alias;
			$this->setRedirect($href,$msg);
		} else $this->setRedirect('index.php',$msg);
	}

	public function delete() {
		$this->checkACL("articleEditing");
		$psid = Request::getInt('psid',0);
		$model = $this->getModel('article');
		$art = $model->getArticle($psid);
		if ($art == false) { $this->setRedirect("index.php?module=article&view=read&psid=".$psid); 	}
		else {
			$user = User::getInstance();
			$href="index.php?module=article&view=read&psid=".$psid;
			if ($art->a_alias) $href.="&amp;alias=".$art->a_alias;
			if (($user->getId() == $art->a_author_id)||($user->isAdmin())) {
				$model->deleteArticle($psid);
				$this->setRedirect($href,Text::_('Article deleted'));
			}	else { $this->setRedirect($href); 	}
		}
	}

	public function undelete() {
		$this->checkACL("articleEditing");
		$psid = Request::getInt('psid',0);
		$model = $this->getModel('article');
		$art = $model->getArticle($psid,0);
		if ($art == false) { $this->setRedirect("index.php?module=article&view=read&psid=".$psid); 	}
		else {
			$user = User::getInstance();
			$href="index.php?module=article&view=read&psid=".$psid;
			if ($art->a_alias) $href.="&amp;alias=".$art->a_alias;
			if (($user->getId() == $art->a_author_id)||($user->isAdmin())) {
				$model->undeleteArticle($psid);
				$this->setRedirect($href,Text::_('Article undeleted'));
			}	else { $this->setRedirect($href); 	}
		}
	}
	public function ajaxVote() {
		$psid = Request::getInt('psid',0);
		$element = Request::getSafe("element",false);
		switch ($element) {
			case "object":
				if ($this->checkACL("articleVoting",false) && $this->getConfigValue("use_rating",false)){
					$model = $this->getModel('article');
					$psid = Request::getInt('psid',0);
					$author= $model->getAuthor($psid);
					$direction = Request::getSafe('dir',"up");
					$params = array("module"=>"article","element"=>"object","psid"=>$psid,"direction"=>$direction, "author"=>$author);
					$data_voted=Event::raise("rating.check",$params);  // content.rating
					if (!siteConfig::$useMultiVote && $data_voted) {
						echo Text::_("Already voted");
					} else {
						if (User::checkFloodPoint()){
							echo Text::_("Flood found");
						} else {
							Event::raise("rating.vote",$params); // content.rating
							if ($direction=="up"){
								echo Text::_("Good");
							} else {
								echo Text::_("Bad");
							}
						}
					}
				}
		case "comment":
			parent::ajaxVote();
			break;
		default:
			return;
		break;
		}
	}
	/* Список статей */
	public function showList() 	{
		$model=$this->getModel('article');
		$model->createPaginator('list',10);
		Portal::getInstance()->setTitle(Text::_("Articles"));
		$view=$this->getView();
		$psid = Request::getInt('psid',0);
		$list=$model->getArticles(true, $psid);
		$view->assign('articles',$list);
	}
	public function createUpBreadcrumb($view,$psid) {
		$i=0;	$bc=array();
		$model = $this->getModel('article');
		$limitBread=Module::getInstance()->getConfigValue('breadcrumb_lenght',0);
		$arr=$model->getParentArticle($psid);
		if(count($arr)>0) {
			foreach($arr as $key=>$val) {
				$i++;
				$str=$val["title"];
				if($limitBread>0 && (mb_strlen($str) > $limitBread)) $bc[$i]['text']=mb_substr($str,0,$limitBread)."...";
				else $bc[$i]['text']=$val["title"];
				$bc[$i]['link']=Router::_("index.php?module=article&amp;view=read&amp;psid=".(int)$key."&amp;alias=".$val["alias"]);
			}
		}
		$i++;
		$breadcrumb_start=Module::getInstance()->getConfigValue('breadcrumb_start','');
		$breadcrumb_start_link=Module::getInstance()->getConfigValue('breadcrumb_start_link','');
		if($breadcrumb_start && $breadcrumb_start_link) {
			$bc[$i]['text']=Text::_($breadcrumb_start); $bc[$i]['link']=Router::_($breadcrumb_start_link);
		} else {
			$bc[$i]['text']=Text::_('Main page'); $bc[$i]['link']=Router::_("index.php");
		}
		$bc=array_reverse($bc);
//		Util::showArray($bc);
		foreach($bc as $tkey=>$tval)	{
		  $view->addBreadcrumb($tval['text'],$tval['link']);
		}
	}
}

?>