<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogControllerdefault extends SpravController {
	private function is_disabled() {
		if (catalogConfig::$ordersDisabled)	{
			if (Portal::getInstance()->get('option')=='ajax') exit(Text::_('This option is temporary disabled'));
			else $this->setRedirect(Router::_('index.php'),Text::_('This option is temporary disabled'));
		}
	}
	public function downloadDemo(){
		$psid = Request::getInt('psid', false);
		$this->set("view","goods", true);
		$model = $this->getModel();
		$result=$model->getElement($psid);
		$redirect=Router::_('index.php?module=catalog&view=goods&layout=info&psid='.$psid);
		$msg=Text::_('Download file');
		if ($result->g_file_demo&& ($result->g_type==3||$result->g_type==4)){
			if ($this->checkACL("viewCatalogDownloadDemo", false)){
				$filepath=ALTADOC_UF_PATH;
				$filename=$result->g_file_demo;
				$filelink=ALTADOC_UF.$result->g_file_demo;
				if (is_file($filepath.$filename)){
					Util::download($filepath,$filename,$redirect,$msg);
				} else $this->setRedirect($redirect,$msg);
			} else $this->setRedirect($redirect,Text::_("Download denied").". ".Text::_("You are not authorized"));
		} else $this->setRedirect($redirect,Text::_("Download denied"));
	}
	public function showVendors() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$reestr->set("needpan",false);
		$this->haltView();
		$psid = Request::getInt('psid', false); 					// ид строки
		if ($psid) $this->showInfo();
		else $this->showData();
	}
	public function showManufacturers() {
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$reestr->set("needpan",false);
		$this->haltView();
		$psid = Request::getInt('psid', false); 					// ид строки
		if ($psid) $this->showInfo();
		else $this->showData();
	}
	public function showGoods() {
		$page404	= Request::getBool('page404',false);
		if ($page404) $this->setRedirect('index.php',Text::_('Goods not found'),404);
		$tp = User::getInstance()->u_pricetype;
		$this->haltView();
		$save_filter = Request::getSafe("save_filter");
		$reset_filter = Request::getSafe("reset_filter");
		if (($save_filter && !Request::getInt('psid', false)) || $reset_filter){
			Router::getInstance()->setVarsVal("psid", 0);
			Router::getInstance()->setVarsVal("multy_code", 0);
		}
		switch($this->get('layout')) {
			case "info":
				$mdl = Module::getInstance();
				$moduleName	= $mdl->getName();
				$reestr = $mdl->get('reestr');
				$model = $this->getModel();
				$old_layout=$this->get("layout");
				$viewname = $this->getView()->getName();
				$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
				$arr_psid     = Request::getSafe('cps_id', false);				// массив отмеченных галочкой элементов
				$multy_code   = Request::getInt('multy_code', false); 		// ид верхней группы
				$psid         = Request::getInt('psid', false); 					// ид строки
				if(!$psid)  if($arr_psid&&is_array($arr_psid)&&count($arr_psid)>0) $psid = $arr_psid[0];
				$reestr->set('ajaxModify',false);
				$reestr->set('view',$viewname);
				$reestr->set('model',$model);
				//					$reestr->set('metadata',$model->meta);
				$reestr->set("multy_code",$multy_code);
				$reestr->set('psid',$psid);
				//$layout			= request::get('layout');
				$start			= request::get('start');
				$sort				= request::get('sort');
				$orderby		= request::get('orderby');
				//$reestr->set('layout',$layout);
				$this->set("layout","default",true);
				$reestr->set('start',$start);
				$reestr->set('sort',$sort);
				$reestr->set('orderby',$orderby);
				$result = $model->getElementData($psid);
				if(is_object($result)&&$result->g_type!=6){
					if(!isset($_COOKIE["altadoc_catalog_group"]) || !$_COOKIE["altadoc_catalog_group"]){
						$group_code=$model->getFirstParent($psid);
						setcookie("altadoc_catalog_group", $group_code, 0, "/");
					}
					if ($result->g_type==5){
						$model->updateComplectPrice($result);
					}
					if((isset($model->meta)&&($model->meta))) {
						if(!catalogConfig::$hide_prices)	$model->meta->updateArrayField('input_view','g_price_'.$tp,1);
						if(!siteConfig::$use_points_system)	$model->meta->updateArrayField('input_view','g_points',0);
						else	$model->meta->updateArrayField('input_view','g_points',0);
						if(catalogConfig::$show_stock)	$model->meta->updateArrayField('input_view','g_stock',1);
						else	$model->meta->updateArrayField('input_view','g_stock',0);
					}
					$view = $this->getView();
					$this->createUpBreadcrumb($view,$result->g_id, 1);
					$limitBread=$mdl->getConfigValue('breadcrumb_lenght',0);
					$text_breadcrumb=$result->g_name;
					if($limitBread>0 && mb_strlen($text_breadcrumb)>$limitBread) $text_breadcrumb=mb_substr($text_breadcrumb,0,$limitBread)."...";
					$view->addBreadcrumb($text_breadcrumb,'#');
					$basket= Basket::getInstance();
					if($result->g_meta_keywords) Portal::getInstance()->setMeta("keywords",$result->g_meta_keywords);
					else Portal::getInstance()->setMeta("keywords",$result->g_name);
					if($result->g_meta_description) Portal::getInstance()->setMeta("description",$result->g_meta_description);
					else Portal::getInstance()->setMeta("description",$result->g_name);
					if($result->g_meta_title) Portal::getInstance()->setTitle($result->g_meta_title);
					else Portal::getInstance()->setTitle($result->g_name);
					$view->setLayout($old_layout);
					if ($result->g_flypage && $result->g_flypage!='info') $view->setLayout($result->g_flypage);
					$view->assign("comm",$this->initComments($psid));
					$view->assign("images",$model->getImages($psid));
//					$view->assign("dopFields",$model->getDataDopField($psid));
					$view->assign("analogs",$model->getAnalogs($psid));
					$view->assign("videos",$model->getVideos($psid));
					$view->assign("video_width",$this->getConfigValue("video_width",320));
					$view->assign("video_height",$this->getConfigValue("video_height",190));
					$view->assign("canDownloadDemo",$this->checkACL("viewCatalogDownloadDemo", false));
//					$model->apendElementGroupFields($model->meta, $result);
//					$view->assign("custom_group_fields",$result->customFields);
					$view->renderInfo($model->meta,$result);
				} else $this->setRedirect(Router::_("index.php?module=catalog"),'','404');
				break;
			default:
				$mdl = Module::getInstance();
				$reestr = $mdl->get('reestr');
				// вынимаем сведения о категории
				$model = $this->getModel();
				$model->loadMeta();
				$psid         = Request::getInt('psid', false); 					// ид строки
				$multy_code   = Request::getInt('multy_code', false); 					// ид верхней группы
				if(!$multy_code)	$multy_code=$psid;
				elseif(!$psid) $psid=$multy_code;
				$grp = $model->loadGroup($multy_code);
				setcookie("altadoc_catalog_group", $multy_code, 0, "/");
				if (is_object($grp) || !$psid){
					if (is_object($grp)) {
						if ($grp->ggr_meta_keywords) Portal::getInstance()->setMeta("keywords",$grp->ggr_meta_keywords);
						if ($grp->ggr_meta_description) Portal::getInstance()->setMeta("description",$grp->ggr_meta_description);
						if ($grp->ggr_meta_title) Portal::getInstance()->setTitle($grp->ggr_meta_title);
					}
					$view = $this->getView();
					$childs=$model->loadChildGroups($multy_code);
					$reestr->set('needpan',false);
					$reestr->set("multy_code",$multy_code);
					$reestr->set('psid',$psid);
					$reestr->set('start',Request::getInt("start",0));
					$reestr->set('sort',Request::get("sort"));
					$reestr->set('orderby',Request::get("orderby"));
					//				if((isset($model->meta)&&($model->meta))) {
					if(!catalogConfig::$hide_prices)	$model->meta->updateArrayField('view','g_price_'.$tp,1);
					if(!siteConfig::$use_points_system)	$model->meta->updateArrayField('view','g_points',0);
					else	$model->meta->updateArrayField('view','g_points',0);
					if(catalogConfig::$show_stock)	$model->meta->updateArrayField('view','g_stock',1);
					else	$model->meta->updateArrayField('view','g_stock',0);
					$filter_vendor_id=Session::getVar("filter.vendor");
					$filter_manufacturer_id=Session::getVar("filter.manufacturer");
					if (!is_null($filter_vendor_id)&&$filter_vendor_id) {
						$model->meta->custom_sql="AND c.g_vendor=".$filter_vendor_id;
						$view->assign("filter_vendor",$model->getVendorName($filter_vendor_id));
					}
					if (!is_null($filter_manufacturer_id)&&$filter_manufacturer_id) {
						$model->meta->custom_sql="AND c.g_manufacturer=".$filter_manufacturer_id;
						$view->assign("filter_manufacturer",$model->getManufacturerName($filter_manufacturer_id));
					}
					//				}
//					Util::showArray($model->meta);
						
					$result = $model->getData();
					if(catalogConfig::$complectPriceAsGoodsSum){
						if(count($result)){
							foreach($result as $res){
								$model->updateComplectPrice($res);
							}
						}
					}
					$this->createUpBreadcrumb($view,$psid, 0);
					if (!is_null($grp)&&$grp->ggr_list_tmpl && $grp->ggr_list_tmpl!='defl') $view->setLayout($grp->ggr_list_tmpl);
					$show_filter_button=$mdl->getConfigValue('show_filter_button',1);
					$show_sort_links=$mdl->getConfigValue('show_sort_links',1);
					$view->assign("grp",$grp);
					$view->assign("show_filter_button",$show_filter_button);
					$view->assign("show_sort_links",$show_sort_links);
					$view->assign("multy_code",$multy_code);
					$view->assign("childs",$childs);
					$view->renderSprav($model->meta,$result);
				} else  {
					$this->setRedirect("index.php?module=catalog","",'404');
				}
				break;
		}
	}
	/* используется для вывода информационной страницы без участия модели */
	public function showPage(){
		$view = $this->getView();
		$layout=$this->get('layout');
		$view->setLayout("default");
		$view->setLayout($layout);
		$view->render();
	}
	// Показываем корзину
	public function ajaxShowBasket() {
		$this->is_disabled();
		$html="<div class=\"full_basket_ajax\"><div class=\"full_basket\">";
		$html.=Basket::getInstance()->modifyBasket(true);
		$html.="</div></div>";
		echo $html;
	}
	public function ajaxUpdateBasketPosition() {
		$this->is_disabled();
		$bs= Basket::getInstance();
		//		$orderbutton = Request::getInt('orderbutton', 1);
		$psid = Request::getSafe('psid', false);
		$quantity = Request::getFloat('quantity', catalogConfig::$quantity_digits);
		if ($psid) $bs->updateBasketPosition($psid,$quantity);
		//		echo $bs->modifyBasket($orderbutton);
		echo $bs->modifyBasket(true);
	}
	public function ajaxgetMiniBasket() {
		$this->is_disabled();
		$bs= Basket::getInstance();
		echo $bs->showMini();
	}
	public function ajaxDeleteBasketPosition() {
		$this->is_disabled();
		$bs= Basket::getInstance();
		//		$orderbutton = Request::getInt('orderbutton', 1);
		$psid = request::get('psid', false);
		if ($psid) $bs->deleteBasketPosition($psid);
		//		echo $bs->modifyBasket($orderbutton);
		echo $bs->modifyBasket(true);
	}
	private function printOrder($order_id) {
		$this->is_disabled();
		Portal::getInstance()->changeTemplateFile('print');
		$this->renderOrder($order_id,1,0);
	}
	private function viewOrder($order_id) {
		$this->is_disabled();
		$view = $this->getView();
		//		if (!$this->get('notmpl')) {
		if (!Portal::getInstance()->inPrintMode()){
			$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
			$view->addBreadcrumb(Text::_('Orders'),Router::_("index.php?module=catalog&view=orders"));
			$view->addBreadcrumb(Text::_('Order'),"#");
		}
		$this->renderOrder($order_id);
	}
	private function renderOrder($order_id, $override_css=0, $controls=1, $_echo=1) {
		$view = $this->getView();
		$model=$this->getModel();
		if ($order_id) {
			$order=$model->getOrder($order_id);
			if ($order) $order_items=$model->getOrderItems($order_id);
			else { $order=false;$order_items=false;
			}
		} else { $order=false;$order_items=false;
		}
		if ($order) {
			$payment=catalogPayment::getPaymentClass($order->o_pt_id);
			$delivery=catalogDelivery::getDeliveryClass($order->o_dt_id);
		} else { $delivery=false; $payment=false;
		}
		$view->assign("override_css",$override_css);
		$view->assign("dt_class", $delivery );
		$view->assign("pt_class", $payment );
		$view->assign("order", $order );
		$view->assign("controls", $controls );
		$view->assign("order_items", $order_items );
		if (!$_echo){
			ob_start();
			$view->render();
			$html=ob_get_contents();
			ob_end_clean();
			$this->haltView();
			return $html;
		}
	}
	private function payOrder($order_id) {
		$this->is_disabled();
		$view = $this->getView();
		if (!Portal::getInstance()->inPrintMode()){
			$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
			$view->addBreadcrumb(Text::_('Orders'),Router::_("index.php?module=catalog&view=orders"));
			$view->addBreadcrumb(Text::_('Order payment'),"#");
		}
		$model=$this->getModel();
		$paycode=Request::getSafe("ALTADOC_TOKEN","");
		$_mode=Request::getSafe('mode','show');
		if ($paycode) $user_id=Session::restoreToken($paycode);
		else $user_id=0;
//		if (Request::getSafe('mode','show')=="recieve") $order=$model->getAbstractOrder($order_id);
//		else $order=$model->getOrder($order_id,$user_id);
		$order=$model->getAbstractOrder($order_id);
		if ($order) {
			$order_items=$model->getOrderItems($order_id);
			$pt_class=catalogPayment::getPaymentClass($order->o_pt_id);
			if ($pt_class) $pt_class->assignOrder($order,$order_items);
//			$dt_class=catalogDelivery::getDeliveryClass($order->o_dt_id);
		}	else {
//			$dt_class=false;
			$pt_class=false;
		}
		$view->assign("pt_class", $pt_class );
	}
	private function selectBasket() {
		$this->is_disabled();
		$vendor=Request::getInt("vendor",0);
		$_SESSION["basket_vendor"]=$vendor;
		if (!$vendor) {
			$view = $this->getView();
			$model=$this->getModel();
			$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
			$view->addBreadcrumb(Text::_('Orders'),Router::_("index.php?module=catalog&view=orders"));
			$view->addBreadcrumb(Text::_('Order registration'),"#");
		} else {
			$this->submitOrder();
		}
	}

	private function submitOrder() {
		$this->is_disabled();
		$err_found=false;
		$err_message="";
		$step = Request::getInt('step',0);
		$view = $this->getView();
		$model=$this->getModel();
		$i_agree = Request::getInt('i_agree', 0);
		if(!$i_agree&&$step==4) $step=0;
		$payment_type = Request::getInt('payment_type',0);
		$delivery_type = Request::getInt('delivery_type',0);
		if (!User::getInstance()->isLoggedIn()){
			$view->setLayout("signin");
		} elseif ($step==3) {
			// пытаемся выдать форму сохранения
			if (($payment_type)&&($payment_type)) {
				$payment=catalogPayment::getPaymentClass($payment_type);
				$delivery=catalogDelivery::getDeliveryClass($delivery_type);
				if ($payment&&$delivery){
					if($delivery->checkData($err_message)){
						$delivery_data=$delivery->save();
						$payment_data="";
						$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
						$view->addBreadcrumb(Text::_('Orders'),Router::_("index.php?module=catalog&view=orders"));
						$view->addBreadcrumb(Text::_('Order registration'),"#");
						$view->setLayout("confirm");
						$view->assign("payment", $payment);
						$view->assign("delivery", $delivery);
						unset($_SESSION["altadoc_order"]);
						$_SESSION["altadoc_order"]['payment_data']=$payment_data;
						$_SESSION["altadoc_order"]['delivery_data']=$delivery_data;
						$_SESSION["altadoc_order"]['payment_type']=$payment_type;
						$_SESSION["altadoc_order"]['delivery_type']=$delivery_type;
					} else $err_found=true;
				} else $err_found=true;
			} else $err_found=true;
		} elseif ($step==4) {
			// ну и сохраняем (и куки чистим, и сессию)
			if (isset($_SESSION["altadoc_order"])) {
				$payment_data=$_SESSION["altadoc_order"]['payment_data'];
				$delivery_data=$_SESSION["altadoc_order"]['delivery_data'];
				$payment_type = $_SESSION["altadoc_order"]['payment_type'];
				$delivery_type = $_SESSION["altadoc_order"]['delivery_type'];
				$payment=catalogPayment::getPaymentClass($payment_type,$payment_data);
				$delivery=catalogDelivery::getDeliveryClass($delivery_type,$delivery_data);
				if ($payment&&$delivery){
					if ($model->saveOrder($payment,$delivery)) {
						$order_id=Basket::getInstance()->order_id;
						$vendor_id=Basket::getInstance()->order_id;
						$this->notifyOrder($order_id, $vendor_id, true);
						$this->haltView();
						Basket::getInstance()->cleanCookie();
						$this->setRedirect("index.php?module=catalog&view=orders&layout=payment&order_id=".$order_id,Basket::getInstance()->order_message);
					} else {
						$this->setRedirect('index.php',Basket::getInstance()->order_message);
					}
				} else {
					unset($_SESSION["altadoc_order"]);
					$err_found=true;
				}
			} else $err_found=true;
		} else $err_found=true;

		if ($err_found){
			$view->setLayout("new");
			$delivery_form="";
			$pt_list=$model->getPaymentTypes();
			//			(count($this->pt_list)>0||(count($this->pt_list)==1 && count($this->dt_list)>0))
			if (count($pt_list)==1) $payment_type=$pt_list[0]->pt_id;
			else if (count($pt_list)==0) {
				$err_message=Text::_("Orders unavailable now");
			}
			if ($payment_type) {
				$items=Basket::getInstance()->getGoods();
				$order_weight=Basket::getInstance()->weight;
				$dt_list=$model->getDeliveryTypes($payment_type,$order_weight);
				if (count($dt_list)==1) $delivery_type=$dt_list[0]->dt_id;
				if (count($dt_list)==0) $err_message=Text::_("Orders unavailable now");
				if ($delivery_type) $delivery_form=$model->renderDeliveryForm($delivery_type);
			}	else $dt_list="";
			$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
			$view->addBreadcrumb(Text::_('Orders'),Router::_("index.php?module=catalog&view=orders"));
			$view->addBreadcrumb(Text::_('Order registration'),"#");
			$view->assign("delivery_form", $delivery_form);
			$view->assign("err_message", $err_message);
			$view->assign("pt_list", $pt_list);
			$view->assign("dt_list", $dt_list);
			$view->assign("pt_selected", $payment_type);
			$view->assign("dt_selected", $delivery_type);
		}
	}

	private function notifyOrder($order_id, $vendor_id, $notify_admin=false){
		$view = $this->getView();
		$model=$this->getModel();
		if (!mailerConfig::$robotNotifier) $_mailer= new Mailer();
		$this->set('layout',"order",true);
		$text= $this->renderOrder($order_id, 1, 0, 0);
		if ($notify_admin && catalogConfig::$catalogAdminEmail){
			$to=catalogConfig::$catalogAdminEmail;
			$theme=Text::_("Order from site")." № ".$order_id." ".Text::_("from")." ".Date::GetdateRus(Date::todaySQL());
			aNotifier::addToMailQueue($to,$theme,$text,"html");
		}
		if ($vendor_id) { // напоминание вендору
			$vendor=Vendor::getInstance($vendor_id);
			if (isset($vendor->v_contact_email) && $vendor->v_contact_email){
				$to=$vendor->v_contact_email;
				$theme=Text::_("Order from site")." № ".$order_id." ".Text::_("from")." ".Date::GetdateRus(Date::todaySQL());
				aNotifier::addToMailQueue($to,$theme,$text,"html");
			}
		}
		if (catalogConfig::$multy_vendor && $vendor_id!=catalogConfig::$default_vendor) {		// напоминание основному вендору вендору
			$vendor=Vendor::getInstance(catalogConfig::$default_vendor);
			if (isset($vendor->v_contact_email) && $vendor->v_contact_email){
				$to=$vendor->v_contact_email;
				$theme=Text::_("Order from site")." № ".$order_id." ".Text::_("from")." ".Date::GetdateRus(Date::todaySQL());
				aNotifier::addToMailQueue($to,$theme,$text,"html");
			}
		}
		$to=User::getInstance()->getEmail();
		$theme=Text::_("Your order")." № ".$order_id." ".Text::_("from")." ".Date::GetdateRus(Date::todaySQL());
		$text.= "<h4>".Text::_("Thank you for your order").".</h4>";
		aNotifier::addToMailQueue($to,$theme,$text,"html");
	}
	public function showSales(){
		$this->is_disabled();
		$view = $this->getView();
		$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
		$view->addBreadcrumb(Text::_('My sales'),"#");
		$model=$this->getModel();
		$orders = $model->getOrders();
		$status_arr = $model->getStatuses();
		$view->assign("orders", $orders);
		$view->assign("status_arr", $status_arr);

	}

	public function showOrders() {
		$this->is_disabled();
		switch($this->get('layout')) {
			case "basket":
				$this->selectBasket();
				break;
			case "new":
				$this->submitOrder();
				break;
			case "payment":
				$order_id = Request::getInt('order_id',0);
				if (!$order_id){ // Для систем которые думают что они самые умные и не дают нормальных возвратных url
					$order_id_alias = Request::getSafe('order_id_alias',"");
					if($order_id_alias)	$order_id = Request::getInt($order_id_alias,0);
				}
				$this->payOrder($order_id);
				break;
			case "order":
				$order_id = Request::getInt('order_id',0);
				$this->viewOrder($order_id);
				break;
			case "print":
				$this->set('layout',"order",true);
				$order_id = Request::getInt('order_id',0);
				$this->printOrder($order_id);
				break;
			default:
				$view = $this->getView();
				$view->addBreadcrumb(Text::_('Cabinet'),Router::_("index.php?module=user&view=panel"));
				$view->addBreadcrumb(Text::_('Orders'),"#");
				$model=$this->getModel();
				$orders = $model->getOrders();
				$status_arr = $model->getStatuses();
				$view->assign("orders", $orders);
				$view->assign("status_arr", $status_arr);
				break;
		}
	}


	/**
	 *
	 * Создает бреадкрамб от главной до позиции по всем путям
	 * @param unknown_type $psid
	 */
	public function createUpBreadcrumb($view,$psid,$is_goods=0) {
		$i=0;	$bc=array();
		$model = $this->getModel('goods');
		$limitBread=Module::getInstance()->getConfigValue('breadcrumb_lenght',0);
		if ($is_goods) $ggr_id=$model->getFirstParent($psid); else $ggr_id=$psid;
		$arr=$model->getParentGroup($ggr_id);
		if(count($arr)>0) {
			foreach($arr as $key=>$val) {
				$i++;
				$str=$val["title"];
				if($limitBread>0 && (mb_strlen($str) > $limitBread)) $bc[$i]['text']=mb_substr($str,0,$limitBread)."...";
				else $bc[$i]['text']=$val["title"];
				$bc[$i]['link']=Router::_("index.php?module=catalog&amp;view=goods&amp;psid=".(int)$key."&amp;alias=".$val["alias"]);
			}
		}
		$i++;
		$breadcrumb_start=Module::getInstance()->getConfigValue('breadcrumb_start','');
		$breadcrumb_start_link=Module::getInstance()->getConfigValue('breadcrumb_start_link','');
		if($breadcrumb_start && $breadcrumb_start_link) {
			$bc[$i]['text']=Text::_($breadcrumb_start); $bc[$i]['link']=Router::_($breadcrumb_start_link);
		} else {
			$bc[$i]['text']=Text::_('Main page'); $bc[$i]['link']=Router::_("index.php");
		}
		$bc=array_reverse($bc);
		//		Util::showArray($bc);
		foreach($bc as $tkey=>$tval)	{
			$view->addBreadcrumb($tval['text'],$tval['link']);
		}
	}

	public function showPayments() {
		$this->is_disabled();
		$view=$this->getView();
		$view->addBreadcrumb(Text::_('Cabinet'),"index.php?module=user&amp;view=panel");
		$view->addBreadcrumb(Text::_('My payments'),"#");
	}

	public function showReports() {
		$view=$this->getView();
		$view->addBreadcrumb(Text::_('Cabinet'),"index.php?module=user&amp;view=panel");
	 $view->addBreadcrumb(Text::_('My reports'),"#");
	}

	/*	public function ajaxgetGroupGoods() {
		$psid=Request::getInt('psid',0);
	$model = $this->getModel();
	$result=$model->getGoodsByGroup($psid);
	echo json_encode($result);
	}
	*/
	public function ajaxgetGoodsInfo() {
		$psid=request::getInt('psid');
		$model = $this->getModel('goods');
		$result=$model->getElement($psid);
		echo json_encode($result);
	}
	public function ajaxrenderDeliveryForm($psid=0){
		$this->is_disabled();
		if (!$psid) $psid=request::getInt('psid');
		$model = $this->getModel("orders");
		echo $model->renderDeliveryForm($psid);
	}

	public function ajaxrenderDeliverySelector(){
		$this->is_disabled();
		$psid = Request::getInt('psid',0);
		if($psid) {
			$items=Basket::getInstance()->getGoods();
			$order_weight=Basket::getInstance()->weight;
			$model = $this->getModel("orders");
			$dt_list=$model->getDeliveryTypes($psid, $order_weight);
			echo HTMLControls::renderLabelField("delivery_type",Text::_("Delivery type")." : ");
			if (count($dt_list)>1){
				echo HTMLControls::renderSelect('delivery_type', '', 'dt_id', 'dt_name', $dt_list, 0, 1,"getDeliveryForm(this)",false,"required");
				echo "<div id=\"delievery_form\"></div>";
			}	elseif(count($dt_list)==1) {
				echo HTMLControls::renderLabelField(false,$dt_list[0]->dt_name);
				echo HTMLControls::renderHiddenField('delivery_type',$dt_list[0]->dt_id);
				$this->ajaxrenderDeliveryForm($dt_list[0]->dt_id);
			}
		}
	}

	public function ajaxgetAddress(){
		$psid=request::getInt('psid');
		$userdata=Userdata::getInstance(User::getInstance()->u_id);
		$address=$userdata->getAddress($psid);
		echo json_encode($address);
	}
	public function ajaxsetCustomFilter(){
		$filter_by=request::getSafe('filter_by');
		$psid=request::getInt('psid');
		if ($filter_by && $psid){
			switch($filter_by){
				case "vendor":
					Session::setVar("filter.vendor",$psid);
					echo "OK";
					break;
				case "manufacturer":
					Session::setVar("filter.manufacturer",$psid);
					echo "OK";
					break;
				default:
					echo "ERROR";
					break;
			}
		} else echo "ERROR";
	}
	public function ajaxresetCustomFilter(){
		$filter_by=request::getSafe('filter_by');
		if ($filter_by){
			switch($filter_by){
				case "vendor":
					Session::unsetVar("filter.vendor");
					echo "OK";
					break;
				case "manufacturer":
					Session::unsetVar("filter.manufacturer");
					echo "OK";
					break;
				default:
					echo "ERROR";
					break;
			}
		} else echo "ERROR";
	}
	public function ajaxgetRandomGoods() {
		$helper=Module::getHelper("goods","catalog");
		$grpsid=0;
		$gid=0;
		$new=0;
		$hit=0;
		$goods = $this->getHelper("goods")->getRandomGoods($grpsid,$gid,$new,$hit);
		if (count($goods)){
			echo json_encode($goods[0],JSON_FORCE_OBJECT);
		}
	}
}
?>