<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class russianpostDeliveryClass extends catalogDelivery{
	protected $exc_required=array("psid","type_id","use_as_default","fullinfo"); 
	protected $inc_required=array(); 
	protected $post_types=array(1=>"normal",2=>"avia");
	private $post_zone=0;
	
	public function __construct($delivery_type,$_data=false) {
		parent::__construct($delivery_type,$_data);
		foreach($this->post_types as $key=>$val) $this->post_types[$key]=Text::_($val);
	}
	public function getParamsMask(){
	  $params['require_person']["vtype"]="boolean"; 		$params['require_person']["vdefault"]=1;
		$params['avia_bonus']["vtype"]="float"; 						$params['avia_bonus']["vdefault"]=231.50; 			$params['avia_bonus']["descr"]="avia bonus description";
		$params['avia_ebonus']["vtype"]="float"; 						$params['avia_ebonus']["vdefault"]=69.50; 			$params['avia_ebonus']["descr"]="avia ebonus description";
		$params['kilo']["vtype"]="table_select"; 						$params['kilo']["vdefault"]=catalogConfig::$default_wmeasure; $params['kilo']["source"]="SELECT meas_id AS fld_id, meas_short_name AS fld_name FROM #__measure WHERE meas_type=4 ORDER BY fld_name";
		$params['rubli']["vtype"]="table_select"; 					$params['rubli']["vdefault"]=catalogConfig::$default_currency; $params['rubli']["source"]="SELECT c_id AS fld_id, c_name AS fld_name FROM #__currency ORDER BY fld_name";
//		$params['country']["vtype"]="string"; 							$params['country']["vdefault"]="";
//		$params['tarif_belt']["vtype"]="select"; 						$params['tarif_belt']["vdefault"]=0; 						$params['tarif_belt']["source"]=array("1","2","3","4","5");
		$params['always_safe']["vtype"]="boolean"; 					$params['always_safe']["vdefault"]=0;
//		$params['max_parcel_weight']["vtype"]="float";	 		$params['max_parcel_weight']["vdefault"]=0; 		
//		$params['max_parcelpost_weight']["vtype"]="float"; 	$params['max_parcelpost_weight']["vdefault"]=0;	
		$params['parcel_price_500_1']["vtype"]="float"; 			$params['parcel_price_500_1']["vdefault"]=119;			$params['parcel_price_500_1']["descr"]="parcel price 500 description";
		$params['parcel_price_500_2']["vtype"]="float"; 			$params['parcel_price_500_2']["vdefault"]=120.6;			$params['parcel_price_500_2']["descr"]="parcel price 500 description";
		$params['parcel_price_500_3']["vtype"]="float"; 			$params['parcel_price_500_3']["vdefault"]=125.5;			$params['parcel_price_500_3']["descr"]="parcel price 500 description";
		$params['parcel_price_500_4']["vtype"]="float"; 			$params['parcel_price_500_4']["vdefault"]=152.9;			$params['parcel_price_500_4']["descr"]="parcel price 500 description";
		$params['parcel_price_500_5']["vtype"]="float"; 			$params['parcel_price_500_5']["vdefault"]=172.3;			$params['parcel_price_500_5']["descr"]="parcel price 500 description";
		$params['parcel_eprice_500_1']["vtype"]="float"; 			$params['parcel_eprice_500_1']["vdefault"]=9.1;			$params['parcel_eprice_500_1']["descr"]="parcel eprice 500 description";
		$params['parcel_eprice_500_2']["vtype"]="float"; 			$params['parcel_eprice_500_2']["vdefault"]=10.5;			$params['parcel_eprice_500_2']["descr"]="parcel eprice 500 description";
		$params['parcel_eprice_500_3']["vtype"]="float"; 			$params['parcel_eprice_500_3']["vdefault"]=15.4;			$params['parcel_eprice_500_3']["descr"]="parcel eprice 500 description";
		$params['parcel_eprice_500_4']["vtype"]="float"; 			$params['parcel_eprice_500_4']["vdefault"]=22.1;			$params['parcel_eprice_500_4']["descr"]="parcel eprice 500 description";
		$params['parcel_eprice_500_5']["vtype"]="float"; 			$params['parcel_eprice_500_5']["vdefault"]=25.50;			$params['parcel_eprice_500_5']["descr"]="parcel eprice 500 description";
		$params['complicated_tariff']["vtype"]="float";			$params['complicated_tariff']["vdefault"]=10;		$params['complicated_tariff']["descr"]="complicated tariff description";
		$params['police_price']["vtype"]="integer"; 					$params['police_price']["vdefault"]=4;					$params['police_price']["descr"]="police price description";
	  return $params; 
	}
	public function save() {
		$this->initRequired();
		$selected_addr=Request::getInt('listAddr');	
		$userdata=Userdata::getInstance(User::getInstance()->u_id);
		if ($selected_addr){
			$address = Userdata::getInstance(User::getInstance()->u_id)->getAddress($selected_addr);
		} else {
			if(Request::getInt('save_adress'))	$userdata->saveAddress();
			$address = Address::getTmpl();
			foreach($address as $key=>$val) $address[$key]=stripslashes(Request::getSafe($key,""));
		}
		$address['person']=Request::getSafe('person');
		$address['safe_post']=Request::getInt('safe_post',($this->getConfigValue("always_safe")?1:0));
		$address['post_type']=Request::getInt('post_type',0);
		$address['post_zone']=$this->post_zone; // ??????????
		$this->data=$address;
		return $this->data;
  }
  public function renderForm(){
  	$this->initRequired();
  	$addresses=Userdata::getInstance(User::getInstance()->u_id)->getAddresses();
  	$required=$this->intersectRequired(Address::getRequiredTmpl());
  	$address=Address::getTmpl();
		$addr_arr[0]="  --- ".Text::_("New address")."  --- ";
  	if(is_array($addresses)&&count($addresses))	{
			foreach($addresses as $key=>$val)	{
				$addr_arr[$key]=$val['fullinfo'];
			}
		}
		if(!isset($address['country_id'])) $address['country_id']=0; 
		if(!isset($address['region_id'])) $address['region_id']=0;
		if(!isset($address['town_id'])) $address['town_id']=0;
		$require_country=(in_array("country",$required)||in_array("country_id",$required));
		$require_town=(in_array("town",$required)||in_array("town_id",$required));
		$require_region=(in_array("region",$required)||in_array("region_id",$required));

		$html="<div style=\"float:left; display:block;\" class=\"delivery_form\">";
		$html.="<fieldset><legend>".Text::_("Delivery address")."</legend>";
		$html.="<div id=\"dt_data_header\">";
		$html.="<table class=\"userAddress\">";
		$selected_addr=Request::getInt("listAddr",0);
//			if ($selected_addr) Portal::getInstance()->addScriptDeclaration("$(document).ready(function() {fillAddressPanel('#listAddr')});");
		$html.="		<tr><th width=\"40%\">".Text::_("Post type")."</th><td>".HTMLControls::renderSelect("post_type", "post_type", false, false, $this->post_types,Request::getInt("post_type",1),false)."</td></tr>";
		if (!$this->getConfigValue("always_safe",0)) {
			$html.="		<tr><th>".Text::_("Safe").HTMLControls::renderBalloonButton("Safe description");
			$html.="		</th><td>".HTMLControls::renderCheckbox("safe_post",Request::getInt("safe_post",0),1)."</td></tr>";
		}
		$html.="<tr><th width=\"40%\">".Text::_("Saved addresses")."</th><td>".HTMLControls::renderSelect("listAddr", "listAddr", "", "", $addr_arr,$selected_addr,0,"toggleAddressPanel(this,'panel_addr');")."</td></tr>";
		$html.="</table>";
		$html.="</div>";
		$html.="<div id=\"panel_addr\"".($selected_addr ? " style=\"display:none;\"" : "").">";
		$html.="	<table class=\"userAddress\">";
		$html.="		<tr><th width=\"40%\">".Text::_("zip_code")."</th><td>".HTMLControls::renderInputText("zipcode", $address['zipcode'],6,6, "zipcode", (in_array('zipcode',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("Country")."</th><td>".Address::renderCountrySelector("",$address,$require_country)."</td></tr>";
		$html.="		<tr><th>".Text::_("Region")."</th><td>".Address::renderRegionSelector(0,"",$address,$require_region)."</td></tr>";
		$html.="		<tr><th>".Text::_("Town")."</th><td>".Address::renderTownSelector(0,"",$address,$require_town)."</td></tr>";
		$html.="		<tr><th>".Text::_("Street")."</th><td>".HTMLControls::renderInputText("street", $address['street'],100,100, "", (in_array('street',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("House")."</th><td>".HTMLControls::renderInputText("house", $address['house'],10,10, "", (in_array('house',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("Apartment")."</th><td>".HTMLControls::renderInputText("apartment", $address['apartment'],10,10, "", (in_array('apartment',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("Use as default")."</th><td>".HTMLControls::renderCheckbox("use_as_default",$address["use_as_default"])."</td></tr>";
		$html.="		<tr><th>".Text::_("Save address in list")."</th><td>".HTMLControls::renderCheckbox("save_adress",1)."</td></tr>";
		$html.="	</table>";
		$html.="</div>";
		$html.="<div id=\"dt_data_footer\">";
		$html.="	<table class=\"userAddress\">";
		$html.="		<tr><th width=\"40%\">".Text::_("Contact person")."</th><td>".HTMLControls::renderInputText("person", Request::getSafe("person",""),100,100, "person", (in_array('person',$required) ? "required" : ""))."</td></tr>";
		$html.="	</table>";
		$html.="</div>";
		$html.="</fieldset>";
		$html.=HTMLControls::renderHiddenField("fullinfo");
		if ($this->getConfigValue("always_safe")) $html.=HTMLControls::renderHiddenField("safe_post",1);
		$html.="</div>";
		return $html;
  }
  public function renderInfo($data=""){
  	if (!$data) $data=$this->getData();
  	$html="<p class=\"delivery_data\">";
  	if (isset($data["post_type"])&&array_key_exists($data["post_type"],$this->post_types)) $html.=$this->post_types[$data["post_type"]];
  	if (isset($data["safe_post"])&&$data["safe_post"]==1) $html.=", ".Text::_("Safe");
  	$html.="<br />".HTMLControls::renderLabelField(false,"Delivery address",true).": ";
		if (isset($data["zipcode"])) $html.=$data["zipcode"].", ";
  	if (siteConfig::$useTextAddress){
	  	if (isset($data["country"])) {
	  		$html.=$data["country"].", ";
  			if (isset($data["region"])) {
  				$html.=$data["region"].", ";
		  		if (isset($data["town"])) $html.=$data["town"].", ";
  			}
	  	}
  	} else {
  		if (isset($data["country_id"])) {
  			$country=Address::getCountryName($data["country_id"]);
  			if ($country) {
  				$html.=$country.", ";
		  		if (isset($data["region_id"])) {
		  			$region=Address::getRegionName($data["region_id"]);
		  			if ($region) {
		  				$html.=$region.", ";
				  		if (isset($data["town_id"])) {
				  			$town=Address::getTownName($data["town_id"]);
				  			if ($town) $html.=$town.", ";
				  		}
			  		}
		  		}
	  		}	  		
  		}
  	}
//Util::showCollapsedArray($data);
  	if (isset($data["street"])&&$data["street"]) $html.=$data["street"].", ";
  	if (isset($data["house"])&&$data["house"]) $html.=$data["house"].", ";
  	if (isset($data["apartment"])&&$data["apartment"]) $html.=$data["apartment"];
  	if (isset($data["person"])&&$data["person"]) $html.="<br />".HTMLControls::renderLabelField(false,"Contact person",true).": ".$data["person"];
  	$html.="</p>";
  	return $html; 
  }
  public function checkData(&$err_message){
	  $this->initRequired();
	  $no_errors=true;
  	$selected_addr=Request::getInt("listAddr",0);
  	if ($selected_addr) {
  		$address = Userdata::getInstance(User::getInstance()->u_id)->getAddress($selected_addr);
  	} else {
			$address = Address::getTmpl();
			$required=$this->intersectRequired(Address::getRequiredTmpl());
			foreach($required as $key) {
				if(in_array($key,$required)) {
					if(!Request::getSafe($key,"")||Request::getSafe($key,"")=="0") {
						$err_message=Text::_("Errors in address");
						$no_errors=false;
					} 
				}
				$address[$key]=stripslashes(Request::getSafe($key)); // отработать пересечения
			}
	//		$address['person']=Request::getSafe('person');
	//		$address['safe_post']=Request::getInt('safe_post',($this->getConfigValue("always_safe")?1:0));
	//		$address['post_type']=Request::getInt('post_type',0);
  	}
		if ($no_errors && $this->checkRegions($err_message,$address)) return $no_errors; 
		else return false;
  }
  public function calculate(){
  	$this->initRequired();
  	$sum=0;
  	$goods=Basket::getInstance()->getGoods();

  	$current_weight=Basket::getInstance()->weight;
//Util::showArray($this,"",true);
//Util::ddump($current_weight);
  	if ($current_weight) {
  		if ($this->data["post_zone"]){
				$gramm_weight=Measure::getInstance()->convert($current_weight,catalogConfig::$default_wmeasure,$this->getConfigValue("kilo"))*1000;
//Util::ddump($gramm_weight);
				$dt_data=$this->getData();

				//наземный транспорт
				$pprice=$this->getConfigValue("parcel_price_500_".$this->data["post_zone"]);
				$eprice=$this->getConfigValue("parcel_eprice_500_".$this->data["post_zone"]);
				// за превышение 500 грамм
				$e_weight=$gramm_weight-500;
				if ($e_weight>0) $ew_coeff=ceil($e_weight/500);
				else $ew_coeff=0;
				$sum=$pprice+$ew_coeff*$eprice; 
//Util::ddump($pprice,"pprice"); Util::ddump($ew_coeff,"ew_coeff");Util::ddump($eprice,"eprice"); Util::ddump($sum,"sum");
				// за тяжеловесные посылки (не учитывая нестандартную упаковку)
				if ($gramm_weight>10000&&$gramm_weight<500001) $sum+=ceil($sum*0.4*100)/100;
				else { if($gramm_weight>10000) $sum+=ceil($sum*0.3*100)/100; }
  						// надбавка за осторожность
				if ($this->getConfigValue("always_safe") || $dt_data["safe_post"]){
					$sum+=ceil($sum*0.3*100)/100;
//Util::ddump($sum,"safe_sum");
				}
				// Если АВИА то делаем надбавки
				if ($dt_data["post_type"]==2) {
	  			$avia_bonus=$this->getConfigValue("avia_bonus");
					$sum=$sum+$avia_bonus;
//Util::ddump($sum,"sum_with_avia");
					// за превышение 10 кг
					$avia_ebonus=$this->getConfigValue("avia_ebonus");
					if ($gramm_weight>10000) $sum=$sum+$avia_ebonus;
//Util::ddump($sum,"sum_with_avia_overall");
				}
				$comission=$this->getConfigValue("police_price");
				if ($comission){
					$sum+=(ceil($sum)*$comission)/100;
				}
  		} 
		}
		return $sum;
  }
  public function checkRegions(&$err_message,$address){
  	$no_errors=true; 
  	if (catalogConfig::$multy_vendor){
  		if (!isset($_SESSION["basket_vendor"]) || $_SESSION["basket_vendor"]==0){
  			$no_errors=false;
  			$err_message=Text::_("It is impossible to calculate delivery cost")."<br />".Text::_("Errors in vendor address");
  		} else {
	  		$self_zipcode=Vendor::getInstance()->getPostZipcode($_SESSION["basket_vendor"]);
  		}
    } else {
    	if (catalogConfig::$default_vendor){
  			$self_zipcode=Vendor::getInstance()->getPostZipcode(catalogConfig::$default_vendor);
				if (!$self_zipcode) {
	  			$no_errors=false;
  				$err_message=Text::_("It is impossible to calculate delivery cost")."<br />".Text::_("Errors in vendor address");
				}
  		} else {
  			$no_errors=false;
  			$err_message=Text::_("Vendor absent");
  		}
  	}
  	if (!$no_errors) return false;
 		$zipcode=Util::getArrParam($address,"zipcode","");
  	if (siteConfig::$useTextAddress){
  		if (array_key_exists("country", $address)) $country=$address["country"]; else $country="";
  		if (array_key_exists("town", $address))	$town=$address["town"]; else $town="";
  	} else {
			$country=Address::getCountryName(Util::getArrParam($address,"country_id",""));
			$town=Address::getTownName(Util::getArrParam($address,"town_id",""));
  	}

  	if ($zipcode&&$country&$town) {
  		if ($this->getRestrictedByZip($zipcode)|| $this->findZoneByZip($self_zipcode, $zipcode)==false){
  			$no_errors=false;
  			$err_message=Text::_("Selected delivery is unavailable to your address");
  		}
  	} else { 
  		$no_errors=false;
  		$err_message=Text::_("It is impossible to calculate delivery cost")."<br />".Text::_("May be errors in address");
  	}
//  	if ($no_errors) return $no_errors;
  	return $no_errors;
  }
  public function getRestrictedByZip($zipcode){
  	$sql="SELECT COUNT(post_index) FROM #__rp_shipping_restrictions WHERE post_index='".$zipcode."'";
  	Database::getInstance()->setQuery($sql);
  	return Database::getInstance()->loadResult();
  }
  public function findZoneByZip($self_zipcode, $zipcode){
  	$post_capital_to=$this->getCapitalByZip($zipcode);
	  if ($post_capital_to) {
	  	$post_capital_from=$this->getCapitalByZip($self_zipcode);
	  	if ($post_capital_from) {
		  	return $this->findZoneByCapitals($post_capital_from,$post_capital_to);
	  	}
	  }
	  return false;
  }
  public function findZoneByCapitals($capital_from,$capital_to){
//Util::ddump($capital_from." - ".$capital_to);
  	$zone_codes=false;
  	$sql="SELECT post_trunkzone, post_trunkzone_verified FROM #__rp_cross_post_regions WHERE post_capital_from='".$capital_from."' AND post_capital_to='".$capital_to."'";
  	Database::getInstance()->setQuery($sql);
  	if (Database::getInstance()->loadObject($zone_codes)) {
  		if ($zone_codes->post_trunkzone_verified) $this->post_zone=intval($zone_codes->post_trunkzone_verified);
  		else $this->post_zone=intval($zone_codes->post_trunkzone);
  		return true;
  	}
  	return false;
  }
  public function getCapitalByZip($zipcode){
  	$sql="SELECT post_capital_code FROM #__rp_post_indexes WHERE post_index='".$zipcode."'";
  	Database::getInstance()->setQuery($sql);
  	$post_capital=Database::getInstance()->loadResult();
  	return trim($post_capital);
  }
  private function initRequired(){
  	if ($this->getConfigValue("require_person")&& !array_key_exists("person", $this->inc_required)) array_push($this->inc_required,"person");
  }
}
?>