<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class simpleDeliveryClass extends catalogDelivery{
	protected $exc_required=array("psid","type_id","use_as_default","fullinfo","apartment");
	
	public function getParamsMask(){
	  $params['require_address']["vtype"]="boolean"; 		$params['require_address']["vdefault"]=1;
		$params['require_person']["vtype"]="boolean"; 		$params['require_person']["vdefault"]=1;
	  $params['require_phone']["vtype"]="boolean"; 			$params['require_phone']["vdefault"]=1;
	  return $params; 
	}
	public function save() {
  	$this->initRequired();
		$savedAddrId=Request::getInt('listAddr');	
		$userdata=Userdata::getInstance(User::getInstance()->u_id);
		if(request::get('save_adress'))	$userdata->saveAddress($savedAddrId);
		$address = Address::getTmpl();
		foreach($address as $key=>$val) $address[$key]=stripslashes(Request::getSafe($key,""));
		$address['person']=Request::getSafe('person');
		$address['phone']=Request::getSafe('phone');
		$this->data=$address;
		return $this->data;
  }
  public function renderForm(){
  	$this->initRequired();
  	$list_address=Userdata::getInstance(User::getInstance()->u_id)->getAddresses();
  	$required=$this->intersectRequired(Address::getRequiredTmpl());
  	$address=Address::getTmpl();
		if(is_array($list_address)&&count($list_address))	{
			foreach($list_address as $key=>$val)	{
				$list_addr[$key]=$val['fullinfo'];
			}
		} else $list_addr=false;
		if(!isset($address['country_id'])) $address['country_id']=0; 
		if(!isset($address['region_id'])) $address['region_id']=0;
		if(!isset($address['town_id'])) $address['town_id']=0;
		$require_country=(in_array("country",$required)||in_array("country_id",$required));
		$require_town=(in_array("town",$required)||in_array("town_id",$required));
		$require_region=(in_array("region",$required)||in_array("region_id",$required));
		$html="<div style=\"float:left; display:block;\" class=\"delivery_form\">";
		if ($this->getConfigValue("require_address")) {
			$html.="<fieldset><legend>".Text::_("Delivery address")."</legend>";
			$html.="<div id=\"useraddrselector\">";
			if($list_addr) { 
				$html.="<table class=\"userAddress\">";
				$selected_addr=Request::getInt("listAddr",0);
				if ($selected_addr) Portal::getInstance()->addScriptDeclaration("$(document).ready(function() {fillAddressPanel('#listAddr')});");
				$html.="<tr><th width=\"40%\">".Text::_("Saved addresses")."</th><td>".HTMLControls::renderSelect('listAddr', 'listAddr', '', '', $list_addr,$selected_addr,1,'fillAddressPanel(this);')."</td></tr>";
				$html.="</table>";
			}
			$html.="</div>";
	
			$html.="<div id=\"panel_addr\">";
			$html.="	<table class=\"userAddress\">";
			$html.="		<tr><th width=\"40%\">".Text::_("zip_code")."</th><td>".HTMLControls::renderInputText("zipcode", $address['zipcode'],6,6, "zipcode", (in_array('zipcode',$required) ? "required" : ""))."</td></tr>";
			$html.="		<tr><th>".Text::_("Country")."</th><td>".Address::renderCountrySelector("",$address,$require_country)."</td></tr>";
			$html.="		<tr><th>".Text::_("Region")."</th><td>".Address::renderRegionSelector(0,"",$address,$require_region)."</td></tr>";
			$html.="		<tr><th>".Text::_("Town")."</th><td>".Address::renderTownSelector(0,"",$address,$require_town)."</td></tr>";
			$html.="		<tr><th>".Text::_("Street")."</th><td>".HTMLControls::renderInputText("street", $address['street'],100,100, "", (in_array('street',$required) ? "required" : ""))."</td></tr>";
			$html.="		<tr><th>".Text::_("House")."</th><td>".HTMLControls::renderInputText("house", $address['house'],10,10, "", (in_array('house',$required) ? "required" : ""))."</td></tr>";
			$html.="		<tr><th>".Text::_("Apartment")."</th><td>".HTMLControls::renderInputText("apartment", $address['apartment'],10,10, "", (in_array('apartment',$required) ? "required" : ""))."</td></tr>";
			$html.="		<tr><th>".Text::_("Use as default")."</th><td>".HTMLControls::renderCheckbox("use_as_default",$address["use_as_default"])."</td></tr>";
			$html.="		<tr><th>".Text::_("Manual input")."</th><td>".HTMLControls::renderInputText("fullinfo", "",200,200, "fullinfo", (in_array('fullinfo',$required) ? "required" : ""))."</td></tr>";
			$html.="		<tr><th>".Text::_("Save address in list")."</th><td>".HTMLControls::renderCheckbox("save_adress",1)."</td></tr>";
			$html.="	</table>";
			$html.="</div>";
			$html.="</fieldset>";
		}
		$html1="";
		if ($this->getConfigValue("require_phone")) $html1.="		<tr><th width=\"40%\">".Text::_("Contact phone")."</th><td>".HTMLControls::renderInputText("phone", Request::getSafe("phone",""),100,100, "phone", (in_array('phone',$required) ? "required" : ""))."</td></tr>";
		if ($this->getConfigValue("require_person")) $html1.="		<tr><th width=\"40%\">".Text::_("Contact person")."</th><td>".HTMLControls::renderInputText("person", Request::getSafe("person",""),100,100, "person", (in_array('person',$required) ? "required" : ""))."</td></tr>";
		if($html1){
			$html.="<fieldset><legend>".Text::_("Contacts")."</legend>";
			$html.="	<table class=\"userAddress\">";
			$html.=$html1;
			$html.="	</table>";
			$html.="</fieldset>";
		}
		$html.="</div>";
		return $html;
  }
  public function renderInfo($data=""){
  	$html="<p class=\"delivery_data\">";
  	$html.=HTMLControls::renderLabelField(false,"Delivery address",true).": ";
  	if ($this->getConfigValue("require_address")) {
	  	if (siteConfig::$useTextAddress){
		  	if (isset($data["country"])) $html.=$data["country"].", ";
	  		if (isset($data["region"])) $html.=$data["region"].", ";
	  		if (isset($data["town"])) $html.=$data["town"].", ";
	  	}
	  	if (isset($data["street"])&&$data["street"]) $html.=$data["street"].", ";
	  	if (isset($data["house"])&&$data["house"]) $html.=$data["house"].", ";
	  	if (isset($data["apartment"])&&$data["apartment"]) $html.=$data["apartment"];
	  }
  	if (isset($data["person"])&&$data["person"]) $html.="<br />".HTMLControls::renderLabelField(false,"Contact person",true).": ".$data["person"];
  	if (isset($data["phone"])&&$data["phone"]) $html.="<br />".HTMLControls::renderLabelField(false,"Contact phone",true).": ".$data["phone"];
  	$html.="</p>";
  	return $html; 
  }
  public function checkData(&$err_message){
  	$this->initRequired();
  	$no_errors=true;
		$address = Address::getTmpl();
		if ($this->getConfigValue("require_address")) {
			$required=$this->intersectRequired(Address::getRequiredTmpl());
			foreach($required as $key) {
				if(!Request::getSafe($key,"")||Request::getSafe($key,"")=="0") $no_errors=false;
			}					
		}
		return $no_errors;
  }
  private function initRequired(){
  	if ($this->getConfigValue("require_phone")&& !array_key_exists("phone", $this->inc_required)) array_push($this->inc_required,"phone");
  	if ($this->getConfigValue("require_person")&& !array_key_exists("person", $this->inc_required)) array_push($this->inc_required,"person");
  }
}
?>