<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogModelgoods extends SpravModel {

	public $current_path = array();
	public $ParentArray=array(); // список родительских групп товара

	public function getImages($psid=0) {
		if ($psid) {
			$query = "SELECT * FROM #__goods_img WHERE i_deleted=0 AND i_enabled=1 AND i_gid='".$psid."' ORDER BY i_ordering";
			$this->_db->setQuery($query);
			return $this->_db->loadObjectList();
		} else return array();
	}
	public function getAnalogs($psid){
		$sql="SELECT DISTINCT a.a_id AS id, g.g_name AS title,g.g_thumb as thumb,
				g.g_alt_thm as seo_alt,g.g_title_thm as seo_title,g.g_alias as alias
			 FROM #__goods_analogs AS a,#__goods AS g WHERE g.g_id=a.a_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function getVideos($psid=0) {
		if ($psid) {
			$query = "SELECT * FROM #__goods_videos WHERE v_deleted=0 AND v_published=1 AND v_gid='".$psid."' ORDER BY v_ordering";
			$this->_db->setQuery($query);
			return $this->_db->loadObjectList();
		} else return array();
	}
	public function getElement($psid=0,$fillempty=false) {
		if (is_null($this->meta)) $this->loadMeta();
		$meta=$this->meta;
		$result=parent::getElement($psid);
		return $result;
	}
	public function getFirstParent($psid){
		$sql="SELECT l.parent_id
				FROM #__goods_links AS l, #__goods_group AS g
				WHERE l.parent_id=g.ggr_id
				AND l.g_id='".$psid."'
				AND g.ggr_deleted=0
				AND g.ggr_enabled=1
				ORDER BY l.ordering";
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadResult();
	}
	public function getParentGroup($gr_id,$level=0){
		if(!$level) $this->current_path=null;
		$sql="SELECT `ggr_id`,`ggr_id_parent`,`ggr_name`,`ggr_alias`
				FROM #__goods_group
				WHERE ggr_deleted=0 AND ggr_id=".(int)$gr_id;
		Database::getInstance()->setQuery($sql);
		if(Database::getInstance()->LoadObject($res))	{
			$this->current_path[$res->ggr_id]["title"]=$res->ggr_name;
			$this->current_path[$res->ggr_id]["alias"]=$res->ggr_alias;
			if($res->ggr_id_parent)	{
				$level++;
				$this->getParentGroup($res->ggr_id_parent,$level);
			}
		}
		return $this->current_path;
	}
	public function loadGroup($ggr_id) {
		$query = "SELECT * FROM #__goods_group WHERE ggr_id=".intval($ggr_id)." AND ggr_enabled=1 AND ggr_deleted=0";
		$this->_db->setQuery($query);
		$this->_db->loadObject($grp);
		return $grp;
	}
	public function loadChildGroups($parent_id) {
		$query = "SELECT * FROM #__goods_group WHERE ggr_id_parent=".intval($parent_id)." AND ggr_enabled=1 AND ggr_deleted=0 ORDER BY ggr_ordering,ggr_name";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	public function getNameGroup($ggr_id) {
		$query = "SELECT ggr_name FROM #__goods_group WHERE ggr_id=".intval($ggr_id)." AND ggr_enabled=1 AND ggr_deleted=0";
		$this->_db->setQuery($query);
		return $this->_db->loadResult();
	}

	/**
	 *
	 * Возвращает массив групп товара
	 * @param unknown_type $id - элемента от которого строимся вверх
	 */
	public function getParentArray($id) {
		$this->_db->setQuery("SELECT ggr_name as title,ggr_id as id, ggr_id_parent as parent FROM #__goods_group
				WHERE ggr_id='".$id."'");
		$row=false;
		$this->_db->loadObject($row);
		if($row) {
			if(!key_exists($row->id, $this->ParentArray)) {
				$this->ParentArray[$row->id]['title']=$row->title;
				$this->ParentArray[$row->id]['parent']=$row->parent;
				if($row->parent>0)	{
					$this->getParentArray($row->parent);
				}
			}
			return true;
		}
	}

	public function GetGroupTree($psid) {
		$listGroup=$this->GetGroupList($psid);
		if($listGroup) 	{
			foreach($listGroup as $val) {
				$group_list=$this->getParentArray($val);
			}
		}
		return $this->ParentArray;
	}
	public function GetGroupList($psid) {
		$sql = "select parent_id from #__goods_links where g_id='".$psid."'";
		$this->_db->setQuery($sql);
		$result=$this->_db->loadResultArray();
		return $result;
	}
	public function getVendorName($psid){
		$sql="SELECT v_name FROM #__vendors WHERE v_id=".(int)$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	public function getManufacturerName($psid){
		$sql="SELECT mf_name FROM #__manufacturers WHERE mf_id=".(int)$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	public function updateComplectPrice($g){
		if (is_object($g) && $g->g_type==5){
			$g->g_price_1=0;
			$g->g_price_2=0;
			$g->g_price_3=0;
			$g->g_price_4=0;
			$g->g_price_5=0;
			$sql="SELECT g.g_id, g.g_price_1, g.g_price_2, g.g_price_3, g.g_price_4, g.g_price_5, s.s_quantity";
			$sql.=" FROM #__goods_sets AS s, #__goods AS g";
			$sql.=" WHERE s.s_id=g.g_id AND s.g_id=".$g->g_id;
			$this->_db->setQuery($sql);
			$gsets = $this->_db->loadObjectList();
			if(count($gsets)){
				foreach($gsets as $gset) {
					$g->g_price_1=$g->g_price_1+$gset->g_price_1*$gset->s_quantity;
					$g->g_price_2=$g->g_price_2+$gset->g_price_2*$gset->s_quantity;
					$g->g_price_3=$g->g_price_3+$gset->g_price_3*$gset->s_quantity;
					$g->g_price_4=$g->g_price_4+$gset->g_price_4*$gset->s_quantity;
					$g->g_price_5=$g->g_price_5+$gset->g_price_5*$gset->s_quantity;
				}
			}
		}
		return $g;
	}
}

?>