<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class robokassaPaymentClass extends catalogPayment {
	/* ROBOKASSA API */
	private $_errors = array();
	private $_payPoint = "http://localhost/";
	private $_allowed_currencies=array();
	public function __construct($payment_type,$_data=false) {
		parent::__construct($payment_type,$_data);
	}
	public function getParamsMask(){
		$params['rk_user']["vtype"]="string"; 		$params['rk_user']["vdefault"]="magazin";
		$params['rk_password_1']["vtype"]="string"; $params['rk_password_1']["vdefault"]="password_1";
		$params['rk_password_2']["vtype"]="string"; $params['rk_password_2']["vdefault"]="password_2";
		$params['rk_sandbox']["vtype"]="boolean";	$params['rk_sandbox']["vdefault"]=true;
		return $params;
	}
	private function initData(){
		$this->_allowed_currencies=array("USD","EUR","RUB");
		if ($this->getConfigValue("rk_sandbox")){
			$this->_payPoint = "http://test.robokassa.ru/Index.aspx";
		} else {
			$this->_payPoint = "https://auth.robokassa.ru/Merchant/Index.aspx";
		}
		if (!in_array(Currency::getCode($this->payment->pt_currency), $this->_allowed_currencies)) {
			echo "<p class=\"error\">".Text::_("Unsupported currency")."</p	>";
			return false;
		}
		return true;
	}
	public function show() {
		if ($this->initData()) {
			$this->showPanel();
		}
	}
	public function recieve(){
		@ob_end_clean(); 
		Portal::getInstance()->disableTemplate();
		$mrh_pass2=$this->getConfigValue("rk_password_2","");
		$inv_id = $this->order->o_id;	// shop's invoice number
		$order_summ  = $this->order->o_total_sum;   // invoice summ
		$out_summ = Request::getSafe("OutSum","");
		$crc= Request::getSafe("SignatureValue","");
		$my_crc = md5($out_summ.":".$inv_id.":".$mrh_pass2.":shp_order_id=".$inv_id);
		if(strtoupper($crc)==strtoupper($my_crc)) {
			echo "OK".$inv_id;
			$this->setPaid();
			Util::halt();
		}
	}
	public function success(){
		$mrh_pass1=$this->getConfigValue("rk_password_1","");
		$inv_id = $this->order->o_id;	// shop's invoice number
		$order_summ  = $this->order->o_total_sum;   // invoice summ
		$out_summ = Request::getSafe("OutSum","");
		$crc= Request::getSafe("SignatureValue","");
		$my_crc = md5($out_summ.":".$inv_id.":".$mrh_pass1.":shp_order_id=".$inv_id);
		if(strtoupper($crc)==strtoupper($my_crc)) {
			if (floatval($order_summ)==floatval($out_summ)){
				$data["OutSum"]=$out_summ;
				$data["OutDate"]=Date::GetdateRus(time(),1,false);
				$this->data=$data;
				$this->addPaymentData();
				echo "<p class=\"ok\">".Text::_("Payment successful")."</p	>";
			} else {
				echo "<p class=\"error\">".Text::_("Incorrect payment sum")."</p	>";
				echo "<p class=\"error\">".Text::_("Please, contact administrator to resolve this problem")."</p	>";
			}
		} else {
			echo "<p class=\"error\">".Text::_("Signature failure")."</p	>";
			echo "<p class=\"error\">".Text::_("Please, contact administrator to resolve this problem")."</p	>";
		}
	}
	public function cancel(){
		echo "<h3 class=\"title\">".Text::_("Order payment")." № ".$this->order->o_id." ".Text::_("from")." ".Date::GetdateRus($this->order->o_date)."</h3>";
		echo "<h4>".Text::_("Your payment type")." : ".$this->payment->pt_name."</h4>";
		echo "<p class=\"error\">".Text::_("Payment canceled")."</p	>";
		echo $this->getPaymentButton();
	}
	private function showPanel() {
		echo "<h3 class=\"title\">".Text::_("Order payment")." № ".$this->order->o_id." ".Text::_("from")." ".Date::GetdateRus($this->order->o_date)."</h3>";
		echo "<h4>".Text::_("Your payment type")." : ".$this->payment->pt_name."</h4>";
		if ($this->order->o_paid){
			echo "<p class=\"ok\">".Text::_("Payment already done")."</p	>";
		} else {
			echo $this->getPaymentButton();
		}
	}
	private function getPaymentButton(){
		$this->initData();
		$mrh_login=$this->getConfigValue("rk_user","");
		$mrh_pass1=$this->getConfigValue("rk_password_1","");
		$inv_id    = $this->order->o_id;	// shop's invoice number
		$inv_desc  = Text::_("Order payment")." № ".$this->order->o_id." ".Text::_("from")." ".Date::GetdateRus($this->order->o_date);   // invoice desc
		$out_summ  = $this->order->o_total_sum;   // invoice summ
		$currency = Currency::getCode($this->order->o_currency);
		$crc  = md5($mrh_login.":".$out_summ.":".$inv_id.":".$mrh_pass1.":shp_order_id=".$inv_id);
		$url = $this->_payPoint."?MrchLogin=".$mrh_login."&OutSum=".$out_summ."&InvId=".$inv_id."&Desc=".$inv_desc."&SignatureValue=".$crc."&shp_order_id=".$inv_id."&sIncCurrLabel=".$currency;
		$html ="<div style=\"float:left; display:block;\" class=\"form_selector\">";
		$html.="<a href=\"".$url."\"><img src=\"/images/payments/robokassa.jpg\" align=\"left\" style=\"margin-right:7px;\" alt=\"ROBOKASSA\" /></a> \n";
		$html.="</div>";
		return $html;
	}
	public function renderInfo($data="") {
		if (!$data) $data=$this->getData();
		$html="<br />";
		if (is_array($data)){
			if (isset($data["OutSum"])&&isset($data["OutDate"])) $html.="<b>".Text::_("Payment sum")." : </b>".$data["OutSum"]."<br /><b>".Text::_("Payment date")." : </b>".$data["OutDate"]."<br />";
		}
		return $html;
	}
}
?>