<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class feedbackControllerdefault extends SpravController {
	public function showMessage($msg="") {
		Module::getInstance()->get('reestr')->set('task',"modify");
		if ($msg) {
			$script="$(document).ready(function(){ alert('".$msg."')});";
			Portal::getInstance()->addScriptDeclaration($script);
		}
		$this->modify();
	}
	public function modify($ajaxModify=false) {
		$reestr = Module::getInstance()->get('reestr');
		$moduleName	= Module::getInstance()->getName();
		$viewname = $this->getView()->getName();
		$model = $this->getModel();
		$multy_code   = 0;
		$psid         = 0;
		$reestr->set('ajaxModify',$ajaxModify);
		$reestr->set('view',$viewname);
		$reestr->set('model',$model);
		$reestr->set('metadata',$model->meta);
		$reestr->set("multy_code",$multy_code);
		$reestr->set('psid',$psid);
		$layout		= request::get('layout');
		$start		= request::get('start');
		$sort		= request::get('sort');
		$orderby	= request::get('orderby');
		$reestr->set('layout',$layout);
		$reestr->set('start',$start);
		$reestr->set('sort',$sort);
		$reestr->set('orderby',$orderby);
		$reestr->set('task',"save");
		$result = $model->getElement();
		if (!$result) $result = new stdClass();
		$view = $this->getView();
		if(User::getInstance()->isLoggedIn()) {
			$view->assign('authorized',true);
			$result->f_uid = User::getInstance()->getID();
			$result->f_sender = User::getInstance()->getNickname();
			$result->f_mail = User::getInstance()->getEmail();
		} else {
			$view->assign('authorized',false);
			$result->f_uid=0;
			$result->f_sender = Request::getSafe('f_sender','');
			$result->f_mail = Request::getSafe('f_mail','');
		}
		$afields=$model->meta->getListAdditionalField($model->meta->tablename);
		$result->f_theme = Request::getSafe('f_theme',$this->getTheme());
		$result->f_text = Request::getSafe('f_text','');
		if (count($afields)){
			foreach($afields as $af=>$obj){ $result->$af = Request::getSafe($af,''); }
		}
		$view->addBreadcrumb(Text::_("Feedback"),"");
		$art_id=$this->getModule()->getConfigValue("forewordArticle",0);
		if ($art_id) {
			$helper=$this->getHelper("article","article");
			$article=$helper->getArticle($art_id);
		} else $article=false;
		$view->assign('article',$article);
		$view->assign('disableCaptcha',$this->checkACL("feedbackDisableCaptcha",false));
		$view->modify($result);
		$this->haltView();
	}
	
	public function save() {
		$is_err=1;
		$model = $this->getModel();
		if(User::getInstance()->isLoggedIn()) {
			$f_uid = User::getInstance()->getID();
			$f_sender = User::getInstance()->getNickname();
			$f_mail = User::getInstance()->getEmail();
		} else {
			$f_uid=0;
			$f_sender = Request::getSafe('f_sender','');
			$f_mail = Request::getSafe('f_mail','');
		}
		$f_theme = Request::getSafe('f_theme',"");
		$f_text = Request::getSafe('f_text','');
		Event::raise("captcha.checkResult",array("module"=>"feedback"));
		if((!$this->checkACL("feedbackDisableCaptcha",false))&&isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) { $msg =Text::_("Wrong captcha"); unset($_SESSION['captcha_string']); }
		elseif (!$f_sender) $msg =Text::_("Enter name");
		elseif (!$f_mail) $msg =Text::_("Enter e-mail");
		elseif (!Mailer::checkEmail($f_mail)) $msg =Text::_("Wrong e-mail");
		elseif (!$f_theme) $msg =Text::_("Enter theme");
		elseif (!$f_text) $msg =Text::_("Enter text");
		elseif((!$this->checkACL("feedbackDisableFloodControl",false))&&(User::checkFloodPoint())) {$msg = Text::_('Flood is found');}
		else {
			$f_ip = User::getInstance()->getIP();
			$_REQUEST["f_uid"]=$f_uid;
			if ($f_uid) {
				$_REQUEST["f_sender"]=$f_sender;
				$_REQUEST["f_mail"]=$f_mail;
			}
			$_REQUEST["f_ip"]=$f_ip;
			$_REQUEST["f_date"]=Date::nowSQL();
			$msgid=$model->save();
			if ($msgid) {
				if (siteConfig::$sendFeedbacksByMail) { $res=$model->send($msgid,$this->getTheme(),$f_sender,$f_mail,$f_ip,$f_theme,$f_text,$this->getCopyAddresses()); }
				Event::raise("feedback.send",array('senderName'=>$f_sender));
				$msg = Text::_('Feedback sent'); $is_err=0;
			}	else {
				$msg = Text::_('Feedback not sent');
			}
		}
		if ($is_err) {
			$this->showMessage($msg,1);
		}	else $this->setRedirect('index.php?module=feedback&view=message',$msg);
	}
	
/******************************************************************************************/	
	public function showSend($msg="",$forceRender=0) {
		if(User::getInstance()->isLoggedIn()) {
			$senderName = User::getInstance()->getNickname();
			$senderEmail = User::getInstance()->getEmail();			
		} else {
		  $senderName = Request::getSafe('feedbackSenderName','');
		  $senderEmail = Request::getSafe('feedbackSenderEmail','');			
		}						
		$feedbackTheme = Request::getSafe('feedbackTheme','');
		$feedbackText = Request::getSafe('feedbackText','');
		$view = $this->getView();
		$view->addBreadcrumb(Text::_('Feedback'),'#');
		Portal::getInstance()->setTitle(Text::_("Contact information"));
		if ($msg) {
			$script="$(document).ready(function(){ alert('".$msg."')});";
			Portal::getInstance()->addScriptDeclaration($script);
		}
		if (!$feedbackTheme) $feedbackTheme=$this->getTheme();
		$view->assign('senderName',$senderName);
		$view->assign('disableCaptcha',$this->checkACL("feedbackDisableCaptcha",false));
		$view->assign('senderEMail',$senderEmail);
		$view->assign('feedbackTheme',$feedbackTheme);
		$view->assign('feedbackText',$feedbackText);
		if ($forceRender) $view->render();
	}

	public function send() {
		$is_err=1;
		$model = $this->getModel('send');
		if(User::getInstance()->isLoggedIn()) {
			$senderName = User::getInstance()->getNickname();
			$senderEmail = User::getInstance()->getEmail();			
		}	else {
			$senderName = Request::getSafe('feedbackSenderName','');
			$senderEmail = Request::getSafe('feedbackSenderEmail','');			
		}						
		$senderIP = User::getInstance()->getIP();
		$feedbackTheme = Request::getSafe('feedbackTheme','');
		$feedbackText = Request::getSafe('feedbackText','');
		$feedbackType = Request::getInt('feedbackType',0);
		$feedbackItemId = Request::get('feedbackItemId','0');
		
		Event::raise("captcha.checkResult",array("module"=>"feedback"));
		if((!$this->checkACL("feedbackDisableCaptcha",false))&&isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) { $msg =Text::_("Wrong captcha"); unset($_SESSION['captcha_string']); }
		elseif (!$senderName) $msg =Text::_("Enter name");
		elseif (!$senderEmail) $msg =Text::_("Enter e-mail");
		elseif (!Mailer::checkEmail($senderEmail)) $msg =Text::_("Wrong e-mail");
		elseif (!$feedbackTheme) $msg =Text::_("Enter theme");
		elseif (!$feedbackText) $msg =Text::_("Enter text");
		elseif((!$this->checkACL("feedbackDisableFloodControl",false))&&(User::checkFloodPoint())) {$msg = Text::_('Flood is found');}
		else {
			$msgid=$model->save($senderName,$senderEmail,$senderIP,$feedbackTheme,$feedbackText);
			if ($msgid) {
				if (siteConfig::$sendFeedbacksByMail) { $res=$model->send($msgid,$this->getTheme(),$senderName,$senderEmail,$senderIP,$feedbackTheme,$feedbackText,$this->getCopyAddresses()); }
				Event::raise("feedback.send",array('senderName'=>$senderName));
				$msg = Text::_('Feedback sent'); $is_err=0;
			}	else {
				$msg = Text::_('Feedback not sent');
			}
		}
		if ($is_err) { 
			$this->showSend($msg,1); 
		}	else $this->setRedirect('index.php?module=feedback',$msg);
	}
	private function getTheme() {
		return $this->getModule()->getConfigValue("Feedback_theme",Text::_('Message for site administration'),true);
	}
	private function getCopyAddresses() {
		return $this->getModule()->getConfigValue("Feedback_copyAdresses","",true);
	}
	
	public function showMessages() {
		$model=$this->getModel();
		$view=$this->getView();
		$view->addBreadcrumb(Text::_('Cabinet'),"index.php?module=user&amp;view=panel");
		$view->addBreadcrumb(Text::_("My feedbacks"),"#");
		if(User::getInstance()->isLoggedIn())$listmessages=$model->getListMessages();
		else $listmessages=array();
		$view->assign('list',$listmessages);
	}
}

?>