<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class forumControllerdefault extends SpravController {
	private function canModerate($forum_id) {
		$rightsModel = $this->getModel('rights');
		return $rightsModel->checkAction($forum_id,"moderate");
	}
	private function canModify($forum_id, $theme=false,$post=false) {
		if (!$forum_id) return false;
		$rightsModel = $this->getModel('rights');
		if ($theme) {
			return ((User::getInstance()->getId() == $theme->t_author_id) || $rightsModel->checkAction($forum_id,"moderate"));
		} elseif ($post) {
			return ((User::getInstance()->getId() == $post->p_author_id) || $rightsModel->checkAction($forum_id,"moderate"));
		} else return false; //$rightsModel->checkAction($forum_id,"moderate");
	}
/*
	private function canVote($post) {
		$rightsModel = $this->getModel('rights');
		return ($rightsModel->checkAction($post->p_blog_id,"postvote"));
	}
*/
	public function showNew() {
		$view=$this->getView();
		$mdl=Module::getInstance();
		$model = $this->getModel();
		$rightsModel = $this->getModel("rights");
		$view->setBreadcrumb(Text::_('Forums'),"index.php?module=forum");
		$allowed_ids = $rightsModel->getForumIdsForUser(User::getInstance()->getId(),User::getInstance()->getRole());
		$last_visit=User::getInstance()->getLastVisit();
		$posts=$model->getMessages($allowed_ids,$last_visit);
		$view->assign('themes',$posts);
	}
	public function showSection() {
		$view=$this->getView();
		$mdl=Module::getInstance();
		$model = $this->getModel();
		$rightsModel = $this->getModel("rights");
		$psid  = Request::getInt('psid', 0);
		$view->setBreadcrumb(Text::_('Forums'),"index.php?module=forum");
		$allowed_ids = $rightsModel->getForumIdsForUser(User::getInstance()->getId(),User::getInstance()->getRole());
		if ($psid) $canRead=in_array($psid,$allowed_ids); else $canRead=true;
		if ($canRead) {
			$canModerate=$rightsModel->checkAction($psid,"moderate");
//			$newposts=$this->getHelper("posts")->countMessagesFromLastVisit(User::getInstance()->getId(),User::getInstance()->getRole(),!$canModerate);
			$newposts=$this->getHelper("posts")->countMessagesFromLastVisit(User::getInstance()->getId(),User::getInstance()->getRole());
			$section=$model->getSection($psid);
			$this->updateBreadcrumb($section,false);
			$sections=$model->getSections($psid,$allowed_ids);
			if ($canModerate) $themesCount=$model->getThemesCount($psid,false);
			else $themesCount=$model->getThemesCount($psid);
			$paginator = $model->createPaginator($view,$themesCount);
			$link="index.php?module=forum&view=section";
			if ($psid) $link.="&psid=".$psid;
			$paginator->buildPagePanel($link);
			if ($canModerate) $themes=$model->getThemes($psid,false);
			else $themes=$model->getThemes($psid);
			$view->assign('newposts',$newposts);
			$view->assign('canModerate',$canModerate);
			$view->assign('canWrite',$rightsModel->checkAction($psid,"write"));
			$view->assign('allowed_ids',$allowed_ids);
			$view->assign('section',$section);
			$view->assign('sections',$sections);
			$view->assign('themes',$themes);
		} else { Util::redirect(Router::_("index.php?module=forum")); }
//		} else { Util::redirect(Router::_("index.php")); } // заглушка
	}
	public function showTheme() {
		$view=$this->getView();
		$mdl=Module::getInstance();
		$model = $this->getModel();
		$rightsModel = $this->getModel("rights");
		$psid  = Request::getInt('psid', 0);
		$lastPage  = Request::getInt('lastPage', 0);
		$view->setBreadcrumb(Text::_('Forums'),"index.php?module=forum");
		$theme=$model->getTheme($psid,false);
		if (($theme)&&($rightsModel->checkAction($theme->t_forum_id,"read"))) {
			$this->updateBreadcrumb(false,$theme);
			$canModerate=$rightsModel->checkAction($theme->t_forum_id,"moderate");
			if ($canModerate||(!$theme->t_deleted&&($theme->t_enabled || $theme->t_author_id==User::getInstance()->getID()))) {
				if($theme->t_author_id!=User::getInstance()->getID()) $this->touchTheme($psid);
				if ($canModerate) $postsCount=$model->getPostsCount($psid, false);
				else $postsCount=$model->getPostsCount($psid);
				$paginator = $model->createPaginator($view,$postsCount);
				$link="index.php?module=forum&view=theme";
				if ($psid) $link.="&psid=".$psid;
				$paginator->buildPagePanel($link);
				if ($canModerate)	$posts=$model->getPosts($psid, false);
				else $posts=$model->getPosts($psid, false);
				$section=$this->getModel("section")->getSection($theme->t_forum_id);
				$view->assign('canModerate',$canModerate);
				$view->assign('canWrite',$rightsModel->checkAction($theme->t_forum_id,"write")&&$theme->t_enabled);
				$view->assign('theme',$theme);
				$view->assign('posts',$posts);
				$view->assign('section',$section);
//				$view->assign('page',$page);
			} else { $this->setRedirect("index.php?module=forum&view=section&psid=".$theme->t_forum_id, Text::_("Theme is absent")); }
		} else { Util::redirect(Router::_("index.php?module=forum")); }
	}
	public function touchTheme($psid) {
		if (($psid)&&(!isset($_SESSION["forum_views"][$psid]))){
			$model = $this->getModel("theme");
			$model->touchTheme($psid);
			$_SESSION["forum_views"][$psid]=1;
		}
	}
	public function modifyTheme($errMessage=""){
		$view=$this->getView();
		$model = $this->getModel("section");
		$rightsModel = $this->getModel("rights");
		$view->setBreadcrumb(Text::_('Forums'),"index.php?module=forum&view=section");
		$this->set("layout","modify", true);
		$page  = Request::getInt('page', 0);
		$forum_id  = Request::getInt('psid', 0);
		$theme_id  = Request::getInt('tid', 0);
		$section=$model->getSection($forum_id);
		if($forum_id) {
			if ($rightsModel->checkAction($forum_id,"write")) {
				/***********************************************/
				if ($theme_id) {
					$theme=$model->getTheme($theme_id,$forum_id,false); 
					if ($theme && !$theme->t_closed) {
						if (!$this->canModify($forum_id,$theme)) {
							$theme_id=0;
							$theme=false;
						}
					} else {
						$theme_id=0;
						$theme=false;
					}
				} else {
					$theme_id=0;
					$theme=false;
				}
				/***********************************************/
				if($section) {
					if ($theme) {
						if($this->getModel('theme')->getPostsCount($theme->t_id,false)) $this->redirect("index.php?module=forum&view=theme&psid=".$theme->t_id, Text::_("Message modifying denied")); 
						$view->addBreadcrumb(Text::_('Modify theme'),"#");
						$newTagData=explode(',',$theme->t_tags);
						$theme->t_tags=""; $themeTags=array();
						foreach ($newTagData as $tag) {
							$tag = trim($tag);
							if ($tag != '' && !in_array($tag,$themeTags)) $themeTags[]=$tag;
						}
						if (count($themeTags)) $theme->t_tags=implode(",",$themeTags);
					} else {
						$view->addBreadcrumb(Text::_('New theme'),"#");
						$theme= new stdClass(); 
						$theme->t_id=0; $theme->t_text=Request::getSafe("themeText","");
						$theme->t_theme=Request::getSafe("themeTitle","");
						$theme->t_tags=Request::getSafe("themeTags","");
						$theme->t_fixed=Request::getInt("t_fixed",0);
						$theme->t_closed=Request::getInt("t_closed",0);
					}
					$view->assign('section',$section);
					$view->assign('page',$page);
					$view->assign('theme',$theme);
					$view->assign('premoderated',$section->f_premoderated);
					$view->assign('errMessage',$errMessage);
					$view->assign('disableCaptcha',$this->checkACL("forumDisableCaptcha",false));
					$view->render();
				} else { $this->setRedirect("index.php?module=forum&view=section", Text::_("Forum is absent")); }
			} else { $this->setRedirect("index.php?module=forum&view=section&psid=".$forum_id, Text::_("Permission is absent to write this forum")); }
		} else { $this->setRedirect("index.php?module=forum&view=section", Text::_("Forum is absent")); }
	}
	public function modifyPost($errMessage=""){
		$this->set("view","theme",true);
		$view=$this->getView();
		$model = $this->getModel("theme");
		$rightsModel = $this->getModel("rights");
		$view->setBreadcrumb(Text::_('Forums'),"index.php?module=forum&view=section");
		$this->set("layout","modify", true);
		$page  = Request::getInt('page', 0);
		$theme_id  = Request::getInt('psid', 0);
		$post_id  = Request::getInt('pid', 0);
		$theme=$model->getTheme($theme_id, false);
		if ($theme){
			if (!$theme->t_closed && $rightsModel->checkAction($theme->t_forum_id,"write")) {
				$section=$this->getModel("section")->getSection($theme->t_forum_id);
				/***********************************************/
				if($post_id) {
					$post=$model->getPost($post_id,$theme_id);
					if ($post){
						if (!$this->canModify($theme->t_forum_id, false, $post)) {
							$post_id=0;
							$post=false;
						}
					} else $post_id=0;
				} else {
					$post_id=0;
					$post=false;
				}
				/***********************************************/
				if ($post) {
					$view->addBreadcrumb(Text::_('Modify post'),"#");
				} else {
					$post= new stdClass(); 
					$post->p_id=0; $post->p_text=Request::getSafe("postText","");
					$post->p_theme=Request::getSafe("postTitle","RE:".$theme->t_theme);
					$view->addBreadcrumb(Text::_('New post'),"#");
				}
				$view->assign('post',$post);
				$view->assign('page',$page);
				$view->assign('theme',$theme);
				$view->assign('errMessage',$errMessage);
				$view->assign('premoderated',$section->f_premoderated);
				$view->assign('disableCaptcha',$this->checkACL("forumDisableCaptcha",false));
				$view->render();
			} else { $this->setRedirect("index.php?module=forum&view=theme&psid=".$theme->t_id, Text::_("Permission is absent to write this forum")); }
		} else { $this->setRedirect("index.php?module=forum&view=section", Text::_("Theme is absent")); }
	}
	
	public function updateBreadcrumb($section,$theme){
		if (!$section && !$theme) return false;
		elseif ($section){
			$parent_id=$section->f_parent_id;
		} elseif ($theme){
			$parent_id=$theme->t_forum_id;
		}
		if ($parent_id) {
			$forum=$this->getModel("section")->getSection($parent_id);
			if ($forum){
				$view=$this->getView();
				$view->addBreadcrumb($forum->f_name,"index.php?module=forum&view=section&psid=".$forum->f_id);
				
			} else return false;
		} else return false;
		return true;
	}

	private function toggleThemeField($field){
		$forum_id  = Request::getInt('psid', 0);
		$theme_id  = Request::getInt('tid', 0);
		$page  = Request::getInt('page', 0);
		if ($forum_id && $theme_id && $this->canModerate($forum_id)){
			$this->getModel("theme")->toggleThemeField($forum_id,$theme_id,$field);
			$redirectLink="index.php?module=forum&view=theme&psid=".$theme_id;
			if ($page) $redirectLink.="&page=".$page;
			$this->setRedirect($redirectLink);
		} else { $this->setRedirect("index.php?module=forum"); }
	}
	public function toggleThemePublished() { $this->toggleThemeField("t_enabled"); }	
	public function toggleThemeClosed() { $this->toggleThemeField("t_closed"); }	
	public function toggleThemeDeleted() { $this->toggleThemeField("t_deleted"); }	
	
	private function togglePostField($field){
		$theme_id  = Request::getInt('psid', 0);
		$post_id  = Request::getInt('pid', 0);
		$page  = Request::getInt('page', 0);
		$theme=$this->getModel("theme")->getTheme($theme_id, false);
		if ($theme && $post_id && $this->canModerate($theme->t_forum_id)){
			$this->getModel("theme")->togglePostField($theme_id,$post_id, $field);
			$redirectLink="index.php?module=forum&view=theme&psid=".$theme->t_id;
			if ($page) $redirectLink.="&page=".$page;
			$redirectLink.="#post".$post_id;
			$this->setRedirect($redirectLink);
		} else { $this->setRedirect("index.php?module=forum"); }
	}
	public function togglePostPublished() { $this->togglePostField("p_enabled"); }
	public function togglePostDeleted() { $this->togglePostField("p_deleted"); }
	
	public function saveTheme(){
		$errMessage=""; $canSave=false;
		$model=$this->getModel("section");
		$forum_id  = Request::getInt('psid', 0);
		$theme_id  = Request::getInt('tid', 0);		
		$page  = Request::getInt('page', 0);
		if (!$forum_id) $this->setRedirect("index.php?module=forum",Text::_("Forum is absent"));
		else {
			$themeTitle=Request::getSafe("themeTitle","");
			$themeText=Request::getSafe("themeText","");
			$themeTags=Request::getSafe("themeTags","");
			$oldTagData=array();
			Event::raise("captcha.checkResult",array("module"=>"forum"));
			if((!$this->checkACL("forumDisableCaptcha",false))&&isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) {
				$errMessage =Text::_("Wrong captcha"); unset($_SESSION['captcha_string']);
			}	elseif (!$themeTitle) $errMessage =Text::_("Specify theme");
			elseif (!$themeText) $errMessage =Text::_("Specify text");
			elseif((!$this->checkACL("forumDisableFloodControl",false))&&(User::checkFloodPoint())) {
				$errMessage = Text::_('Flood is found');
			} else {	
				$model=$this->getModel("section");
				$rightsModel=$this->getModel("rights");
				$canModerate=$rightsModel->checkAction($forum_id,"moderate");
				if ($canModerate) {
					$themeClosed=Request::getInt("t_closed",0);
					$themeFixed=Request::getInt("t_fixed",0);
				} else { $themeClosed=0; $themeFixed=0; }
				$forum=$model->getSection($forum_id);
				if ($forum) {
					$premoderated=$forum->f_premoderated;
					if($theme_id){
						if($this->getModel('theme')->getPostsCount($theme_id,false)) $this->redirect("index.php?module=forum&view=theme&psid=".$theme_id, Text::_("Message modifying denied"));				
						if ($canModerate) $theme=$model->getTheme($theme_id,$forum_id, false);
						else $theme=$model->getTheme($theme_id,$forum_id);
						if($theme && $this->canModify($forum_id, $theme)) { 
							$canSave=true; 
							$oldTagData=explode(',',$theme->t_tags);
						}
					} else { // считаем что тема новая
						if($rightsModel->checkAction($forum_id,"write")) { $canSave=true; }
					}
				}
				if ($canSave){
					// Вариант с простой фильтрацией
					$newTagData=explode(',',$themeTags); 
					$themeTags="";	$themeTagsArr=array();
					foreach ($newTagData as $tag) {
						$tag = trim($tag);
						if ($tag != '' && !in_array($tag,$themeTagsArr)) $themeTagsArr[]=$tag;
					}
					if (count($themeTagsArr)) $themeTags=",".implode(",",$themeTagsArr).",";
					// @TODO ТЕГИ !!!!!
/*
					$newTagData=explode(',',$themeTags);
					$themeTags="";
					foreach ($newTagData as $tag) {
						$tag = trim($tag);
						if ($tag != '') {
							if (!in_array($tag,$oldTagData)) $model->increaseTag($theme_id,$tag);	$themeTags .= $tag.",";
						}
					}
					foreach ($oldTagData as $ptag) {
						$ptag = trim($ptag);
						if ($ptag != '') { if (!in_array($ptag,$newTagData))	$model->decreaseTag($theme_id,$ptag);	}
					}
*/					
					if (!$theme_id) $newflag=1; else $newflag=0; // ???????????
					$theme_id=$model->saveTheme($theme_id, $forum_id, $themeTitle, $themeText, $themeTags, $themeClosed, $themeFixed, $premoderated);
					$redirectLink="index.php?module=forum&view=theme&psid=".$theme_id;
					if ($page) $redirectLink.="&page=".$page;
					if ($theme_id) $msg="Save successfull";
					else $msg="Save unsuccessfull";
					if (($newflag||$premoderated) && $theme_id) $this->reminderForModerator(false, $theme_id, $forum_id, $themeTitle);
				} else { $redirectLink=Router::_("index.php?module=forum"); $msg="Permission is absent to save this theme"; }
				$this->setRedirect($redirectLink, Text::_($msg));
			}	
			if($errMessage) $this->modifyTheme($errMessage);
		}
	}
	
	public function savePost(){
		$errMessage=""; $canSave=false; 
		$theme_id  = Request::getInt('psid', 0);
		$post_id  = Request::getInt('pid', 0);
		$page  = Request::getInt('page', 0);
		if (!$theme_id) $this->setRedirect("index.php?module=forum",Text::_("Theme is absent"));
		else {
			$postTitle=Request::getSafe("postTitle","");
			$postText=Request::getSafe("postText","");
			Event::raise("captcha.checkResult",array("module"=>"forum"));
			if((!$this->checkACL("forumDisableCaptcha",false))&&isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) {
				$errMessage =Text::_("Wrong captcha"); unset($_SESSION['captcha_string']);
			}	elseif (!$postTitle) $errMessage =Text::_("Specify theme");
			elseif (!$postText) $errMessage =Text::_("Specify text");
			elseif((!$this->checkACL("forumDisableFloodControl",false))&&(User::checkFloodPoint())) {
				$errMessage = Text::_('Flood is found');
			}	else {	
				$model=$this->getModel("theme");
				$rightsModel=$this->getModel("rights");
				// получим форум в который пишем через тему
				$theme=$theme=$model->getTheme($theme_id, false);
				if ($theme) $forum_id=$theme->t_forum_id; else $forum_id=0;
				$canModerate=$rightsModel->checkAction($forum_id,"moderate");
				if($forum_id){
					$fmodel=$this->getModel("section");
					$forum=$fmodel->getSection($forum_id);
					if ($forum) {
						$premoderated=$forum->f_premoderated;
						if ($post_id)	{
							if ($canModerate) $post=$model->getPost($post_id,$theme_id,false);
							else $post=$model->getPost($post_id,$theme_id);
							if($post && $this->canModify($forum_id, false,$post)) {	$canSave=true; }
						} else { // считаем что пост новый
							if($rightsModel->checkAction($forum_id,"write")) { $canSave=true;	}
						}
						if(!$theme->t_enabled) $canSave=false;
					} else Util::redirect("index.php?module=forum&view=section", Text::_("Forum is absent"));
				} else Util::redirect("index.php?module=forum&view=section", Text::_("Forum is absent"));
				if ($canSave){
					if (!$post_id) $nflag=1; else $nflag=0; // ???????????
					$post_id=$model->savePost($post_id, $theme_id, $postTitle, $postText,$premoderated);
					$redirectLink="index.php?module=forum&view=theme&psid=".$theme_id;
					if ($nflag && $post_id) $redirectLink.="&lastPage=1";
					elseif ($page) $redirectLink.="&page=".$page;
					if ($nflag && $post_id) $this->reminderForModerator($post_id, $theme_id, $forum_id, $postTitle);
					if ($post_id) $msg="Save successfull";
					else $msg="Save unsuccessfull";
				} else { $redirectLink=Router::_("index.php?module=forum"); $msg="Permission is absent to save this post"; }
				$this->setRedirect($redirectLink, Text::_($msg));
			}	
			if($errMessage) $this->modifyPost($errMessage);
		}
	}
  public function reminderForModerator($post_id, $theme_id, $forum_id, $theme) {
		if (!$theme_id) return false;
		$_mailer= new Mailer();
		$theme=Text::_("Message for forum moderator");
		$link="index.php?module=forum&view=theme&psid=".$theme_id;
		if ($post_id) $link.="&lastPage=1";
		$link=Router::_($link);
		$text=sprintf(Text::_("forum mail short text"),Portal::getURI(),	$theme, $link);
		$to=$this->getModerators($forum_id);
		foreach($to as $email=>$val){
			aNotifier::addToQueue($email, $theme, $text);
		} 
	}
  private function getModerators($forum_id=0) {
  	// @TODO Пока только по группам
  	$sql="SELECT r_id FROM #__forum_rights WHERE f_id=".$forum_id." AND flag=1 AND action='moderate'";
  	Database::getInstance()->setQuery($sql);
  	$roles=Database::getInstance()->loadObjectList("r_id");
  	$default_emails=array(soConfig::$siteEmail=>soConfig::$siteEmail);
  	if (count($roles)){
  		$roles_str=implode(",",array_keys($roles));
  		$sql="SELECT u_email FROM #__users WHERE u_role IN (".$roles_str.") AND u_id<>".User::getInstance()->getID();
  		Database::getInstance()->setQuery($sql);
  		$emails=Database::getInstance()->loadObjectList("u_email");
  		if (!count($emails)) return $default_emails;
  		return $emails;
  	} else return $default_emails;
  }
}
?>