<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class mailControllerdefault extends Controller {
	
	private $boxes=array();
	
	public function __construct($name,$module) {
		parent::__construct($name, $module);
		$this->boxes[0]=Text::_("Outgoing");
		$this->boxes[1]=Text::_("Inbox");
	}
	public function showContents() {
		$this->checkAuth();

		$mode = Request::get('mode','all');
		$inbox = Request::getInt('inbox',1);
		$view = $this->getView();
		$view->assign("boxes",$this->boxes);
		$view->assign("inbox",$inbox);
		$model = $this->getModel('letter');

		$view->addBreadcrumb(Text::_('Mail'),'index.php?module=mail');

		$view->addShortcut(Text::_('New letter'),"javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;view=write';","newLetter",130);
		if ($mode == 'all') {
			$view->addShortcut(Text::_('Unread'),"javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;view=contents&amp;mode=unread&amp;inbox=".$inbox."';","unreadletters");
		}	else {
			$view->addShortcut(Text::_('All'),"javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;view=contents&amp;inbox=".$inbox."';","allLetters",130);
		}
		$unreadOnly = ($mode != 'all');

		// Paging
		$letterCount = $model->getLetterCount(($inbox == 1),$unreadOnly);
		$paginator = $model->createPaginator($view,$letterCount);
		
		$letters = $model->getMail(($inbox == 1),$unreadOnly);
		if ($inbox == 1) {
			$view->inbox = true;
			$view->addBreadcrumb(Text::_('Inbox'),'index.php?module=mail&amp;view=contents');
			$pageLinkTail = "&amp;view=contents";
		}	else {
			$view->inbox = false;
			$view->addBreadcrumb(Text::_('Outgoing'),'index.php?module=mail&amp;view=contents&amp;inbox=0');
			$pageLinkTail = "&amp;view=contents&amp;inbox=0";
		}

		if ($letterCount < 1) {
			$view->setNoLetters();
		}	else {
			$paginator->buildPagePanel("index.php?module=mail",$pageLinkTail);
			foreach ($letters as $letter) {	$view->addLetter($letter);	}
		}
	}

	public function showRead() {
		$this->checkAuth();

		$letterId = Request::getInt('ltrid',0);
		$view = $this->getView();

		$view->addBreadcrumb(Text::_('Mail'),'index.php?module=mail');
		$view->assign("boxes",$this->boxes);
		
		$model = $this->getModel('letter');
		$letter = $model->getLetter($letterId);
		if ($letter === false) {
			$this->setRedirect("index.php?module=mail",Text::_("Letter absent"));
		}	else {
			$answerTheme = "Re: ".$letter->l_theme;
			$answerTheme = urlencode($answerTheme);
			$answerJS = "javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;view=write&amp;recvuid=".$letter->l_sender_id."&amp;theme=".$answerTheme."';";
			$view->addShortcut(Text::_('Answer'),$answerJS,"answerLetter");

			if (User::getInstance()->getId() == $letter->l_sender_id) {
				$view->assign("inbox",0);
				$view->addBreadcrumb(Text::_('Outgoing'),Router::_("index.php?module=mail&amp;view=contents&amp;inbox=0"));
				$deleteJS = "javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;task=delete&amp;inbox=0&amp;letterid=".$letter->l_id."';";
			}	else {
				$view->assign("inbox",1);
				$view->addBreadcrumb(Text::_('Inbox'),Router::_("index.php?module=mail&amp;view=contents"));
				$deleteJS = "javascript: document.location.href='".Portal::getURI()."index.php?module=mail&amp;task=delete&amp;inbox=1&amp;letterid=".$letter->l_id."';";
			}

			
			$view->addShortcut(Text::_('Delete'),$deleteJS,"deleteLetter");
			
			$objectType = Text::_('Sender');
			$object = User::getInstance()->getNicknameFor($letter->l_sender_id);
			if (User::getInstance()->getId() == $letter->l_sender_id) {
				$objectType = Text::_('Reciever');
				$object = User::getInstance()->getNicknameFor($letter->l_reciever_id);
			}

			$letterText = $letter->l_text;
			$view->assign('letterText',$letterText);
			$view->assign('letterTheme',$letter->l_theme);
			$view->assign('objectType',$objectType);
			$view->assign('object',$object);
			$view->assign('date',$letter->l_date);

			if (User::getInstance()->getId() == $letter->l_reciever_id) {
				$model->setRead($letterId);
			}
		}
	}

	public function showWrite() {
		$this->checkAuth();
		$letterText		= Request::getSafe('letterText','');
		
		$theme = Request::get('theme','');
		if ($theme) $theme = urldecode($theme);	

		$recvId = Request::getInt('recvuid',0);
		$recvUser		= Request::getSafe('recvUser','');
		
		$nickname = '';
		if ($recvId) {
			$nickname = User::getInstance()->getNicknameFor($recvId);
		} else $nickname=$recvUser;

		$view = $this->getView();

		$view->addBreadcrumb(Text::_('Mail'),'index.php?module=mail');
		$view->addBreadcrumb(Text::_('New letter'),'#');
		$view->assign('letterText',$letterText);
		$view->assign('recvNickname',$nickname);
		$view->assign('theme',$theme);
	}

	public function send() {
		$this->checkAuth();
		$recvUser		= Request::getSafe('recvUser','');
		$letterTheme	= Request::getSafe('letterTheme','');
		$letterText		= Request::getSafe('letterText','');
		Event::raise("captcha.checkResult",array("module"=>"mail"));
		$redirectUrl="index.php?module=mail&view=write&recvUser=".urlencode($recvUser);
		if ($letterTheme == '' || $letterText == '' || $recvUser == '') {
			$msg=Text::_('Form incomplete');
		} else if(isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) { 
				$msg =Text::_("Wrong captcha"); 
				unset($_SESSION['captcha_string']); 
				$redirectUrl.="&theme=".urlencode($letterTheme)."&letterText=".urlencode($letterText);
		} elseif (User::checkFloodPoint()){
			$msg=Text::_('Flood is found');
		}	else {
			// получаем все данные по пользователю
			$infoUserRecv=User::getInstance()->getInfoUserFor($recvUser);
			if($infoUserRecv ) {
				$recvId = $infoUserRecv->u_id;
				$recvEmail =$infoUserRecv->u_email;
			} else {
				$recvId =0;
				$recvEmail ='';				
			}
      
			if ($recvId == 0) {
				$msg=Text::_('Absent nickname');
			} else {
				$model = $this->getModel('letter');
				if($model->writeLetter($recvId,$letterTheme,$letterText))	{
					$link = "index.php?module=mail&view=contents&mode=unread&inbox=1";
					$letter = sprintf(Text::_('new mail text'),$recvUser,siteConfig::$metaTitle,Portal::getURI().$link)."\n";
					$mailer = new Mailer();
					if($mailer->send($recvEmail,sprintf(Text::_('New post portal'),siteConfig::$metaTitle),$letter)) {
						$msg=Text::_('Letter sent');
					}	else {
						$msg=Text::_('Letter saved butnot sent');
					}
					$redirectUrl="index.php?module=mail&view=contents&inbox=0";
				}	else {$msg=Text::_('Operation failed');}
			}
		}
		$this->setRedirect($redirectUrl,$msg);
	}

	public function delete() {
		$this->checkAuth();

		$letterId	= Request::getInt('letterid',0);
		$inbox=Request::getInt('inbox',1);

		$model = $this->getModel('letter');
		$letter = $model->getLetter($letterId);
		if ($letter == false) {
			$this->setRedirect("index.php?module=mail");
		}
		else {
			$uid = User::getInstance()->getId();
			if ($uid == $letter->l_sender_id) {
				$model->deleteLetter($letter->l_id,"s");
				$this->setRedirect("index.php?module=mail",Text::_('Letter deleted'));
			}
			else if ($uid == $letter->l_reciever_id) {
				$model->deleteLetter($letter->l_id,"r");
				$this->setRedirect("index.php?module=mail",Text::_('Letter deleted'));
			}
			else {
				$this->setRedirect("index.php?module=mail&inbox=".$inbox);
			}
		}
	}

}

?>