<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

$js="$(document).ready(function() {
	$('#regForm').validate({
		messages: {
			rAgree: { required: '!!!' },
			rLogin: { required: '!!!' },
			rNickname: { required: '!!!' },
			rPassword: { required: '!!!' },
			rEmail: { required: '!!!', email: '!!!' },
			rPasswordRetype: { required: '!!!' },
			rCaptchaText: { required: '!!!' }
		}
	});
	$('#login').bind('blur', function() {checkFieldUnique('user',this,0);});
	$('#nickname').bind('blur', function() {checkFieldUnique('user',this,0);});
	$('#email').bind('blur', function() {checkFieldUnique('user',this,0);});
});
";
Portal::getInstance()->addScriptDeclaration($js); 
$helper = Module::getHelper('article','article');
$article=$helper->getArticle(intval(siteConfig::$site_rules_article));
?>
<?php if(is_object($article)) { ?>
<div id="registrationForm">
	<form id="regForm" action="<?php echo Router::_("index.php"); ?>" method="post">
		<input type="hidden" name="module" value="user" />
		<input type="hidden" name="return_url" value="<?php echo $this->return_url; ?>" />
		<input type="hidden" name="task" value="registerUser" />
		<b><a href="<?php echo Router::_("index.php?module=user&view=login"); ?>"  rel="nofollow" class="relpopup"><?php echo Text::_('If you are already registered log in'); ?>.</a></b><br /><br />
		<?php if (backofficeConfig::$regConfirmation==1) { ?>
			<b><?php echo Text::_('If you do not recieved confirmation letter'); ?> <a href="<?php echo Router::_("index.php?module=user&view=confirm"); ?>"  rel="nofollow" class="relpopup"><?php echo Text::_('click here'); ?>.</a></b><br /><br />
		<?php } ?>
		<?php echo Text::_('By registering you are accepting with'); ?>&nbsp;<a target="_blank" href="<?php echo Router::_("index.php?module=article&amp;view=read&amp;psid=".$article->a_id."&amp;alias=".$article->a_alias); ?>"><?php echo Text::_('site rules'); ?></a>
		&nbsp;<input class="commonEdit required" type="checkbox" id="agree" name="rAgree" value="1" />&nbsp;<b><?php echo Text::_('Agree')?></b><br /><br />
		<div class="registrationFormLabel"><?php echo Text::_('Nickname')?>:</div>
		<div class="registrationFormField">
		<input class="commonEdit required" style="width:280px;" type="text" id="nickname" name="rNickname" value="" />
		</div>
<?php if(!backofficeConfig::$allowEmailLogin) { ?>
		<div class="registrationFormLabel"><?php echo Text::_('Login name')?>:</div>
		<div class="registrationFormField">
		<input class="commonEdit required" style="width:280px;" type="text" id="login" name="rLogin" value="" />
		</div>
<?php } ?>
		<div class="registrationFormLabel"><?php echo Text::_('E-mail')?>:</div>
		<div class="registrationFormField">
		<input class="commonEdit required email" style="width:280px;" type="text" id="email" name="rEmail" value="" />
		</div>
		
		<div class="registrationFormLabel"><?php echo Text::_('Password')?>:</div>
		<div class="registrationFormField">
		<input class="commonEdit required" style="width:280px;" type="password" name="rPassword" value="" />
		</div>

		<div class="registrationFormLabel"><?php echo Text::_('Confirm password')?>:</div>
		<div class="registrationFormField">
		<input class="commonEdit required" style="width:280px;" type="password" name="rPasswordRetype" value="" />
		</div>
<?php if (siteConfig::$use_referral_system) {?>		
<?php if (isset($_COOKIE['referral'])) { ?>
		<input type="hidden" name="codeassign" value="<?php echo $_COOKIE['referral']; ?>" />
		<label><?php echo Text::_('You were invited by'); ?>&nbsp;<?php echo User::getNicknameByAffCode($_COOKIE['referral']); ?></label><br />
<?php } else {?>
		<div class="registrationFormLabel"><?php echo Text::_('assign code')?>:</div>
		
		<div class="registrationFormField">
		<input class="commonEdit" style="width:280px;" type="text" name="codeassign" value="" />
		</div>
<?php } }?>
		<?php echo Event::raise("register.renderForm",array("module"=>"user"))?>
		<?php echo Event::raise("captcha.renderForm",array("module"=>"user"))?>
		<div id="mySettingsFooter" class="buttons">
			<input id="apply" type="submit" class="commonButton" value="<?php echo Text::_('Register'); ?>" />
		</div>
	</form>
</div>
<?php } else { ?>
<?php echo Text::_('Registration disabled'); ?>
<?php }?>
