<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class videosetControllerdefault extends Controller {
	public function showGroups() {
		$view=$this->getView();
		$viewname = $view->getName();
		$mdl=Module::getInstance();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		$model = $this->getModel();
		$psid = request::getSafe('psid', false); 					// ид строки
		$groups=$model->getGroups();
		$view->assign('groups',$groups);
		$view->addBreadcrumb(Text::_("Videos"),Router::_("index.php"));
	}
	public function showItems() {
		$view=$this->getView();
		$viewname = $view->getName();
		$mdl=Module::getInstance("gallery");
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		$model = $this->getModel();
		$psid         = request::getSafe('psid', false); 					// ид строки
		$group=$model->getGroup($psid);
		$items=$model->getItems($psid);
		if (is_object($group)){
			if($group->vgr_meta_keywords<>'')Portal::getInstance()->setMeta("keywords",$group->vgr_meta_keywords);
			if($group->vgr_meta_description<>'') Portal::getInstance()->setMeta("description",$group->vgr_meta_description);
			if($group->vgr_meta_title<>'') Portal::getInstance()->setTitle($group->vgr_meta_title);
			else Portal::getInstance()->setTitle($group->vgr_title);
			$view->addBreadcrumb(Text::_("Videos"),Router::_("index.php"));
			$href="index.php?module=videoset&view=items&psid=".$group->vgr_id;
			if($group->vgr_alias) $href.="&alias=".$group->vgr_alias;
			$view->addBreadcrumb(Text::_($group->vgr_title),Router::_($href));
			$view->assign('group',$group);
			$view->assign('items',$items);
		}
		else {$this->setRedirect("index.php?module=videoset");
		}
	}
	public function showVideos() {
		$view=$this->getView();
		$viewname = $view->getName();
		$mdl=Module::getInstance();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname));
		$model = $this->getModel();
		$psid = request::getSafe('psid', false); 	// ид строки
		$layout=$this->get('layout');
		$view->assign("medium_width",$this->getConfigValue("medium_width",320));
		$view->assign("medium_height",$this->getConfigValue("medium_height",190));
		$view->addBreadcrumb(Text::_('Videos'),Router::_("index.php"));
		$item=$model->getItem($psid);
		if (is_object($item)) {
			$group=$model->getGroup($item->vg_group_id);
			if(is_object($group)){						
				if($group->vgr_meta_keywords<>'')Portal::getInstance()->setMeta("keywords",$group->vgr_meta_keywords);
				if($group->vgr_meta_description<>'') Portal::getInstance()->setMeta("description",$group->vgr_meta_description);
				if($group->vgr_meta_title<>'') Portal::getInstance()->setTitle($group->vgr_meta_title);
				else Portal::getInstance()->setTitle($group->vgr_title);
			}
			if(is_object($group)&&$group->vgr_show_in_list)
			{
				$href="index.php?module=videoset&view=items&psid=".$group->vgr_id;
				if($group->vgr_alias) $href.="&alias=".$group->vgr_alias;
				$view->addBreadcrumb(Text::_($group->vgr_title),Router::_($href));
			}
			$href="index.php?module=videoset&view=videos&psid=".$item->vg_id;
			if($item->vg_alias) $href.="&alias=".$item->vg_alias;
			$view->addBreadcrumb(Text::_($item->vg_title),Router::_($href));
		} else $group="";
		$view->assign('group',$group);
		$videos=$model->getVideos($psid);
		$view->assign('item',$item);
		$view->assign('videos',$videos);
	}
	public function showVideo() {
		$view=$this->getView();
		$viewname = $view->getName();
		$mdl=Module::getInstance();
		$this->checkACL("view".ucfirst($mdl->getName()).ucfirst($viewname)."s");
		$model = $this->getModel();
		$psid = request::getSafe('psid', false); 	// ид строки
		$layout=$this->get('layout');
		$view->assign("big_width",$this->getConfigValue("big_width",640));
		$view->assign("big_height",$this->getConfigValue("big_height",380));
		$view->addBreadcrumb(Text::_('Videos'),Router::_("index.php"));
		$video=$model->getVideo($psid);
		if(is_object($video)){
			if($video->v_meta_keywords<>'')Portal::getInstance()->setMeta("keywords",$video->v_meta_keywords);
			if($video->v_meta_description<>'') Portal::getInstance()->setMeta("description",$video->v_meta_description);
			if($video->v_meta_title<>'') Portal::getInstance()->setTitle($video->v_meta_title);
			else Portal::getInstance()->setTitle($video->v_title);
			$videos=$model->getVideos($video->v_gallery_id);
			$gallery=$model->getItem($video->v_gallery_id);
			if(is_object($gallery)) {
				$group=$model->getGroup($gallery->vg_group_id);
				if(is_object($group)&&$group->vgr_show_in_list) {
					$href="index.php?module=videoset&view=items&psid=".$group->vgr_id;
					if($group->vgr_alias) $href.="&alias=".$group->vgr_alias;
					$view->addBreadcrumb(Text::_($group->vgr_title),Router::_($href));
				}
				$href="index.php?module=videoset&view=videos&psid=".$gallery->vg_id;
				if($gallery->vg_alias) $href.="&alias=".$gallery->vg_alias;
				$view->addBreadcrumb(Text::_($gallery->vg_title),Router::_($href));
			}
			$view->addBreadcrumb($video->v_title,"#");
		} else $videos=array();
		$view->assign('video',$video);
		$view->assign('videos',$videos);
	}
}

?>