<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Address extends Object{
	public static $address_types=array("0"=>"Address delivering","1"=>"Address living","2"=>"Address registration");
	public static $tmpl_id=array('psid'=>'',
																		'type_id'=>0,
																		'country_id'=>'',
																		'region_id'=>'',
																		'town_id'=>'',
																		'zipcode'=>'',
																		'street'=>'',
																		'house'=>'',
																		'apartment'=>'',
																		'use_as_default'=>0,
																		'fullinfo'=>'');
	public static $tmpl_text=array('psid'=>'',
																		'type_id'=>0,
																		'country'=>'',
																		'region'=>'',
																		'town'=>'',
																		'zipcode'=>'',
																		'street'=>'',
																		'house'=>'',
																		'apartment'=>'',
																		'use_as_default'=>0,
																		'fullinfo'=>'');
	private static $tmpl_required=array('psid'=>true,
																		'type_id'=>true,
																		'country_id'=>true,
																		'region_id'=>true,
																		'town_id'=>true,
																		'country'=>true,
																		'region'=>true,
																		'town'=>true,
																		'zipcode'=>true,
																		'street'=>true,
																		'house'=>true,
																		'apartment'=>true,
																		'use_as_default'=>true,
																		'fullinfo'=>true);

	
	public static function getTmpl(){
		if(siteConfig::$useTextAddress) return self::$tmpl_text; else return self::$tmpl_id;
	}
	public static function getRequiredTmpl(){
		if(siteConfig::$useTextAddress) $tmpl=self::$tmpl_text; else $tmpl=self::$tmpl_id;
		foreach($tmpl as $key=>$val){
			if (self::$tmpl_required[$key]) $result[]=$key;
		}
		return $result;
	}
	public static function getTypeTitle($type){
		if (isset(self::$address_types[$type])) return Text::_(self::$address_types[$type]);
		else return "";
	}
	public static function getCountryName($id=0){
		if (!$id) return "";
		$country=self::getCountry($id,false);
		if ($country) return $country->c_name; else return "";
	}
	public static function getCountry($id=0, $enabled_only=true){
		if (!$id) return false;
		$sql="SELECT * FROM #__addr_countries WHERE c_id=".(int)$id;
		if ($enabled_only) $sql.=" AND c_enabled=1 AND c_deleted=0";
		Database::getInstance()->setQuery($sql);
		$country=false;
		Database::getInstance()->loadObject($country);
		return $country;
	}

	public static function getCountries($enabled_only=true){
		$sql="SELECT c_id as id, c_name as title FROM #__addr_countries";
		if ($enabled_only) $sql.=" WHERE c_enabled=1 AND c_deleted=0";
		$sql.=" ORDER BY c_ordering, title";
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadObjectList();
	}
	
	public static function getRegionName($id=0){
		if (!$id) return "";
		$region=self::getRegion($id,false);
		if ($region) return $region->r_name; else return "";
	}
	
	public static function getRegion($id=0,$enabled_only=true){
		if(!$id) return false;
		$sql="SELECT * FROM #__addr_regions WHERE r_id=".(int)$id;
		if ($enabled_only) $sql.=" AND r_enabled=1 AND r_deleted=0";
		Database::getInstance()->setQuery($sql);
		$region=false;
		Database::getInstance()->loadObject($region);
		return $region;
	}
	
	public static function getRegions($parent_id=0,$enabled_only=true){
		if(!$parent_id) return null;
		$sql="SELECT r_id as id, r_name as title FROM #__addr_regions WHERE r_parent_id=".(int)$parent_id;
		if ($enabled_only) $sql.=" AND r_enabled=1 AND r_deleted=0";
		$sql.=" ORDER BY r_ordering,title";
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadObjectList();
	}

	public static function getTownName($id=0){
		if (!$id) return "";
		$town=self::getTown($id,false);
		if ($town) return $town->t_name; else return "";
	}
	public static function getTown($id=0, $enabled_only=true) {
		if (!$id) return false;
		$sql="SELECT * FROM #__addr_towns WHERE t_id=".(int)$id;
		if ($enabled_only) $sql.=" AND t_enabled=1 AND t_deleted=0";
		Database::getInstance()->setQuery($sql);
		$town=false;
		Database::getInstance()->loadObject($town);
		return $town;
	}
	
	public static function getTowns($parent_id=0,$enabled_only=true) {
		if (!$parent_id) return null;
		$sql="SELECT t_id as id, t_name as title FROM #__addr_towns WHERE t_parent_id=".(int)$parent_id;
		if ($enabled_only) $sql.=" AND t_enabled=1 AND t_deleted=0";
		$sql.=" ORDER BY t_ordering,title";
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadObjectList();
	}

	public static function renderCountrySelector($ctrl_prefix="",$address=array(),$required=false, $enabled_only=true) {
		if($required) $class="required"; else $class='';
		if(siteConfig::$useTextAddress) {
			if(!isset($address['country'])) $text=''; else $text=$address['country'];
			$control_name=$ctrl_prefix."country";
			$html=HTMLControls::renderInputText($control_name, $text, 100, 150, "", $class);
		} else {
			if(count($address)) {
				$psid=$address['country_id'];
			} else $psid=0;
			$list=self::getCountries($enabled_only);
			$control_name=$ctrl_prefix."country_id";
			$js="updateRegionSelector('".$ctrl_prefix."','country_id','region_id','town_id')";
			$html=HTMLControls::renderSelect($control_name, "", "id", "title", $list,$psid,true,$js,0,$class);
		}
		return $html;
	}

	public static function renderRegionSelector($parent_id, $ctrl_prefix="", $address=array(),$required=false, $enabled_only=true) {
		if($required) $class="required"; else $class='';
		if(siteConfig::$useTextAddress) {
			if(!isset($address['region'])) $text=''; else $text=$address['region'];
			$control_name=$ctrl_prefix."region";
			$html=HTMLControls::renderInputText($control_name, $text, 100,150,"",$class);
		}	else {
			if(count($address)) {
				$parent_id=$address['country_id'];
				$psid=$address['region_id'];
			} else $psid=0;
			$list=self::getRegions($parent_id,$enabled_only);
			$control_name=$ctrl_prefix."region_id";
			$js="updateTownSelector('".$ctrl_prefix."','region_id','town_id')"; 
			$html=HTMLControls::renderSelect($control_name, "", "id", "title", $list,$psid,true,$js,0,$class);
		}
		return $html;
	}

	public static function renderTownSelector($parent_id, $ctrl_prefix="", $address=array(),$required=false, $enabled_only=true)	{
		if($required) $class="required"; else $class='';
		if(siteConfig::$useTextAddress) {
			if(!isset($address['town'])) $text=''; else $text=$address['town'];
			$control_name=$ctrl_prefix."town";
			$html=HTMLControls::renderInputText($control_name, $text, 100,150,"",$class);
		} else {
			if(count($address)) {
				$parent_id=$address['region_id'];
				$psid=$address['town_id'];
			} else $psid=0;
				
			$list=self::getTowns($parent_id,$enabled_only);
			$control_name=$ctrl_prefix."town_id";
			$html=HTMLControls::renderSelect($control_name, "", "id", "title", $list, $psid, true, "", 0, $class);
		}
		return $html;
	}

	public static function renderTypeSelector($type_id) {
		foreach (self::$address_types as $key=>$val){
			$address_types[$key]=Text::_($val);
		}
		$html=HTMLControls::renderSelect("type_id", "", "", "", $address_types,$type_id,false);
		return $html;
	}
	public static function decode($data, $asString=false){
		$address=self::getTmpl();
		$data=json_decode(base64_decode($data),true);
		foreach($address as $key=>$val){
			if (isset($data[$key])) $address[$key]=$data[$key]; else $address[$key]=$val;
		}
		if ($asString) return $address['fullinfo'];
		else return $address;
	}
	public static function renderEditor($data, $submit=""){
		$address=self::decode($data);
		$required=self::getRequiredTmpl();
		if(!isset($address['country_id'])) $address['country_id']=0;
		if(!isset($address['region_id'])) $address['region_id']=0;
		if(!isset($address['town_id'])) $address['town_id']=0;
		$require_country=(in_array("country",$required)||in_array("country_id",$required));
		$require_town=(in_array("town",$required)||in_array("town_id",$required));
		$require_region=(in_array("region",$required)||in_array("region_id",$required));
		$html="<div id=\"panel_addr\">";
		$html.="	<table class=\"panelAddress\">";
		$html.="		<tr><th width=\"40%\">".Text::_("zip_code")."</th><td>".HTMLControls::renderInputText("pa_zipcode", $address['zipcode'],6,6, "", (in_array('zipcode',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("Country")."</th><td>".Address::renderCountrySelector("pa_",$address,$require_country)."</td></tr>";
		$html.="		<tr><th>".Text::_("Region")."</th><td>".Address::renderRegionSelector(0,"pa_",$address,$require_region)."</td></tr>";
		$html.="		<tr><th>".Text::_("Town")."</th><td>".Address::renderTownSelector(0,"pa_",$address,$require_town)."</td></tr>";
		$html.="		<tr><th>".Text::_("Street")."</th><td>".HTMLControls::renderInputText("pa_street", $address['street'],100,100, "", (in_array('street',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("House")."</th><td>".HTMLControls::renderInputText("pa_house", $address['house'],10,10, "", (in_array('house',$required) ? "required" : ""))."</td></tr>";
		$html.="		<tr><th>".Text::_("Apartment")."</th><td>".HTMLControls::renderInputText("pa_apartment", $address['apartment'],10,10, "", (in_array('apartment',$required) ? "required" : ""))."</td></tr>";
		if ($submit) $html.="		<tr><td class=\"buttons\" colspan=\"2\">".HTMLControls::renderButton("pa_submit_addr", Text::_("OK"),  "button",  "", $class='commonButton',$submit)."</td></tr>";
		$html.="	</table>";
		$html.="</div>";
		return $html;
	}
}
?>