<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class ConfigTMPL {
	public static $_tabs= array("1"=>array("site","Site settings"),
			"2"=>array("backoffice","Security settings"),
			"3"=>array("admin","Admin panel settings"),
			"4"=>array("catalog","Catalog settings"),
			"5"=>array("gallery","Gallery settings"),
			"6"=>array("mailer","Mail settings"),
			"7"=>array("so","Site owner settings"),
			"8"=>array("seo","Seo settings")
	);
	public static function _loadConfigs() {
		foreach(self::$_tabs as $config) {
			require_once PATH_CONFIG.$config[0].'.php';
		}
	}
	public static function getConfigVar($className, $property) {
		if(!class_exists($className)) return null;
		if(!property_exists($className, $property)) return null;
		$vars = get_class_vars($className);
		return $vars[$property];
	}
	public static function setConfigVar($className, $property, $value) {
		if(!class_exists($className)) return false;
		if(!property_exists($className, $property)) return false;
		eval($className.'::$'.$property.'=$value;');
		return true;
	}
	public static function _loadVars() {
		// подбираем все из базы
		$db=Database::getInstance();
		$sql="SELECT * from #__config ORDER BY cfg_section, cfg_key";
		$db->setQuery($sql);
		$res=$db->loadObjectList();
		if (count($res)>0) {
			foreach($res as $row) {
				self::setConfigVar($row->cfg_section.'Config', $row->cfg_key, $row->cfg_value);
			}
		}
		$db->setDebugMode();
		Debugger::getInstance()->milestone("First possible milestone.Configs updated.");
	}
	/*  public static function _saveVars($arr) { } */
}
/* тип , значение по умолчанию , source, показывать ли подсказку вида (имя параметра description - прописывается в ini файлах перевода) */
class siteConfigTMPL extends ConfigTMPL {
	public $props = array(
			"metaTitle"					=>	array("string","Altadoc-CMS"),
			"siteDisabled"				=>	array("boolean",false),
			"metaDescription"			=>	array("string",""),
			"metaKeywords"				=>	array("string",""),
			"siteUrl"					=>	array("string","http://altadoc-cms.web",false,true),
			"sitePort"					=>	array("integer","80"),
			"siteSSLPort"				=>	array("integer","443"),
			"enableGeneratorMetaTag"	=>	array("boolean",false,false,false),
//			"gzipMode"					=>	array("boolean",true,false,true),
			"allowedType"				=>	array("multiselect_method","bmp,csv,gif,jpeg,jpg,pdf,png,swf,zip","Mime::getMimeKeys"),
			"cssOverride"				=>	array("boolean",false),
			"debugMode"					=>	array("select","0",array("0"=>"Disabled","1"=>"Except CSS and translation - Admin only","2"=>"Except CSS - Admin only","100"=>"Full - Admin only","101"=>"Except CSS and translation - All users","102"=>"Except CSS - All users","200"=>"Full - All users")),
			"siteMemoryLimit"			=>	array("select","20",array("20"=>"20","25"=>"25","30"=>"30","35"=>"35","40"=>"40","50"=>"50","60"=>"60","80"=>"80","100"=>"100","120"=>"120","140"=>"140","160"=>"160","190"=>"190")),
			"siteTimeLimit"				=>	array("select","30",array("30"=>"30","45"=>"45","60"=>"60","90"=>"90","120"=>"120","180"=>"180","240"=>"240")),
			"cookieLifeTime"			=>	array("integer",1440),
			"cacheLife"					=>	array("integer",0),
			"defaultMenuID"				=>	array("table_select", 0, "SELECT mi_id AS fld_id, CONCAT('(',mi_id,') ',mi_name) AS fld_name FROM #__menus ORDER BY fld_name"),
			"activeMidFromTable"		=>	array("boolean",false),
			"defaultLanguage"			=>	array("folder","ru", "/language/common"),
			"site_rules_article"		=>	array("table_select",2,"SELECT a_id AS fld_id, a_title AS fld_name FROM #__articles ORDER BY fld_name"),
			"defaultModule"				=>	array("folder","article", "/modules"),
			"defaultItemID"				=>	array("integer",1),
			"pagesPerPanel"				=>	array("integer",10),
			"recordsPerPage"			=>	array("integer",10),
			"shortTextLength"			=>	array("integer",350),
			"saveOriginalImageName"		=>	array("boolean",false,false,true),
			"searchTargetBlank"			=>	array("boolean",true),
			"treeDepth"					=>	array("integer",20),
			"sendFeedbacksByMail"		=>	array("boolean",true),
			"siteTemplate"				=>	array("folder","example","/templates"),
			"siteTemplatesByMenu"		=>	array("boolean", false),
			"use_referral_system"		=>	array("boolean", true),
			"use_points_system"			=>	array("boolean", true),
			"useMultiVote"				=>	array("boolean", false),
			"def_account_bonus"			=>	array("integer", 0),
			"useTextAddress"			=>	array("boolean", false,false,true)
	);
}
class backofficeConfigTMPL extends ConfigTMPL {
	public $props = array(
			"noRegistration"			=>	array("boolean",false),
			"floodDelay"				=>	array("integer",5),
			"useSSL"					=>	array("boolean",false),
			"cryptoUserData"			=>	array("boolean",true,false,true),
			"cryptoPath"				=>  array("string","",false,true),
			"regConfirmation"			=>	array("select","1", array(0=>"Not required",1=>"Confirmation by E-mail",2=>"Confirmation by admin")),
			"allowSNLogin"				=>	array("boolean",false,false,true),
			"allowEmailLogin"			=>	array("boolean",false),
			"defaultUserRole"			=>	array("table_select", 2,"SELECT ar_id AS fld_id, ar_title AS fld_name FROM #__acl_roles ORDER BY fld_name"),
			"secretCode"				=>  array("string", "Secret Code",false,true),
			"unlockKey"					=>  array("string", "",false,true),
	);
}
class catalogConfigTMPL extends ConfigTMPL {
	public $props = array(
			"catalogDisabled"			=>	array("boolean", false),
			"catalogDisabledMsg"		=>	array("text", "Catalog is temporary disabled.<br />Please visit us later."),
			"ordersDisabled"			=>	array("boolean", false),
			"catalogAdminEmail"			=>	array("string", "admin@localhost"),
			"catalog_rules_article"		=>	array("table_select",2,"SELECT a_id AS fld_id, a_title AS fld_name FROM #__articles ORDER BY fld_name"),
			"default_currency" 			=>	array("table_select", "0","SELECT c_id AS fld_id, c_name AS fld_name FROM #__currency ORDER BY fld_name"),
			"default_wmeasure" 			=>	array("table_select", "0","SELECT meas_id AS fld_id, meas_short_name AS fld_name FROM #__measure WHERE meas_type=4 ORDER BY fld_name"),
			"default_measure" 			=>	array("table_select", "0","SELECT meas_id AS fld_id, meas_short_name AS fld_name FROM #__measure ORDER BY fld_name"),
			"default_size_measure"		=>	array("table_select", "0","SELECT meas_id AS fld_id, meas_short_name AS fld_name FROM #__measure WHERE meas_type=2 ORDER BY fld_name"),
			"default_vol_measure"		=>	array("table_select", "0","SELECT meas_id AS fld_id, meas_short_name AS fld_name FROM #__measure WHERE meas_type=1 ORDER BY fld_name"),
			"hide_prices"				=>	array("boolean", false),
			"default_order_status"		=>	array("table_select", 1,"SELECT os_id AS fld_id, os_name AS fld_name FROM #__orders_status ORDER BY fld_id"),
			"default_order_taxes"		=>	array("table_select", 1,"SELECT t_id AS fld_id, t_name AS fld_name FROM #__taxes ORDER BY fld_id"),
			"quantity_digits"			=>	array("integer", 4),
			"thumbAutoCreate"			=>	array("boolean",false),
			"ggr_thumb_width"			=>	array("integer", 150),
			"ggr_thumb_height"			=>	array("integer", 150),
			"thumb_width"				=>	array("integer", 100),
			"thumb_height"				=>	array("integer", 100),
			"mediumImgAutoCreate"		=>	array("boolean",false),
			"mediumImgWidth"			=>	array("integer", 250),
			"mediumImgHeight"			=>	array("integer", 250),
			"listImageLink"				=>	array("select","0",array("0"=>"Disabled","1"=>"Popup","2"=>"Flypage")),
			"show_stock"				=>	array("boolean", true),
			"check_stock"				=>	array("boolean", false),
			"show_base_price"			=>	array("boolean", false),
			"show_pack_price"			=>	array("boolean", false),
			"complectPriceAsGoodsSum"	=>	array("boolean", false),
			"multy_vendor"				=>	array("boolean", false,false,true),
			"default_vendor"			=>	array("table_select", "0","SELECT v_id AS fld_id, v_name AS fld_name FROM #__vendors ORDER BY fld_name"),
			"default_manufacturer"		=>	array("table_select", 1,"SELECT mf_id AS fld_id, mf_name AS fld_name FROM #__manufacturers ORDER BY fld_id"),
	);
}
class adminConfigTMPL extends ConfigTMPL {
	public $props = array(
			"adminTemplate"				=>	array("folder","example","/administrator/templates"),
			"cssOverride"				=>	array("boolean",false),
			"adminDefaultModule"		=>	array("folder","help", "/administrator/modules"),
			"adminMemoryLimit"			=>	array("select","100",array("20"=>"20","25"=>"25","30"=>"30","35"=>"35","40"=>"40","50"=>"50","60"=>"60","80"=>"80","100"=>"100","120"=>"120","140"=>"140","160"=>"160","190"=>"190")),
			"adminTimeLimit"			=>	array("select","60",array("30"=>"30","45"=>"45","60"=>"60","90"=>"90","120"=>"120","180"=>"180","240"=>"240")),
			"adminPagesPerPanel"		=>	array("integer",20),
			"adminRecordsPerPage"		=>	array("integer",30),
			"adminCleanRowsPerQuery" 	=> 	array("integer",20),
			"adminDeleteSubordinates" 	=> 	array("boolean",true),
			"adminFltIncCustomFld"		=>	array("boolean",false),
	);
}
class soConfigTMPL extends ConfigTMPL {
	public $props = array(
			"showOnFeedbackPage"		=>	array("boolean",false),
			"firmName"					=>	array("string", ""),
			"fullFirmName"				=>	array("string", ""),
			"siteEmail"					=>	array("string","admin@localhost"),
			"contactName"				=>	array("string", ""),
			"Address"					=>	array("string", ""),
			"Phone"						=>	array("string", ""),
			"Fax"						=>	array("string", ""),
			"ICQ"						=>	array("string", ""),
			"Jabber"					=>	array("string", ""),
			"Skype"						=>	array("string", ""),
			"OGRN"						=>	array("string", ""),
			"INN"						=>	array("string", ""),
			"KPP"						=>	array("string", ""),
	);
}
class mailerConfigTMPL extends ConfigTMPL {
	public $props = array(
			"robotNotifier"				=>	array("select","0",array("0"=>"Disabled","1"=>"Internal","2"=>"External")),
			"robotNotifierMessages"		=>	array("integer", 10),
			"robotEmail" 				=>	array("string", "admin@localhost",false,true),
			"useSMTP"					=>	array("boolean", true),
			"logErrors"					=>	array("boolean", true),
			"smtpServer" 				=>	array("string", "127.0.0.1"),
			"smtpPort" 					=>	array("integer", 25,false,true),
			"smtpUser" 					=>	array("string", "guest"),
			"smtpPassword" 				=>	array("string", "guest"),
			"pop3Server" 				=>	array("string", "127.0.0.1"),
			"pop3Port" 					=>	array("integer", 110),
			"pop3User" 					=>	array("string", "guest"),
			"pop3Password"				=>	array("string", "guest"),
			"exchangeEmail"				=>  array("string", "admin@localhost"),
			"exchangePassword"			=>  array("string", "111")
	);
}
class galleryConfigTMPL extends ConfigTMPL {
	public $props = array(
			"ggr_thumbWidth"				=>	array("integer",200),
			"ggr_thumbHeight"				=>	array("integer",200),
			"gal_thumbWidth"				=>	array("integer",200),
			"gal_thumbHeight"				=>	array("integer",200),
			"thumbAutoCreate"			=>	array("boolean",false),
			"thumbWidth"				=>	array("integer",100),
			"thumbHeight"				=>	array("integer",100),
			"thumbTitleDelta"			=>	array("integer",30),
			"slideshow_timeout"			=>	array("integer",3),
			"showParentDescr"			=>	array("boolean",true)
	);
}
class seoConfigTMPL extends ConfigTMPL {
	public $props = array(
			"sefMode"					=>	array("boolean",true,false,true),
//			"strictSefMode"				=>	array("boolean",false,false,true),
			"stop404"					=>	array("boolean",false,false,true)
	);
}

?>