<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Currency extends Object {
	//---------- Factory implementation ------------
	private static $_instances = Array();
	private $_default_currency = null;
	private $_dtc = null;
	private $_rate = Array();

	private function __construct($dtc) {
		$this->initObj();
		$this->_dtc=$dtc;
		$this->_default_currency=DEFAULT_CURRENCY;//catalogConfig::$default_currency;
	}

	public static function getInstance($datetime_c='') {
		if ($datetime_c) $dtc=date('Y-m-d H:i:s', $datetime_c); else $dtc=DTC;
		if (array_key_exists($dtc,self::$_instances) == false) { self::$_instances[$dtc] = new self($dtc); }
		return self::$_instances[$dtc];
	}
	//------------------------------------------------
	public static function getCode($id=0) {
		if (!$id) return "";
		$db=Database::getInstance();
		$sql="SELECT c_code FROM #__currency WHERE c_id=".$id;
		$db->setQuery($sql);
		$result=$db->loadResult();
		if (!$result) $result=Text::_($id);
		return $result;
	}
	public static function getShortName($id=0) {
		if (!$id) return "";
		$db=Database::getInstance();
		$sql="SELECT c_short_name FROM #__currency WHERE c_id=".$id;
		$db->setQuery($sql);
		$result=$db->loadResult();
		if (!$result){
			$result=self::getCode($id);
		} 
		return $result;
	}
	private function getRate($cid) {
		$db=Database::getInstance();
		$sql="SELECT c_value FROM #__currency_rate WHERE c_id=".$cid." AND c_datetime<='".$this->_dtc."' ORDER BY c_datetime DESC LIMIT 0,1";
		$db->setQuery($sql);
		if (!$result=$db->loadResult()) $result=0;
		$this->_rate[$cid]=$result;
	}
	private function convertFromDefault($val, $currency){
		if (array_key_exists($currency,$this->_rate) == false) {
			$this->getRate($currency);
		}
		if(!$this->_rate[$currency]) return 0;
		$_val = round($val/$this->_rate[$currency],2);
		return $_val;
	}
	private function convertToDefault($val, $currency){
		if (array_key_exists($currency,$this->_rate) == false) { $this->getRate($currency); }
		$_val = round($val * $this->_rate[$currency],2);
		return $_val;
	}
	public function convert($val,$from_currency='', $to_currency='') {
  	if (!$to_currency) $to_currency=$this->_default_currency;
    if ($from_currency==$to_currency) return $val;
    if ($from_currency !=$this->_default_currency)  $_val=$this->convertToDefault($val, $from_currency);
    else $_val=$val;
    if ($to_currency==$this->_default_currency) return $_val;
    $_val=$this->convertFromDefault($_val, $to_currency);
    return $_val;
  }
}