<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

final class ErrorPages {
	public static function renderRedirect($url, $message, $code){
		$_SESSION['altadoc_message']="";
		$bodyHtml = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
						<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ru-ru\" lang=\"ru-ru\" >
						<head>
						<title>Debug mode</title>
						<meta content=\"text/html; charset=utf-8\" http-equiv=\"Content-Type\" />
						<link href=\"/css/debug.css\" type=\"text/css\" rel=\"stylesheet\" />
						</head><body> \n";
		$bodyHtml.="<p style=\"text-align:center; font-size:12px;\"><img src=\"/images/redirect.png\" alt=\"Redirect\" /></p>";
		$bodyHtml.="<p style=\"text-align:center; font-size:12px;\"> Redirect code: ".$code."</p>";
		$bodyHtml.="<p style=\"text-align:center; font-size:12px;\"> Debug message: ".$message."</p>";
		$bodyHtml.="<p style=\"text-align:center; font-size:12px;\"> Redirect link : <a href=\"".$url."\">".$url."</a></p>";
		$bodyHtml.=Debugger::getInstance()->dump();
		$bodyHtml.="</body></html>";
		echo $bodyHtml;
	}
	public static function render404($url, $message=""){
		$custom_path=PATH_TEMPLATES.SiteConfig::$siteTemplate.DS."404.php";
		if((file_exists($custom_path))&&(is_file($custom_path))) {
			require_once($custom_path); exit();
		} else {
			$_stylesheets=array("/css/debug.css","/css/errors.css");
			$errorHTML = HTMLControls::renderStaticHeader(Text::_("Page not found"),"","",$_stylesheets);
			$errorHTML .= "<div id=\"error_header\"><div id=\"logo\" class=\"logo404\"></div><div id=\"headLine\"></div></div>";
			$errorHTML .= "<div class=\"fatal-error-text\">".Text::_("Error 404").": ".$message."</div>";
			$errorHTML .= "<div class=\"fatal-error-link\"><a class=\"go_back\" href=\"".($url ? $url : "/")."\">".Text::_('Go main page')."</a></div>";
			if ((siteConfig::$debugMode && User::getInstance()->isAdmin()) || siteConfig::$debugMode>100){
				$errorHTML .= Debugger::getInstance()->dump();
			}
			$errorHTML .= HTMLControls::renderStaticFooter();
			exit($errorHTML);
		}
	}
	public static function render503($message=""){
		$custom_path=PATH_TEMPLATES.SiteConfig::$siteTemplate.DS."503.php";
		if((file_exists($custom_path))&&(is_file($custom_path))) {
			require_once($custom_path); exit();
		} else {
			$_stylesheets=array("/css/debug.css","/css/errors.css");
			$errorHTML = HTMLControls::renderStaticHeader(Text::_("Fatal error"),"","",$_stylesheets);
			$errorHTML .= "<div id=\"error_header\"><div id=\"logo\" onclick=\"javascript: document.getElementById('loginForm').style.display='block';\"></div><div id=\"headLine\"></div></div>";
			if(!User::getInstance()->isLoggedIn()) {
				$errorHTML .= "<div id=\"loginForm\" class=\"commonPopup\" style=\"display:none; margin:20px auto; text-align: center; width: 400px;\">
									<form action=\"/index.php\" method=\"post\">
										<input type=\"hidden\" name=\"option\" value=\"login\" />".Text::_("Username").":&nbsp;
										<input type=\"text\"  style=\"width:75px;\" class=\"commonEdit loginEdit\" id=\"username\" name=\"username\" value=\"\" />
										&nbsp;&nbsp;".Text::_("Password").":&nbsp;
										<input type=\"password\"  style=\"width:75px;\" class=\"commonEdit loginEdit\" name=\"userpass\" value=\"\" />
										&nbsp;<input type=\"submit\" class=\"commonButton\" style=\"width:75px;\" value=\"".Text::_("Log in")."\" onclick=\"javascript: $('#loginForm').hide('fast'); return true;\" />
									</form>
								</div>";
			}
			$errorHTML .= "<div class=\"fatal-error-text\">".Text::_("Fatal error").": ".$message."</div>";
			$errorHTML .= "<div class=\"fatal-error-link\"><a class=\"go_back\" href=\"/index.php\">".Text::_('Go main page')."</a></div>";
			if ((siteConfig::$debugMode && User::getInstance()->isAdmin()) || siteConfig::$debugMode>100){
				$errorHTML .= Debugger::getInstance()->dump();
			}
			$errorHTML .= HTMLControls::renderStaticFooter();
			exit($errorHTML);
		}
	}	
}
?>