<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Event {
	private static $_events	= array();
	public static function register($eventName,$pluginName) {
 		if (array_key_exists($eventName,self::$_events)&&array_key_exists($pluginName,self::$_events[$eventName])) {
			Debugger::getInstance()->warning("Event reregistration");
		}
		else {
			self::$_events[$eventName][$pluginName] = $pluginName;
			Debugger::getInstance()->message("Event registered: ".$eventName."-".$pluginName);
		}
	}

	public static function raise($eventName,$params=array(), &$data=null) {
		$result=null;
		if (array_key_exists($eventName,self::$_events)) {
			Debugger::getInstance()->message("Event raised : ".$eventName);
			foreach (self::$_events[$eventName] as $plugin=>$val) {
				$result=Plugin::getInstance($plugin)->executeEvent($eventName,$params, $data);
			}
		}
		return $result;
	}
	public static function getEvents(){
		return self::$_events;
	}
}
?>