<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Filter extends Object{

  private static $_instance = null;
	public $CensorMode=0;
	public $CensorReplace='';
	public $EditedMessage='';
	public $CensorList=array();

	public static function createInstance() {
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}

	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}

	public function check_words($Message) {
		$EditedMessage = $Message;
		if ($CensorMode != 0) {
			if (is_array($CensorList)) {
				$Replace = $CensorReplace;
				if ($CensorMode == 1) {
					for ($i = 0; $i < count($CensorList); $i++)
					{  $EditedMessage = eregi_replace("$CensorList[$i]([^a-zA-Z0-9])","$Replace\\1",$EditedMessage);	 }
				} elseif ($CensorMode == 2) {
					for ($i = 0; $i < count($CensorList); $i++)
					{  $EditedMessage = eregi_replace("(^|[^[:alnum:]])$CensorList[$i]","\\1$Replace",$EditedMessage);  }
				} elseif ($CensorMode == 3) {
					for ($i = 0; $i < count($CensorList); $i++)
					{  $EditedMessage = eregi_replace("$CensorList[$i]","$Replace",$EditedMessage);  }
				}
			}
		}
		$this->EditedMessage=$EditedMessage;
		return ($this->EditedMessage);
	}

	public function delQuotes($string){
		/* no recursive function to add quote to an HTML tag if needed */
		/* and delete duplicate spaces between attribs. */
		$tmp="";    # string buffer
		$result=""; # result string
		$i=0;
		$attrib=-1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
		$quote=0;   # Is a string quote delimited opened ? 0=no, 1=yes
		$len = mb_strlen($string);
		while ($i<$len) {
			switch($string[$i]) { # What car is it in the buffer ?
				case "\"": #"       # a quote.
					if ($quote==0) { $quote=1;	}
					else {
						$quote=0;
						if (($attrib>0) && ($tmp != "")) { $result .= "=\"$tmp\""; }
						$tmp="";
						$attrib=-1;
					}
					break;
				case "=":           # an equal - attrib delimiter
					if ($quote==0) {  # Is it found in a string ?
						$attrib=1;
						if ($tmp!="") $result.=" $tmp";
						$tmp="";
					} else $tmp .= '=';
					break;
				case " ":           # a blank ?
					if ($attrib>0) {  # add it to the string, if one opened.
						$tmp .= $string[$i];
					}
					break;
				default:            # Other
					if ($attrib<0)    # If we weren't in an attrib, set attrib to 0
					$attrib=0;
					$tmp .= $string[$i];
					break;
			}
			$i++;
		}
		if (($quote!=0) && ($tmp != "")) {
			if ($attrib==1) $result .= "=";
			/* If it is the value of an atrib, add the '=' */
			$result .= "\"$tmp\"";  /* Add quote if needed (the reason of the function ;-) */
		}
		return $result;
	}

	public function check_html ($str, $strip="") {
		/* The core of this code has been lifted from phpslash */
		/* which is licenced under the GPL. */
		if ($strip == "nohtml")
		$AllowableHTML=array('');
		$str = stripslashes($str);
		$str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
		// Delete all spaces from html tags .
		$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
		// Delete all attribs from Anchor, except an href, double quoted.
		$str = eregi_replace("<[[:space:]]* img[[:space:]]*([^>]*)[[:space:]]*>", '', $str);
		// Delete all img tags
		$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?javascript[[:punct:]]*\"?[^>]*>", '', $str);
		// Delete javascript code from a href tags -- Zhen-Xjell @ http://nukecops.com
		$tmp = "";
		while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
			$i = mb_strpos($str,$reg[0]);
			$l = mb_strlen($reg[0]);
			if ($reg[1][0] == "/") $tag = mb_strtolower(mb_substr($reg[1],1));
			else $tag = mb_strtolower($reg[1]);
			if ($a = $AllowableHTML[$tag])
			if ($reg[1][0] == "/") $tag = "</$tag>";
			elseif (($a == 1) || ($reg[2] == "")) $tag = "<$tag>";
			else {
				# Place here the double quote fix function.
				$attrb_list=delQuotes($reg[2]);
				// A VER		//$attrb_list = ereg_replace("&","&amp;",$attrb_list);
				$tag = "<$tag" . $attrb_list . ">";
			} # Attribs in tag allowed
			else $tag = "";
			$tmp .= mb_substr($str,0,$i) . $tag;
			$str = mb_substr($str,$i+$l);
		}
		$str = $tmp . $str;
		return $str;
		exit;
		/* Squash PHP tags unconditionally */
		$str = mb_ereg_replace("<\?","",$str);
		return $str;
	}

	public function FixQuotes ($what = "") {
		//$what = ereg_replace("'","''",$what);
		while (mb_eregi("\\\\'", $what)) {	$what = mb_ereg_replace("\\\\'","'",$what);  }
		return $what;
	}

	public function filter_text($Message, $strip="") {
		self::check_words($Message);
		$this->$EditedMessage=self::check_html($EditedMessage, $strip);
		return $this->$EditedMessage;
	}

	// функция с переменным числом параметров, и сопределнными значениями по умолчанию
	public function check_data($what, $strip="", $save="", $type="") {
		if ($strip == "nohtml") {
			$what = self::check_html($what, $strip);
			// If the variable $what doesn't comes from a preview screen should be converted
			if ($type != "preview" AND $save != 1) { $what = html_entity_decode($what,ENT_COMPAT,DEF_CP); }
		}
		if ($save == 1) {
			$what = self::check_words($what);
			$what = self::check_html($what, $strip);
			$what = addslashes($what);
		} else {
			$what = stripslashes(FixQuotes($what));
			$what = self::check_words($what);
			$what = self::check_html($what, $strip);
		}
		$what = addslashes($what);
		return($what);
	}
}