<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class HTMLControls extends Object {
	private static $unificator=0;
	private static $elid=0;

	public static function renderBalloonButton($text,$translate=true){
		if ($translate) $text=Text::_($text);
		$html="<div title=\"".$text."\" class=\"balloon_button\"></div>";
		return $html;
	}
	public static function renderPopupMultySelect($name, $data, $key_fld="", $name_fld="", $link_add="", $js_add="",$js_inf='',$isNewLink=false) {
		return self::renderPopupMultySelectWQ($name, $data, false, $key_fld, $name_fld, "", $link_add, $js_add, $js_inf,$isNewLink);
	}
	public static function renderPopupMultySelectWQ($name, $data, $withQuantity=false, $key_fld="", $name_fld="", $quant_fld="", $link_add="", $js_add="",$js_inf='',$isNewLink=false) {
		if (!$key_fld) $key_fld="id";
		if (!$name_fld) $name_fld="title";
		if (!$quant_fld) $quant_fld="quantity";
		$html="<div id=\"".$name."\" class=\"multyselector\">";

		$html.="<input type=\"hidden\"  id=\"".$name."_delete\" name=\"".$name."_delete\" value=\"".Text::_("Delete")."\" />";
		$html.="<input type=\"hidden\" id=\"".$name."_exists\" name=\"".$name."_exists\" value=\"".Text::_("Already added")."\" />";
		$html.="<input type=\"hidden\" id=\"".$name."_wq\" name=\"".$name."_wq\" value=\"".($withQuantity ? 1 : 0)."\" />";
		if($link_add) {
			$html.="<p class=\"add-but\"><a class=\"spravselector\" href=\"".$link_add."\">".Text::_("Add")."<img alt=\"+\" title=\"".Text::_("Add")."\" class=\"add-but\" src=\"/images/blank.gif\" width=\"1\" height=\"1\" /></a></p>";
		}	elseif ($js_add) {
			$html.="<p class=\"add-but\"><a onclick=\"".$js_add."\">".Text::_("Add")."<img alt=\"+\" title=\"".Text::_("Add")."\" class=\"add-but\" src=\"/images/blank.gif\" width=\"1\" height=\"1\" /></a></p>";
		}
		if (count($data)) {
			foreach($data as $elem){
				$current_id=$name."_".htmlspecialchars($elem[$key_fld]);
				if ($isNewLink) $html.="<p class=\"newline clearfix\">"; else $html.="<p class=\"clearfix\">";
				$html.="<img width=\"1\" height=\"1\" alt=\"-\" title=\"".Text::_("Delete")."\" onclick=\"deleteMultyRow('".$current_id."','".Text::_("Delete")."')\" class=\"delete-but\" src=\"/images/blank.gif\" />";
				$html.=self::renderHiddenField($name."[]",$elem[$key_fld],$current_id);
				$cur_js_inf=sprintf($js_inf,$elem[$key_fld]);
				$html.=self::renderLabelField($current_id,$elem[$name_fld],0,$cur_js_inf);
				//if($withQuantity) $html.=self::renderInputText($name."_quantity[]", $val="",$size="",$length="", $id="", $class='',$readonly=false,$required=false,$title='');
				if($withQuantity) $html.=self::renderInputText($name."_quantity[".$elem[$key_fld]."]", $elem[$quant_fld], "", "", $name."_quantity_".$elem[$key_fld], 'quantity numeric');
				$html.="</p>";
			}
		}
		$html.="</div>";
		return $html;
	}
	public static function renderAddressPanel($name, $data, $id, $class, $readonly){
		$html="<div class=\"addressselector\">";
		$html.=self::renderImageButton(false, "", false, 'addressbutton', "showAddressEditor('".$id."')");
		$html.=self::renderHiddenField($name,base64_encode(json_encode($data)),$id);
		$html.=self::renderLabelField($id,$data["fullinfo"]);
		$html.="</div>";
		return $html;
	}
	public static function renderCheckbox($name, $checked_val="", $val=1, $id="", $class="", $js="") {
		if(!$id) $id=$name;
		$html="<input type=\"checkbox\" id=\"".$id."\" name=\"".$name."\" value=\"".$val."\"";
		if ($class) $html.= " class=\"".$class."\"";
		if($checked_val==$val) $html.=" checked=\"checked\"";
		if($js) $html.=" onclick=\"javascript:".$js.";\"";
		$html.=" />";
		return $html;
	}

	public static function renderInputText($name, $val="",$size="",$length="", $id="", $class='',$readonly=false,$required=false,$title='') {
		if($id===false)
			$id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		if ($readonly) $readonly=" readonly=\"readonly\""; else $readonly="";
		$html="<input type=\"text\" ".$id_text.$readonly." value=\"".htmlspecialchars($val)."\" name=\"".$name."\"";
		if ($size) $html.= " size=\"".$size."\"";
		if ($class) $html.= " class=\"".$class."\"";
		if ($length) $html.=" maxlength=\"".$length."\"";
		if ($title) $html.=" title=\"".$title."\"";
		if ($required) $html.=" required=\"required\"";
		$html.=" />";
		return $html;
	}

	public static function renderFileSelector($name, $val="",$size="",$length="", $id="", $class='',$readonly=false,$required=false,$title='') {
		if($id===false)
			$id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		if ($readonly) $readonly=" readonly=\"readonly\""; else $readonly="";
		$html="<input type=\"text\" ".$id_text.$readonly." value=\"".htmlspecialchars($val)."\" name=\"".$name."\"";
		if ($size) $html.= " size=\"".$size."\"";
		if ($class) $html.= " class=\"".$class."\"";
		if ($length) $html.=" maxlength=\"".$length."\"";
		if ($title) $html.=" title=\"".$title."\"";
		if ($required) $html.=" required=\"required\"";
		$html.=" />";
		$js="alert('".$name."')";
		$html.="<a class=\"relpopupwt\" href=\"index.php?module=service&amp;task=startMediamanager&amp;nfl=0&amp;ret_elem=".$id."\">".self::renderImageButton("", "", "", 'file_selector', "")."</a>";
		return $html;
	}
	
	public static function renderInputFile($name, $val="",$size=20, $id="", $class='') {
		if($id===false)
			$id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		$html="<input type=\"file\" ".$id_text." size=\"".$size."\" value=\"".$val."\" name=\"".$name."\"";
		if ($class) $html.= " class=\"".$class."\"";
		$html.=" />";
		return $html;
	}

	public static function renderDateSelector($name, $val="", $id="", $class='') {
		if($id===false) $id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		$html="<input type=\"text\" ".$id_text." maxlength=\"10\" size=\"10\" value=\"".$val."\" name=\"".$name."\"";
		if ($class) $html.= " class=\"dateselector ".$class."\"";
		else $html.= " class=\"dateselector\"";
		$html.=" />";
		$html.="<img width=\"1\" height=\"1\" class=\"date_selector\" src=\"/images/blank.gif\" title=\"".Text::_("Select date")."\" alt=\"D\" />";
		return $html;
	}

	public static function renderButton($name, $val="",  $type="button",  $id="", $class='commonButton',$js='',$title="") {
		if($id===false) $id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		if($js) $js=" onclick=\"javascript:".$js.";\"";
		if($title) $title=" title=\"".$title."\"";
		$html="<input type=\"".$type."\" ".$id_text." value=\"".htmlspecialchars($val)."\" name=\"".$name."\"";
		if ($class) $html.= " class=\"".$class."\"";
		$html.=" ".$js.$title." />";
		return $html;
	}

	public static function renderImageButton($name, $title="", $id="", $class='button',$js='') {
		if($id===false)  $id="";
		else {
			if(!$id) {
				if($name===false) $id=""; else $id=$name;
			}
		}
		$html="<img width=\"1\" height=\"1\" src=\"/images/blank.gif\"";
		if($name) $html.= " name=\"".$name."\"";
		if ($id) $html.= " id=\"".$id."\"";
		if ($class) $html.= " class=\"".$class."\"";
		if($js) $html.=" onclick=\"javascript:".$js.";\"";
		if($title) $html.=" title =\"".$title."\"";
		$html.=" alt=\"\"  />";
		return $html;
	}

	public static function renderIcon($class,$size=16) {
		$html="<img width=\"".$size."\" height=\"".$size."\" src=\"/images/blank.gif\" class=\"".$class."\" alt=\"\" />";
		return $html;
	}
	public static function renderRadio($name, $id, $val="", $label="",$class="", $checked=true, $js=''){
		$html="<input type=\"radio\" value=\"".$val."\" name=\"".$name."\"";
		$html.= " id=\"".$id."\"";
		if ($checked) $html.= " checked=\"checked\"";
		if ($class) $html.= " class=\"".$class."\"";
		if ($js) $html.= " onchange=\"".$js."\"";
		$html.=" />";
		if($label) $html.=self::renderLabelField($id,$label);
		return $html;
	}
	public static function renderYesNoRadioButton($name,$id,$value=1,$label_yes='',$label_no='', $class='',$js="") {

		if(!$label_yes) $label_yes=Text::_("Yes");
		if(!$label_no) $label_no=Text::_("No");
		$checked_yes=$value; $checked_no=!$value;
		$html=self::renderRadio($name, $name."_yes", 1, $label_yes ,$class,$checked_yes,$js);
		$html.=self::renderRadio($name, $name."_no", 0, $label_no ,$class,$checked_no,$js);
		return $html;
	}

	public static function renderLabelField($id="", $value="", $forceTranslation=0,$js='') {
		if($js) $js=" title=\"".Text::_("Update")."\" style=\"cursor:pointer;\" onclick=\"javascript:".$js.";\"";
		if($forceTranslation) $value=Text::_($value);
		if($id)	return "<label".$js." for=\"".$id."\">".$value."</label>";
		else return "<span class=\"fake_label\"".$js.">".$value."</span>";
	}

	public static function renderHiddenField($name="", $val="", $id="", $class="") {
		if($id===false) $id_text='';
		else {
			if(!$id) $id=$name;
			$id_text="id=\"".$id."\"";
		}
		if ($class) $class="class=\"".$class."\"";
		return "<input type=\"hidden\" ".$id_text." value=\"".htmlspecialchars($val)."\" name=\"".$name."\" ".$class." />";
	}

	public static function renderImage($link="", $noimage=false, $width=0, $height=0, $title="", $alt="", $default_dims=false) {
		if ($link) {
			$src=" src=\"".$link."\"";
		} else {
			if ($noimage===false) $src="";
			elseif ($noimage) $src=" src=\"".$noimage."\"";
			else $src=" src=\"/images/nophoto.png\"";
		}
		if (!$width && !$height && $default_dims) {	// размеры из галереи, она ближе всех к картинкам
			$width=galleryConfig::$thumbWidth;
			//$height=galleryConfig::$thumbHeight;
		}
		if ($width) $width=" width=\"".$width."\""; else $width="";
		if ($height) $height=" height=\"".$height."\""; else $height="";
		if ($title) $title=" title=\"".htmlspecialchars($title)."\"";
		$_html="<img".$title.$width.$height.$src." alt=\"".$alt."\" />";
		return $_html;
	}
	public static function renderFlash($link="", $width=0, $height=0) {
		if ($link&&$width&&$height) {
			$_html='<object type="application/x-shockwave-flash" data="'.$link.'"';
			if ($width) $_html.=' width ="'. $width.'"';
			if ($height) $_html.=' height ="'. $height.'"';
			$_html.='>';
			$_html.='<param name="movie" value="'.$link.'" />';
			$_html.='<param name="quality" value="high" />';
			$_html.='<param name="wmode" value="transparent" />';
			$_html.='</object>';
		} else $_html="";
		return $_html;
	}
	public static function renderRating($rating=0,$max_raiting=5) {
		$html="<div class=\"stars\">";
		for ($i = 1; $i <= $max_raiting; $i++) {
			if (($rating<$i)&&($rating>($i-1))) {
				$img="rating_half.gif";
			}
			elseif($rating<$i) {
				$img="rating_off.gif";
			}
			else {$img="rating_on.gif";
			}
			$imgpath='/templates/'.siteConfig::$siteTemplate.'/images/'.$img;
			$html.="<img src=\"".$imgpath."\" alt=\"\" />";
		}
		$html.="</div>";
		return $html;
	}

	/**
	 *
	 * Формирование списка по массивам разных типов. Определяется передаваемыми данными.
	 * @param _name - имя поля
	 * @param _id - ид поля
	 * @param _key_fld - имя поля (value option) в элементе массива( в объекте) если пусто - работает по обычному варианту ассоциативного массива
	 * @param _val_fld - имя поля (title option) в элементе массива( в объекте) если пусто - работает по обычному варианту ассоциативного массива
	 * @param _arr - массив данных формата массив объектов
	 * @param _sel_val - выбранное значение(ключ)
	 * @param _zero_fill -  добавлять базовое (пустое значение)
	 * @param _js - функиця обработки
	 * @param multiple - ждет значения одновременно видимых элементов, 0 - отключен
	 * @param class - класс css
	 */
	public static function renderSelect($_name, $_id, $_key_fld, $_val_fld, $_arr, $_sel_val=0, $_zero_fill=1, $_js="", $multiple=0, $class="",$required=false) {
		if($_id===false) $id_text='';
		else {
			if(!$_id) $_id=$_name;
			$id_text="id=\"".$_id."\"";
		}
		$selected=" selected=\"selected\"";
		$_selection=preg_split('/[\,]/',$_sel_val);
		if ($multiple) {
			$multiple = " multiple=\"multiple\" size=\"".$multiple."\""; $_name=$_name."[]";
			$_class = "multiSelect ";
		} else {
			$multiple = "";
			$_class = "singleSelect ";
		}
		if ($class) $_class.= $class;
		if ($required) $required_txt=" required=\"required\""; else $required_txt="";
		
		$_html ="<select class=\"".$_class."\" ".$multiple." name=\"".$_name."\" ".$id_text." ".$required_txt.($_js ? "onchange=\"".$_js."\"" : "").">";
		if($_zero_fill)
			$_html.="<option value=\"0\"".($_sel_val==0 ? $selected : "")."> --- ".Text::_("Not selected")." --- </option>";
		if (count($_arr)>0) {
			foreach($_arr as $key=>$val) {
				if (is_object($val)) {
					$_html.="<option value=\"".$val->$_key_fld."\"".(in_array($val->$_key_fld,$_selection) ? $selected : "").">".$val->$_val_fld."</option>";
				} else {
					if ($_key_fld&&$_val_fld) {
						$_html.="<option value=\"".$val[$_key_fld]."\"".(in_array($val[$_key_fld],$_selection) ? $selected : "").">".$val[$_val_fld]."</option>";
					} elseif ($_val_fld) {
						$_html.="<option value=\"".$key."\"".(in_array($key,$_selection) ? $selected : "").">".$val[$_val_fld]."</option>";
					} else {
						$_html.="<option value=\"".$key."\"".(in_array($key,$_selection) ? $selected : "").">".$val."</option>";
					}
				}
			}
		}
		$_html.="</select>";
		return $_html;
	}

	public static function renderStaticHeader($title='', $keywords='', $description='',$stylesheets=null) {
		$_html='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ru-ru" lang="ru-ru">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<meta name="generator" content="ALTADOC CMS" />
				<meta name="description" content="'.$description.'" />
				<meta http-equiv="Pragma" content="no-cache" />
				<meta http-equiv="cache-control" content="no-cache" />
				<meta name="keywords" content="'.$keywords.'" />
				<title>'.$title.'</title>';
		if (count($stylesheets)){
			foreach($stylesheets as $style) {
				$_html.=	'<link rel="stylesheet" href="'.$style.'" type="text/css" />';
			}
		}
		$_html.=	'</head>
				<body>
				';
		return $_html;
	}
	public static function renderStaticFooter() {
		$_html='</body></html>';
		return $_html;
	}

	public static function renderEditor($id,$taName='',$editorText='',$toolbar='Default',$height=0,$width=0,$params=array(), $class='editorArea') {
		if(!$taName) $taName=$id;
		if (array_key_exists("cols",$params)) $cols=$params["cols"]; else $cols=80;
		if (array_key_exists("rows",$params)) $rows=$params["rows"]; else $rows=10;
		$params["edName"]=$taName;
		if($height) $params["height"]=$height;
		if($width) $params["width"]=$width;
		$params["toolbar"]=$toolbar;
		Event::raise("editor.render",$params);
		$editorHTML = "<textarea name=\"".$taName."\" cols=\"".$cols."\" class=\"".$class."\" rows=\"".$rows."\" id=\"".$id."\">".htmlentities($editorText,ENT_COMPAT,DEF_CP)."</textarea>";
		return $editorHTML;
	}

	public static function renderBBCodeEditor($id, $name='',$val='', $cols=35, $rows=7, $class='',$readonly=false,$required=false,$title='') {
		if(!$name) $name=$id;
		$html = "<textarea name=\"".$name."\" cols=\"".$cols."\"";
		if ($class) $html.= " class=\"".$class."\"";
		if ($required) $html.=" required=\"required\"";
		if ($title) $html.=" title=\"".$title."\"";
		if ($readonly) $html.=" readonly=\"readonly\"";
		$html.= "rows=\"".$rows."\" id=\"".$id."\">".$val."</textarea>";
		return $html;
	}
	public static function hideEmail($email,$class="",$replace_with_link=true){
		if ($class) $class=" class=\"".$class."\"";
		if (rand(0,1)) $el="span"; else $el="p";
		self::$unificator=self::$unificator+1;
		if (!self::$elid) self::$elid=md5(time());
		$elid=self::$elid.self::$unificator;
		$rand=rand(0,3);
		switch ($rand) {
			case 0: $dot=" tutadot ";		$at=" predostavlen ";	break;
			case 1: $dot=" zdesenot ";	$at=" na servere "; 	break;
			case 2: $dot=" chtoto ";		$at=" sponsor ";			break;
			case 3: $dot=" tochka ";		$at=" sobaka "; 			break;
		}

		$email=str_replace(".", $dot, $email);
		$email=str_replace("@", $at, $email);
		$newmail = "<".$el." id=\"".$elid."\">".$email."</".$el.">";
		$js="$(document).ready(function(){
				var chego = $('".$el."#".$elid."');
						var gdemy = /".$at."/;
								var razdelili = /".$dot."/g;
										var zamenit = $(chego).text().replace(gdemy,'@').replace(razdelili,'.');";
		if ($replace_with_link)	$js.="$(chego).after('<a".$class." href=\"mailto:'+zamenit+'\">'+ zamenit +'</a>');";
		else 	$js.="$(chego).after(zamenit);";
		$js.="$(chego).remove();
	});";
		Portal::getInstance()->addScriptDeclaration($js);
		return $newmail;
	}
	public static function renderParamsPanel($name,$title,$mask,$params, $forceTranslate=true){
		$html="<fieldset><legend>";
		if ($forceTranslate) $html.=self::renderLabelField(false,Text::_($title));
		else $html.=self::renderLabelField(false,$title);
		$html.="</legend>";
		if (count($mask)) {
			$html.="<table class=\"params\">";
			foreach ($mask as $prmName=>$prmType) {
				if ($prmName) {
					$html.="<tr><td class=\"tablLabel\">";
					$html.="<label for=\"".$prmName."\">".Text::_(str_replace("_"," ",$prmName))."</label>";
					if(isset($prmType["descr"])&&$prmType["descr"]) $html.=HTMLControls::renderBalloonButton($prmType["descr"]);
					$html.="</td><td>";
					if ((is_array($params))&&(array_key_exists($prmName,$params))) $val = $params[$prmName];
					else $val = $prmType["vdefault"];
					switch ($prmType["vtype"]) {
						case "boolean":
							if ($val) $checked = "checked=\"checked\" ";
							else $checked = "";
							$html.="<input id=\"".$prmName."\" name=\"".$name."[".$prmName."]\" type=\"checkbox\" ".$checked." value=\"1\" />";
							break;
						case "table_select":
							if(isset($prmType["source"])) {
								Database::getInstance()->setQuery($prmType["source"]);
								$_source=Database::getInstance()->loadObjectList();
								$html.=HTMLControls::renderSelect($name."[".$prmName."]", $prmName, "fld_id", "fld_name", $_source,$val);
							}	else $html.="<input id=\"".$prmName."\" name=\"".$name."[".$prmName."]\" type=\"text\" value=\"".$val."\" />";
							break;
						case "select":
							if(isset($prmType["source"])&&is_array($prmType["source"])) $html.=HTMLControls::renderSelect($name."[".$prmName."]", $prmName, "id", "name", $prmType["source"],$val);
							else $html.="<input id=\"".$prmName."\" name=\"".$name."[".$prmName."]\" type=\"text\" value=\"".$val."\" />";
							break;
						case "integer":
						case "float":
						case "string":
							$html.="<input id=\"".$prmName."\" name=\"".$name."[".$prmName."]\" type=\"text\" value=\"".$val."\" />";
							break;
						case "ro_string":
							$html.="<p>".$val."</p>";
							break;
						default:
							$html.=Text::_("Wrong parameter type").": ".$prmType;
							break;
					}
					$html.="</td></tr>";
				}
			}
			$html.="</table>";
		}
		$html.="</fieldset>";
		return $html;
	}
}
?>