<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Measure extends Object{
	private $_loadedMeasures = array();
	
  //---------- Singleton implementation ------------
  private static $_instance = null;

  public static function createInstance() {
    if (self::$_instance == null) {
      self::$_instance = new self();
    }
  }

  public static function getInstance() {
    self::createInstance();
    return self::$_instance;
  }
  //------------------------------------------------

  private function __construct() {

  }
		
	private function getMeasure($id){
		if (!array_key_exists($id,$this->_loadedMeasures)) $this->loadMeasure($id);
		return $this->_loadedMeasures[$id];
	}
	
  private function loadMeasure($id){
    $res=false;
		$db=Database::getInstance();
		$db->setQuery("SELECT * FROM #__measure WHERE meas_id='".$id."'");
		$db->loadObject($res);
		$this->_loadedMeasures[$id]=$res;
	}
	public function getTitle($id){
		$meas = $this->getMeasure($id);
		if ($meas) return $meas->meas_full_name; else return "";
	}
	public function getShortName($id){
		$meas = $this->getMeasure($id);
		if ($meas) return $meas->meas_short_name; else return "";
	}
	
	public function convert($quantity, $in_id, $out_id){
		$meas_in=$this->getMeasure($in_id);
		$meas_out=$this->getMeasure($out_id);
		if ($meas_in&&$meas_out&&($meas_in->meas_type==$meas_out->meas_type)){
			if (!$meas_out->meas_kf) return 0;
			$result=$quantity*$meas_in->meas_kf/$meas_out->meas_kf;
			return $result; 
		} else return 0;
	}
	public function getKoeff($id){
		$meas = $this->getMeasure($id);
		if ($meas) return $meas->meas_kf; else return 0;
	}
}
