<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Menus extends Object{

	private $max_levels = 5;
	private $all_parents = "";
	private $all_res = "";
	private $tree_level = 0;
	private $html = "";
	private $root_id = ""; // ID of root menu item
	private $ul_id = ""; // id for main ul of tree
	private $translate = true;
	private $activemenu = 0;
	private $_unique_id = "";
		
	public function render($root_id="",$ul_id="",$translate=true,$max_levels=0) {
		$this->_unique_id=$ul_id;
		if(!$translate) $this->translate=false;
//		if($max_levels) $this->max_levels=$max_levels;
		if (!$root_id) return "";
		$this->root_id=$root_id; 
		$this->ul_id=$ul_id; 
//		$mid=Request::getInt("mid",0);	if ($mid) $_SESSION['active_menu_id']=$mid;
//		if (!isset($_SESSION['active_menu_id']) Portal::getInstance()->initActiveMenuItem();
		$this->activemenu=$_SESSION['active_menu_id'];
		$this->buildTreeArrays($max_levels);
		$this->html=""; $this->tree_level=0;
		$parents_arr=preg_split("/(\,)/", $this->root_id);
		$this->drawTreeLevelUL ($parents_arr, $ul_id); 
		$menuHTML = $this->html; 
		return $menuHTML;
	}
	
	private function makeParents($res) {
		if (count($res)>0) {
			foreach($res as $row) {	$result[]=$row->mi_parent_id; }
		} else return false;
		return $result;
	}
	private function drawTreeLevelUL($parent_id, $ul_id) {
		$item_drawed=0; $this->tree_level++;
		if (count($this->all_res)) {
			foreach($this->all_res as $res_row) {
				if (in_array($res_row->mi_parent_id,$parent_id)) {
					if (!$item_drawed) {
						if ($ul_id) $this->html.= "<ul id=\"".$ul_id."\">"; else $this->html.= "<ul>";
						$item_drawed=1;
					}
					
				if ($res_row->mi_access != "all") {
					$roles=preg_split("/(\;)/", trim($res_row->mi_access)); $roles=array_flip($roles);
					if (!array_key_exists(User::getInstance()->getRole(), $roles)) continue;
				}
//					if ($this->activemenu==$res_row->mi_id) $class=" class=\"active\""; else $class="";
//					$this->html.= "<li id=\"menuitem".$res_row->mi_id."\"".$class.">";
					$this->html.= "<li id=\"".$this->ul_id."_item_".$res_row->mi_id."\">";
					if ($res_row->mi_link) $href=$res_row->mi_link;
					else {
						$href="index.php?";
						if ($res_row->mi_module) $href.="module=".$res_row->mi_module."&amp;";
						if ($res_row->mi_view) $href.="view=".$res_row->mi_view."&amp;";
						if ($res_row->mi_layout) $href.="layout=".$res_row->mi_layout."&amp;";
						if ($res_row->mi_alias) $href.="alias=".$res_row->mi_alias."&amp;";
						if ($res_row->mi_psid) $href.="psid=".$res_row->mi_psid."&amp;";
						$href.="mid=".$res_row->mi_id;
					}
					$target=""; $class="";
					switch  ($res_row->mi_target) {
						case "_blank":
							$target=" target=\"_blank\""; 
							break;
						case "popup":
							$class=" class=\"relpopuptext\""; 
							break;
					}
					if($res_row->mi_nofollow) $rel=" rel=\"nofollow\"";	else $rel="";						
					
					if ($this->translate) $cur_name =	Text::_($res_row->mi_name);
					else $cur_name = $res_row->mi_name;
					$this->html.= '<a href="'.Router::_($href).'"'.$rel.$target.$class.'><span>'.$cur_name.'</span></a>';
					$parents_arr=preg_split("/(\,)/", $res_row->mi_id);
					if ($this->tree_level<$this->max_levels) $this->drawTreeLevelUL ( $parents_arr, 'tree-'.$res_row->mi_id);
					$this->html.= '</li>';
				}
			}
			$this->tree_level--;
			if ($item_drawed) $this->html.=  '</ul>';
		}	
	}

	private function buildTreeArrays( $max_levels=0) {
		if ($max_levels) $this->max_levels=(int)$max_levels;
		else 
			if (siteConfig::$treeDepth) $this->max_levels=(int)siteConfig::$treeDepth;
		$sql = "SELECT * FROM #__menus WHERE mi_id>0 AND mi_enabled=1 AND mi_deleted=0 ORDER BY mi_ordering";
		Database::getInstance()->setQuery($sql);
		$this->all_res=Database::getInstance()->loadObjectList();
		$this->all_parents=$this->makeParents($this->all_res);
	}
	
	public function getAllMenusItems() {
		$query = "SELECT mi.mi_id,0 as mi_level, mi.mi_parent_id,mi.mi_name";
		$query .= " FROM #__menus AS mi";
		$query .= " WHERE mi.mi_deleted=0";
		$query .= " ORDER BY mi.mi_ordering";
		Database::getInstance()->setQuery($query);
		$items=null;
		$this->tree_level=0;	$this->all_res=Database::getInstance()->loadObjectList();
		$parents_arr=preg_split("/(\,)/", 0);
		$this->markLevels($items,$parents_arr);
		return $items;
	}
	public function getMenusItems($parent_id) {
		$query = "SELECT mi_id,0 as mi_level,mi_parent_id,mi_name FROM #__menus WHERE mi_enabled=1 AND mi_deleted=0";
		Database::getInstance()->setQuery($query);
		$items=null;
		$this->tree_level=0;	$this->all_res=Database::getInstance()->loadObjectList();
		$parents_arr=preg_split("/(\,)/", $parent_id);
		$this->markLevels($items,$parents_arr);
		return $items;
	}
	public static function getMenusTemplate($psid) {
		$query = "SELECT mi_custom_template FROM #__menus WHERE mi_id=".$psid;
		Database::getInstance()->setQuery($query);
		return Database::getInstance()->loadResult();
	}
	private function markLevels(&$items,$parent_id){
		$this->tree_level++;
		if (count($this->all_res)) {
			foreach($this->all_res as $res_row) {
				if (in_array($res_row->mi_parent_id,$parent_id)) {
					$res_row->mi_level=$this->tree_level;
					$items[]=$res_row;
					$parents_arr=preg_split("/(\,)/", $res_row->mi_id);
					if ($this->tree_level<$this->max_levels) $this->markLevels ($items, $parents_arr);
				}
			}
			$this->tree_level--;
		}	
	}
	public static function searchSuitableMID(){
		// ссылки в пунктах меню отрабатывае только по модулю
		// остальное надо забивать не ссылками а параметрами
		$mid=0; $possible=array();
		$view=""; $layout="default"; $psid=""; $alias="";
		$req = Router::getInstance()->getVarsArr(); 
		if (isset($req["module"])) $module=$req["module"]; 
		elseif(Request::get("module","")) $module=Request::get("module","");
		else {
			return siteConfig::$defaultMenuID;
		}
// Отработка не sef ссылки при включенном sef 
		$view=Request::getSafe("view","");
		$layout=Request::getSafe("layout","default");
		$psid=Request::getInt("psid","");
		$alias=Request::getSafe("alias","");
/*
		if (isset($req["view"])) $view=$req["view"]; else $view="";
		if (isset($req["layout"])) $layout=$req["layout"]; else $layout="default";
		if (isset($req["psid"])) $psid=$req["psid"]; else $psid="";
		if (isset($req["alias"])) $alias=$req["alias"]; else $alias="";
*/		
		// сузим поиск до модуля
		$sql="SELECT mi_id,mi_link,mi_module,mi_view,mi_layout,mi_alias,mi_psid FROM #__menus WHERE mi_enabled=1 AND mi_deleted=0";
		$sql.=" AND mi_module='".$module."'";
		$sql.=" ORDER BY mi_ordering"; // ??????????????
		Database::getInstance()->setQuery($sql);
		$nearer=Database::getInstance()->loadObjectList();
		if (count($nearer)){
			// теперь вариантов немного складываем в массивы по порядку
			// 1 - view, layout,psid
			// 2 - view, psid
			// 3 - view, layout
			// 4 - view
			// 5 - только модуль :(
			foreach($nearer as $key=>$row){
				if ($alias && $row->mi_alias==$alias){
					$possible[0][]=$row->mi_id;
				} elseif ($row->mi_view==$view && $row->mi_layout==$layout && $row->mi_psid==$psid){
					$possible[1][]=$row->mi_id;
				} elseif ($row->mi_view==$view && $row->mi_psid==$psid){
					$possible[2][]=$row->mi_id;
				} elseif ($row->mi_view==$view && $row->mi_layout==$layout){
					$possible[3][]=$row->mi_id;
				} elseif ($row->mi_view==$view){
					$possible[4][]=$row->mi_id;
				} else {
					$possible[5][]=$row->mi_id;
				}
			}
			for ($i=0;$i<6;$i++){	
				if (isset($possible[$i]) && count($possible[$i])) return $possible[$i][0];
			}
		}
		return $mid;
	}
}
?>