<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

final class Params {
	private static $ravno="{=}";
	private static $semicolon="{;}";
	private static $hvost=3;
	
	public static function parse($str){
		$res=null;
		$configArray = explode(self::$semicolon,$str);
		if (count($configArray)) {
			foreach($configArray as $config)	{
				$cfgPair = explode(self::$ravno,$config);
				if($cfgPair[0]&&isset($cfgPair[1])) $res[$cfgPair[0]]=$cfgPair[1];
			}
		}
		return $res;
	}
	public static function parse64($data){
		return json_decode(base64_decode($data));
	}
	public static function intersect($params, $def_params){
		$param_str="";
		$param_arr=array();
		foreach ($def_params as $prmName=>$prmType) {
			if($prmType["vtype"]=="ro_string") continue;
			$normalVal = "";
			switch ($prmType["vtype"]) {
				case "boolean":
					if (array_key_exists($prmName,$params)) {	$normalVal = "1"; }	else $normalVal = "0";
					break;
				case "integer":
					if (array_key_exists($prmName,$params)) {
						$normalVal = intval($params[$prmName]);
					}
					break;
				case "float":
					if (array_key_exists($prmName,$params)) {
						$normalVal = floatval(str_replace(',', '.',$params[$prmName]));
					}
					break;
				case "string":
					if (array_key_exists($prmName,$params)) {
						$normalVal = htmlspecialchars(htmlspecialchars_decode($params[$prmName],ENT_QUOTES),ENT_QUOTES,DEF_CP);
					}
					break;
				default:
					if (array_key_exists($prmName,$params)) {
						$normalVal = $params[$prmName];
					}
					break;
			}
			//$param_str .= $prmName.self::$ravno.$normalVal.self::$semicolon;
			$param_arr[]= $prmName.self::$ravno.$normalVal;
		}
		//$param_str = mb_substr($param_str,0,mb_strlen($param_str,DEF_CP) - self::$hvost,DEF_CP);
		$param_str = implode(self::$semicolon, $param_arr);
		return $param_str;
	}
}

?>