<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Session extends Object {
	//---------- Singleton implementation ------------
	private $_coname = false;
	private static $_instance = null;
	public static function createInstance() {
		Debugger::getInstance()->milestone("Starting session");
		if (self::$_instance == null) {
			self::$_instance = new self();
		}
	}
	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}
	//------------------------------------------------
	private function __construct() {
		$this->initObj();
		$this->_coname=md5($_SERVER['SERVER_NAME']);
		session_start();
		$key=$this->getKey();
		if ($key){
			$sess_data=false; 
			$db=Database::getInstance();
			$db->setQuery("SELECT * FROM #__sessions WHERE s_id='".$key."'");
			$db->loadObject($sess_data);
			if ($sess_data && $sess_data->s_uid) {
				if ($sess_data->s_ip == $this->getIP() && $sess_data->s_agent == md5($this->getAgent())) {
					$this->set('user_id',$sess_data->s_uid,true);
					if(rand(1,3)==2) $this->update($key);
					$this->milestone("Session started");
				} else {
					if (!Session::restoreToken(Request::getSafe("ALTADOC_TOKEN","")))	$this->delete($key);
				}
			}
		}	
	}
	private function delete($key=""){
		if ($key){
			$db=Database::getInstance();
			$db->setQuery("DELETE FROM #__sessions WHERE s_id='".$key."'");
			$db->query();
		}
	}
	private function update($key=""){
		$db=Database::getInstance();
		if ($key) {
			$db->setQuery("UPDATE #__sessions SET s_last='".time()."' WHERE s_id='".$key."'");
			$db->query();
			$this->milestone("Session updated");
		}
		$db->setQuery("DELETE FROM #__sessions WHERE s_last<".(time()-intval(60*siteConfig::$cookieLifeTime)));
		$db->query();
	}
	public function getKey(){
		return Request::getSafe("sess_id",Request::getSafe($this->_coname,"","cookie"),"session");
	}
	private function buildKey($uid,$ip,$agent,$time) {
		return md5($uid).md5($ip).$agent.md5($time);
	}
	public function create($uid, $remember=false) { // Вызывается только во время логина
		$time = time(); 	
		$ip=$this->getIP();
		$agent=md5($this->getAgent());
		$key = $this->buildKey($uid,$ip,$agent,md5($time));
		$sql="INSERT INTO #__sessions (s_id, s_uid, s_agent, s_ip, s_time, s_last)
			VALUES ('".$key."', '".$uid."', '".$agent."', '".$ip."', '".$time."', '".$time."')";
		Database::getInstance()->setQuery($sql);
		if(Database::getInstance()->query()) {
			if ($remember) setcookie($this->_coname,$key,time()+60*siteConfig::$cookieLifeTime,"/");
			$_SESSION['sess_id'] = $key;
		}	else {
			$this->destroy();
		}
	}
	public function getIP() {
		return $_SERVER["REMOTE_ADDR"];
	}
	public function getAgent() {
		// заглушка из-за IE10
		return "HTTP_USER_AGENT";
		return $_SERVER['HTTP_USER_AGENT'];
	}
	public function destroy() {
		$this->delete($this->getKey());
		setcookie($this->_coname,"",0,"/");
		setcookie(session_name(),'',time()-42000,'/');
		unset($_SESSION['sess_id']);
		session_destroy();
		$this->milestone('Session destroyed');
	}
	public static function setVar($var,$val) {
		if(isset($_SESSION[$var])) $old_val=$_SESSION[$var];
		else $old_val=null;
		$_SESSION[$var]=$val;
		return $old_val;
	}
	public static function unsetVar($var) {
		if(isset($_SESSION[$var])) unset($_SESSION[$var]);
	}
	public static function getVar($var) {
		if(isset($_SESSION[$var])) return $_SESSION[$var];
		else return null;
	}
  public static function restoreToken($code)  {
  	if (!$code) return 0;
  	$crypt=new Crypta();		
		$proc=json_decode($crypt->xxtea_decrypt(base64_decode($code), backofficeConfig::$secretCode),true);
		if(is_array($proc)&&isset($proc['user'])&&isset($proc['time'])&&($proc['time']<time())&&($proc['time']>time()-120)) {
			return intval($proc['user']);
		}	else return 0;
  }
  public static function getToken() {
  	$data_ppc['user']=User::getInstance()->getID();
  	$data_ppc['time']=time();
  	$crypt=new Crypta();		
		return base64_encode($crypt->xxtea_encrypt(json_encode($data_ppc), backofficeConfig::$secretCode)); 
  }
	
}
?>