<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogDelivery extends Object{
	protected $delivery=null;
	protected $data="";
	protected $items=null;
	protected $params=null;
	protected $inc_required=array();// что из отсутствующего в шаблоне добавить при записи
	protected $exc_required=array();// что из имеющегося в шаблоне исключить при записи
	protected $inc_data=array();// что из отсутствующего в шаблоне добавить при записи
	protected $exc_data=array();// что из имеющегося в шаблоне исключить при записи
	protected $delivery_data=null;

	public function __construct($delivery_type,$_data=false) {
		$this->delivery=$delivery_type;
		if ($_data) $this->data=$_data;
		if ($this->delivery) {
			Text::parse("catalog.".$this->delivery->dt_file,"custom");
			$this->params=Params::parse($this->delivery->dt_params);
		}
	}
	public static function getDeliveryClass($dt_id, $dt_data=false) {
		$delivery=self::getDeliveryType($dt_id);
		if ($delivery){
			if (defined("_ADMIN_MODE")) $modules_path=PATH_FRONT_MODULES; else $modules_path=PATH_MODULES;
			$dt_file=$modules_path."catalog".DS."deliveries".DS.$delivery->dt_file.DS."default.php";
			$dt_class=$delivery->dt_file."DeliveryClass";
			if (is_file($dt_file)){
				require_once $dt_file;
				if (class_exists($dt_class)) return new $dt_class($delivery,$dt_data);
			}
		}
		return new self($delivery);
	}
	public static function getDeliveryType($dt_id) {
		$db=Database::getInstance();
		if (!defined("_ADMIN_MODE")) $enabled = " AND  dt_enabled=1"; else $enabled="";
		$sql="SELECT * FROM #__goods_dts WHERE dt_deleted=0 AND dt_id=".$dt_id.$enabled;
		$db->setQuery($sql);
		if ($db->loadObject($res)) return $res;
		else return false;
	}
	public function getConfigValue($key){
		if (isset($this->params[$key])) return $this->params[$key]; else return false;
	}
	public function getParamsMask(){
		return array();
	}
	public function assignOrder($order,$items){
		$this->order=$order;
		$this->items=$items;
	}
	public function save() {
		return true;
	}

	public function renderForm() {
		return "";
	}

	public function renderInfo($data="") {
		if (!$data) $data=$this->getData();
		$html="<br />";
		if (is_array($data)){
			foreach ($data as $k=>$v){
				if ($v)	$html.="<b>".Text::_($k)." : </b>".$v."<br />";
			}
		}
		return $html;
	}

	public function checkData(&$err_message) {
		return true;
	}

	public function calculate(){
		return $this->delivery->dt_price;
	}
	// для одномерных массивов
	protected function intersectRequired($arr){
		$res=array_merge(array_diff($arr,$this->exc_required),$this->inc_required);
		return $res;
	}
	protected function intersect($arr){
		$res=array_merge(array_diff($arr,$this->exc_data),$this->inc_data);
		return $res;
	}
	public function getId() {
		return $this->delivery->dt_id;
	}
	public function getTitle() {
		return $this->delivery->dt_name;
	}
	public function getCurrency() {
		return $this->delivery->dt_currency;
	}
	public function getData() {
		return $this->data;
	}
	public function getEncodedData() {
		return Userdata::getInstance(User::getInstance()->u_id)->encode($this->data);
	}
}
?>