<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogPayment extends Object{
	protected $payment=null;
	protected $order=null;
	protected $items=null;
	protected $data="";

	public function getParamsMask(){
		return array();
	}
	public function __construct($payment_type,$_data=false) {
		$this->payment=$payment_type;
		if ($_data) $this->data=$_data;
		if ($this->payment) {
			Text::parse("catalog.".$this->payment->pt_file,"custom");
			$this->params=Params::parse($this->payment->pt_params);
		}
	}
	public static function getPaymentClass($pt_id, $pt_data=false) {
		$payment=self::getPaymentType($pt_id);
		if ($payment){
			if (defined("_ADMIN_MODE")) $modules_path=PATH_FRONT_MODULES; else $modules_path=PATH_MODULES;
			$pt_file=$modules_path."catalog".DS."payments".DS.$payment->pt_file.DS."default.php";
			$pt_class=$payment->pt_file."PaymentClass";
			if (is_file($pt_file)){
				require_once $pt_file;
				if (class_exists($pt_class)) return new $pt_class($payment,$pt_data);
			}
		}
		return new self($payment);
	}
	public static function getPaymentType($pt_id) {
		$db=Database::getInstance();
		if (!defined("_ADMIN_MODE")) $enabled = " AND  pt_enabled=1"; else $enabled="";
		$sql="SELECT * FROM #__goods_pts WHERE pt_deleted=0 AND pt_id=".$pt_id.$enabled;
		$db->setQuery($sql);
		if ($db->loadObject($res)) return $res;
		else return false;
	}
	public function getConfigValue($key){
		if (isset($this->params[$key])) return $this->params[$key]; else return false;
	}
	public function assignOrder($order,$items){
		$this->order=$order;
		$this->items=$items;
	}
	public function show() {
	}

	public function renderInfo($data="") {
		if (!$data) $data=$this->getData();
		$html="<br />";
		if (is_array($data)){
			foreach ($data as $k=>$v){
				if ($v)	$html.="<b>".Text::_($k)." : </b>".$v."<br />";
			}
		}
		return $html;
	}
	public function setPaid(){
		$sql="UPDATE #__orders SET o_paid=1 WHERE o_id=".$this->order->o_id;
		Database::getInstance()->setQuery($sql);
		if (Database::getInstance()->query())	return true;
		else return false;
	}
	public function addPaymentData(){
		$enc_data=$this->getEncodedData();
		$sql="UPDATE #__orders SET o_pt_data='".$enc_data."' WHERE o_id=".$this->order->o_id;
		Database::getInstance()->setQuery($sql);
		if (Database::getInstance()->query())	return true;
		else return false;
	}
	public function send(){
		return true;
	}
	public function recieve(){
		return true;
	}
	public function calculate(){
		return $this->payment->pt_price;
	}
	public function getId() {
		return $this->payment->pt_id;
	}
	public function getTitle() {
		return $this->payment->pt_name;
	}
	public function getCurrency() {
		return $this->payment->pt_currency;
	}
	public function getData() {
		return $this->data;
	}
	public function getEncodedData() {
		return Userdata::getInstance(User::getInstance()->u_id)->encode($this->data);
	}
}

?>