<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class widgetZone extends Object {
	private static $_zones=array();
	private static $_instance = null;

	public static function createInstance() {
		if (self::$_instance == null) {
			Debugger::getInstance()->milestone("Create widgetZone");
			self::$_instance = new self();
		}
	}

	public static function getInstance() {
		self::createInstance();
		return self::$_instance;
	}

	private function __construct() {
		$this->initObj();
		$this->prepare();
	}
	private function prepare() {
		$query = "SELECT aw.* FROM `#__widgets_active` as aw
							WHERE aw.aw_enabled=1 AND aw.aw_deleted=0
							ORDER BY aw.aw_zone, aw.aw_ordering";
		$db = Database::getInstance();
		$db->setQuery($query);
		$awlist = $db->loadObjectList();
		if (count($awlist)){
			foreach ($awlist as $aw) {
				if(trim($aw->aw_access)!="all") {
					$roles=preg_split("/(\;)/", trim($aw->aw_access)); $roles=array_flip($roles);
					if (!array_key_exists(User::getInstance()->getRole(), $roles)) continue;
				}	
				if(trim($aw->aw_visible_in)!="all") {
					$menuitems=preg_split("/(\;)/", trim($aw->aw_visible_in));
					$visible_except= (isset($menuitems[0])&&$menuitems[0]=="except"); // $visible_except=1; else $visible_except=0;
					$menuitems=array_flip($menuitems);
					$activemenu=$_SESSION['active_menu_id'];
					if($visible_except) {
						if (array_key_exists($activemenu, $menuitems)) continue;
					} else {
						if (!array_key_exists($activemenu, $menuitems)) continue;
					}
				}
				$params = array("class"=>$aw->aw_class,"title"=>$aw->aw_title,"title_link"=>$aw->aw_title_link,"show_title"=>$aw->aw_show_title,"content"=>$aw->aw_content,"use_cache"=>$aw->aw_cache);
				$configArray=Params::parse($aw->aw_config);
				$defParams=Widget::getInstance($aw->aw_name)->getParamsMask();
				if (count($defParams)) {
					foreach ($defParams as $param_name=>$param_data){
						if (!isset($configArray[$param_name]))$configArray[$param_name]=$param_data["vdefault"]; 
					}
				} 	
				if(is_array($configArray)) $params=array_merge($params,$configArray);
				self::$_zones[$aw->aw_zone][$aw->aw_id]=array("id"=>$aw->aw_id,"name"=>$aw->aw_name,"params"=>$params);
			}
		}
	}
	public function countZone($zoneName){
		if (array_key_exists($zoneName, self::$_zones)) return count(self::$_zones[$zoneName]); else return 0;
	}
	public function getZone($zoneName){
		if (array_key_exists($zoneName, self::$_zones)) return self::$_zones[$zoneName]; else return false;
	}
}

?>