<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class Controller extends Object {

	private $_module		= null;
	private $_view			= null;
	private $_view_halted	= false;

	private $_redUrl	= '';
	private $_redMsg	= '';
	private $_redReferer= '';
	private $_redCode	= 302;
	
	public function haltView() {
		$this->_view_halted =true;
	}
	
	public function __construct($name,$module) {
		Debugger::getInstance()->milestone("Controller constructor : ".$name);
		$this->initObj($name);
		$this->_module = $module;
		$this->milestone("Controller created : ".$name);
	}

	protected function getModule() {
		if (is_object($this->_module)) return $this->_module;
		else return Module::getInstance();
	}

	protected function getModel($modelName='') {
		return $this->_module->getModel($modelName);
	}
	public function ajaxVote(){
		// здесь только по по комментам
		$element = Request::getSafe("element",false);
		if ($element=="comment") {
			$this->initComments(0);
			$psid = Request::getInt('psid',0);
			BaseComments::getInstance()->updateRating($psid);
		}
		return false;
	}
	public function getConfigValue($key,$defaultValue='') {
		return $this->getModule()->getConfigValue($key,$defaultValue);
	}
	public function setViewName($viewname=null) {
		$this->_view = $viewname;
	}

	public function ajaxgetComments() {
		$psid       = request::getInt('psid', 0);
		$parent_id  = request::getInt('parent_id', 0);
		$start      = request::getInt('start', 0);
		$this->initComments($psid);
		echo BaseComments::getInstance()->renderComments($parent_id,$start);
	}

	public function getComment() {
		$psid       = Request::getInt('psid', 0);
		$comm_id    = Request::getInt('comm_id', 0);
		$this->initComments($psid);
		echo BaseComments::getInstance()->renderComment($comm_id);
	}
	
	public function ajaxToggleCommentEnabled(){
		$psid       = request::getSafe('psid', 0);
		$comm_id    = request::getSafe('comm_id', 0);
		$published  = request::getSafe('published', 0);
		if ($psid && $comm_id){
			$this->initComments($psid);
			if (BaseComments::getInstance()->togglePublished($comm_id)){
				if ($published)	echo Text::_("Enable"); else echo Text::_("Disable");
			} else echo "Update error";
		} else echo "Data error";
	}

	public function ajaxToggleCommentDeleted(){
		$psid       = request::getSafe('psid', 0);
		$comm_id    = request::getSafe('comm_id', 0);
		$deleted  = request::getSafe('deleted', 0);
		if ($psid && $comm_id){
			$this->initComments($psid);
			if (BaseComments::getInstance()->toggleDeleted($comm_id)){
				if ($deleted)	echo Text::_("Delete"); else echo Text::_("Undelete");
			} else echo "Update error";
		} else echo "Data error";
	}
	
	public function initComments($psid,$moduleName="",$viewName="",$layout="") {
		if (!$moduleName) $moduleName=$this->get('module');
		if (!$viewName) $viewName=$this->get('view');
		if (!$layout) $layout=$this->get('layout');
		BaseComments::getInstance()->init($moduleName,$viewName,$psid,$layout);
		return BaseComments::getInstance();	
	}
	
	public function saveComment() {
		$moduleName	= Module::getInstance()->getName();
		$viewName 	= $this->getView()->getName();
		$psid       = Request::getSafe('psid', false); 					// ид строки
		$multy_code	= Request::getSafe('multy_code', 0);
		$layout			= $this->get('layout');
		
		$start			= request::getInt('start');
		$sort				= request::getSafe('sort');
		$orderby		= request::getSafe('orderby');
		$parent_id	=	Request::getInt("parent_id",0);
		$cm_cat			= request::getInt('cm_cat',0);
		$cm_type		= request::getInt('cm_type',0);
		$title=Request::getSafe("comm_title","");
		if(User::getInstance()->isLoggedIn()){
			$email=User::getInstance()->getEmail();
			$nickname=User::getInstance()->getNickname();
		} else {
			$email=Request::getSafe("comm_email","");
			$nickname=Request::getSafe("comm_nickname",Text::_("Anonymous"));
		}
		$text=Request::getSafe("comm_text",""); 
		$url='index.php?module='.$moduleName."&psid=".$psid."&view=".$viewName."&layout=".$layout."&sort=".$sort."&start=".$start."&orderby=".$orderby."&multy_code=".$multy_code;
		$msg="";
		Event::raise("captcha.checkResult",array("module"=>$moduleName));
		if(isset($_SESSION['captcha_string'])&&($_SESSION['captcha_string']!="OK")) { $msg =Text::_("Wrong captcha"); unset($_SESSION['captcha_string']); }
		elseif(!$title && !$text) { $msg = Text::_('Empty message'); }
		elseif(!User::getInstance()->isLoggedIn()&&(!$nickname)) {$msg = Text::_('Wrong nickname'); }
		elseif(!User::getInstance()->isLoggedIn()&&(!Mailer::checkEmail($email))) {$msg = Text::_('Wrong email');}
		elseif(User::checkFloodPoint()) { $msg = Text::_('Flood is found'); }
		$this->initComments($psid);
		$text=BaseComments::getInstance()->cutCommentByLimit($text);
		if($msg) {
			$url.="&parent_id=".$parent_id."&comm_nickname=".urlencode($nickname)."&comm_email=".urlencode($email)."&parent_id=".$parent_id."&comm_title=".urlencode($title)."&comm_text=".urlencode($text);
			if($cm_cat) $url.="&cm_cat=".$cm_cat; 
			if($cm_type) $url.="&cm_type=".$cm_type; 
		} else {
			$this->initComments($psid);
			$cid=BaseComments::getInstance()->saveComment($parent_id,$title,$text,$nickname,$email,$cm_cat,$cm_type); 
			if($cid) {
				$msg=Text::_("Save successfull");
				if (BaseComments::getInstance()->premoderateEnabled()) $msg.="<br />".Text::_("Waiting moderation");
			}	else $msg=Text::_("Save unsuccessfull"); 
		}
		$this->setRedirect($url,$msg);
	}
	
	public function getView() {
		if (!is_object($this->_view)) { 	// Load view script
			$mName = $this->get('module');
			$vName = $this->get('view');
			$path = PATH_MODULES.$mName.DS.'views'.DS.$vName.'.php';
			if (!is_file($path)){ 
				if($this->_debugger==0) $this->fatalError(Text::_("View not found")." => ".$mName.".".$vName,"404");
				else $this->fatalError(Text::_("View not found")." => ".$mName.".".$vName);
			}
			else {
				Debugger::getInstance()->milestone("Including (require_once) ".$path );
				require_once $path;
				Debugger::getInstance()->milestone("Included (require_once) ".$path );
				$vClass = $this->getName().'View'.$vName;
				$this->_view = new $vClass($vName);
			}
		}
		return $this->_view;
	}

	public function getHelper($helperName,$moduleName='') {
		if ($moduleName == '') { $moduleName = $this->get('module');	}
		return Module::getHelper($helperName,$moduleName);
	}

	protected function setRedirect($url,$message='',$code=0,$referer="") {
		$this->_redUrl = Router::_($url,false,false);
		$this->_redMsg = $message;
		if ($code) $this->_redCode = $code;
		if ($referer) $this->_redReferer=$referer;
	}

	private function redirect($url) {
		Util::redirect($url,$this->_redMsg,$this->_redCode,$this->_redReferer);
	}

	protected function checkAuth($redirect2Login=false) {
		if (User::getInstance()->isLoggedIn() == false) {
			if($redirect2Login) $this->setRedirect('index.php?module=user&task=login');
			else $this->setRedirect('index.php?module=user&view=register');
			return false;
		} else return true;
	}

	protected function checkACL($aclObjectName,$critical=true) {
		$aclObject = ACLObject::getInstance($aclObjectName,false);
		// Сообщения с информацией только в админке
		// Фатальны если включена отладка
		$result = false;
		if ($aclObject === false) {
			if ($critical && ((siteConfig::$debugMode && User::getInstance()->isAdmin()) || siteConfig::$debugMode>100)) $this->fatalError(Text::_('ACL object not exists')." (1) ".$aclObjectName);
			else { 
//				if (defined("_ADMIN_MODE")) $pref="/administrator/"; else $pref="";
				if (defined("_ADMIN_MODE"))$message=Text::_('ACL object not exists')." (2) ".$aclObjectName;
				else $message=Text::_('ACL object not exists')." (3) ".$aclObjectName;
//				if ($critical) $this->setRedirect($pref."index.php",$message);
				if ($critical) $this->setRedirect("index.php",$message);
				else $this->warning($message);
				return false;
			}
		}	else {
			$result = $aclObject->canAccess();
		}

		if ($critical && !$result ) {
			$description = $aclObjectName;
			if (is_object($aclObject)) {	$description = $aclObject->getDescription();	}
			if (!defined("_ADMIN_MODE")) Text::parseModule("aclmgr");
			if ((siteConfig::$debugMode && User::getInstance()->isAdmin()) || siteConfig::$debugMode>100) $this->fatalError(Text::_('Permission is absent for')." ".$aclObjectName."(".Text::_($description).")");
			else { 
				if (defined("_ADMIN_MODE")) $message=Text::_('Permission is absent for')." ".Text::_($description);
				else $message=Text::_('Permission is absent');
				$this->setRedirect("index.php",$message);
			}
		}

		return $result;
	}

	private function executeMethod($methodName) {
		if (method_exists($this,$methodName)) {
			$this->$methodName();
			$this->milestone("Module task executed => ".$this->get('module').".".$this->get('controller').".".$methodName);
		}
		else {
			$this->error(Text::_("Undefined module task")." ".$methodName);
		}
	}

	//----------------- Interface methods ------------------
	public function executeTask() {
		$task = $this->get('task');
		$this->executeMethod($task);
		if ($this->_redUrl != '') $this->redirect($this->_redUrl);
	}

	public function executeAjax() {
		$task = $this->get('task');
		$task = 'ajax'.ucfirst($task);
		$this->executeMethod($task);
	}
	//------------------------------------------------------

	public function defaultTask() {
		// Just do nothing
	}

	public function search() {
		SearchMachine::getInstance()->parseRequest();
		Event::raise("search.renderForm");
		SearchMachine::getInstance()->renderForm();
		SearchMachine::getInstance()->renderResult();
	}
	
	public function show() {
		$view = $this->getView();
		$viewName = $view->getName();
		$methodName = 'show'.ucfirst($viewName);
		if (method_exists($this,$methodName)) { $this->$methodName(); }

		if ($this->_redUrl == '') {
			if(!$this->_view_halted) $view->render();
		}
	}
	public function downloadFile(){
		$folder=Request::getSafe("folder","");
		$file=Request::getSafe("filename","");
		$absolute=Request::getInt("abs",0);
		if ($this->_module && $file){
			$filepath=ALTADOC_UF_PATH;
			if (!$absolute) { $filepath.=$this->_module->getName().DS; }
			if ($folder){ $filepath.=Util::dsPath($folder).DS; }
			Util::download($filepath, $file, $redirect=Util::getRefererUrl(false));
		}
	}
/*
	public function restrictedByVersion($module="",$issave=0){
		if (Portal::getLicenseType()=="DEMO") {
			if(!$module) $module=$this->getModule()->getName();
			Portal::getInstance()->restrictedByVersion($module, $issave);
		}
	}
*/
}
?>