<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class View extends HTMLRenderer {
	private $_shortcuts			= array();
	private $_showPagePanel		= false;
	private $_breadCrumb		= array();
	private $_headerRendered = false;
	protected $_rendered = false;
	private $_layoutFile = "";
	public function __construct($name) {
		$this->initObj($name);
	}
	public function setMeta($metatag, $metavalue) {
		if (($metatag)&&($metavalue)) {
			switch ($metatag) {
				case "title":
					$metavalue=mb_substr($metavalue,0,250,DEF_CP);
					Portal::getInstance()->setTitle($metavalue);
					break;
				case "keywords":
					$metavalue=mb_substr($metavalue,0,250,DEF_CP);
					Portal::getInstance()->setMeta("keywords", $metavalue);
					break;
				case "description":
					$metavalue=mb_substr($metavalue,0,250,DEF_CP);
					Portal::getInstance()->setDescription($metavalue);
					break;
			}
		}
	}
	public function getLayout() {
		return $this->get('layout');
	}
	public function setLayout($layout) {
		$_layout=$this->get('layout');
		if (defined('_ADMIN_MODE')) $lPath = PATH_TEMPLATES.adminConfig::$adminTemplate.DS.'html'.DS.'modules'.DS.$this->get('module').DS.$this->getName().DS.$layout.'.php';
		else $lPath = PATH_TEMPLATES.siteConfig::$siteTemplate.DS.'html'.DS.'modules'.DS.$this->get('module').DS.$this->getName().DS.$layout.'.php';
		if (!is_file($lPath)) {
			$lPath = PATH_MODULES.$this->get('module').DS.'views'.DS.'template'.DS.$this->getName().DS.$layout.'.php';
			if (!is_file($lPath) && defined('_ADMIN_MODE')) {
				$lPath = PATH_FRONT_MODULES.$this->get('module').DS.'views'.DS.'template'.DS.$this->getName().DS.$layout.'.php';
			}
		}
		if (is_file($lPath)) {
			$this->set('layout',$layout);
			$this->_layoutFile = $lPath;
		} else {
			if ($_layout!=$layout) {
				$this->error(Text::_("Layout change error")." : |".$_layout."| => |".$layout."|");
			} else {
				if($this->_debugger==0) $this->fatalError(Text::_("Layout not found")." : ".$lPath,"404");
				else  $this->fatalError(Text::_("Layout not found")." : ".$lPath);
			}
		}
	}
	public function render() {
		$this->prepare();
		$layout = $this->get('layout');
		$this->setLayout($layout);

		if (!is_file($this->_layoutFile)) {
			if($this->_debugger==0) $this->fatalError(Text::_("Layout not found")." : ".$this->_layoutFile,"404");
			else $this->fatalError(Text::_("Layout not found")." : ".$this->_layoutFile,"404");
		}	else {
			if (!$this->_rendered){ 
				if (Portal::getInstance()->noTemplate()) $class_postfix="_nt"; else $class_postfix="";
				echo $this->renderHeader();
				echo "<div class=\"moduleBody".$class_postfix." ".$this->get("module")."Module\"><div class=\"content".$class_postfix."\">";
				include_once $this->_layoutFile;
				echo "</div>";
				echo $this->renderPagePanel();
				echo "</div>";
			}
		}
		$this->milestone("View rendered => ".$this->get('module').".".$this->getName().".".$layout);
	}
	private function renderShortcut($shortcut) {
		$scHTML = "";
		if ($shortcut["text"]) {
/*			
			$scHTML .= "<input type=\"button\" class=\"shortcutButton\" value=\"".$shortcut['text']."\"";
			if ($shortcut["id"]) $scHTML .= " id=\"".$shortcut['id']."\"";
			$buttonWidth = intval($shortcut['width']);
			if ($buttonWidth) $scHTML .= " style=\"width:".$buttonWidth."px\"";
			$scHTML .= " onclick=\"".$shortcut["onclick"]."\" />";
*/
			$scHTML .= "<a href=\"#\" class=\"linkButton\" rel=\"nofollow\"";
			if ($shortcut["id"]) $scHTML .= " id=\"".$shortcut['id']."\"";
			$buttonWidth = intval($shortcut['width']);
			if ($buttonWidth) $scHTML .= " style=\"width:".$buttonWidth."px\"";
			$scHTML .= " onclick=\"".$shortcut["onclick"]."\">".$shortcut['text']."</a>";
				
		}
		return $scHTML;
	}
	public function getBreadCrumbArray() { 
		return $this->_breadCrumb;
	}
	public function renderBreadCrumb() { 
		if (Portal::getInstance()->inPrintMode()) return "";
//		$tplPath = "/".LINK_TEMPLATES."/".siteConfig::$siteTemplate."/";
		$headerHTML = "<div class=\"moduleBreadcrumb\">";
		foreach ($this->_breadCrumb as $bc) {
			if(defined("_ADMIN_MODE")) $headerHTML .= "<img class=\"breadcrumb\" src=\"/images/blank.gif\" width=\"1\" height=\"1\" alt=\"\" />";
			else $headerHTML .= "<img class=\"breadcrumb\" src=\"/images/blank.gif\" width=\"1\" height=\"1\" alt=\"\" />";
			if ($bc->link=="#")	$headerHTML .= "<a class=\"breadcrumb\">".$bc->text."</a>";
			else $headerHTML .= "<a class=\"breadcrumb\" href=\"".$bc->link."\">".$bc->text."</a>";
		}
		$headerHTML .= "</div>";
		return $headerHTML;
	}
	public function renderHeader($_override=false) {
		$headerHTML="";
		if(!$this->_headerRendered||$_override){
//			if (Module::getInstance()->showBreadcrumb() && (defined("_ADMIN_MODE")? adminConfig::$adminShowBreadcrumbs : siteConfig::$showBreadcrumbs)) {
//				if (count($this->_breadCrumb)) $headerHTML.=$this->renderBreadCrumb();
//			}
			if (count($this->_shortcuts)) {
				$headerHTML .= "<div class=\"moduleShortcuts\">";
				foreach ($this->_shortcuts as $sc) $headerHTML .= $this->renderShortcut($sc);
				$headerHTML .= "</div>";
			}
			$this->_headerRendered=true;
		}
		return $headerHTML;
	}
	public function renderPagePanel() {
		if ($this->_showPagePanel == true) {
			if (defined('_ADMIN_MODE')) $lPath = PATH_TEMPLATES.adminConfig::$adminTemplate.DS.'html'.DS.'modules'.DS.'paginator.php';
			else $lPath = PATH_TEMPLATES.siteConfig::$siteTemplate.DS.'html'.DS.'modules'.DS.'paginator.php';
			if (is_file($lPath)) {
				ob_start();
				include $lPath;
				$_html = ob_get_contents();
				ob_end_clean();
			} else { 
				$_pageLinks="";
				if ($this->firstPageLink) $firstPageLink = "<a class=\"pageLink\" href=\"".$this->firstPageLink."\">&lt;&lt;</a>&nbsp;&nbsp;"; else $firstPageLink=""; 	
				if ($this->lastPageLink) $lastPageLink = "&nbsp;&nbsp;<a class=\"pageLink\" href=\"".$this->lastPageLink."\">&gt;&gt;</a>"; else $lastPageLink="";
				if ($this->prevPageLink) $prevPageLink = "<a class=\"pageLink\" href=\"".$this->prevPageLink."\">&lt;</a>&nbsp;&nbsp;"; else $prevPageLink=""; 	
				if ($this->nextPageLink) $nextPageLink = "&nbsp;&nbsp;<a class=\"pageLink\" href=\"".$this->nextPageLink."\">&gt;</a>"; else $nextPageLink="";
				
				$_html = "<div class=\"navigator\">
							<table class=\"navigator\"><tbody>
								<tr class=\"navigator_pages\"><td align=\"center\">".Text::_("Pages")."&nbsp;&nbsp;&nbsp;".$firstPageLink.$prevPageLink.$this->pageLinks.$nextPageLink.$lastPageLink."</td></tr>
								<tr class=\"navigator_records\"><td align=\"center\">".Text::_("Records")."&nbsp;".$this->pageRange."&nbsp;".Text::_("of")."&nbsp;".$this->recordsTotal."</td></tr>
							</tbody></table>
						</div>";
			}
		} else $_html=""; 
		return $_html;
	}
	public function showPagePanel($show=true) {
		$this->_showPagePanel = $show;
	}
	public function addShortcut($text,$onclick,$id="",$width=0) {
		$this->_shortcuts [] = array("id"=>$id, "text"=>$text, "width"=>$width, "onclick"=>$onclick);
	}
	public function addBreadcrumb($text,$link) {
		$bc = new stdClass();
		$bc->text = $text;
		if ($link=="#")	$bc->link = $link;
		else $bc->link = Router::_($link);
		$this->_breadCrumb []= $bc;
	}
	public function setBreadcrumb($text,$link) {
		$bc = new stdClass();
		$bc->text = $text;
		if ($link=="#")	$bc->link = $link;
		else $bc->link = Router::_($link);
		$this->_breadCrumb = array($bc);
	}
	public function prepare() {} // For overriding
}
?>