<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class SpravMetadata extends Object {
	protected $store_type	= 1;		// Тип хранения данных в файлах
	protected $_prepView = true;		// апдейт полей из таблицы
	public $success			= false;	// Флаг удачной загрузки

	public $constants		= array();	// Константы
	public $classname		= "";		// Имя класса
	public $module			= "";		// Имя модуля (совпадает с именем каталога модуля)
	public $tablename		= "";		// Основная таблица БД без префикса
	public $linktable		= "";		// Линковочная таблица БД без префикса
	public $parent_table = '';  // родительская  таблица, актуальна при линковке, а так равна ch_table поля multy_field
	public $parent_name	= '';		// поле наименования родительской таблицы, актуально при линковке
	public $title				= "";		// Заголовок таблицы
	public $namestring	= "";		// Имя поля с названием в таблице для reserveID
	public $alias_field	= "";		// Имя поля с псевдонимом в таблице для reserveID
	public $parent_code	= '';		// ключевое поле родительского представления
	public $parent_view = '';   // родительское представление, куда перейдем по go_up
	public $parent_layout = ''; // родительское отображение, куда перейдем по go_up
	public $keystring		= "";		// Основное Ключевое поле таблицы
	public $nofilter		= false;// Принудительное отключение фильтрации
	public $enabled			= "";		// Поле пометки вкл/выкл
	public $deleted			= "";		// Поле пометки на удаление
	public $keysort			= "";		// Поле сортировки по умолчанию при показе
	public $ordering_field	= "";		// Поле порядка отображения
	public $ordering_parent = "";		// Поле внутри которого существует порядок отображения
	public $keycurrency	= "";		// Поле в котором содержится валюта хранения(опц.)
	public $checkbox		= true;		// Надо ли выводить первой колонкой checkbox для выбора элементов
	public $selector		= false;		// Надо ли выводить первой колонкой кнопку для подстановки элементов
	public $tree_index	= 0;		// если является деревом тогда здесь индекс поля
	public $multy_field	= "";		// Поле таблицы для связи с родительской таблицей
	public $custom_sql	= "";		// Дополнительный текст SQL запроса в условии WHERE
	public $templates		= array();	// Шаблоны
	public $buttons			= array();	// Общие для всех кнопки
	public $uni_buttons	= array();	// Кнопки уникальные для данного справочника
	public $field				= array();	// Поля таблицы
	public $filter			= array();	// Наличие фильтрации по полю
	public $field_orderby	= array();	// Направление сортировки поля таблицы
	public $field_title		= array();	// Заголовки полей таблицы
	public $field_descr		= array();	// Описание (всплывающий balloon) полей таблицы
	public $field_on_change	= array();	// Javascript на изменение поля при редактировании
	public $field_is_method	= array();	// Значение в поле является результатом вычислений и не полем таблицы
	public $size				= array();	// Ширина колонки при просмотре
	public $view				= array();	// Показывать колонку
	public $link				= array();	// Ссылка для значения ячейки
	public $link_vars		= array();	// Параметры для подстановки в link
	public $link_types	= array();	// Параметры для подстановки в link ( например popup)
	public $link_picture	= array();	// Картинка для  подстановки в ячейку
	public $upload_path	= array();	// хвост пути, куда сохранять этот файл (userfiles/имя модуля/$upload_path)
	public $val_type		= array();	// Тип данных поля
	public $val_size		= array();	// Длина данных поля
	public $input_size	= array();	// Размер контрола при редактировании
	public $input_type	= array();	// Тип контрола при редактировании
	public $input_view	= array();	// Показывать колонку при редактировании
	public $field_no_update	= array();	// Не изменять при редактировании
	public $check_value	= array();	// Проверять значение при редактировании элемента
	public $translate_value	= array();	// Переводить ли полученное значение
	public $default_value	= array();	// Значение по умолчанию
	public $ck_reestr		= array();	// Подстановка фиксированного набора значений
	public $ch_table		= array();	// Таблицы подстановки для зависимых полей
	public $ch_field		= array();	// Поле подстановки из таблицы подстановки
	public $ch_parent_field		= array();	// Поле родителя таблицы подстановки (если таблица подстановки дерево и не равна текущей таблице)
	public $ch_id				= array();	// Ключевое поле таблицы подстановки
	public $ch_deleted	= array();	// Поле пометки на удаление таблицы подстановки
	public $ch_enabled	= array();	// Поле пометки на включенность в таблице подстановки
	public $ch_sort			= array();	// Поле сортировки таблицы подстановки
	public $ch_sp_field	= array();	// Дополнительное условие для выборки из таблицы подстановки (Приравнивается к psid редактируемого элемента)
	public $is_add			= array();	// поле является дополнительным и живет в другой таблице [tablename]_data
	public $is_add_custom	= array();	// если (is_add), то 1 - используется для объекта от группы объектов, 2- является опцией (множественна и подчинена объекту)
	public $classTable    = '';
	public $viewName		= '';
	public $layoutName  = '';
	public $field_order	= array();	// Номер по порядку в массиве полей. Для пересортировки массива метаданных
	public $metaside =0;						// принудительная указание что метадата на фронтенде (при вызове из админки)
	public function __construct($moduleName='', $viewName='',$layoutName='',$critical=true,$autoPrepView=true,$metaside=0) {
		$this->_prepView=$autoPrepView;
		$this->initObj($moduleName.'Metadata');
		if ($moduleName == '') { $this->module = $this->get('module'); }
		else { $this->module = $moduleName; }

		if ($viewName == '') { $this->viewName = $this->get('view'); 	}
		else { $this->viewName = $viewName; }

		if ($layoutName == '') { $this->layoutName = $this->get('layout'); }
		else { $this->layoutName = $layoutName; }		    
		$this->metaside=$metaside;
		$this->defaultButtons();
		$this->defaultConstants();
		
		$this->read($critical);
		if ($this->_prepView) $this->prepareView();
	}

	private function prepareView() {
		// вызов простановки из базы
		$this->updateViewFromTable();
	}

	private function defaultButtons(){
		$this->buttons["go_up"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["new"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["clone"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["new_string"]	= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["modify"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["info"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["filter"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["refresh"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["reorder"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["print"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["datagramm"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["modify_links"]	= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["delete"]		= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["undelete"]		= array("module"=>'',"show"=>1,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["trash"]			= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["list"]			= array("module"=>'',"show"=>1,"view"=>"","task"=>"","link"=>false,"layout"=>'');
		$this->buttons["clean_trash"]	= array("module"=>'',"show"=>0,"view"=>"","task"=>"","link"=>false,"layout"=>'');
	}

	private function defaultConstants(){
		$this->constants["AUTHOR"]	= User::getInstance()->getId();
		$this->constants["AUTHOR_MAIL"]	= User::getInstance()->getEmail();
		$this->constants["AUTHOR_NAME"]	= User::getInstance()->getNickname();
		$this->constants["AUTHOR_IP"]	= User::getInstance()->getIP();
		$this->constants["NOW"]		= date("d.m.Y H:i:s");
		$this->constants["TODAY"]	= date("d.m.Y");
	}

	public function read($critical) {
		$_module	= $this->module;
		$_view		= $this->viewName;
		$_task		= $this->get('task');
		$_layout  = $this->layoutName;
		
		if($_layout == '') $_layout	= $this->get('layout');

		$_meta=$_view.".".$_layout;
		if($_layout=='default') $_meta=$_view.".defl";
		if($this->metaside==1) {
			$metaPath = PATH_FRONT_MODULES.$_module.DS.'metadata'.DS.$_meta.'.php';
		} else {
			$metaPath = PATH_MODULES.$_module.DS.'metadata'.DS.$_meta.'.php';
		}
		$this->milestone('Meta: &quot;'.$_meta.'&quot; Metadata file: '.$metaPath);
		if (file_exists($metaPath)) {
			$arr_parms[$_view]['view'] = array();
			$arr_parms[$_view]['size'] = array();
			include $metaPath;			
			if (isset($tablname)) $this->tablename = $tablname;
			if (isset($parent_table)) $this->parent_table = $parent_table; // else $this->linktable = "";
			if (isset($parent_code)) $this->parent_code = $parent_code;
			if (isset($parent_name)) $this->parent_name = $parent_name;
			if (isset($parent_view)) {
				$parent_meta_name=preg_split("/[.]/", $parent_view);
				if (count($parent_meta_name)==2) { // указана мета вместе с layout пробуем загрузить метадату родителя
					$this->parent_view = $parent_meta_name[0];
					$this->parent_layout = $parent_meta_name[1];
				} else {// указана без layout? грузим дефолтную !
					$this->parent_view = $parent_view;
					$this->parent_layout = "default";
				}
			}
			
			if (isset($nametabl)) $this->title = $nametabl;
			if (isset($classname)) $this->classname = $classname;
			if (isset($classTable)) $this->classTable = $classTable;
			if (isset($keystring)) $this->keystring = $keystring;
			if (isset($nofilter)) $this->nofilter = $nofilter;
			
			if (isset($dopkeyid)) $this->dopkeyid = $dopkeyid;
			if (isset($enabled)) $this->enabled = $enabled;
			if (isset($deleted)) $this->deleted = $deleted;
			if (isset($templates)) $this->templates = $templates;
			if (isset($multy_field)) $this->multy_field = $multy_field;
			if (isset($keysort)) $this->keysort = $keysort;
			if (isset($keycurrency)) $this->keycurrency = $keycurrency;
			if (isset($ordering_field)) $this->ordering_field = $ordering_field;
			if (isset($ordering_parent)) $this->ordering_parent = $ordering_parent;
			if (isset($checkbox)) $this->checkbox = $checkbox;
			if (isset($selector)) $this->selector = $selector;
			if (isset($custom_sql)) $this->custom_sql = $custom_sql;
			if (isset($namestring)) $this->namestring = $namestring; else $this->namestring = $this->keystring;
			if (isset($alias_field)) $this->alias_field = $alias_field; else $this->alias_field = "";
			
			// у нас есть все необходимые сведения для формирвоания дополинтельных полей
			// хотя можно вставить проверку на наличие необходимых реквизитов
			// достаем список дополнительных полей
			$cur_table_arr=$this->appendBaseAddFields($tablname,$cur_table_arr);
			// значение линковочной таблицы имеет смысл только тогда когда выполняется ряд условий
			if ($this->multy_field==$this->keystring) {
				if (($this->parent_table)&&($this->parent_code)) {
					if (isset($linktable)) $this->linktable = $linktable;
					else $this->linktable = $this->tablename."_links";
				}
			}

			foreach ($this->buttons as $b_key=>$b_vals) {
				if (isset($buttons[$b_key]['module'])) $this->buttons[$b_key]['module']	= $buttons[$b_key]['module'];
				else {$this->buttons[$b_key]['module']	= $this->module;}
				if (isset($buttons[$b_key]['show'])) $this->buttons[$b_key]['show']	= $buttons[$b_key]['show'];
				if (isset($buttons[$b_key]['view'])) $this->buttons[$b_key]['view']	= $buttons[$b_key]['view']; // else $this->buttons[$b_key]['view']=$this->viewName;
				if (isset($buttons[$b_key]['task'])) $this->buttons[$b_key]['task']	= $buttons[$b_key]['task'];
				if (isset($buttons[$b_key]['layout'])) $this->buttons[$b_key]['layout']	= $buttons[$b_key]['layout']; else $this->buttons[$b_key]['layout']=$this->layoutName;
				if (isset($buttons[$b_key]['link'])) $this->buttons[$b_key]['link']	= $buttons[$b_key]['link'];
			}

			if (isset($uni_buttons)) $this->uni_buttons = $uni_buttons;
			if (isset($cur_table_arr['multy_field'])) $this->multy_field = $cur_table_arr['multy_field'];
			if (isset($cur_table_arr['field'])) $this->field = $cur_table_arr['field'];
			if (count($this->field) > 0) {
				foreach ($this->field as $key=>$data) {
					if (isset($cur_table_arr['filter'][$key])) $this->filter[$key] = $cur_table_arr['filter'][$key]; else $this->filter[$key]=1;
					if (isset($cur_table_arr['sort_order'][$key])) $this->field_orderby[$key] = $cur_table_arr['sort_order'][$key]; else $this->field_orderby[$key]="";
					if (isset($cur_table_arr['fim'][$key])) $this->field_is_method[$key] = $cur_table_arr['fim'][$key]; else $this->field_is_method[$key]=false;
					if (isset($cur_table_arr['field_on_change'][$key])) $this->field_on_change[$key] = $cur_table_arr['field_on_change'][$key]; else $this->field_on_change[$key]="";
					if (isset($cur_table_arr['update_type'][$key])&&($cur_table_arr['update_type'][$key]==0)) $this->field_no_update[$key]=1; else $this->field_no_update[$key]= 0;
					if (isset($cur_table_arr['name'][$key])) $this->field_title[$key] = $cur_table_arr['name'][$key]; else $this->field_title[$key]="";
					if (isset($cur_table_arr['descr'][$key])) $this->field_descr[$key] = $cur_table_arr['descr'][$key]; else $this->field_descr[$key]="";
					if (isset($cur_table_arr['size'][$key])) $this->size[$key] = str_replace('"', "", $cur_table_arr['size'][$key]); else $this->size[$key]="";
					if (isset($cur_table_arr['view'][$key])) $this->view[$key] = $cur_table_arr['view'][$key]; else $this->view[$key]="1";
					if (isset($cur_table_arr['link'][$key])) $this->link[$key] = $cur_table_arr['link'][$key]; else $this->link[$key]="";
					if (isset($cur_table_arr['is_add'][$key])) $this->is_add[$key] = $cur_table_arr['is_add'][$key]; else $this->is_add[$key]=false;
					if (isset($cur_table_arr['is_add_custom'][$key])) $this->is_add_custom[$key] = $cur_table_arr['is_add_custom'][$key]; else $this->is_add_custom[$key]=false;
					if (isset($cur_table_arr['link_key'][$key])) $this->link_vars[$key] = $cur_table_arr['link_key'][$key]; else $this->link_vars[$key]="";
					if (isset($cur_table_arr['link_type'][$key])) $this->link_types[$key] = $cur_table_arr['link_type'][$key]; else $this->link_types[$key]="";
					if (isset($cur_table_arr['link_picture'][$key])) $this->link_picture[$key] = $cur_table_arr['link_picture'][$key]; else $this->link_picture[$key]="";
					if (isset($cur_table_arr['upload_path'][$key])) $this->upload_path[$key] = $cur_table_arr['upload_path'][$key]; else $this->upload_path[$key]="";
					if (isset($cur_table_arr['val_type'][$key])) $this->val_type[$key] = $cur_table_arr['val_type'][$key]; else $this->val_type[$key]="";
					if (isset($cur_table_arr['val_size'][$key])) $this->val_size[$key] = (int)$cur_table_arr['val_size'][$key]; else { 
						if ($this->_prepView) $this->val_size[$key]=-1; else $this->val_size[$key]=0;
					}
					if (isset($cur_table_arr['val_const'][$key])) $this->val_type[$key] = "constanta";
					if (isset($cur_table_arr['input_view'][$key])) $this->input_view[$key] = $cur_table_arr['input_view'][$key]; else $this->input_view[$key]="1";
					if (isset($cur_table_arr['input_size'][$key])) $this->input_size[$key] = str_replace('"', "", $cur_table_arr['input_size'][$key]); else $this->input_size[$key]="";
					if (isset($cur_table_arr['input_type'][$key])) $this->input_type[$key] = $cur_table_arr['input_type'][$key]; else $this->input_type[$key]="";
					$this->field_order[$key]=0;
					if (isset($cur_table_arr['check_value'][$key])) $this->check_value[$key] = $cur_table_arr['check_value'][$key]; else $this->check_value[$key]="";
					if (isset($cur_table_arr['translate_value'][$key])) $this->translate_value[$key] = $cur_table_arr['translate_value'][$key]; else $this->translate_value[$key]=false;
					if (isset($cur_table_arr['default_value'][$key])) $this->default_value[$key]= $cur_table_arr['default_value'][$key]; else $this->default_value[$key]="";
					if (isset($cur_table_arr['ch_table'][$key])) $this->ch_table[$key] = $cur_table_arr['ch_table'][$key]; else $this->ch_table[$key]="";
					if ($this->ch_table[$key]==$this->tablename) $this->tree_index=$key;
					if (isset($cur_table_arr['ch_field'][$key])) $this->ch_field[$key] = $cur_table_arr['ch_field'][$key]; else $this->ch_field[$key]="";
					if (isset($cur_table_arr['ch_parent_field'][$key])) $this->ch_parent_field[$key] = $cur_table_arr['ch_parent_field'][$key];	else $this->ch_parent_field[$key]="";
					if (isset($cur_table_arr['ch_id'][$key])) $this->ch_id[$key] = $cur_table_arr['ch_id'][$key]; else $this->ch_id[$key]="";
					if (isset($cur_table_arr['ch_sort'][$key])) $this->ch_sort[$key] = $cur_table_arr['ch_sort'][$key]; else $this->ch_sort[$key]="";
					if (isset($cur_table_arr['ch_sp_field'][$key])) $this->ch_sp_field[$key] = $cur_table_arr['ch_sp_field'][$key]; else $this->ch_sp_field[$key]="";
					if (isset($cur_table_arr['ch_deleted'][$key])) $this->ch_deleted[$key] = $cur_table_arr['ch_deleted'][$key]; else $this->ch_deleted[$key]="";					
					if (isset($cur_table_arr['ch_enabled'][$key])) $this->ch_enabled[$key] = $cur_table_arr['ch_enabled'][$key]; else $this->ch_enabled[$key]="";
					if (isset($cur_table_arr['ck_reestr'][$key])) $this->ck_reestr[$key] = $cur_table_arr['ck_reestr'][$key]; else $this->ck_reestr[$key]="";
				}
				$this->success=true;
			}
		} else {
			if ($critical) $this->fatalError('Metadata file not found: '.$metaPath);
		}
	}

	/**
	 *
	 * дополнием описатели таблиц динамической частью
	 * @param $tablname имя таблицы к кторой подбираем дополнительные поля
	 * @param unknown_type $cur_table_arr предварительно собранный массив который будем наращивать
	 */
	private function appendBaseAddFields($tablname,$cur_table_arr) {
		$add_list=$this->getListAdditionalField($tablname);
		$_tps=$this->getArrayFieldsType();
		if(is_array($add_list)&&count($add_list)>0) {
			$count=count($cur_table_arr["field"]);
			$cur_table_arr["is_add"]=array();
			$cur_table_arr["is_add_custom"]=array();
			foreach($add_list as $list) {
				$count++;
				$cur_table_arr["field"][$count]=$list->f_name;
				$cur_table_arr["name"][$count]=$list->f_descr;
				$cur_table_arr["check_value"][$count]=$list->f_required;
				if(!isset($_tps[$list->f_type])) {
					$cur_table_arr["val_type"][$count]='string';
					$cur_table_arr["input_type"][$count]='text';
				}	else {
					$cur_table_arr["val_type"][$count]=$_tps[$list->f_type]->t_val_type;
					$cur_table_arr["input_type"][$count]=$_tps[$list->f_type]->t_input_type;
					if ($cur_table_arr["input_type"][$count]=="select") {
						$choice_string=trim($list->f_choices);
						$ck_array=array();
						if($choice_string){
							$choice_arr=explode(";", htmlspecialchars_decode($choice_string,ENT_QUOTES));
							if (count($choice_arr)) {
								foreach($choice_arr as $choice) {	
									if ($choice) {
										$choice=htmlspecialchars(trim($choice),ENT_QUOTES,DEF_CP);
										$ck_array[$choice]=$choice;	
									}
								}
								$cur_table_arr["ck_reestr"][$count]=$ck_array;
							}
						} else { // если массив значений пустой проверим может по имени поля у нас есть предустановленный список
							$cur_table_arr["ck_reestr"][$count]=SpravStatic::getCKArray($list->f_name);
						}
					}
				}
				$cur_table_arr["is_add"][$count]=$list->f_id;
				$cur_table_arr["is_add_custom"][$count]=$list->f_custom;
				$cur_table_arr["input_view"][$count]=0;
				$cur_table_arr["view"][$count]=0;
			}
		}
		return $cur_table_arr;
	}

	/**
	 * Список дополнительных полей к таблице,
	 * @param $table имя таблицы к кторой подбираем дополнительные поля
	 * return массив объектов с ключом по ид поля
	**/
	public function getListAdditionalField($table='') {
		$db=Database::getInstance();
		$query="SELECT ff.* FROM #__fields_list AS ff WHERE ff.f_deleted=0 AND ff.f_table='".$table."'";
		$db->setQuery($query);
		return $db->loadObjectList('f_name');
	}

	private function getArrayFieldsType() {
		$db=Database::getInstance();
		$sql = "SELECT * FROM #__fields_type";
		$db->setQuery($sql);
		return $db->loadObjectList("t_id");
	}

	private function updateViewFromTable() {
		$_module	= $this->module;
		$_view	= $this->viewName;
		$_layout	= $this->layoutName;
		
		if ($_layout=='' || is_null($_layout)) $_layout='default';
		if($_layout=='default') $layout_base='defl'; else $layout_base=$_layout;
		$field     = $this->field;
		$field_obr = array_flip($field);
		$db=Database::getInstance();
		if (defined('_ADMIN_MODE')){
			if ($this->metaside) $m_admin_side=0; else $m_admin_side=1;
		} else {
			$m_admin_side=0;
		}
		$query=" SELECT * FROM #__metadata WHERE `m_module`='".$_module."' AND `m_view`='".$_view."' AND `m_layout`='".$layout_base."' AND `m_admin_side`=".$m_admin_side;
		$db->setQuery($query);
		$cur = $db->loadAssocList();
		if (!$cur)  return false;
		foreach($cur as $fld_dop) {
			$f_key=$fld_dop["m_field"];
			if(isset($field_obr[$f_key])) {
				$key=$field_obr[$f_key];
				$this->size[$key]=$fld_dop["m_width"];
				$this->view[$key]=$fld_dop["m_show"];
				$this->input_size[$key]=$fld_dop["m_input_size"];
				$this->input_view[$key]=$fld_dop["m_input_view"];
				if($this->val_size[$key]<0){
					$this->val_size[$key]=intval($this->input_size[$key]);
				}
				$this->filter[$key]=$fld_dop["m_show_in_filter"];
				if($fld_dop["m_field_order"]) $this->field_order[$key]=$fld_dop["m_field_order"]; else $this->field_order[$key]=$key;
			}
		}
		$this->reorderFields();
		return true;
	}
	private function reorderFields(){
		Debugger::getInstance()->milestone("Start Metadata sorting");
		$array_for_sort=array("field",	"filter",	"field_orderby",	"field_title",	"field_descr",
							"field_on_change",	"field_is_method",	"size",	"view",	"link",
							"link_vars",	"link_types",	"link_picture",	"upload_path",	"val_type",
							"val_size",	"input_size",	"input_type",	"input_view",	"field_no_update",
							"check_value",	"translate_value",	"default_value",	"ck_reestr",	"ch_table",
							"ch_field",	"ch_parent_field",	"ch_id",	"ch_deleted",	"ch_enabled",
							"ch_sort",	"ch_sp_field",	"is_add",	"is_add_custom", "field_order");
		// формируем порядковые номера
		$counter=1;
		asort($this->field_order);
		foreach($this->field_order as $fok=>$fov){
			$this->field_order[$fok]=$counter;
			$counter++;
		}
		// меняем индекс поля дерева
		if ($this->tree_index){ $this->tree_index=$this->field_order[$this->tree_index]; }
		// пересортировываем остальные элементы
		$new_order=$this->field_order;
		foreach($array_for_sort as $array_name){
			$new_array = array();
			foreach($this->$array_name as  $key=>$val){
				$new_array[$new_order[$key]]=$val;
//				echo $key."=".$val."<br />";
			}
//			Util::showCollapsedArray($new_array);
			ksort($new_array);
			$this->$array_name=$new_array;
//			Util::showCollapsedArray($this->$array_name);
		}
		Debugger::getInstance()->milestone("Finish Metadata sorting");
//		Util::showCollapsedArray($this);
	}
	public function updateArrayField($arrayname, $fieldname, $value) {
		if (count($this->field)>0) {
			foreach ($this->field as $key=>$val) {
				if ($val==$fieldname) {
					switch($arrayname) {
						case "view":
							if (isset($this->view[$key]))	$this->view[$key]=$value;
							break;
						case "input_view":
							if (isset($this->input_view[$key]))	$this->input_view[$key]=$value;
							break;
					}
				}
			}
		}
	}
}
?>