<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class contentPlugincatalogfilter extends Plugin {

	private $module="catalog";
	private $view= "goods";
	private $layout= "default";
	private $side=0;
	protected $_events=array("system.executeModuleBefore","filter.reset");	
	
	public function getParamsMask(){
		$params=array();
		return $params;
	}
	
	protected function onRaise($event, &$data) {
		if (Module::getInstance()->getName()!="catalog") return "";
		switch($event){
			case "filter.reset";
			case "system.executeModuleBefore":
				$module=$this->module;
				$view= $this->view;
				$layout= $this->layout;
				$side=$this->side;
				$psid         = Request::getInt('psid', false); 					// ид строки
				$multy_code   = Request::getInt('multy_code', false); 					// ид верхней группы
				if(!$multy_code)	$multy_code=$psid;
				elseif(!$psid) $psid=$multy_code;
				$fbgList=$this->getGroupsFields($psid);
				$this->initCatalogFilter($fbgList);
			break;
			default:
			break;
	  	}	
	}
	public function getWholeTreeUp($psid){
		$arr[]=$psid;
		$ggrTree = new simpleTreeTable();
		$ggrTree->table="goods_group";
		$ggrTree->fld_id="ggr_id";
		$ggrTree->fld_parent_id="ggr_id_parent";
		$ggrTree->fld_title="ggr_name";
		$ggrTree->fld_deleted="ggr_deleted";
		$ggrTree->fld_enabled="ggr_enabled";
		$ggrTree->fld_orderby="ggr_name";
		$ggrTree->element_link="";
		$ggrTree->buildTreeArrays();
		return $ggrTree->getWholeTreeUp($arr);
	}
	public function getGroupsFields($psid){
		if (!$psid) return array();
		$parents=$this->getWholeTreeUp($psid);
		$linkArray = array_keys($parents);
		if (!is_array($linkArray) || !count($linkArray)) return array();
		$sql = "SELECT f.f_id,f.f_name FROM #__fields_list AS f";
		$sql.=" LEFT JOIN #__goods_group_fields AS ggf ON ggf.f_id=f.f_id";
		$sql.=" WHERE f.f_custom=1 AND f.f_table='goods'";
		$sql.=" AND ggf.parent_id IN ('".implode("','",$linkArray)."') ";
		$sql.=" ORDER BY f.f_descr";
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadObjectList("f_id");
	}
	
	public function initCatalogFilter($fbgList){
		$filter_arr=array();
		$fbgListNames=array();
		if (is_array($fbgList) && count($fbgList)) {
			foreach($fbgList as $k=>$v){
				$fbgListNames[$v->f_name]=1;
			}
		} 
		$module=$this->module;
		$view= $this->view;
		$layout= $this->layout;
		$side=$this->side;
		$meta=new SpravMetadata($module, $view, $layout);
		$col_count = count($meta->field);
 		for ($i = 1; $i <= $col_count; $i++){
			if($meta->filter[$i] && (!$meta->is_add_custom[$i] || (array_key_exists($meta->field[$i], $fbgListNames)))) {
				if ($meta->ch_table[$i]) {
					$filter_arr["c".$i.".".$meta->ch_field[$i].""]['type']="string";
					$filter_arr["c".$i.".".$meta->ch_field[$i].""]['title']=$meta->field_title[$i];
					$filter_arr["c".$i.".".$meta->ch_field[$i].""]['ck_reestr']=false;
				} else {
					if($meta->is_add[$i]) $field_alias="c".$i."."."field_value";
					else $field_alias="c.".$meta->field[$i];
					$filter_arr[$field_alias]['type']=$meta->val_type[$i];
					$filter_arr[$field_alias]['title']=$meta->field_title[$i];
					if ($meta->ck_reestr[$i]) $filter_arr[$field_alias]['ck_reestr']=$meta->ck_reestr[$i];
					else $filter_arr[$field_alias]['ck_reestr']=false;
				}
			}
		}
		$_SESSION[$module][$view.".".$layout.".".$side]['filt_arr']=$filter_arr;
	}
}
?>