<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class contentPlugingallery extends Plugin {
	protected $_events=array("content.prepare");

	public function getParamsMask(){
		$params = parent::getParamsMask();
		$params["using_plugin"]["vtype"]="ro_string"; $params["using_plugin"]["vdefault"]=Text::_("content_gallery_description");
		$params["plugin_use_in_article"]["vtype"]="boolean"; $params["plugin_use_in_article"]["vdefault"]="1";
		$params["plugin_use_in_blogs"]["vtype"]="boolean"; $params["plugin_use_in_blogs"]["vdefault"]="0";
		$params["plugin_class_prefix"]["vtype"]="string"; $params["plugin_class_prefix"]["vdefault"]="content_gallery";
		return $params;
	}

	protected function onRaise($event, &$data) {
		$plugin_use_in_article = $this->get("plugin_use_in_article",1);
		$plugin_use_in_blogs = $this->get("plugin_use_in_blogs",0);
		$html="";
		$used_in_module=$this->get("used_in_module");
		$clean_all=$this->get("clean_all",0);
		switch($used_in_module){
			case "article":
				if (!$plugin_use_in_article) return false;
				break;
			case "blog":
				if (!$plugin_use_in_blogs) return false;
				break;
			default:
				if(!$clean_all) return false;
				break;
		}
		$gallery_regex = "#{gallery(.*?)}(.*?){/gallery}#s";
		preg_match_all( $gallery_regex, $data, $matches );
		$count = count( $matches[0] );
		if ( $count ) {
			if($clean_all) $this->processCleaning( $data, $matches, $count, $gallery_regex);
			else $this->processImages( $data, $matches, $count, $gallery_regex);
		}
		return $html;
	}
	private function processCleaning(&$data, $matches, $count, $gallery_regex){
		for ( $i=0; $i < $count; $i++ ) {
			$data = str_replace( $matches[0][$i], "", $data );
		}
	}
	
	private function processImages(&$data, $matches, $count, $gallery_regex){
		for ( $i=0; $i < $count; $i++ ) {
			if (isset($matches[1][$i])) {
				$html="";
				$gallery_id = 0;
				$use_popup=0;
				$thumb_limit=0;
				$thumb_height=0;
				$thumb_width=0;
				$thumb_titles_height=0;
				if (isset($matches[2][$i]))$title = $matches[2][$i]; else $title = '';
				$gallery_params = $matches[1][$i];

				$id_matches = array();
				preg_match( "#gallery_id=\|(.*?)\|#s", $gallery_params, $id_matches );
				if (isset($id_matches[1])) $gallery_id = intval($id_matches[1]);

				if($gallery_id){
						
					$popup_matches = array();
					preg_match( "#popup=\|(.*?)\|#s", $gallery_params, $popup_matches );
					if (isset($popup_matches[1])) $use_popup=1;

					$thumb_titles = array();
					preg_match( "#thumb_titles_height=\|(.*?)\|#s", $gallery_params, $thumb_titles_matches );
					if (isset($thumb_titles_matches[1])) $thumb_titles_height=intval($thumb_titles_matches[1]);
						
					$thumb_limit_matches = array();
					preg_match( "#thumb_limit=\|(.*?)\|#s", $gallery_params, $thumb_limit_matches );
					if (isset($thumb_limit_matches[1])) $thumb_limit=intval($thumb_limit_matches[1]);
						
					$thumb_height_matches = array();
					preg_match( "#thumb_height=\|(.*?)\|#s", $gallery_params, $thumb_height_matches );
					if (isset($thumb_height_matches[1])) $thumb_height=intval($thumb_height_matches[1]);
						
					$thumb_width_matches = array();
					preg_match( "#thumb_width=\|(.*?)\|#s", $gallery_params, $thumb_width_matches );
					if (isset($thumb_width_matches[1])) $thumb_width=intval($thumb_width_matches[1]);
					if (!$thumb_height && !$thumb_width){
						$thumb_height=galleryConfig::$thumbHeight;
						$thumb_width=galleryConfig::$thumbWidth;
					}
					$images=$this->getImages($gallery_id, $thumb_limit);
					$class_prefix = $this->get("plugin_class","content_gallery");
					$html.="<div class=\"".$class_prefix." clearfix\">";
					if($title) $html.="<h3 class=\"".$class_prefix."_title\">".$title."</h3>";
					$html.=$this->renderThumbs($images, $use_popup, $thumb_width, $thumb_height, $thumb_titles_height);
					$html.="</div>";
					$data = str_replace( $matches[0][$i], $html, $data );
				}
			}
		}
	}
	private function renderThumbs($images, $use_popup, $thumb_width, $thumb_height, $thumb_titles_height){
		$html="";
		$class_prefix = $this->get("plugin_class","content_gallery");
		if(count($images)){
			$img_autosize=" style=\"width:".$thumb_width."px; height:".$thumb_height."px;\"";
			$automax=" style=\"max-width:".$thumb_width."px; max-height:".$thumb_height."px;\"";
			$autowidth=" style=\"width:".$thumb_width."px;\"";
			$div_autosize=" style=\"width:".$thumb_width."px; height:".((int)$thumb_height+(int)$thumb_titles_height)."px;	\"";
			$link_autosize=" style=\"width:".$thumb_width."px; height:".((int)$thumb_height)."px;	\"";
			foreach($images as $image) {
				$thumb_file=ALTADOC_UF_PATH.'gallery'.DS.'i/thumbs'.DS.Files::getAppendix($image->gi_thumb).DS.$image->gi_thumb;
				$thumb=file_exists($thumb_file);
				$img_file=ALTADOC_UF_PATH.'gallery'.DS.'i'.DS.Files::getAppendix($image->gi_image).DS.$image->gi_image;
				$img=file_exists($img_file);
				$title=addslashes($image->gi_title);
				if ((!$thumb)&&(!$img)) {
					$thumb_link="";
					$image_link="";
				} elseif(!$thumb) {
					$image_link=ALTADOC_UF.'/gallery/i/'.Files::getAppendix($image->gi_image)."/".$image->gi_image;
					$thumb_link=ALTADOC_UF.'/gallery/i/'.Files::getAppendix($image->gi_image)."/".$image->gi_image;
				} elseif(!$img) {
					$image_link="";
					$thumb_link=ALTADOC_UF.'/gallery/i/thumbs/'.Files::getAppendix($image->gi_thumb)."/".$image->gi_thumb;
				} else {
					$image_link=ALTADOC_UF.'/gallery/i/'.Files::getAppendix($image->gi_image)."/".$image->gi_image;
					$thumb_link=ALTADOC_UF.'/gallery/i/thumbs/'.Files::getAppendix($image->gi_thumb)."/".$image->gi_thumb;
				}
				$html.= "<div".$div_autosize." class=\"".$class_prefix."_image\">";
				
				if ($use_popup && $image_link) $html.= "<a".$link_autosize." title=\"".$title."\" class=\"".$class_prefix."_thumb_link relpopupwt\" href=\"".$image_link."\">";
				else $html.= "<div".$autowidth." class=\"".$class_prefix."_thumb_div\">";
				
				if ($thumb_link) $html.= "<img".$automax." title=\"".$image->gi_title_img."\" alt=\"".$image->gi_alt_img."\" class=\"".$class_prefix."_thumb\" src=\"".$thumb_link."\" />";
				else $html.= "<img width=\"1\" height=\"1\"".$img_autosize." alt=\"\" class=\"".$class_prefix."_empty_thumb\" src=\"/images/blank.gif\" />";
				
				if ($use_popup && $image_link) $html.= "</a>";
				else $html.= "</div>";
				if($thumb_titles_height) {
					if($image_link) $html.= "<a title=\"".$title."\" class=\"".$class_prefix."_title_link relpopupwt\" href=\"".$image_link."\">".$title."</a>";
					else $html.= $title;
				}
				$html.= "</div>";
			}
		}
		return $html;
	}
	private function getImages($gallery_id, $thumb_limit){
		$sql="SELECT * FROM #__gallery_images WHERE gi_gallery_id=".$gallery_id." AND gi_published=1 AND gi_deleted=0 ORDER BY gi_ordering";
		if($thumb_limit) $sql.=" LIMIT ".$thumb_limit;
		Database::getInstance()->setQuery($sql);
		return Database::getInstance()->loadObjectList();
	}
}
?>