<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class userPluginelogin extends Plugin {
	private $callback_url="index.php?option=elogin";
  protected $_events = array("user.login_form","user.before_elogin","user.after_elogin");
  public function getParamsMask(){
  	$params['twitter_use']["vtype"]="boolean"; 		$params['twitter_use']["vdefault"]=false;
  	$params['twitter_key']["vtype"]="string"; 		$params['twitter_key']["vdefault"]="";
  	$params['twitter_secret']["vtype"]="string"; 	$params['twitter_secret']["vdefault"]="";
  	$params['facebook_use']["vtype"]="boolean"; 	$params['facebook_use']["vdefault"]=false;
  	$params['facebook_key']["vtype"]="string"; 		$params['facebook_key']["vdefault"]="";
  	$params['facebook_secret']["vtype"]="string"; $params['facebook_secret']["vdefault"]="";
  	$params['vkontakte_use']["vtype"]="boolean"; 	$params['vkontakte_use']["vdefault"]=false;
  	$params['vkontakte_key']["vtype"]="string"; 	$params['vkontakte_key']["vdefault"]="";
  	$params['vkontakte_secret']["vtype"]="string";$params['vkontakte_secret']["vdefault"]="";
  	return $params;
  }
  
  protected function onRaise($event, &$data) { 
  	$html="";
  	switch($event){
  		case "user.login_form":
  			$in_twitter=$this->get("twitter_use","");
  			$in_facebook=$this->get("facebook_use","");
  			$in_vk=$this->get("vkontakte_use","");
  			if ($in_twitter) $html.="<a class=\"sn_button\" href=\"".Router::_("index.php?module=user&task=elogin&use=twitter")."\">".HTMLControls::renderImage("/images/sn/twitter.png",false,0,0,Text::_("Login with")." Twitter")."</a>";
 				if ($in_facebook) $html.="<a class=\"sn_button\" href=\"".Router::_("index.php?module=user&task=elogin&use=facebook")."\">".HTMLControls::renderImage("/images/sn/facebook.png",false,0,0,Text::_("Login with")." Facebook")."</a>";
 				if ($in_vk) $html.="<a class=\"sn_button\" href=\"".Router::_("index.php?module=user&task=elogin&use=vkontakte")."\">".HTMLControls::renderImage("/images/sn/vkontakte.png",false,0,0,Text::_("Login with")." VKontakte")."</a>";
 				return $html;
  			break;
  		case "user.before_elogin":
  			if (!backofficeConfig::$allowSNLogin) Util::redirect("index.php",Text::_('Error signing in'));
  			$sn=Session::getVar("eauth_type");
		  	User::resetEAuth(false);
  			switch($sn){
 					case "twitter":
 						$this->authTwitter();
 						break;
					case "facebook":
 						$this->authFacebook();
						break;
					case "vkontakte":
 						$this->authVkontakte();
						break;
					default:	
						User::resetEAuth();
						break;
 				}
  			break;
  		case "user.after_elogin":
  			if (!backofficeConfig::$allowSNLogin) Util::redirect("index.php",Text::_('Error signing in'));
  			$sn=Session::getVar("eauth_type");
  			$eauth_return=Session::getVar("eauth_return");
	 			if (!is_null($eauth_return))	User::getInstance()->set("returnUrl",$eauth_return);
  			switch($sn){
 					case "twitter":
 						$this->proceedTwitter();
 						break;
					case "facebook":
 						$this->proceedFacebook();
						break;
					case "vkontakte":
 						$this->proceedVkontakte();
						break;
					default:	
						User::resetEAuth();
						break;
 				}
  			break;
  	}
  }
  private function authTwitter(){
		require_once(PATH_SITE."redistribution".DS."twitter".DS."twitteroauth.php");
  	$twitter_key=$this->get("twitter_key","");
		$twitter_secret=$this->get("twitter_secret","");
		if ($twitter_key && $twitter_secret){
			$connection = new TwitterOAuth($twitter_key, $twitter_secret);
			$req = $connection->getRequestToken(Router::_($this->callback_url));
			if ($connection->http_code==200) {
				$eauth_token  = Util::getArrParam($req, "oauth_token", "");
				$eauth_token_secret = Util::getArrParam($req, "oauth_token_secret", "");
				if ($eauth_token && $eauth_token_secret) {
					Session::setVar("eauth_token",$eauth_token);
					Session::setVar("eauth_token_secret",$eauth_token_secret);
					Util::redirect("https://api.twitter.com/oauth/authorize?oauth_token=".$eauth_token);
				} else Util::redirect("index.php",Text::_('Error signing in')." x01");
			} else Util::redirect("index.php",Text::_('Error signing in')." x02");
		}
  }
  private function proceedTwitter(){
		require_once(PATH_SITE."redistribution".DS."twitter".DS."twitteroauth.php");
		$twitter_key=$this->get("twitter_key","");
		$twitter_secret=$this->get("twitter_secret","");
		$eauth_token=Session::getVar("eauth_token");
		$eauth_token_secret=Session::getVar("eauth_token_secret");
		if ($twitter_key && $twitter_secret && $eauth_token && $eauth_token_secret){
  		$conn = new TwitterOAuth($twitter_key, $twitter_secret,$eauth_token,$eauth_token_secret);
 			$access_token = $conn->getAccessToken(Request::getSafe("oauth_verifier","")); // нужен сам вызов функции, переменная для просто так ара
 			if ($conn->http_code==200) {
	 			$user = $conn->get('account/verify_credentials');
	 			if ($conn->http_code==200) {
	 				$login="sn-".$user->id_str;
	 				$nickname=$user->name;
	 				$email="";
	 				$this->tryAuth($login,$nickname,$email,"twitter");
	 			}
 			} else Util::redirect("index.php",Text::_('Error signing in')." x03");
		} else Util::redirect("index.php",Text::_('Error signing in')." x04");
  }
  private function authFacebook(){
		require_once(PATH_SITE."redistribution".DS."facebook".DS."src".DS."facebook.php");
		$facebook_key=$this->get("facebook_key","");
		$facebook_secret=$this->get("facebook_secret","");
		if ($facebook_key && $facebook_secret) {
			$conn = new Facebook(array( 'appId'  => $facebook_key, 'secret' => $facebook_secret	));
 			$loginUrl = $conn->getLoginUrl(Router::_($this->callback_url));
			$access_token = $conn->getAccessToken();
 			if (!is_null($access_token)) {
				Session::setVar("eauth_token",$access_token);
				Session::setVar("eauth_token_secret",Session::getVar("fb_".$facebook_key."_state"));
				Util::redirect($loginUrl);
 			} else Util::redirect("index.php",Text::_('Error signing in')." x01");
		} else Util::redirect("index.php",Text::_('Error signing in')." x02");
  }
  private function proceedFacebook(){
  	require_once(PATH_SITE."redistribution".DS."facebook".DS."src".DS."facebook.php");
  	$facebook_key=$this->get("facebook_key","");
  	$facebook_secret=$this->get("facebook_secret","");
  	if ($facebook_key && $facebook_secret) {
  		$conn = new Facebook(array( 'appId'  => $facebook_key, 'secret' => $facebook_secret	));
  		$user=$conn->getUser();
  		if ($user && !is_null($conn->getAccessToken())) {
  			$profile = $conn->api('/me');
  			$login="sn-".$profile["id"];
  			$nickname=$profile["name"];
  			$email="";
  			$this->tryAuth($login,$nickname,$email,"facebook");
 			} else Util::redirect("index.php",Text::_('Error signing in')." x03");
 		} else Util::redirect("index.php",Text::_('Error signing in')." x04");
  }
  private function authVkontakte(){
  	require_once(PATH_SITE."redistribution".DS."vk".DS."vk_api.php");
  	$vk_key=$this->get("vkontakte_key","");
  	$vk_secret=$this->get("vkontakte_secret","");
  	if ($vk_key && $vk_secret) {
  		$vk=new VK_OAuth($vk_key, $vk_secret);
  		$loginUrl=$vk->getLoginURI(Router::_($this->callback_url));
  		Util::redirect($loginUrl);
  	} else Util::redirect("index.php",Text::_('Error signing in')." x01");
  }
  private function proceedVkontakte(){
  	require_once(PATH_SITE."redistribution".DS."vk".DS."vk_api.php");
  	$vk_key=$this->get("vkontakte_key","");
	  $vk_secret=$this->get("vkontakte_secret","");
  	if ($vk_key && $vk_secret) {
  		$vk=new VK_OAuth($vk_key, $vk_secret);
  		if ($vk->validateAuthResponse()){
	  		$profile=$vk->getProfile();
	  		if ($profile&&is_array($profile)){
	  			$login="sn-".$profile["id"];
		  		$nickname=$profile["name"];
	  			$email="";
	  			$this->tryAuth($login,$nickname,$email,"vkontakte");
  			} else Util::redirect("index.php",Text::_('Error signing in')." x04");
  		} else {
	  		Util::redirect("index.php",$vk->error_desc);
	  	}
  	} else Util::redirect("index.php",Text::_('Error signing in')." x02");
  }
  private function tryAuth($login,$nickname,$email,$provider){ 
 		$password="";
 		$role=backofficeConfig::$defaultUserRole;
 		$referral=User::checkReferral();
 		$activated=1;
 		$discount=0;
 		$price_type=1;
 		User::resetEAuth();
 		if(User::isUser($login)){
 			User::getInstance()->elogin($login,$provider);
 		}	else if (!backofficeConfig::$noRegistration && User::addUser($login,$nickname,$password,$email,$role,$referral,$activated,$discount,$price_type,$provider)) {
 			User::getInstance()->elogin($login,$provider);
 		} else {
 			Util::redirect("index.php",Text::_('Error signing in'));
		}
  }
}
?>