<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class acrmWidget extends Widget {
	public function getParamsMask(){
	  $params["Widget_ID"]["vtype"]="string"; 			$params["Widget_ID"]["vdefault"]="";
	  $params["Client_ID"]["vtype"]="table_select"; 	$params["Client_ID"]["vdefault"]=0;		$params['Client_ID']["source"]="SELECT bcl_id AS fld_id, bcl_name AS fld_name FROM #__banners_clients ORDER BY fld_name";
	  $params["Category_ID"]["vtype"]="table_select"; 	$params["Category_ID"]["vdefault"]=0;	$params['Category_ID']["source"]="SELECT bc_id AS fld_id, bc_name AS fld_name FROM #__banners_categories ORDER BY fld_name";
	  $params["Quantity"]["vtype"]="integer"; 			$params["Quantity"]["vdefault"]=1;
	  $params["Show_title"]["vtype"]="boolean"; 		$params["Show_title"]["vdefault"]=1;
	  $params["Randomize"]["vtype"]="boolean"; 			$params["Randomize"]["vdefault"]=0;
	  return $params;
	}
	public function prepare() {
//		Portal::getInstance()->addScript(""); 
	}
	public function render() {
		$widgetHTML="";
		$client = intval($this->get('Client_ID',0));
		$cat = intval($this->get('Category_ID',0));
		$quantity = intval($this->get('Quantity',0));
		$randomize = intval($this->get('Randomize',0));
		$model = new ACRM();
		$items = $model->getItems($client,$cat,$quantity,$randomize);
		
		if (($items)&&(count($items))) {
			foreach($items as $item){
				$widgetHTML.=$this->renderItem($item);
				$arr_ids[]=$item->b_id;
			}
			$items_ids=implode(",",$arr_ids);
			$widgetHTML.= HTMLControls::renderHiddenField("itms_ident",$items_ids,false,"itms_ident");
		}
		return $widgetHTML;
	}
	public function renderItem($item){
		$_html="<div class=\"itms\">";
		$width=intval($item->b_width);
		$height=intval($item->b_height);
		$name=$item->b_name;
		$target=$item->b_target;
		if($target) {
			if (Router::isFullLink($target)) $_blank=" target=\"_blank\""; else $_blank="";
			$_html.="<a rel=\"nofollow\" onclick=\"javascript:clickACRM('".$item->b_id."')\" ".$_blank." href=\"".$target."\">";
		}
		if ($item->b_image) {
			$imageurl=ALTADOC_UF."/acrm/i/".Files::splitAppendix($item->b_image);
			$imagefile=ALTADOC_UF_PATH."acrm".DS."i".DS.Files::getAppendix($item->b_image,true).DS.$item->b_image;
			if (Files::isFlash($imagefile)) {
				$_html.=HTMLControls::renderFlash($imageurl, $width, $height); 
			} elseif(Files::isImage($imagefile)) {
				$_html.=HTMLControls::renderImage($imageurl, false, $width, $height, $name, $name, false);
			}
		} elseif ($item->b_custom_code) {
			$_html.=html_entity_decode($item->b_custom_code);
		} else return '';
		if($target) $_html.="</a>";
		$_html.="</div>";
		return $_html;
	}
}
?>

