<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class blogcalendarWidget extends Widget {

	public function getParamsMask(){
		$params["blog_id"]["vtype"]="table_select";	$params["blog_id"]["vdefault"]="";	$params['blog_id']["source"]="SELECT b_id AS fld_id, b_name AS fld_name FROM #__blogs ORDER BY fld_name";
		$params["menu_id"]["vtype"]="table_select";	$params["menu_id"]["vdefault"]=0;	$params['menu_id']["source"]="SELECT mi_id AS fld_id, CONCAT('(',mi_id,') ',mi_name) AS fld_name FROM #__menus ORDER BY fld_name";
		return $params;
	}

	public function render() {
		$blog_id = $this->get('blog_id',0);
		if (!$blog_id) return Text::_("Undefined blog");
		if ($this->get('menu_id',0)) $mid="&amp;mid=".$this->get('menu_id'); else $mid="";
		$route_vars=Router::getInstance()->getVarsArr();
		$body="";
		$psid=0;
		$postDates=array("postStartDate"=>false,"postEndDate"=>false);
		if (isset($route_vars["module"]) && $route_vars["module"]=="blog" && isset($route_vars["view"]) && $route_vars["view"]=="list" && isset($route_vars["psid"]) && $route_vars["psid"]){
			$psid=$route_vars["psid"];
			$postDates = Module::getHelper("post","blog")->getDates($route_vars["psid"],$postDates);
		}

		if ($postDates["postStartDate"] && $psid){
			$time=Date::mysqldatetime_to_timestamp($postDates["postStartDate"]);
		} else {
			$time=time();
			$psid = $blog_id;
		}
		$starYear = date("Y",$time);
		$starMonth = date("m",Date::mysqldatetime_to_timestamp($postDates["postStartDate"]));
		
		$blog_alias = Module::getHelper("blog","blog")->getAliasByID("list",$blog_id);
		$link=Router::_("index.php?module=blog&view=list&psid=".$blog_id."&alias=".$blog_alias."&mid=".$mid,false,false);
		$dates_arr=Module::getHelper("post","blog")->getPostsDates($blog_id, $starYear, $starMonth);
		$script="var blogEnabledDates=".json_encode($dates_arr).";
				$(document).ready(function() {
					$('#blogCalendar').datepicker({
//						beforeShow: getPostDatesForMonth(".$psid.",".$starYear.",".$starMonth."),
						dateFormat: 'yy-mm-dd',
						beforeShowDay:  disableBlogCalendarDates, 
						onChangeMonthYear:  function(year, month, inst) { getPostDatesForMonth(".$psid.",year,month); },
						onSelect: function(date){
							setBlogCalendarCookie(".$psid.",date,date);
							window.location.href = '".$link."';
						}
					});";
		if($postDates["postStartDate"]) $script.=	"$('#blogCalendar').datepicker('setDate','".$postDates["postStartDate"]."');";				
		$script.="}); ";
		Portal::getInstance()->addScriptDeclaration($script);
		$body.="<div id=\"blogCalendar\"></div>";
		$body.="<p class=\"calendar_show_all\"><a onclick=\"resetBlogCalendarCookie(".$psid.")\" href=\"".$link."\">".Text::_("Show all")."</a></p>";
		return $body;
	}
}
?>