<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class blogpostWidget extends Widget {

	public function getParamsMask(){
		$params["blog_Id"]["vtype"]="string";				$params["blog_Id"]["vdefault"]="";
		$params["blog_Id_ex"]["vtype"]="string";			$params["blog_Id_ex"]["vdefault"]="";
		$params["post_count"]["vtype"]="integer";			$params["post_count"]["vdefault"]=5;
		$params["show_date"]["vtype"]="boolean"; 			$params["show_date"]["vdefault"]=0;
		$params["show_time_in_date"]["vtype"]="boolean"; 	$params["show_time_in_date"]["vdefault"]=0;
		$params["show_post_title"]["vtype"]="boolean"; 		$params["show_post_title"]["vdefault"]=1;
		$params["brief_length"]["vtype"]="integer"; 		$params["brief_length"]["vdefault"]=0;
		$params["show_readmore"]["vtype"]="boolean"; 		$params["show_readmore"]["vdefault"]=1;
		$params["show_thumb"]["vtype"]="boolean"; 			$params["show_thumb"]["vdefault"]=1;
		$params["show_all_blog_id"]["vtype"]="integer"; 	$params["show_all_blog_id"]["vdefault"]=0;
		$params["menu_id"]["vtype"]="table_select"; 		$params["menu_id"]["vdefault"]=0; $params['menu_id']["source"]="SELECT mi_id AS fld_id, CONCAT('(',mi_id,') ',mi_name) AS fld_name FROM #__menus ORDER BY fld_name";
		return $params;
	}

	public function render() {
		$post_count	= $this->get('post_count',5);
		$arrpsid		= explode(",",$this->get('blog_Id',""));
		$arrexpsid	= explode(",",$this->get('blog_Id_ex',""));
		$show_date	= $this->get('show_date',0);
		if($this->get('show_time_in_date',0)) $hide_time_in_date = 0; else $hide_time_in_date = 1;
		$show_post_title	= $this->get('show_post_title',1);
		$brief_length	= $this->get('brief_length',0);
		$show_readmore	= $this->get('show_readmore',0);
		$show_thumb	= $this->get('show_thumb',0);
		$show_all_blog_id = $this->get('show_all_blog_id',0);
		if ($this->get('menu_id',0)) $mid="&amp;mid=".$this->get('menu_id'); else $mid="";
		if(count($arrpsid)==1 && empty($arrpsid[0]) ) $arrpsid=array();
		if(count($arrexpsid)==1 && empty($arrexpsid[0]) ) $arrexpsid=array();
		$body="";
		$list = $this->getListPost($arrpsid,$arrexpsid,$post_count);
		if (count($list)) {
			foreach($list as $val) {
				$link=Router::_("index.php?module=blog&amp;view=post&amp;psid=".$val->p_id.$mid);
				$link_aut=Router::_("index.php?module=user&view=info&psid=".$val->u_id);
				$body.='<div class="wblog clearfix"><div class="wbTheme">';
				if ($show_date) $body.='<span class="post_date">'.Date::fromSQL($val->date,$hide_time_in_date,true).'</span>';
				if($show_post_title) $body.='<a href="'.$link.'">'.$val->title.'</a>';
				$body.='</div>';
				if($brief_length){
					$body.='<div class="wbText clearfix">';

					if ($show_thumb && $val->thumb) {
						$filename=ALTADOC_UF_PATH."blog".DS."thumbs".DS.Files::splitAppendix($val->thumb,true);
						if (Files::isImage($filename))	{
							$filelink=ALTADOC_UF."/blog/thumbs/".Files::splitAppendix($val->thumb);
							$body.= "<img class=\"wbThumb\" title=\"".$val->title_thumb."\" alt=\"".$val->alt_thumb."\" src=\"".$filelink."\" />";
						}
					}

					$body.=mb_substr(strip_tags($val->text), 0, $brief_length,DEF_CP)."...";
					if($show_readmore){
						$body.='<p class="readmore"><a href="'.$link.'">'.Text::_("Read more").'</a></p>';
					}
					$body.='</div>';
				}
				$body.='</div>';
			}
			if($show_all_blog_id){ 
				$blog_alias = Module::getHelper("blog","blog")->getAliasByID("list",$show_all_blog_id);
				$body .= "<p class=\"view_archive\"><a href=\"".Router::_("index.php?module=blog&view=list&psid=".$show_all_blog_id."&alias=".$blog_alias)."\">".Text::_('Show all')."</a></p>";
			}
		}	else {	// Render failure
			$body .= "<p class=\"messages_absent\">".Text::_('Posts not found')."</p>";
		}
		return $body;
	}
	private function getListPost($arrblogId,$arrblogIdEx,$post_count=5) {
		$db = Database::getInstance();
		$rights=Module::getInstance('blog')->getModel('rights');
		$res=array();  	$res_ex=array();
		if(!count($arrblogId)) {
			$sql_blog="SELECT b_id FROM #__blogs WHERE b_deleted=0 AND b_enabled=1";
			$db->setQuery($sql_blog);
			$arrblogId=$db->LoadResultArray();
		}

		if(count($arrblogId)) {
			$res=array_keys($rights->getBlogsWithAction($arrblogId,'read'));
		}
		if(count($arrblogIdEx)) {
			foreach($arrblogIdEx as $blogId) {
				$res_ex[]=intval($blogId);
			}
		}
/*
		$query = "SELECT b.p_id,b.p_blog_id,b.p_theme as title,b.p_touch_date as date,b.p_author_id as u_id,
				u.u_nickname as author 	FROM `#__blogs_posts` as b,	#__users as u
				WHERE b.p_deleted=0 AND b.p_enabled=1";
		$query .= " AND b.p_author_id=u.u_id";
*/
		$query = "SELECT b.p_id,b.p_blog_id,b.p_theme as title, b.p_text as text, b.p_thumb as thumb, b.p_title_thm as title_thumb, b.p_alt_thm as alt_thumb,b.p_touch_date as date,b.p_author_id as u_id,
				u.u_nickname as author 	FROM `#__blogs_posts` as b
				LEFT JOIN #__users AS u  ON u.u_id=b.p_author_id
				WHERE b.p_deleted=0 AND b.p_enabled=1";
		if (count($res)) {
			$query .= " AND (b.p_blog_id IN (".implode(",",$res)."))";
		} else return array();
		if (count($res_ex)) {
			$query .= " AND (b.p_blog_id NOT IN (".implode(",",$res_ex)."))";
		}
		$query .= " ORDER BY b.p_touch_date DESC";
		$query .= " LIMIT ".(int)$post_count;
		$db->setQuery($query);
		$posts = $db->loadObjectList();
		if (is_array($posts) && count($posts) > 0) {
			return $posts;
		}	else 	{
			return array();
		}
	}
}
?>