<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogfilterWidget extends Widget {
	
	private $equis=array("none","eq","lt","gt");
	private $null_date='0000-00-00';
	private $module="catalog";
	private $view= "goods";
	private $layout= "default";
	private $side=0;
	
	
	public function __construct($name,$data) {
		$this->initObj('widget'.$name);
		$this->_data = $data;
		$cssPath = "widgets/".$name.".css";
		Portal::getInstance()->addStyleSheet($cssPath);
		$jsPath = "widgets/".$name.".js";
		Portal::getInstance()->addScript($jsPath);
		Text::parseWidget($name);
	}
	public function getParamsMask(){  
		$params=parent::getParamsMask();
		$params["Filter_ID"]["vtype"]="string"; $params["Filter_ID"]["vdefault"]="";
		$params["Hide_filter_panel"]["vtype"]="boolean"; $params["Hide_filter_panel"]["vdefault"]=false;
		$params["Show_own_filter_panel"]["vtype"]="boolean"; $params["Show_own_filter_panel"]["vdefault"]=false;
		$params["max_checkbox_per_parameter"]["vtype"]="integer"; $params["max_checkbox_per_parameter"]["vdefault"]=10;
		return $params;
	}
	
	public function prepare() {
		$div_id = $this->get('Filter_ID',"");
		if (Module::getInstance()->getName()!="catalog") return "";
		$hide_filter_panel=$this->get('Hide_filter_panel',false);
		if ($hide_filter_panel){
			$css="div.catalogModule div#filterBlock{ display:none; }";
			Portal::getInstance()->addStyle($css);
		}
	}
	
	public function render() {
		$div_id = $this->get('Filter_ID',"");
		if (Module::getInstance()->getName()!="catalog") return "";
		if (!isset($_SESSION[$this->module][$this->view.".".$this->layout.".".$this->side]['filt_arr'])) return "";
		$psid = Request::getInt('psid', false);
		$html="<div class=\"catalog_extended_filter\" id=\"".$div_id."\">";
		$html.=$this->getCatalogFilterForm();
		$html.="</div>";
		return $html;
	}
	public function getCatalogFilterForm(){
		$module=$this->module;
		$view= $this->view;
		$layout= $this->layout;
		$side=$this->side;
		$div_id = $this->get('Filter_ID',"");
		$show_own_filter_panel=$this->get('Show_own_filter_panel',false);
		$max_checkbox_per_parameter=$this->get('max_checkbox_per_parameter',10);
		$psid         = Request::getInt('psid', false); 					// ид строки
		$multy_code   = Request::getInt('multy_code', false); 					// ид верхней группы
		if(!$multy_code)	$multy_code=$psid;
		$filter_arr = $_SESSION[$module][$view.".".$layout.".".$side]['filt_arr'];
		$flt=new SpravFilter();
		$filter=$flt->getFilter($side,$module, $view,$layout);
		$_selected="selected=\"selected\"";
		$_html=""; $filtered="";
		$_html_full = "<form name=\"frmfilterext\" method=\"post\" action=\"".Router::_("index.php")."\" >";
		$_html_full.= "<input type=\"hidden\" name=\"module\" value=\"".$module."\"  />";
		$_html_full.= "<input type=\"hidden\" name=\"view\" value=\"".$view."\"  />";
		$_html_full.= "<input type=\"hidden\" name=\"layout\" value=\"".$layout."\"  />";
		$_html_full.= "<input type=\"hidden\" name=\"multy_code\" value=\"".$multy_code."\"  />";
		$_html_full.= "<input type=\"hidden\" name=\"psid\" value=\"".$psid."\"  />";
		$_html_full.= "<table class=\"catalog_extended_filter\">";
		if($filter_arr && count($filter_arr)) {
			foreach ($filter_arr as $key => $value) {
				$cur_key=str_replace(".","_",$key);
				if ($filter) {
					if (array_key_exists($key,$filter)) {$cur_val=$filter[$key];} else {$cur_val="";}
				}	else $cur_val="";
				if ($value['type']=="boolean") {
					$cur_sel_0="";$cur_sel_1="";$cur_sel="";
					if ($cur_val=="0") $cur_sel_0=$_selected;
					elseif ($cur_val=="1") $cur_sel_1=$_selected;
					else $cur_sel=$_selected;
					if (!isset($bool_array)) $bool_array=array(0=>Text::_('N'), 1=>Text::_('Y'));
					if($cur_val=="0" || $cur_val=="1") $filtered.= "<span class=\"w_filter_row\"><span class=\"w_reset_filter_key\" onclick=\"reset_filter_key('".$div_id."','frmfilterext','".$cur_key."', this);\"></span><span class=\"w_filter_row_title\">".strval(Text::_($filter_arr[$key]['title'])."</span> : ".$bool_array[$cur_val]."</span>");
					$_html.= "<tr><td class=\"formlabel\">".Text::_($value['title'])."</td></tr>";
					$_html.= "<tr><td class=\"forminput\"><select class=\"bln\" id=\"".$cur_key."\" name=\"".$cur_key."\" size=\"1\">";
					$_html.= "<option ".$cur_sel." value=\"-1\">".Text::_("All")."</option>";
					$_html.= "<option ".$cur_sel_0." value=\"0\">".Text::_("N")."</option>";
					$_html.= "<option ".$cur_sel_1." value=\"1\">".Text::_("Y")."</option>";
					$_html.= "</select></td></tr>";
				} elseif (($value['type']=="date")||($value['type']=="datetime")) {
					$fakes=$flt->parseDateFilter($cur_val);
					if ($fakes[1]==$this->null_date) $cur_val=""; else $cur_val=Date::fromSQL($fakes[1],true,true);
					$cur_sel_eq=""; $cur_sel_lt=""; $cur_sel_gt="";
					if ($fakes[0]==$this->equis[1]) $cur_sel_eq=$_selected;
					elseif ($fakes[0]==$this->equis[2]) $cur_sel_lt=$_selected;
					elseif ($fakes[0]==$this->equis[3]) $cur_sel_gt=$_selected;
					if($cur_val) $filtered.= "<span class=\"w_filter_row\"><span class=\"w_reset_filter_key\" onclick=\"reset_filter_key('".$div_id."','frmfilterext','".$cur_key."', this);\"></span><span class=\"w_filter_row_title\">".strval(Text::_($filter_arr[$key]['title'])."</span> : ".$flt->parseDateFilterToStr($cur_val)."</span>");
					$_html.= "<tr><td class=\"formlabel\">".Text::_($value['title'])."</td></tr>";
					$_html.= "<tr><td class=\"forminput\"><select class=\"eq\" id=\"fake1_".$cur_key."\" name=\"fake1_".$cur_key."\" size=\"1\">";
					$_html.= "<option value=\"".$this->equis[0]."\">*</option><option ".$cur_sel_eq." value=\"".$this->equis[1]."\">=</option><option ".$cur_sel_lt." value=\"".$this->equis[2]."\">&lt;</option><option ".$cur_sel_gt." value=\"".$this->equis[3]."\">&gt;</option>";
					$_html.= "</select>";
					$_html.= "<input name=\"fake2_".$cur_key."\" id=\"fake2_".$cur_key."\" value=\"".$cur_val."\" class=\"datepicker\" readonly=\"readonly\" maxlength=\"10\" size=\"10\" type=\"text\" />";
					$_html.= '<img width="1" height="1" class="date_selector" src="/images/blank.gif" title="'.Text::_("Select date").'"	alt="D" /></td></tr>';
					if ($fakes[3]==$this->null_date) $cur_val=""; else $cur_val=Date::fromSQL($fakes[3],true,true);
					$cur_sel_eq=""; $cur_sel_lt=""; $cur_sel_gt="";
					if ($fakes[2]==$this->equis[1]) $cur_sel_eq=$_selected;
					elseif ($fakes[2]==$this->equis[2]) $cur_sel_lt=$_selected;
					elseif ($fakes[2]==$this->equis[3]) $cur_sel_gt=$_selected;
					$_html.= "<tr><td class=\"formlabel\">&nbsp;</td></tr>";
					$_html.= "<tr><td class=\"forminput\"><select class=\"eq\" id=\"fake3_".$cur_key."\" name=\"fake3_".$cur_key."\" size=\"1\">";
					$_html.= "<option value=\"".$this->equis[0]."\">*</option><option ".$cur_sel_eq." value=\"".$this->equis[1]."\">=</option><option ".$cur_sel_lt." value=\"".$this->equis[2]."\">&lt;</option><option ".$cur_sel_gt." value=\"".$this->equis[3]."\">&gt;</option>";
					$_html.= "</select>";
					$_html.= "<input name=\"fake4_".$cur_key."\" id=\"fake4_".$cur_key."\" value=\"".$cur_val."\" class=\"datepicker\" readonly=\"readonly\" maxlength=\"10\" size=\"10\" type=\"text\" />";
					$_html.= '<img width="1" height="1" class="date_selector" src="/images/blank.gif" title="'.Text::_("Select date").'"	alt="D" /></td></tr>';
				} elseif (($value['type']=="int")||($value['type']=="float")) {
					$fakes=$flt->parseFloatFilter($cur_val);
					$cur_sel_eq=""; $cur_sel_lt=""; $cur_sel_gt="";
					if ($fakes[0]==$this->equis[1]) $cur_sel_eq=$_selected;
					elseif ($fakes[0]==$this->equis[2]) $cur_sel_lt=$_selected;
					elseif ($fakes[0]==$this->equis[3]) $cur_sel_gt=$_selected;
					$cur_val=$fakes[1];
					if($cur_val) $filtered.= "<span class=\"w_filter_row\"><span class=\"w_reset_filter_key\" onclick=\"reset_filter_key('".$div_id."','frmfilterext','".$cur_key."', this);\"></span><span class=\"w_filter_row_title\">".strval(Text::_($filter_arr[$key]['title'])."</span> : ".$cur_val."</span>");
					$_html.= "<tr><td class=\"formlabel\">".Text::_($value['title'])."</td></tr>";
					$_html.= "<tr><td class=\"forminput\"><select class=\"eq\" id=\"fake1_".$cur_key."\" name=\"fake1_".$cur_key."\" size=\"1\">";
					$_html.= "<option value=\"".$this->equis[0]."\">*</option><option ".$cur_sel_eq." value=\"".$this->equis[1]."\">=</option><option ".$cur_sel_lt." value=\"".$this->equis[2]."\">&lt;</option><option ".$cur_sel_gt." value=\"".$this->equis[3]."\">&gt;</option>";
					$_html.= "</select>";
					$_html.= "<input type=\"text\" class=\"filterfloat filterint\"  name=\"fake2_".$cur_key."\" id=\"fake2_".$cur_key."\" value=\"".$cur_val."\" /></td></tr>";
				}	elseif($value['ck_reestr']) {
					if (is_array($value['ck_reestr'])) $ck_array=$value['ck_reestr'];
					else $ck_array=SpravStatic::getCKArray($value['ck_reestr']);
					if(count($ck_array)){
						$_html.= "<tr><td class=\"formlabel\">".Text::_($value['title'])."</td></tr>";
						$i=0;
						if(count($ck_array)>$max_checkbox_per_parameter){
							$_html.= "<tr><td class=\"forminput form_multiselect\">";
							$_html.= HTMLControls::renderSelect($cur_key, $cur_key, false, false, $ck_array, str_replace("&&", ",",$cur_val), false, false, "10", "multi");
							$_html.= "</td></tr>";
						} else {
							$cur_val_array=explode("&&",$cur_val);
							foreach ($ck_array as $ck_key=>$ck_val){
								if ($ck_key){
									$_html.= "<tr><td class=\"forminput formcheckboxes\">";
									$i++;
									if (in_array($ck_key, $cur_val_array)) $checked_val=$ck_key; else $checked_val=""; 
									$_html.= HTMLControls::renderCheckbox($cur_key."[]", $checked_val, $ck_key, $cur_key."_".$i);
									$_html.= HTMLControls::renderLabelField($cur_key."_".$i, $ck_val);
									$_html.= "</td></tr>";
								}
							}
						}
						if($cur_val) $filtered.= "<span class=\"w_filter_row\"><span class=\"w_reset_filter_key\" onclick=\"reset_filter_key('".$div_id."','frmfilterext','".$cur_key."', this);\"></span><span class=\"w_filter_row_title\">".strval(Text::_($filter_arr[$key]['title'])."</span> : ".str_replace("&&", " + ", $cur_val)."</span>");						
					}
				}	else {
					if($cur_val) $filtered.= "<span class=\"w_filter_row\"><span class=\"w_reset_filter_key\" onclick=\"reset_filter_key('".$div_id."','frmfilterext','".$cur_key."', this);\"></span><span class=\"w_filter_row_title\">".strval(Text::_($filter_arr[$key]['title'])."</span> : ".$cur_val."</span>");
					$_html.= "<tr><td class=\"formlabel\">".Text::_($value['title'])."</td></tr>";
					$_html.= "<tr><td class=\"forminput\"><input type=\"text\" name=\"".$cur_key."\" value=\"".$cur_val."\" /></td></tr>";
				}
			}
			$_html.= "<tr><td class=\"flt-button\" align=\"center\">";
			$_html.= "<input type=\"hidden\" name=\"no_pages\" value=\"0\" />";
			$_html.= "<input type=\"hidden\" name=\"without_parents\" value=\"0\" />";
			$_html.= "<input name=\"save_filter\" type=\"submit\" class=\"commonButton\" value=\"".Text::_("Apply")."\" />";
			$_html.= "<input name=\"reset_filter\" type=\"submit\" class=\"commonButton\" value=\"".Text::_("Reset")."\" />";
			$_html.= "</td></tr>";
		}	else	{
			$_html.= "<tr><td class=\"warning\" style=\"text-align:center;\" >";
			$_html.= Text::_("Filter fields undefined");
			$_html.= "</td></tr>";
		}
		if($show_own_filter_panel && $filtered) $_html_full.= "<tr><td colspan=\"2\" class=\"filter_text\">".$filtered."</td></tr>";
		$_html_full.=$_html;
		$_html_full.= "</table>";
		$_html_full.= "</form>";
		return $_html_full;
	}
}
?>