<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class catalogmenuWidget extends Widget {

	public function getParamsMask(){
		$params["Menu_ID"]["vtype"]="string"; 				$params["Menu_ID"]["vdefault"]="";
		$params["Order_by"]["vtype"]="select";				$params["Order_by"]["vdefault"]="ggr_name";	$params["Order_by"]["source"]=array(array("id"=>"ggr_name","name"=>Text::_("Name")),array("id"=>"ggr_ordering","name"=>Text::_("Ordering")));
		$params["Expand_behaviour"]["vtype"]="select";		$params["Expand_behaviour"]["vdefault"]="location";	$params["Expand_behaviour"]["source"]=array(array("id"=>"cookie","name"=>Text::_("By last expanded")),array("id"=>"location","name"=>Text::_("Current location")));
		$params["Exclude_groups_ids"]["vtype"]="string"; 	$params["Exclude_groups_ids"]["vdefault"]="";
		$params["Max_levels"]["vtype"]="integer"; 			$params["Max_levels"]["vdefault"]=5;
		$params["Cart_button"]["vtype"]="boolean";			$params["Cart_button"]["vdefault"]=0;
		$params["Filter_button"]["vtype"]="boolean"; 		$params["Filter_button"]["vdefault"]=0;
		$params["Vendors_button"]["vtype"]="boolean"; 		$params["Vendors_button"]["vdefault"]=0;
		$params["Manufacturers_button"]["vtype"]="boolean"; $params["Manufacturers_button"]["vdefault"]=0;
		return $params;
	}

	public function prepare() {
		Portal::getInstance()->addScript("/redistribution/jquery.plugins/jquery.treeview.js");
		$id = $this->get('Menu_ID','');
		if($id) {
			$persist = $this->get('Expand_behaviour',"location"); 
			Portal::getInstance()->AddScriptDeclaration('$(document).ready(function(){ $("#'.$id.'").treeview({  animated: "fast", collapsed: true, unique: true, persist: "'.$persist.'" }); });');
			if(Request::getSafe("module")=="catalog" && $persist=="location"){
				Portal::getInstance()->AddScriptDeclaration('
					$(document).ready(function(){
						if ($.cookie("altadoc_catalog_group")!=null){
							'.$id.'lid="'.$id.'_item_"+$.cookie("altadoc_catalog_group");
							$("#'.$id.' li").removeClass("active");
							$("#'.$id.' li#"+'.$id.'lid).addClass("active");
							$("#'.$id.' li#"+'.$id.'lid + ">a").addClass("active").addClass("selected").parents("ul, li").show();
						} 
					});');
			} else {
			}
		}
	}
	public function render() {
		if (catalogConfig::$catalogDisabled) {
			$menuHTML=""; return $menuHTML;
		}
		$id = $this->get('Menu_ID','');
		$exc_grp_ids = $this->get('Exclude_groups_ids','');
		$max_levels = $this->get('Max_levels',5);
		$filter_button=$this->get('Filter_button',0);
		$cart_button=$this->get('Cart_button',0);
		$vendors_button=$this->get('Vendors_button',0);
		$manufacturers_button=$this->get('Manufacturers_button',0);
		$name = $this->get('name','');
		$ordering=$this->get('Order_by','ggr_name');
		$model = new catalogmenuTree($this->get('controller'),$ordering,$max_levels,$exc_grp_ids);
		$menuHTML = "<div class=\"catalog-tree-wrapper tree-wrapper\">".$model->getTreeHTML(0,'ul',$id, 'treeview', 0, $id."_item")."</div>";
		if ($filter_button||$cart_button||$manufacturers_button){
			$menuHTML.= "<div class=\"catalog-tree-buttons\">";
			if ($filter_button) $menuHTML.="<div class=\"filter_button\"><a class=\"linkButton\" onclick=\"javascript:showFilter('catalog','goods','','0'); return false;\">".Text::_("Filter")."</a></div>";
			if ($cart_button) $menuHTML.="<div class=\"cart_button\"><a class=\"relpopupwt linkButton\" href=\"".Router::_("index.php?module=catalog&amp;task=ShowBasket&amp;option=ajax")."\">".Text::_("Basket")."</a></div>";
			if ($vendors_button) $menuHTML.="<div class=\"vendors_button\"><a class=\"linkButton\" href=\"".Router::_("index.php?module=catalog&amp;view=vendors")."\">".Text::_("Vendors")."</a></div>";
			if ($manufacturers_button) $menuHTML.="<div class=\"manufacturers_button\"><a class=\"linkButton\" href=\"".Router::_("index.php?module=catalog&amp;view=manufacturers")."\">".Text::_("Manufacturers")."</a></div>";
			$menuHTML.= "</div>";
		}
		return $menuHTML;
	}
}

class catalogmenuTree extends simpleTreeTable {
	public function __construct($controller='',$ordering,$max_levels,$exc_grp_ids) {
		parent::__construct();
		$this->table="goods_group";
		$this->fld_id="ggr_id";
		$this->fld_parent_id="ggr_id_parent";
		$this->fld_title="ggr_name";
		$this->fld_alias="ggr_alias";
		$this->fld_enabled="ggr_enabled";
		$this->fld_deleted="ggr_deleted";
		$this->fld_orderby=$ordering;
		$this->element_link="index.php?module=catalog&amp;view=goods&amp;psid=";
		$this->buildTreeArrays($exc_grp_ids,0,1,1,$max_levels);
	}
}
?>