<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class menuWidget extends Widget {

	public function getParamsMask(){
		$params["Menu_ID"]["vtype"]="string";	$params["Menu_ID"]["vdefault"]="";
		$params["Menu_root_id"]["vtype"]="select"; 	$params["Menu_root_id"]["vdefault"]="";
		$params["Menu_root_id"]["source"]=$this->getTopItems();
		$params["Menu_max_levels"]["vtype"]="integer";	$params["Menu_max_levels"]["vdefault"]=0;
		$params["Collapse_menu"]["vtype"]="boolean";	$params["Collapse_menu"]["vdefault"]=0;
		$params["Translate"]["vtype"]="boolean"; $params["Translate"]["vdefault"]=0;
		return $params;
	}

	public function prepare() {
		$wid = $this->get('Menu_ID','');
		$li = $wid."_item_".$_SESSION['active_menu_id'];
		if($wid) {
			if($this->get('Collapse_menu',0)) {
				Portal::getInstance()->addScript("/redistribution/jquery.plugins/jquery.treeview.js");
				$persist = $this->get('Expand_behaviour',"location");
				Portal::getInstance()->AddScriptDeclaration('
					$(document).ready(function(){
						$("#'.$wid.'").addClass("tree_menu");	
						$("#'.$wid.'").treeview({  animated: "fast", collapsed: true, unique: true, persist: "'.$persist.'" });
					});
				');
			}
			Portal::getInstance()->AddScriptDeclaration('
					$(document).ready(function(){
						$("#'.$wid.' li").removeClass("active");
						$("#'.$wid.' li#'.$li.'").addClass("active");
						$("#'.$wid.' li#'.$li.'").parents("li").addClass("has_active_child");
					});
			');
		}
	}
	public function render() {
		$widgetHTML="";
		$wid = $this->get('Menu_ID','');
		$root_id = $this->get('Menu_root_id','');
		$translate = $this->get('Translate',0);
		$max_levels= $this->get('Menu_max_levels',0);
		if ($root_id) {
			$model = new Menus();
			$widgetHTML .= $model->render($root_id,$wid,$translate,$max_levels);
		}
		return $widgetHTML;
	}
	public function getTopItems(){
		if(!defined('_ADMIN_MODE')) return null;
		$sql="SELECT mi_id AS id, mi_name AS name FROM #__menus WHERE mi_parent_id=0 ORDER by mi_ordering";
		Database::getInstance()->setQuery($sql);
		$result = Database::getInstance()->loadObjectList();
		return $result;
	}
}

?>