<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class pollsWidget extends Widget {

	public function getParamsMask(){
	  $params["Widget_ID"]["vtype"]="string";			$params["Widget_ID"]["vdefault"]="";
	  $params["Poll_ID"]["vtype"]="table_select"; 		$params["Poll_ID"]["vdefault"]=0;	$params['Poll_ID']["source"]="SELECT p_id AS fld_id, p_title AS fld_name FROM #__polls ORDER BY fld_name";
	  $params["Poll_results"]["vtype"]="boolean"; 		$params["Poll_results"]["vdefault"]=1;
	  $params["All_polls_button"]["vtype"]="boolean"; 	$params["All_polls_button"]["vdefault"]=1;
	  $params["Show_bars"]["vtype"]="boolean"; 			$params["Show_bars"]["vdefault"]=1;
	  $params["Bar_color_hex"]["vtype"]="string"; 		$params["Bar_color_hex"]["vdefault"]="";
	  return $params;
	}
	public function render() {
		$widgetHTML="";
		$poll_id = intval($this->get("Poll_ID",0));
		$model = new Polls();
		$poll = $model->getPoll($poll_id);
		$items = $model->getItems($poll_id);
		if (($poll)&&($items)&&(count($items))) {
			$widgetHTML.=$this->renderPoll($poll, $items);
			$color=$this->get("Bar_color_hex","#0000FF");
			$widgetHTML.=HTMLControls::renderHiddenField("barcolor_".$poll_id,$color);
		}
		return $widgetHTML;
	}
	public function renderPoll($poll,$items){
		$url=Router::_("index.php");
		$all_polls_button = intval($this->get("All_polls_button",1));
		$show_bars = intval($this->get("Show_bars",1));
		$poll_results = intval($this->get("Poll_results",1));
		$total=0;
		$color="background:".$this->get("Bar_color_hex","#0000FF").";";
		$_html="<div class=\"poll\" id=\"wpoll_".$poll->p_id."\">";
		$_html.="<p class=\"poll_title\">".$poll->p_title."</p>";
		$_html.="<form name=\"wpoll\" method=\"post\" action=\"".$url."\">";
		foreach($items as $item) {
			$total=$total+$item->pi_hits;
		}
		foreach($items as $item) {
			$percentage=0;	if ($total) $percentage=round(100*($item->pi_hits)/$total, 2);
			$_html.="<input class=\"vote_radio\" type=\"radio\" name=\"voteid[]\" id=\"voteid".$item->pi_id."\" value=\"".$item->pi_id."\" />";
			$_html.="<label class=\"vote_label\" for=\"voteid".$item->pi_id."\">".htmlspecialchars($item->pi_text)."</label>";
			if($show_bars) {
				$_html.="<div class=\"pollbar\">";
				$_html.="<div class=\"percentage\" style=\"".$color.";width:".round((0.8*$percentage),0)."%\"></div>&nbsp;".$percentage."%";
				$_html.="</div>";
			}
		}
		$_html.="</form>";
		if($poll_results) $_html.="<p class=\"total_votes\">".Text::_("Total voted").": ".$total."</p>";
		$_html.="<p class=\"vote_button\">";
		if($all_polls_button) $_html.="<input style=\"float:left;\" type=\"button\" class=\"commonButton\" value=\"".Text::_("All polls")."\"  onclick=\"javascript:document.location.href='".Router::_("index.php?module=polls")."'; return false;\" />";
		$_html.="<input type=\"button\" class=\"commonButton\" value=\"".Text::_("Vote")."\" onclick=\"votePoll(".$poll->p_id."); return false;\" />";
		$_html.="<input type=\"hidden\" value=\"polls\" name=\"module\" />";
		$_html.="</p>";
		$_html.="</div>";
		return $_html;
	}
	
}
?>