<?php
/*
 * AltaDoc-CMS
 * Copyright (c) AltaDoc Group
 * Web: http://altadoc.ru
 * Commercial license http://altadoc.ru/article/litsenzionnoe_soglashenie.html
 * Last Changed Rev: 279
 * Build: 157
 * Build date: 2014.04.09 0:18:56
 * 
 */
defined('_ALTADOC_VALID') or die("Access denied");

class searchWidget extends Widget {

	public function getParamsMask(){
		$params=parent::getParamsMask();
		$params["search_type"]["vtype"]="select"; 	$params["search_type"]["vdefault"]="blogs_posts"; $params["search_type"]["source"]=array(array("id"=>"blogs_posts","name"=>Text::_("Blogs posts")),array("id"=>"article","name"=>Text::_("Articles")),array("id"=>"forum_posts","name"=>Text::_("Forum posts")),array("id"=>"comments","name"=>Text::_("Comments")));
		$params["show_label"]["vtype"]="boolean"; 	$params["show_label"]["vdefault"]=0;
		$params["show_button"]["vtype"]="boolean"; 	$params["show_button"]["vdefault"]=0;
		$params["text_in_field"]["vtype"]="string"; $params["text_in_field"]["vdefault"]=Text::_("Search entire site");
		$params["text_in_button"]["vtype"]="string"; $params["text_in_button"]["vdefault"]=Text::_("Search");
		$params["minimum_search_length"]["vtype"]="integer"; 	$params["minimum_search_length"]["vdefault"]=4;
		return $params;
	}
	public function prepare() {
		$text_in_field = $this->get('text_in_field',Text::_("Search entire site"));
		$minimum_search_length = $this->get('minimum_search_length',4);
		$script="
			$(document).ready(function() {
				$('#w_search_keywords').val('".$text_in_field."');
				$('#w_search_keywords').bind('blur', function() {if (this.value=='') this.value='".$text_in_field."';});
				$('#w_search_keywords').bind('focus', function() {if (this.value=='".$text_in_field."') this.value='';});
				$('#wFrmSearch').bind('submit', function() { if ($('#w_search_keywords').val().length<".intval($minimum_search_length).") return false;	});
			});";
		Portal::getInstance()->addScriptDeclaration($script);
	}
	public function render() {
		$search_type = $this->get('search_type','blogs_posts');
		$show_label = $this->get('show_label',0);
		$show_button = $this->get('show_button',0);
		$text_in_button = $this->get('text_in_button',"");
		$html= "<form action=\"".Router::_("index.php")."\" method=\"post\" id=\"wFrmSearch\" name=\"wFrmSearch\">";
		$html.= "<div class=\"w_searchform\">";
		if ($show_label) $html.= HTMLControls::renderLabelField("keywords","Search phrase",1);
		$html.= HTMLControls::renderInputText("keywords","",30,"","w_search_keywords");
		$html.= "</div>";
		if($show_button) {
			$html.= "<div class=\"w_searchform_button\">";
			$html.= HTMLControls::renderButton("submit", $text_in_button,  "submit");
			$html.= "</div>";
		}
		$html.= HTMLControls::renderHiddenField("where_search", $search_type);
		$html.= HTMLControls::renderHiddenField("searchtype", "any");
		$html.= HTMLControls::renderHiddenField("module", "");
		$html.= HTMLControls::renderHiddenField("view", "");
		$html.= HTMLControls::renderHiddenField("task", "search");
		$html.= "</form>";
		return $html;
	}
}

?>